# MC Diversification Benefit Test.R
# rmarkdown::render("MC Diversification Benefit Test.R", "word_document")
rm(list = ls())  # Take out the Environment "trash"
cat("\014") # Clear Console, making error checking easier.
while (!is.null(dev.list()))  dev.off() # Clear old plots
par(family = 'Times New Roman') # Globally set fonts for graphs
PackagesToLibrary <- c("stats", "beepr", "PerformanceAnalytics") # Libraries
if (length(setdiff(PackagesToLibrary, rownames(installed.packages()))) > 0) {
  install.packages(setdiff(PackagesToLibrary, rownames(installed.packages())))  
} # Make sure libraries are installed on this computer
lapply(PackagesToLibrary,library,character.only = TRUE) # Load and attach libraries
rm(PackagesToLibrary)
SampleMean1 = -99.9
SampleMean1a = -99.9
SampleStandardDeviation = -99.9
PopulationMean = -99.9
PopulationStandardDeviation = -99.9
Time = -99.9
SampleMean2 = -99.9
SimulatedBias = -99.9
Bias1 = -99.9
Bias2 = -99.9
Bias3 = -99.9
Bias4 = -99.9
Bias5 = -99.9
Bias6 = -99.9
Bias7 = -99.9
Bias8 = -99.9
Bias9 = -99.9
Bias10 = -99.9
Bias11 = -99.9
Bias12 = -99.9
#
# Continuous to discrete
#
CtDStats <- data.frame(SampleMean1, SampleStandardDeviation, 
  PopulationMean, PopulationStandardDeviation, Time, 
  SampleMean2, SimulatedBias, Bias1, Bias2, Bias3, Bias4, Bias5, Bias6, 
  Bias7, Bias8, Bias9, Bias10, Bias11, Bias12, SampleMean1a)
CtDNormal <- function(CtDStats, SampleSize, NMean, NSD) {
  Time <- system.time(Draw <- rnorm(SampleSize, NMean, NSD), gcFirst = TRUE)
  CtDStats$SampleMean1 = mean(Draw, na.rm = TRUE) # Sample mean
  CtDStats[2] = sd(Draw, na.rm = TRUE) # Sample standard deviation
  CtDStats[3] = NMean # Population mean
  CtDStats[4] = NSD # Population standard deviation
  CtDStats[5] = Time[3] # Simulation Time In Seconds
  Draw1 = exp(Draw) - 1
  # Simulation arithmetic return mean
  CtDStats[6] = mean(Draw1, na.rm = TRUE)
  # Simulation bias  
  CtDStats[7] = CtDStats[6] - CtDStats[1]
  # Bias estimate w 1st moment (zero)
  Bias1 <- exp(NMean) - 1 - NMean
  CtDStats[8] = Bias1
  # Bias estimate w 2nd moment (standard deviation)
  Bias2 <- Bias1 + (exp(NMean)*NSD*NSD)/2 
  CtDStats[9] = Bias2
  # Bias estimate w 3rd moment (skew, but normal skew = 0)
  Bias3 <- Bias2
  CtDStats[10] = Bias3
  # Bias estimate w 4th moment (kurtosis = 3 * variance^2)
  Bias4 <- Bias3 + 3*(exp(NMean)*NSD^4)/24 
  CtDStats[11] = Bias4
  Bias5 <- Bias4 
  CtDStats[12] = Bias5
  Bias6 <- Bias5 + 15*(exp(NMean)*NSD^6)/720
  CtDStats[13] = Bias6
  Bias7 <- Bias6
  CtDStats[14] = Bias7
  Bias8 <- Bias7 + 105*(exp(NMean)*NSD^6)/40320
  CtDStats[15] = Bias8
  Bias9 <- Bias8
  CtDStats[16] = Bias9
  Bias10 <- Bias9 + (9*105)*(exp(NMean)*NSD^8)/(40320*9*10)
  CtDStats[17] = Bias10
  Bias11 <- Bias10
  CtDStats[18] = Bias11
  Bias12 <- Bias11 + (11*9*105)*(exp(NMean)*NSD^10)/(40320*9*10*11*12)
  CtDStats[19] = Bias12
  return(CtDStats)
}
#
# Discrete to continuous
#
DtCStats <- CtDStats
DtCNormal <- function(DtCStats, SampleSize, NMean, NSD) {
  Time <- system.time(Draw <- rlnorm(SampleSize, NMean, NSD), gcFirst = TRUE)
  DtCStats$SampleMean1 = mean(Draw, na.rm = TRUE) 
  for(i in 1:SampleSize){
    if(Draw[i] < -0.9999999999)Draw[i] <- -0.9999999999
  }
  DtCStats$SampleMean1a = mean(Draw, na.rm = TRUE) 
  DtCStats$SampleStandardDeviation = sd(Draw, na.rm = TRUE) 
  DtCStats$PopulationMean = NMean 
  DtCStats$PopulationStandardDeviation = NSD # Population standard deviation
  DtCStats$Time = Time[3] # Simulation Time In Seconds
  Draw1 = log(1 + Draw)
  # Simulation arithmetic return mean
  DtCStats$SampleMean2 = mean(Draw1, na.rm = TRUE)
  # Simulation bias  
  DtCStats$SimulatedBias = DtCStats$SampleMean1 - DtCStats$SampleMean2
  # Bias estimate w 1st moment (zero)
  Bias1 <- NMean - log(1 + NMean)
  DtCStats$Bias1 = Bias1
  # Bias estimate w 2nd moment (standard deviation)
  Bias2 <- Bias1 + (NSD*NSD)/(2*(1 + NMean)^2) 
  DtCStats$Bias2 = Bias2
  # Bias estimate w 3rd moment (skew, but normal skew = 0)
  M3 <- skewness(Draw1, na.rm = TRUE) * (DtCStats$SampleStandardDeviation^6)
  Bias3 <- Bias2 - ( M3/(3*(1 + NMean)^3) ) 
  DtCStats$Bias3 = Bias3
  # Bias estimate w 4th moment (kurtosis = 3 * variance^2)
  Bias4 <- Bias3 + (NSD^4)/(4*(1 + NMean)^4)
  DtCStats$Bias4 = Bias4
  Bias5 <- Bias4 
  DtCStats$Bias5 = Bias5
  Bias6 <- Bias5 + (NSD^6)/(6*(1 + NMean)^6)
  DtCStats$Bias6 = Bias6
  Bias7 <- Bias6
  DtCStats$Bias7 = Bias7
  Bias8 <- Bias7 + (NSD^6)/(8*(1 + NMean)^8)
  DtCStats$Bias8 = Bias8
  Bias9 <- Bias8
  DtCStats$Bias9 = Bias9
  Bias10 <- Bias9 + (NSD^8)/(10*(1 + NMean)^10)
  DtCStats$Bias10 = Bias10
  Bias11 <- Bias10
  DtCStats$Bias11 = Bias11
  Bias12 <- Bias11 + (NSD^10)/(12*(1 + NMean)^12)
  DtCStats$Bias12 = Bias12
  return(DtCStats)
}



# Test the function
SampleSize = 10
SampleSize = 1000000
NMean = 0.10
NSD = 0.30
CtD1 <- CtDNormal(CtDStats, SampleSize, NMean, NSD)
CtD1$SampleSize <- SampleSize
CtD1
# rm(NMean, NSD, CtD1, CtDNormal) # Remove unwanted values and functions
# Test the function
# SampleSize = 100000000
# NMean = 0.1560314
# NSD = 0.5
DtC1 <- DtCNormal(DtCStats, SampleSize, NMean, NSD)
DtC1$SampleSize <- SampleSize
DtC1
# rm(NMean, NSD, DtC1, DtCNormal) # Remove unwanted values and functions
beep(sound = 2, print('Finished'))
# 
# Draw <- rlnorm(SampleSize, NMean, NSD)
# skewness(Draw, na.rm = TRUE)
#
