# Rolling Plots.R
#
# A few plots
#
# display.brewer.all() # All palette available from RColorBrewer
# cols<-brewer.pal(n=9,name="Paired") # First 9 colors in Paired palette (prints well)
# cols<-brewer.pal(n=9,name="Greys") # First 9 colors in Paired palette (prints well)
if(Color){
  cols<-rainbow(20) # Color scale
  cols[2] <- "#0000FF"
  cols[3] <- "#8FBC8F"
  cols[4] <- "#9932CC"
  cols[5] <- "#FFD700"
} else {
  cols<-gray.colors(20) # Gray scale
}
# cols #cols contain the names of different colors
x <- as.numeric(SPz$JDate)
MaxValueX = max(as.numeric(SPz$JDate))
MinValueX = min(as.numeric(SPz$JDate))
xlim1 = c(1:2)
xlim1[1] = MinValueX
xlim1[2] = MaxValueX
IncrementX = (as.numeric(MaxValueX) - as.numeric(MinValueX))/7.0
TickMarksX = c(seq(from=MinValueX,to=MaxValueX,by=IncrementX))
# Need cleaner way to address date misalignment
lblX = format.Date(as.date(TickMarksX+3654), "%Y-%m")
legtxt = Names
lTitle = "Instruments"
xTitle = "Date"
Stat <- rep(0,NTickers) # Holds instrument average statistics
Names1 <- Names # Holds names with stats
#
# Total Returns Plots
#
if(TOTALRETURNS){
  MaxValueY <- -99
  MinValueY <- 99
  for(i in 1:NTickers){
    MaxValueY = max(as.numeric(SPz[,i+1]), MaxValueY, na.rm = TRUE)
    MinValueY = min(as.numeric(SPz[,i+1]), MinValueY, na.rm = TRUE)
  }
  if(FIXYAXISTRETURNS){
    MaxValueY <- MAXTRETURNS
    MinValueY <- MINTRETURNS
  }
  IncrementY = (as.numeric(MaxValueY) - as.numeric(MinValueY))/7.0
  ylim1 = c(1:2)
  ylim1[1] = MinValueY
  ylim1[2] = MaxValueY
  mTitle = paste0(InstrumentType, " Total Returns")
  yTitle = "Total Returns"
  TickMarksY = c(seq(from=MinValueY,to=MaxValueY,by=IncrementY))
  TickMarksY = round(TickMarksY, 2)
  lblY = paste0("$", format(TickMarksY, trim = TRUE, digits = 3, #nsmall = 1,
                            justify = c("right"), width = 0, big.mark = ","))
  plot(as.Date(x),as.numeric(SPz[,2]), axes = FALSE,
       type = "l", main = mTitle, sub = sTitle, xlab = xTitle, ylab = yTitle, 
       col = "black", xlim = xlim1, ylim = ylim1, pch = 2, cex = 1.0, lwd = 2)
  for(i in 2:NTickers){
    lines(as.Date(x),as.numeric(SPz[,i+1]), type = "l", col = cols[i], 
          xlim = xlim1, ylim = ylim1, pch = 2, cex = 0.5)
  }
  box() # create a wrap around the points plotted
  axis(labels=NA,side=1,tck=-0.015,at=TickMarksX)
  axis(lwd=0,side=1,line=-0.4,at=TickMarksX, label=lblX)
  axis(labels=NA,side=2,tck=-0.015, at=TickMarksY)
  axis(lwd=0,line=-0.4,side=2,las=1,
       at=TickMarksY, label = lblY)
  legend("topleft", legtxt, cex = 0.75, lwd = c(2, 1, 1, 1, 1, 1, 1, 1, 1, 1),
         lty = c(1, 1, 1, 1, 1, 1, 1, 1, 1, 1),
         col = c("black", cols[2], cols[3], cols[4], cols[5], cols[6], cols[7],
                 cols[8], cols[9], cols[10]), pch = c(NA, NA, NA, NA, NA, NA, NA, NA, NA, NA), 
         bty = "n", title = lTitle)}

#
# Periodic Returns Plots
#
if(PERIODICRETURNS){
  MaxValueY <- -99
  MinValueY <- 99
  for(i in 1:NTickers){
    MaxValueY = max(as.numeric(SPz[,NTickers+i+1])*100, MaxValueY, na.rm = TRUE)
    MinValueY = min(as.numeric(SPz[,NTickers+i+1])*100, MinValueY, na.rm = TRUE)
  }
  if(FIXYAXISMEANSPRETURNS){
    MaxValueY <- MAXPRETURNS
    MinValueY <- MINPRETURNS
  }
  IncrementY = (as.numeric(MaxValueY) - as.numeric(MinValueY))/7.0
  ylim1 = c(1:2)
  ylim1[1] = MinValueY
  ylim1[2] = MaxValueY
  mTitle = paste0(InstrumentType, " Periodic Returns")
  yTitle = "Periodic Returns (%)"
  TickMarksY = c(seq(from=MinValueY,to=MaxValueY,by=IncrementY))
  TickMarksY = round(TickMarksY, 2)
  lblY = paste0(format(TickMarksY, trim = TRUE, digits = 3, #nsmall = 1,
                       justify = c("right"), width = 0, big.mark = ","))
  plot(as.Date(x),as.numeric(SPz[,NTickers+2])*100, axes = FALSE,
       type = "p", main = mTitle, sub = sTitle, xlab = xTitle, ylab = yTitle, 
       col = "black", xlim = xlim1, ylim = ylim1, pch = 1, cex = 1.0, lwd = 2)
  Stat[1] <- mean(as.numeric(SPz[,NTickers+2])*100, na.rm = TRUE)
  for(i in 2:NTickers){
    lines(as.Date(x),as.numeric(SPz[,NTickers+i+1])*100, type = "p", 
          col = cols[2*(i-1)], xlim = xlim1, ylim = ylim1, pch = 2*(i-1), cex = 0.5)
    Stat[i] <- mean(as.numeric(SPz[,NTickers+i+1])*100, na.rm = TRUE)
  }
  for(i in 1:NTickers){
    Names1[i] <- paste0(Names[i], ' (',round(Stat[i],4),')')
  }
  legtxt = Names1
  box() # create a wrap around the points plotted
  axis(labels=NA,side=1,tck=-0.015,at=TickMarksX)
  axis(lwd=0,side=1,line=-0.4,at=TickMarksX, label=lblX)
  axis(labels=NA,side=2,tck=-0.015, at=TickMarksY)
  axis(lwd=0,line=-0.4,side=2,las=1,at=TickMarksY, label = lblY)
  legend("topleft", legtxt, cex = 0.75, lwd = c(2, 1, 1, 1, 1, 1, 1, 1, 1, 1),
         lty = rep(0,9), col = c("black", cols[2], cols[3], cols[4], cols[5], cols[6], cols[7],
                                 cols[8], cols[9], cols[10]), 
         pch = c(1,2,4,6,8,10,12,14,16,18), bty = "n", title = lTitle)
}
#
# Rolling Mean Plots
#
if(ROLLINGMEANS){
  MaxValueY <- -99
  MinValueY <- 99
  for(i in 1:NTickers){
    MaxValueY = max(as.numeric(SPz[,2*NTickers+i+1])*100, MaxValueY, na.rm = TRUE)
    MinValueY = min(as.numeric(SPz[,2*NTickers+i+1])*100, MinValueY, na.rm = TRUE)
  }
  if(FIXYAXISMEANS){
    MaxValueY <- MAXMEANS
    MinValueY <- MINMEANS
  }
  IncrementY = (as.numeric(MaxValueY) - as.numeric(MinValueY))/7.0
  ylim1 = c(1:2)
  ylim1[1] = MinValueY
  ylim1[2] = MaxValueY
  mTitle = paste0(InstrumentType, " Rolling Means")
  yTitle = "Rolling Means (%)"
  TickMarksY = c(seq(from=MinValueY,to=MaxValueY,by=IncrementY))
  TickMarksY = round(TickMarksY, 2)
  lblY = paste0(format(TickMarksY, trim = TRUE, digits = 3, #nsmall = 1,
                       justify = c("right"), width = 0, big.mark = ","))
  plot(as.Date(x),as.numeric(SPz[,2*NTickers+2])*100, axes = FALSE,
       type = "p", main = mTitle, sub = sTitle, xlab = xTitle, ylab = yTitle, 
       col = "black", xlim = xlim1, ylim = ylim1, pch = 1, cex = 1.0, lwd = 2)
  Stat[1] <- mean(as.numeric(SPz[,2*NTickers+2])*100, na.rm = TRUE)
  for(i in 2:NTickers){
    lines(as.Date(x),as.numeric(SPz[,2*NTickers+i+1])*100, type = "p", 
          col = cols[2*(i-1)], xlim = xlim1, ylim = ylim1, pch = 2*(i-1), cex = 0.5)
    Stat[i] <- mean(as.numeric(SPz[,2*NTickers+i+1])*100, na.rm = TRUE)
  }
  for(i in 1:NTickers){
    Names1[i] <- paste0(Names[i], ' (',round(Stat[i],4),')')
  }
  legtxt = Names1
  lTitle = "Instruments (Average)"
  box() # create a wrap around the points plotted
  axis(labels=NA,side=1,tck=-0.015,at=TickMarksX)
  axis(lwd=0,side=1,line=-0.4,at=TickMarksX, label=lblX)
  axis(labels=NA,side=2,tck=-0.015, at=TickMarksY)
  axis(lwd=0,line=-0.4,side=2,las=1,at=TickMarksY, label = lblY)
  legend("bottomleft", legtxt, cex = 0.75, lwd = c(2, 1, 1, 1, 1, 1, 1, 1, 1, 1),
         lty = rep(0,9), col = c("black", cols[2], cols[3], cols[4], cols[5], cols[6], cols[7],
                                 cols[8], cols[9], cols[10]), 
         pch = c(1,2,4,6,8,10,12,14,16,18), bty = "n", title = lTitle)
}
#
# Rolling Standard Deviation Plots
#
if(ROLLINGSD){
  MaxValueY <- -99
  MinValueY <- 99
  for(i in 1:NTickers){
    MaxValueY = max(as.numeric(SPz[,3*NTickers+i+1])*100, MaxValueY, na.rm = TRUE)
    MinValueY = min(as.numeric(SPz[,3*NTickers+i+1])*100, MinValueY, na.rm = TRUE)
  }
  if(FIXYAXISSD){
    MaxValueY <- MAXSD
    MinValueY <- MINSD
  }
  IncrementY = (as.numeric(MaxValueY) - as.numeric(MinValueY))/7.0
  ylim1 = c(1:2)
  ylim1[1] = MinValueY
  ylim1[2] = MaxValueY
  mTitle = paste0(InstrumentType, " Rolling Standard Deviations")
  yTitle = "Rolling Standard Deviations (%)"
  TickMarksY = c(seq(from=MinValueY,to=MaxValueY,by=IncrementY))
  TickMarksY = round(TickMarksY, 2)
  lblY = paste0(format(TickMarksY, trim = TRUE, digits = 3, #nsmall = 1,
                       justify = c("right"), width = 0, big.mark = ","))
  plot(as.Date(x),as.numeric(SPz[,3*NTickers+2])*100, axes = FALSE,
       type = "p", main = mTitle, sub = sTitle, xlab = xTitle, ylab = yTitle, 
       col = "black", xlim = xlim1, ylim = ylim1, pch = 1, cex = 1.0, lwd = 2)
  Stat[1] <- mean(as.numeric(SPz[,3*NTickers+2])*100, na.rm = TRUE)
  for(i in 2:NTickers){
    lines(as.Date(x),as.numeric(SPz[,3*NTickers+i+1])*100, type = "p", 
          col = cols[2*(i-1)], xlim = xlim1, ylim = ylim1, pch = 2*(i-1), cex = 0.5)
    Stat[i] <- mean(as.numeric(SPz[,3*NTickers+i+1])*100, na.rm = TRUE)
  }
  for(i in 1:NTickers){
    Names1[i] <- paste0(Names[i], ' (',round(Stat[i],4),')')
  }
  legtxt = Names1
  lTitle = "Instruments (Average)"
  box() # create a wrap around the points plotted
  axis(labels=NA,side=1,tck=-0.015,at=TickMarksX)
  axis(lwd=0,side=1,line=-0.4,at=TickMarksX, label=lblX)
  axis(labels=NA,side=2,tck=-0.015, at=TickMarksY)
  axis(lwd=0,line=-0.4,side=2,las=1,at=TickMarksY, label = lblY)
  legend("topleft", legtxt, cex = 0.75, lwd = c(2, 1, 1, 1, 1, 1, 1, 1, 1, 1),
         lty = rep(0,9), col = c("black", cols[2], cols[3], cols[4], cols[5], cols[6], cols[7],
                                 cols[8], cols[9], cols[10]), 
         pch = c(1,2,4,6,8,10,12,14,16,18), bty = "n", title = lTitle)
}
#
# Rolling Beta Plots
#
if(ROLLINGBETA){
  MaxValueY <- -99
  MinValueY <- 99
  for(i in 1:NTickers){
    MaxValueY = max(as.numeric(SPz[,4*NTickers+2*i+1]), MaxValueY, na.rm = TRUE)
    MinValueY = min(as.numeric(SPz[,4*NTickers+2*i+1]), MinValueY, na.rm = TRUE)
  }
  if(FIXYAXISBETA){
    MaxValueY <- MAXBETA
    MinValueY <- MINBETA
  }
  IncrementY = (as.numeric(MaxValueY) - as.numeric(MinValueY))/7.0
  ylim1 = c(1:2)
  ylim1[1] = MinValueY
  ylim1[2] = MaxValueY
  mTitle = paste0(InstrumentType, " Rolling Beta with Benchmark")
  yTitle = "Rolling Beta with Benchmark"
  TickMarksY = c(seq(from=MinValueY,to=MaxValueY,by=IncrementY))
  TickMarksY = round(TickMarksY, 2)
  lblY = paste0(format(TickMarksY, trim = TRUE, digits = 3, #nsmall = 1,
                       justify = c("right"), width = 0, big.mark = ","))
  plot(as.Date(x),as.numeric(SPz[,4*NTickers+3]), axes = FALSE,
       type = "l", main = mTitle, sub = sTitle, xlab = xTitle, ylab = yTitle, 
       col = "black", xlim = xlim1, ylim = ylim1, pch = 1, cex = 1.0, lwd = 2)
  Stat[1] <- mean(as.numeric(SPz[,4*NTickers+3]), na.rm = TRUE)
  for(i in 2:NTickers){
    lines(as.Date(x),as.numeric(SPz[,4*NTickers+2*i+1]), type = "p", 
          col = cols[i], xlim = xlim1, ylim = ylim1, pch = 2*(i-1), cex = 0.5)
    Stat[i] <- mean(as.numeric(SPz[,4*NTickers+2*i+1]), na.rm = TRUE)
  }
  for(i in 1:NTickers){
    Names1[i] <- paste0(Names[i], ' (',round(Stat[i],4),')')
  }
  legtxt = Names1
  lTitle = "Instruments (Average)"
  box() # create a wrap around the points plotted
  axis(labels=NA,side=1,tck=-0.015,at=TickMarksX)
  axis(lwd=0,side=1,line=-0.4,at=TickMarksX, label=lblX)
  axis(labels=NA,side=2,tck=-0.015, at=TickMarksY)
  axis(lwd=0,line=-0.4,side=2,las=1,at=TickMarksY, label = lblY)
  legend("bottomleft", legtxt, cex = 0.75, lwd = c(2, 1, 1, 1, 1, 1, 1, 1, 1, 1),
         lty = c(1,rep(0,9)), col = c("black", cols[2], cols[3], cols[4], cols[5], cols[6], cols[7],
                                      cols[8], cols[9], cols[10]), 
         pch = c(NA,2,4,6,8,10,12,14,16,18), bty = "n", title = lTitle)
}
#
# Volatility Benefit
#
if(VOLBEN){
  MaxValueY <- -99
  MinValueY <- 99
  for(i in 1:NTickers){
    MaxValueY = max(as.numeric(VolBen[,i+2]), MaxValueY, na.rm = TRUE)
    MinValueY = min(as.numeric(VolBen[,i+2]), MinValueY, na.rm = TRUE)
  }
  if(FIXYAXISBETA){
    MaxValueY <- MAXVOLBEN
    MinValueY <- MINVOLBEN
  }
  IncrementY = (as.numeric(MaxValueY) - as.numeric(MinValueY))/10.0
  ylim1 = c(1:2)
  ylim1[1] = MinValueY
  ylim1[2] = MaxValueY
  mTitle = paste0(InstrumentType, " Volatility Benefit (in %)", 
    '\n(', Names[1], ', ', Names[2], ')')
  if(length(Names) > 2){
    mTitle = paste0(InstrumentType, " Volatility Benefit (in %)", 
                    '\n(', Names[1], ', ', Names[2], '...)')
  }
  yTitle = "Volatility Benefit (%)"
  TickMarksY = c(seq(from=MinValueY,to=MaxValueY,by=IncrementY))
  TickMarksY = round(TickMarksY, 2)
  lblY = paste0(format(TickMarksY, trim = TRUE, digits = 3, #nsmall = 1,
                       justify = c("right"), width = 0, big.mark = ","))
  plot(as.Date(x),as.numeric(VolBen[,NTickers+3]), axes = FALSE,
       type = "l", main = mTitle, sub = sTitle, xlab = xTitle, ylab = yTitle, 
       col = "black", xlim = xlim1, ylim = ylim1, pch = 1, cex = 1.0, lwd = 2)
  Stat[1] <- mean(as.numeric(VolBen[,NTickers+3]), na.rm = TRUE)
  # for(i in 2:NTickers){
  #   lines(as.Date(x),as.numeric(SPz[,4*NTickers+2*i+1]), type = "p", 
  #         col = cols[i], xlim = xlim1, ylim = ylim1, pch = 2*(i-1), cex = 0.5)
  #   Stat[i] <- mean(as.numeric(SPz[,4*NTickers+2*i+1]), na.rm = TRUE)
  # }
  # Names1[1] <- paste0('Average Volatility Benefit = ', round(Stat[1],2), '%')
  legtxt = paste0('Average Volatility Benefit = ', round(Stat[1],2), '%')
  lTitle = '' #paste0(Names1[2])
  box() # create a wrap around the points plotted
  axis(labels=NA,side=1,tck=-0.015,at=TickMarksX)
  axis(lwd=0,side=1,line=-0.4,at=TickMarksX, label=lblX)
  axis(labels=NA,side=2,tck=-0.015, at=TickMarksY)
  axis(lwd=0,line=-0.4,side=2,las=1,at=TickMarksY, label = lblY)
  legend("topleft", legtxt, cex = 0.75, lwd = c(2, 1, 1, 1, 1, 1, 1, 1, 1, 1),
         lty = c(1,rep(0,9)), col = c("black", cols[2], cols[3], cols[4], cols[5], cols[6], cols[7],
                                      cols[8], cols[9], cols[10]),
         pch = c(NA,2,4,6,8,10,12,14,16,18), bty = "n", title = lTitle)
}

