# KM Inputs.R
#
# All input data: FileName (set in main program)
#
KMInputs <- read.xlsx(xlsxFile = FileName, sheet = "MainInputs", skipEmptyRows = TRUE)
InitialCurves <- read.xlsx(xlsxFile = FileName, sheet = "InitialCurves", 
  rowNames = TRUE, skipEmptyRows = FALSE)
HorizonCurves <- read.xlsx(xlsxFile = FileName, sheet = "HorizonCurves", 
  rowNames = TRUE, skipEmptyRows = FALSE)
NumberOfAssets <- as.numeric(KMInputs$Number[1]) # Number of assets
NumberOfLiabilities <- as.numeric(KMInputs$Number[2]) # Number of liabilities
NumberOfCurves <- as.numeric(KMInputs$Number[3]) # Total number of LSC curve inputs (Base + CreditN + GrowthN)
MaxCashFlows <- as.numeric(KMInputs$Number[4]) # Maximum number of cash flows across all instruments
NumberOfVariables <- as.numeric(KMInputs$Number[5]) # Maturity and expected cash flow
Horizon <- as.numeric(KMInputs$Number[6])
#
# Generic Data Frame
#
MaxInstruments = NumberOfAssets + NumberOfLiabilities # Number of instruments
#
# Work on Assets: read.xlsx output is a data.frame
#
if(NumberOfAssets > 0){
  Asset1 <- read.xlsx(xlsxFile = FileName, sheet = "Asset1", 
    rowNames = TRUE, skipEmptyRows = TRUE)
#  is.data.frame(Asset1)
  Asset1$Instrument <- 1
  Asset1$Name <- KMInputs$Number[Asset1$Instrument+6]
  Asset1$WBase <- KMInputs$Base[Asset1$Instrument+6]
  Asset1$WSpread1 <- KMInputs$Spread1[Asset1$Instrument+6]
  Asset1$WSpread2 <- KMInputs$Spread2[Asset1$Instrument+6]
  Asset1$WSpread3 <- KMInputs$Spread3[Asset1$Instrument+6]
  Asset1$WSpread4 <- KMInputs$Spread4[Asset1$Instrument+6]
  Asset1$WSpread5 <- KMInputs$Spread5[Asset1$Instrument+6]
  dfInstruments <- Asset1
}
if(NumberOfAssets > 1){
  Asset2 <- read.xlsx(xlsxFile = FileName, sheet = "Asset2", 
    rowNames = TRUE, skipEmptyRows = TRUE)
  Asset2$Instrument <- 2
  Asset2$Name <- KMInputs$Number[Asset2$Instrument+6]
  Asset2$WBase <- KMInputs$Base[Asset2$Instrument+6]
  Asset2$WSpread1 <- KMInputs$Spread1[Asset2$Instrument+6]
  Asset2$WSpread2 <- KMInputs$Spread2[Asset2$Instrument+6]
  Asset2$WSpread3 <- KMInputs$Spread3[Asset2$Instrument+6]
  Asset2$WSpread4 <- KMInputs$Spread4[Asset2$Instrument+6]
  Asset2$WSpread5 <- KMInputs$Spread5[Asset2$Instrument+6]
  dfInstruments <- Reduce(function(x, y) merge(x, y, all=TRUE), list(dfInstruments, Asset2))
}
if(NumberOfAssets > 2){
  Asset3 <- read.xlsx(xlsxFile = FileName, sheet = "Asset3", 
    rowNames = TRUE, skipEmptyRows = TRUE)
  Asset3$Instrument <- 3
  Asset3$Name <- KMInputs$Number[Asset3$Instrument+6]
  Asset3$WBase <- KMInputs$Base[Asset3$Instrument+6]
  Asset3$WSpread1 <- KMInputs$Spread1[Asset3$Instrument+6]
  Asset3$WSpread2 <- KMInputs$Spread2[Asset3$Instrument+6]
  Asset3$WSpread3 <- KMInputs$Spread3[Asset3$Instrument+6]
  Asset3$WSpread4 <- KMInputs$Spread4[Asset3$Instrument+6]
  Asset3$WSpread5 <- KMInputs$Spread5[Asset3$Instrument+6]
  dfInstruments <- Reduce(function(x, y) merge(x, y, all=TRUE), list(dfInstruments, Asset3))
}
if(NumberOfAssets > 3){
  Asset4 <- read.xlsx(xlsxFile = FileName, sheet = "Asset4", 
    rowNames = TRUE, skipEmptyRows = TRUE)
  Asset4$Instrument <- 4
  Asset4$Name <- KMInputs$Number[Asset4$Instrument+6]
  Asset4$WBase <- KMInputs$Base[Asset4$Instrument+6]
  Asset4$WSpread1 <- KMInputs$Spread1[Asset4$Instrument+6]
  Asset4$WSpread2 <- KMInputs$Spread2[Asset4$Instrument+6]
  Asset4$WSpread3 <- KMInputs$Spread3[Asset4$Instrument+6]
  Asset4$WSpread4 <- KMInputs$Spread4[Asset4$Instrument+6]
  Asset4$WSpread5 <- KMInputs$Spread5[Asset4$Instrument+6]
  dfInstruments <- Reduce(function(x, y) merge(x, y, all=TRUE), list(dfInstruments, Asset4))
}
if(NumberOfAssets > 4){
  Asset5 <- read.xlsx(xlsxFile = FileName, sheet = "Asset5", 
    rowNames = TRUE, skipEmptyRows = TRUE)
  Asset5$Instrument <- 5
  Asset5$Name <- KMInputs$Number[Asset5$Instrument+6]
  Asset5$WBase <- KMInputs$Base[Asset5$Instrument+6]
  Asset5$WSpread1 <- KMInputs$Spread1[Asset5$Instrument+6]
  Asset5$WSpread2 <- KMInputs$Spread2[Asset5$Instrument+6]
  Asset5$WSpread3 <- KMInputs$Spread3[Asset5$Instrument+6]
  Asset5$WSpread4 <- KMInputs$Spread4[Asset5$Instrument+6]
  Asset5$WSpread5 <- KMInputs$Spread5[Asset5$Instrument+6]
  dfInstruments <- Reduce(function(x, y) merge(x, y, all=TRUE), list(dfInstruments, Asset5))
}
if(NumberOfLiabilities > 0){
  Liability1 <- read.xlsx(xlsxFile = FileName, sheet = "Liability1", 
    rowNames = TRUE, skipEmptyRows = TRUE)
  Liability1$Instrument <- NumberOfAssets + 1
  Liability1$Name <- KMInputs$Number[Liability1$Instrument+6]
  Liability1$ECF <- -Liability1$ECF
  Liability1$WBase <- KMInputs$Base[Liability1$Instrument+6]
  Liability1$WSpread1 <- KMInputs$Spread1[Liability1$Instrument+6]
  Liability1$WSpread2 <- KMInputs$Spread2[Liability1$Instrument+6]
  Liability1$WSpread3 <- KMInputs$Spread3[Liability1$Instrument+6]
  Liability1$WSpread4 <- KMInputs$Spread4[Liability1$Instrument+6]
  Liability1$WSpread5 <- KMInputs$Spread5[Liability1$Instrument+6]
  dfInstruments <- Reduce(function(x, y) merge(x, y, all=TRUE), list(dfInstruments, Liability1))
}
if(NumberOfLiabilities > 1){
  Liability2 <- read.xlsx(xlsxFile = FileName, sheet = "Liability2", 
    rowNames = TRUE, skipEmptyRows = TRUE)
  Liability2$Instrument <- NumberOfAssets + 2
  Liability2$Name <- KMInputs$Number[Liability2$Instrument+6]
  Liability2$ECF <- -Liability2$ECF
  Liability2$WBase <- KMInputs$Base[Liability2$Instrument+6]
  Liability2$WSpread1 <- KMInputs$Spread1[Liability2$Instrument+6]
  Liability2$WSpread2 <- KMInputs$Spread2[Liability2$Instrument+6]
  Liability2$WSpread3 <- KMInputs$Spread3[Liability2$Instrument+6]
  Liability2$WSpread4 <- KMInputs$Spread4[Liability2$Instrument+6]
  Liability2$WSpread5 <- KMInputs$Spread5[Liability2$Instrument+6]
  dfInstruments <- Reduce(function(x, y) merge(x, y, all=TRUE), list(dfInstruments, Liability2))
}
if(NumberOfLiabilities > 2){
  Liability3 <- read.xlsx(xlsxFile = FileName, sheet = "Liability3", 
    rowNames = TRUE, skipEmptyRows = TRUE)
  Liability3$Instrument <- NumberOfAssets + 3
  Liability3$Name <- KMInputs$Number[Liability3$Instrument+6]
  Liability3$ECF <- -Liability3$ECF
  Liability3$WBase <- KMInputs$Base[Liability3$Instrument+6]
  Liability3$WSpread1 <- KMInputs$Spread1[Liability3$Instrument+6]
  Liability3$WSpread2 <- KMInputs$Spread2[Liability3$Instrument+6]
  Liability3$WSpread3 <- KMInputs$Spread3[Liability3$Instrument+6]
  Liability3$WSpread4 <- KMInputs$Spread4[Liability3$Instrument+6]
  Liability3$WSpread5 <- KMInputs$Spread5[Liability3$Instrument+6]
  dfInstruments <- Reduce(function(x, y) merge(x, y, all=TRUE), list(dfInstruments, Liability3))
}
if(NumberOfLiabilities > 3){
  Liability4 <- read.xlsx(xlsxFile = FileName, sheet = "Liability4", 
    rowNames = TRUE, skipEmptyRows = TRUE)
  Liability4$Instrument <- NumberOfAssets + 4
  Liability4$Name <- KMInputs$Number[Liability4$Instrument+6]
  Liability4$ECF <- -Liability4$ECF
  Liability4$WBase <- KMInputs$Base[Liability4$Instrument+6]
  Liability4$WSpread1 <- KMInputs$Spread1[Liability4$Instrument+6]
  Liability4$WSpread2 <- KMInputs$Spread2[Liability4$Instrument+6]
  Liability4$WSpread3 <- KMInputs$Spread3[Liability4$Instrument+6]
  Liability4$WSpread4 <- KMInputs$Spread4[Liability4$Instrument+6]
  Liability4$WSpread5 <- KMInputs$Spread5[Liability4$Instrument+6]
  dfInstruments <- Reduce(function(x, y) merge(x, y, all=TRUE), list(dfInstruments, Liability4))
}
# Asset1
# Asset2
# Asset3
# Asset4
# Asset5
# Liability1
# Liability2
# Liability3
# Liability4
# dfInstruments <- Reduce(function(x, y) merge(x, y, all=TRUE), 
#   list(Asset1, Asset2, Asset3, Asset4, Asset5, Liability1, Liability2, Liability3, Liability4))
