# KM Rates.R
LengthdfInstruments = length(dfInstruments$Maturity)
for(i in 1:LengthdfInstruments){ # Cannot have zero in LSC model
  if(dfInstruments$Maturity[i] == 0)dfInstruments$Maturity[i] <- 0.000001
}
#
# Rates
#
# Initial Base Rates
L <- InitialCurves$Base[2]
k1 <- InitialCurves$Base[3]
S <- InitialCurves$Base[4]
C1 <- InitialCurves$Base[5]
k2 <- InitialCurves$Base[6]
C2 <- InitialCurves$Base[7]
k3 <- InitialCurves$Base[8]
C3 <- InitialCurves$Base[9]
k4 <- InitialCurves$Base[10]
C4 <- InitialCurves$Base[11]
k5 <- InitialCurves$Base[12]
C5 <- InitialCurves$Base[13]
# Base rate maturity coefficients
x1 <- (k1/dfInstruments$Maturity)*(1.0 - exp(-dfInstruments$Maturity/k1))
x2 <- x1 - exp(-dfInstruments$Maturity/k1)
x3 <- (k2/dfInstruments$Maturity)*(1.0-exp(-dfInstruments$Maturity/k2))-
  exp(-dfInstruments$Maturity/k2)
x4 <- (k3/dfInstruments$Maturity)*(1.0-exp(-dfInstruments$Maturity/k3))-
  exp(-dfInstruments$Maturity/k3)
x5 <- (k4/dfInstruments$Maturity)*(1.0-exp(-dfInstruments$Maturity/k4))-
  exp(-dfInstruments$Maturity/k4)
x6 <- (k5/dfInstruments$Maturity)*(1.0-exp(-dfInstruments$Maturity/k5))-
  exp(-dfInstruments$Maturity/k5)
dfInstruments$InitialBaseRate <- L + S*x1 + C1*x2 + C2*x3 + C3*x4 + C4*x5 + C5*x6
# Base rate maturity coefficients at Horizon
M <- dfInstruments$Maturity-Horizon
LengthM = length(M)
for(i in 1:LengthM){ # Cannot have zero in LSC model
  if(M[i] == 0)M[i] <- 0.000001
}
x1 <- (k1/M)*(1.0 - exp(-M/k1))
x2 <- x1 - exp(-M/k1)
x3 <- (k2/M)*(1.0-exp(-M/k2))-exp(-M/k2)
x4 <- (k3/M)*(1.0-exp(-M/k3))-exp(-M/k3)
x5 <- (k4/M)*(1.0-exp(-M/k4))-exp(-M/k4)
x6 <- (k5/M)*(1.0-exp(-M/k5))-exp(-M/k5)
dfInstruments$InitialBaseRateAtHorizon <- L + S*x1 + C1*x2 + C2*x3 + C3*x4 + C4*x5 + C5*x6

# Initial Spread1 Rates
L <- InitialCurves$Spread1[2]
k1 <- InitialCurves$Spread1[3]
S <- InitialCurves$Spread1[4]
C1 <- InitialCurves$Spread1[5]
k2 <- InitialCurves$Spread1[6]
C2 <- InitialCurves$Spread1[7]
k3 <- InitialCurves$Spread1[8]
C3 <- InitialCurves$Spread1[9]
k4 <- InitialCurves$Spread1[10]
C4 <- InitialCurves$Spread1[11]
k5 <- InitialCurves$Spread1[12]
C5 <- InitialCurves$Spread1[13]
# Spread1 rate maturity coefficients
x1 <- (k1/dfInstruments$Maturity)*(1.0 - exp(-dfInstruments$Maturity/k1))
x2 <- x1 - exp(-dfInstruments$Maturity/k1)
x3 <- (k2/dfInstruments$Maturity)*(1.0-exp(-dfInstruments$Maturity/k2))-
  exp(-dfInstruments$Maturity/k2)
x4 <- (k3/dfInstruments$Maturity)*(1.0-exp(-dfInstruments$Maturity/k3))-
  exp(-dfInstruments$Maturity/k3)
x5 <- (k4/dfInstruments$Maturity)*(1.0-exp(-dfInstruments$Maturity/k4))-
  exp(-dfInstruments$Maturity/k4)
x6 <- (k5/dfInstruments$Maturity)*(1.0-exp(-dfInstruments$Maturity/k5))-
  exp(-dfInstruments$Maturity/k5)
dfInstruments$InitialSpread1Rate <- L + S*x1 + C1*x2 + C2*x3 + C3*x4 + C4*x5 + C5*x6
# Spread1 rate maturity coefficients at Horizon
x1 <- (k1/M)*(1.0 - exp(-M/k1))
x2 <- x1 - exp(-M/k1)
x3 <- (k2/M)*(1.0-exp(-M/k2))-exp(-M/k2)
x4 <- (k3/M)*(1.0-exp(-M/k3))-exp(-M/k3)
x5 <- (k4/M)*(1.0-exp(-M/k4))-exp(-M/k4)
x6 <- (k5/M)*(1.0-exp(-M/k5))-exp(-M/k5)
dfInstruments$InitialSpread1RateAtHorizon <- L + S*x1 + C1*x2 + C2*x3 + C3*x4 + C4*x5 + C5*x6
# Initial Spread2 Rates
L <- InitialCurves$Spread2[2]
k1 <- InitialCurves$Spread2[3]
S <- InitialCurves$Spread2[4]
C1 <- InitialCurves$Spread2[5]
k2 <- InitialCurves$Spread2[6]
C2 <- InitialCurves$Spread2[7]
k3 <- InitialCurves$Spread2[8]
C3 <- InitialCurves$Spread2[9]
k4 <- InitialCurves$Spread2[10]
C4 <- InitialCurves$Spread2[11]
k5 <- InitialCurves$Spread2[12]
C5 <- InitialCurves$Spread2[13]
# Spread2 rate maturity coefficients
x1 <- (k1/dfInstruments$Maturity)*(1.0 - exp(-dfInstruments$Maturity/k1))
x2 <- x1 - exp(-dfInstruments$Maturity/k1)
x3 <- (k2/dfInstruments$Maturity)*(1.0-exp(-dfInstruments$Maturity/k2))-
  exp(-dfInstruments$Maturity/k2)
x4 <- (k3/dfInstruments$Maturity)*(1.0-exp(-dfInstruments$Maturity/k3))-
  exp(-dfInstruments$Maturity/k3)
x5 <- (k4/dfInstruments$Maturity)*(1.0-exp(-dfInstruments$Maturity/k4))-
  exp(-dfInstruments$Maturity/k4)
x6 <- (k5/dfInstruments$Maturity)*(1.0-exp(-dfInstruments$Maturity/k5))-
  exp(-dfInstruments$Maturity/k5)
dfInstruments$InitialSpread2Rate <- L + S*x1 + C1*x2 + C2*x3 + C3*x4 + C4*x5 + C5*x6
# Spread2 rate maturity coefficients at Horizon
x1 <- (k1/M)*(1.0 - exp(-M/k1))
x2 <- x1 - exp(-M/k1)
x3 <- (k2/M)*(1.0-exp(-M/k2))-exp(-M/k2)
x4 <- (k3/M)*(1.0-exp(-M/k3))-exp(-M/k3)
x5 <- (k4/M)*(1.0-exp(-M/k4))-exp(-M/k4)
x6 <- (k5/M)*(1.0-exp(-M/k5))-exp(-M/k5)
dfInstruments$InitialSpread2RateAtHorizon <- L + S*x1 + C1*x2 + C2*x3 + C3*x4 + C4*x5 + C5*x6
# Initial Spread3 Rates
L <- InitialCurves$Spread3[2]
k1 <- InitialCurves$Spread3[3]
S <- InitialCurves$Spread3[4]
C1 <- InitialCurves$Spread3[5]
k2 <- InitialCurves$Spread3[6]
C2 <- InitialCurves$Spread3[7]
k3 <- InitialCurves$Spread3[8]
C3 <- InitialCurves$Spread3[9]
k4 <- InitialCurves$Spread3[10]
C4 <- InitialCurves$Spread3[11]
k5 <- InitialCurves$Spread3[12]
C5 <- InitialCurves$Spread3[13]
# Spread3 rate maturity coefficients
x1 <- (k1/dfInstruments$Maturity)*(1.0 - exp(-dfInstruments$Maturity/k1))
x2 <- x1 - exp(-dfInstruments$Maturity/k1)
x3 <- (k2/dfInstruments$Maturity)*(1.0-exp(-dfInstruments$Maturity/k2))-
  exp(-dfInstruments$Maturity/k2)
x4 <- (k3/dfInstruments$Maturity)*(1.0-exp(-dfInstruments$Maturity/k3))-
  exp(-dfInstruments$Maturity/k3)
x5 <- (k4/dfInstruments$Maturity)*(1.0-exp(-dfInstruments$Maturity/k4))-
  exp(-dfInstruments$Maturity/k4)
x6 <- (k5/dfInstruments$Maturity)*(1.0-exp(-dfInstruments$Maturity/k5))-
  exp(-dfInstruments$Maturity/k5)
dfInstruments$InitialSpread3Rate <- L + S*x1 + C1*x2 + C2*x3 + C3*x4 + C4*x5 + C5*x6
# Spread3 rate maturity coefficients at Horizon
x1 <- (k1/M)*(1.0 - exp(-M/k1))
x2 <- x1 - exp(-M/k1)
x3 <- (k2/M)*(1.0-exp(-M/k2))-exp(-M/k2)
x4 <- (k3/M)*(1.0-exp(-M/k3))-exp(-M/k3)
x5 <- (k4/M)*(1.0-exp(-M/k4))-exp(-M/k4)
x6 <- (k5/M)*(1.0-exp(-M/k5))-exp(-M/k5)
dfInstruments$InitialSpread3RateAtHorizon <- L + S*x1 + C1*x2 + C2*x3 + C3*x4 + C4*x5 + C5*x6
# Initial Spread4 Rates
L <- InitialCurves$Spread4[2]
k1 <- InitialCurves$Spread4[3]
S <- InitialCurves$Spread4[4]
C1 <- InitialCurves$Spread4[5]
k2 <- InitialCurves$Spread4[6]
C2 <- InitialCurves$Spread4[7]
k3 <- InitialCurves$Spread4[8]
C3 <- InitialCurves$Spread4[9]
k4 <- InitialCurves$Spread4[10]
C4 <- InitialCurves$Spread4[11]
k5 <- InitialCurves$Spread4[12]
C5 <- InitialCurves$Spread4[13]
# Spread4 rate maturity coefficients
x1 <- (k1/dfInstruments$Maturity)*(1.0 - exp(-dfInstruments$Maturity/k1))
x2 <- x1 - exp(-dfInstruments$Maturity/k1)
x3 <- (k2/dfInstruments$Maturity)*(1.0-exp(-dfInstruments$Maturity/k2))-
  exp(-dfInstruments$Maturity/k2)
x4 <- (k3/dfInstruments$Maturity)*(1.0-exp(-dfInstruments$Maturity/k3))-
  exp(-dfInstruments$Maturity/k3)
x5 <- (k4/dfInstruments$Maturity)*(1.0-exp(-dfInstruments$Maturity/k4))-
  exp(-dfInstruments$Maturity/k4)
x6 <- (k5/dfInstruments$Maturity)*(1.0-exp(-dfInstruments$Maturity/k5))-
  exp(-dfInstruments$Maturity/k5)
dfInstruments$InitialSpread4Rate <- L + S*x1 + C1*x2 + C2*x3 + C3*x4 + C4*x5 + C5*x6
# Spread4 rate maturity coefficients at Horizon
x1 <- (k1/M)*(1.0 - exp(-M/k1))
x2 <- x1 - exp(-M/k1)
x3 <- (k2/M)*(1.0-exp(-M/k2))-exp(-M/k2)
x4 <- (k3/M)*(1.0-exp(-M/k3))-exp(-M/k3)
x5 <- (k4/M)*(1.0-exp(-M/k4))-exp(-M/k4)
x6 <- (k5/M)*(1.0-exp(-M/k5))-exp(-M/k5)
dfInstruments$InitialSpread4RateAtHorizon <- L + S*x1 + C1*x2 + C2*x3 + C3*x4 + C4*x5 + C5*x6
# Initial Spread5 Rates
L <- InitialCurves$Spread5[2]
k1 <- InitialCurves$Spread5[3]
S <- InitialCurves$Spread5[4]
C1 <- InitialCurves$Spread5[5]
k2 <- InitialCurves$Spread5[6]
C2 <- InitialCurves$Spread5[7]
k3 <- InitialCurves$Spread5[8]
C3 <- InitialCurves$Spread5[9]
k4 <- InitialCurves$Spread5[10]
C4 <- InitialCurves$Spread5[11]
k5 <- InitialCurves$Spread5[12]
C5 <- InitialCurves$Spread5[13]
# Spread5 rate maturity coefficients
x1 <- (k1/dfInstruments$Maturity)*(1.0 - exp(-dfInstruments$Maturity/k1))
x2 <- x1 - exp(-dfInstruments$Maturity/k1)
x3 <- (k2/dfInstruments$Maturity)*(1.0-exp(-dfInstruments$Maturity/k2))-
  exp(-dfInstruments$Maturity/k2)
x4 <- (k3/dfInstruments$Maturity)*(1.0-exp(-dfInstruments$Maturity/k3))-
  exp(-dfInstruments$Maturity/k3)
x5 <- (k4/dfInstruments$Maturity)*(1.0-exp(-dfInstruments$Maturity/k4))-
  exp(-dfInstruments$Maturity/k4)
x6 <- (k5/dfInstruments$Maturity)*(1.0-exp(-dfInstruments$Maturity/k5))-
  exp(-dfInstruments$Maturity/k5)
dfInstruments$InitialSpread5Rate <- L + S*x1 + C1*x2 + C2*x3 + C3*x4 + C4*x5 + C5*x6
# Spread5 rate maturity coefficients at Horizon
x1 <- (k1/M)*(1.0 - exp(-M/k1))
x2 <- x1 - exp(-M/k1)
x3 <- (k2/M)*(1.0-exp(-M/k2))-exp(-M/k2)
x4 <- (k3/M)*(1.0-exp(-M/k3))-exp(-M/k3)
x5 <- (k4/M)*(1.0-exp(-M/k4))-exp(-M/k4)
x6 <- (k5/M)*(1.0-exp(-M/k5))-exp(-M/k5)
dfInstruments$InitialSpread5RateAtHorizon <- L + S*x1 + C1*x2 + C2*x3 + C3*x4 + C4*x5 + C5*x6


# Horizon Rates (NOTE: M is maturity at horizon)
L <- HorizonCurves$Base[2]
k1 <- HorizonCurves$Base[3]
S <- HorizonCurves$Base[4]
C1 <- HorizonCurves$Base[5]
k2 <- HorizonCurves$Base[6]
C2 <- HorizonCurves$Base[7]
k3 <- HorizonCurves$Base[8]
C3 <- HorizonCurves$Base[9]
k4 <- HorizonCurves$Base[10]
C4 <- HorizonCurves$Base[11]
k5 <- HorizonCurves$Base[12]
C5 <- HorizonCurves$Base[13]
# Maturity coefficients
x1 <- (k1/M)*(1.0 - exp(-M/k1))
x2 <- x1 - exp(-M/k1)
x3 <- (k2/M)*(1.0-exp(-M/k2))-exp(-M/k2)
x4 <- (k3/M)*(1.0-exp(-M/k3))-exp(-M/k3)
x5 <- (k4/M)*(1.0-exp(-M/k4))-exp(-M/k4)
x6 <- (k5/M)*(1.0-exp(-M/k5))-exp(-M/k5)
dfInstruments$HorizonBaseRate <- L + S*x1 + C1*x2 + C2*x3 + C3*x4 + C4*x5 + C5*x6  
# Horizon Spread1 Rates
L <- HorizonCurves$Spread1[2]
k1 <- HorizonCurves$Spread1[3]
S <- HorizonCurves$Spread1[4]
C1 <- HorizonCurves$Spread1[5]
k2 <- HorizonCurves$Spread1[6]
C2 <- HorizonCurves$Spread1[7]
k3 <- HorizonCurves$Spread1[8]
C3 <- HorizonCurves$Spread1[9]
k4 <- HorizonCurves$Spread1[10]
C4 <- HorizonCurves$Spread1[11]
k5 <- HorizonCurves$Spread1[12]
C5 <- HorizonCurves$Spread1[13]
# Spread1 rate maturity coefficients
x1 <- (k1/M)*(1.0 - exp(-M/k1))
x2 <- x1 - exp(-M/k1)
x3 <- (k2/M)*(1.0-exp(-M/k2))-exp(-M/k2)
x4 <- (k3/M)*(1.0-exp(-M/k3))-exp(-M/k3)
x5 <- (k4/M)*(1.0-exp(-M/k4))-exp(-M/k4)
x6 <- (k5/M)*(1.0-exp(-M/k5))-exp(-M/k5)
dfInstruments$HorizonSpread1Rate <- L + S*x1 + C1*x2 + C2*x3 + C3*x4 + C4*x5 + C5*x6
# Horizon Spread2 Rates
L <- HorizonCurves$Spread2[2]
k1 <- HorizonCurves$Spread2[3]
S <- HorizonCurves$Spread2[4]
C1 <- HorizonCurves$Spread2[5]
k2 <- HorizonCurves$Spread2[6]
C2 <- HorizonCurves$Spread2[7]
k3 <- HorizonCurves$Spread2[8]
C3 <- HorizonCurves$Spread2[9]
k4 <- HorizonCurves$Spread2[10]
C4 <- HorizonCurves$Spread2[11]
k5 <- HorizonCurves$Spread2[12]
C5 <- HorizonCurves$Spread2[13]
# Spread2 rate maturity coefficients
x1 <- (k1/M)*(1.0 - exp(-M/k1))
x2 <- x1 - exp(-M/k1)
x3 <- (k2/M)*(1.0-exp(-M/k2))-exp(-M/k2)
x4 <- (k3/M)*(1.0-exp(-M/k3))-exp(-M/k3)
x5 <- (k4/M)*(1.0-exp(-M/k4))-exp(-M/k4)
x6 <- (k5/M)*(1.0-exp(-M/k5))-exp(-M/k5)
dfInstruments$HorizonSpread2Rate <- L + S*x1 + C1*x2 + C2*x3 + C3*x4 + C4*x5 + C5*x6
# Horizon Spread3 Rates
L <- HorizonCurves$Spread3[2]
k1 <- HorizonCurves$Spread3[3]
S <- HorizonCurves$Spread3[4]
C1 <- HorizonCurves$Spread3[5]
k2 <- HorizonCurves$Spread3[6]
C2 <- HorizonCurves$Spread3[7]
k3 <- HorizonCurves$Spread3[8]
C3 <- HorizonCurves$Spread3[9]
k4 <- HorizonCurves$Spread3[10]
C4 <- HorizonCurves$Spread3[11]
k5 <- HorizonCurves$Spread3[12]
C5 <- HorizonCurves$Spread3[13]
# Spread3 rate maturity coefficients
x1 <- (k1/M)*(1.0 - exp(-M/k1))
x2 <- x1 - exp(-M/k1)
x3 <- (k2/M)*(1.0-exp(-M/k2))-exp(-M/k2)
x4 <- (k3/M)*(1.0-exp(-M/k3))-exp(-M/k3)
x5 <- (k4/M)*(1.0-exp(-M/k4))-exp(-M/k4)
x6 <- (k5/M)*(1.0-exp(-M/k5))-exp(-M/k5)
dfInstruments$HorizonSpread3Rate <- L + S*x1 + C1*x2 + C2*x3 + C3*x4 + C4*x5 + C5*x6
# Horizon Spread4 Rates
L <- HorizonCurves$Spread4[2]
k1 <- HorizonCurves$Spread4[3]
S <- HorizonCurves$Spread4[4]
C1 <- HorizonCurves$Spread4[5]
k2 <- HorizonCurves$Spread4[6]
C2 <- HorizonCurves$Spread4[7]
k3 <- HorizonCurves$Spread4[8]
C3 <- HorizonCurves$Spread4[9]
k4 <- HorizonCurves$Spread4[10]
C4 <- HorizonCurves$Spread4[11]
k5 <- HorizonCurves$Spread4[12]
C5 <- HorizonCurves$Spread4[13]
# Spread4 rate maturity coefficients
x1 <- (k1/M)*(1.0 - exp(-M/k1))
x2 <- x1 - exp(-M/k1)
x3 <- (k2/M)*(1.0-exp(-M/k2))-exp(-M/k2)
x4 <- (k3/M)*(1.0-exp(-M/k3))-exp(-M/k3)
x5 <- (k4/M)*(1.0-exp(-M/k4))-exp(-M/k4)
x6 <- (k5/M)*(1.0-exp(-M/k5))-exp(-M/k5)
dfInstruments$HorizonSpread4Rate <- L + S*x1 + C1*x2 + C2*x3 + C3*x4 + C4*x5 + C5*x6
# Horizon Spread5 Rates
L <- HorizonCurves$Spread5[2]
k1 <- HorizonCurves$Spread5[3]
S <- HorizonCurves$Spread5[4]
C1 <- HorizonCurves$Spread5[5]
k2 <- HorizonCurves$Spread5[6]
C2 <- HorizonCurves$Spread5[7]
k3 <- HorizonCurves$Spread5[8]
C3 <- HorizonCurves$Spread5[9]
k4 <- HorizonCurves$Spread5[10]
C4 <- HorizonCurves$Spread5[11]
k5 <- HorizonCurves$Spread5[12]
C5 <- HorizonCurves$Spread5[13]
# Spread5 rate maturity coefficients
x1 <- (k1/M)*(1.0 - exp(-M/k1))
x2 <- x1 - exp(-M/k1)
x3 <- (k2/M)*(1.0-exp(-M/k2))-exp(-M/k2)
x4 <- (k3/M)*(1.0-exp(-M/k3))-exp(-M/k3)
x5 <- (k4/M)*(1.0-exp(-M/k4))-exp(-M/k4)
x6 <- (k5/M)*(1.0-exp(-M/k5))-exp(-M/k5)
dfInstruments$HorizonSpread5Rate <- L + S*x1 + C1*x2 + C2*x3 + C3*x4 + C4*x5 + C5*x6
dfInstruments$InitialDiscountRate <- dfInstruments$WBase*dfInstruments$InitialBaseRate + 
  dfInstruments$WSpread1*dfInstruments$InitialSpread1Rate + 
  dfInstruments$WSpread2*dfInstruments$InitialSpread2Rate + 
  dfInstruments$WSpread3*dfInstruments$InitialSpread3Rate + 
  dfInstruments$WSpread4*dfInstruments$InitialSpread4Rate + 
  dfInstruments$WSpread4*dfInstruments$InitialSpread5Rate
dfInstruments$InitialDiscountRateAtHorizon <- dfInstruments$WBase*dfInstruments$InitialBaseRateAtHorizon + 
  dfInstruments$WSpread1*dfInstruments$InitialSpread1RateAtHorizon + 
  dfInstruments$WSpread2*dfInstruments$InitialSpread2RateAtHorizon + 
  dfInstruments$WSpread3*dfInstruments$InitialSpread3RateAtHorizon + 
  dfInstruments$WSpread4*dfInstruments$InitialSpread4RateAtHorizon + 
  dfInstruments$WSpread4*dfInstruments$InitialSpread5RateAtHorizon
dfInstruments$HorizonDiscountRate <- dfInstruments$WBase*dfInstruments$HorizonBaseRate + 
  dfInstruments$WSpread1*dfInstruments$HorizonSpread1Rate + 
  dfInstruments$WSpread2*dfInstruments$HorizonSpread2Rate + 
  dfInstruments$WSpread3*dfInstruments$HorizonSpread3Rate + 
  dfInstruments$WSpread4*dfInstruments$HorizonSpread4Rate + 
  dfInstruments$WSpread5*dfInstruments$HorizonSpread5Rate
# Work on incremental analysis
dfInstruments$HorizonDiscountRateBase <- dfInstruments$WBase*dfInstruments$HorizonBaseRate + 
  dfInstruments$WSpread1*dfInstruments$InitialSpread1RateAtHorizon + 
  dfInstruments$WSpread2*dfInstruments$InitialSpread2RateAtHorizon + 
  dfInstruments$WSpread3*dfInstruments$InitialSpread3RateAtHorizon + 
  dfInstruments$WSpread4*dfInstruments$InitialSpread4RateAtHorizon + 
  dfInstruments$WSpread5*dfInstruments$InitialSpread5RateAtHorizon
dfInstruments$HorizonDiscountRateSpread1 <- dfInstruments$WBase*dfInstruments$InitialBaseRateAtHorizon + 
  dfInstruments$WSpread1*dfInstruments$HorizonSpread1Rate + 
  dfInstruments$WSpread2*dfInstruments$InitialSpread2RateAtHorizon + 
  dfInstruments$WSpread3*dfInstruments$InitialSpread3RateAtHorizon + 
  dfInstruments$WSpread4*dfInstruments$InitialSpread4RateAtHorizon + 
  dfInstruments$WSpread5*dfInstruments$InitialSpread5RateAtHorizon
dfInstruments$HorizonDiscountRateSpread2 <- dfInstruments$WBase*dfInstruments$InitialBaseRateAtHorizon + 
  dfInstruments$WSpread1*dfInstruments$InitialSpread1RateAtHorizon + 
  dfInstruments$WSpread2*dfInstruments$HorizonSpread2Rate + 
  dfInstruments$WSpread3*dfInstruments$InitialSpread3RateAtHorizon + 
  dfInstruments$WSpread4*dfInstruments$InitialSpread4RateAtHorizon + 
  dfInstruments$WSpread5*dfInstruments$InitialSpread5RateAtHorizon
dfInstruments$HorizonDiscountRateSpread3 <- dfInstruments$WBase*dfInstruments$InitialBaseRateAtHorizon + 
  dfInstruments$WSpread1*dfInstruments$InitialSpread1RateAtHorizon + 
  dfInstruments$WSpread2*dfInstruments$InitialSpread2RateAtHorizon + 
  dfInstruments$WSpread3*dfInstruments$HorizonSpread3Rate + 
  dfInstruments$WSpread4*dfInstruments$InitialSpread4RateAtHorizon + 
  dfInstruments$WSpread5*dfInstruments$InitialSpread5RateAtHorizon
dfInstruments$HorizonDiscountRateSpread4 <- dfInstruments$WBase*dfInstruments$InitialBaseRateAtHorizon + 
  dfInstruments$WSpread1*dfInstruments$InitialSpread1RateAtHorizon + 
  dfInstruments$WSpread2*dfInstruments$InitialSpread2RateAtHorizon + 
  dfInstruments$WSpread3*dfInstruments$InitialSpread3RateAtHorizon + 
  dfInstruments$WSpread4*dfInstruments$HorizonSpread4Rate + 
  dfInstruments$WSpread5*dfInstruments$InitialSpread5RateAtHorizon
dfInstruments$HorizonDiscountRateSpread5 <- dfInstruments$WBase*dfInstruments$InitialBaseRateAtHorizon + 
  dfInstruments$WSpread1*dfInstruments$InitialSpread1RateAtHorizon + 
  dfInstruments$WSpread2*dfInstruments$InitialSpread2RateAtHorizon + 
  dfInstruments$WSpread3*dfInstruments$InitialSpread3RateAtHorizon + 
  dfInstruments$WSpread4*dfInstruments$InitialSpread4RateAtHorizon + 
  dfInstruments$WSpread5*dfInstruments$HorizonSpread5Rate

