# KM Reports C4F3.R

RiskMeasuresC4F3 <- Reduce(function(x, y) merge(x, y, all=TRUE), 
  list(dfReportedBalanceSheet, dfPVBalanceSheet, dfPVBalanceSheetAtHorizonInitial,
  dfPVBalanceSheetAtHorizonBase, dfPVBalanceSheetAtHorizonSpread1, dfPVBalanceSheetAtHorizonSpread2, 
  dfPVBalanceSheetAtHorizonSpread3, dfPVBalanceSheetAtHorizonAll,   
  dfBaseDurationLevel, dfBaseDurationSlope, dfBaseDurationCurve1,
  dfBaseConvexityLevel, dfBaseConvexitySlope, dfBaseConvexityCurve1,
  dfBaseCrossConvexityCCLS, dfBaseCrossConvexityCCLC1, dfBaseCrossConvexityCCSC1,
  dfSpread1DurationLevel, dfSpread1DurationSlope, dfSpread1DurationCurve1,
  dfSpread1ConvexityLevel, dfSpread1ConvexitySlope, dfSpread1ConvexityCurve1,
  dfSpread1CrossConvexityCCLS, dfSpread1CrossConvexityCCLC1, dfSpread1CrossConvexityCCSC1,
  dfSpread2DurationLevel, dfSpread2DurationSlope, dfSpread2DurationCurve1,
  dfSpread2ConvexityLevel, dfSpread2ConvexitySlope, dfSpread2ConvexityCurve1,
  dfSpread2CrossConvexityCCLS, dfSpread2CrossConvexityCCLC1, dfSpread2CrossConvexityCCSC1,
  dfSpread3DurationLevel, dfSpread3DurationSlope, dfSpread3DurationCurve1,
  dfSpread3ConvexityLevel, dfSpread3ConvexitySlope, dfSpread3ConvexityCurve1,
  dfSpread3CrossConvexityCCLS, dfSpread3CrossConvexityCCLC1, dfSpread3CrossConvexityCCSC1
  ))
# Add Names
RiskMeasuresC4F3$Names <- "NA"
NumberOfInstruments <- NumberOfAssets + NumberOfLiabilities
for(i in 1:(NumberOfInstruments+3)){
  if(i < (NumberOfInstruments+1)){
    RiskMeasuresC4F3$Names[i] <- KMInputs$Number[i + 6]
  }
  if(i == (NumberOfInstruments+1))RiskMeasuresC4F3$Names[i] <- "Net Worth"
  if(i == (NumberOfInstruments+2))RiskMeasuresC4F3$Names[i] <- "Total Assets"
  if(i == (NumberOfInstruments+3))RiskMeasuresC4F3$Names[i] <- "Total Liabilities"
}
RiskMeasuresC4F3$NamesIndex <- NA
for(i in 1:NumberOfAssets){
  RiskMeasuresC4F3$NamesIndex[i] <- i
}
for(i in 1:NumberOfLiabilities){
  RiskMeasuresC4F3$NamesIndex[NumberOfAssets + i] <- NumberOfAssets + 1 + i
}
j <- NumberOfAssets + 1 + NumberOfLiabilities
RiskMeasuresC4F3$NamesIndex[j] <- j + 2
RiskMeasuresC4F3$NamesIndex[j+1] <- NumberOfAssets + 1
RiskMeasuresC4F3$NamesIndex[j+2] <- j + 1
TA <- RiskMeasuresC4F3[NumberOfInstruments+2,]
TA$Names <- "Total Liab/Eq"
TA$NamesIndex <- j+3
#TA
RiskMeasuresC4F3 <- rbind(RiskMeasuresC4F3, y = c(TA))
# Reorder data frames
#arrange(RiskMeasuresC4F3, NamesIndex)
RiskMeasuresC4F3 <- RiskMeasuresC4F3[order(RiskMeasuresC4F3$NamesIndex), , drop = FALSE]
# Reorder by column name
RiskMeasuresC4F3$Instrument <- NULL
RiskMeasuresC4F3$NamesIndex <- NULL
refcols <- c("Names", "StatedValue", "EstimatedValue", "EstimatedValueAtHorizon", "EstimatedValueAtHorizonAll",
  "EstimatedValueAtHorizonBase", "EstimatedValueAtHorizonSpread1", "EstimatedValueAtHorizonSpread2", "EstimatedValueAtHorizonSpread3",
  "BaseDurationLevel", "BaseDurationSlope", "BaseDurationCurve1", 
  "BaseConvexityLevel", "BaseConvexitySlope", "BaseConvexityCurve1",                            
  "BaseCrossConvexityCCLS", "BaseCrossConvexityCCLC1", "BaseCrossConvexityCCSC1", 
  "Spread1DurationLevel", "Spread1DurationSlope", "Spread1DurationCurve1", 
  "Spread1ConvexityLevel", "Spread1ConvexitySlope", "Spread1ConvexityCurve1",                            
  "Spread1CrossConvexityCCLS", "Spread1CrossConvexityCCLC1", "Spread1CrossConvexityCCSC1",
  "Spread2DurationLevel", "Spread2DurationSlope", "Spread2DurationCurve1", 
  "Spread2ConvexityLevel", "Spread2ConvexitySlope", "Spread2ConvexityCurve1",                            
  "Spread2CrossConvexityCCLS", "Spread2CrossConvexityCCLC1", "Spread2CrossConvexityCCSC1",
  "Spread3DurationLevel", "Spread3DurationSlope", "Spread3DurationCurve1", 
  "Spread3ConvexityLevel", "Spread3ConvexitySlope", "Spread3ConvexityCurve1",                            
  "Spread3CrossConvexityCCLS", "Spread3CrossConvexityCCLC1", "Spread3CrossConvexityCCSC1"
)
RiskMeasuresC4F3 <- RiskMeasuresC4F3[,refcols]
# Convert liabilities to positive values
N <- NumberOfLiabilities+2
for(i in 1:N){
  RiskMeasuresC4F3$StatedValue[NumberOfAssets+1+i] <- -RiskMeasuresC4F3$StatedValue[NumberOfAssets+1+i]
  RiskMeasuresC4F3$EstimatedValue[NumberOfAssets+1+i] <- -RiskMeasuresC4F3$EstimatedValue[NumberOfAssets+1+i]
  RiskMeasuresC4F3$EstimatedValueAtHorizon[NumberOfAssets+1+i] <- -RiskMeasuresC4F3$EstimatedValueAtHorizon[NumberOfAssets+1+i]
  RiskMeasuresC4F3$EstimatedValueAtHorizonAll[NumberOfAssets+1+i] <- -RiskMeasuresC4F3$EstimatedValueAtHorizonAll[NumberOfAssets+1+i]
  RiskMeasuresC4F3$EstimatedValueAtHorizonBase[NumberOfAssets+1+i] <- -RiskMeasuresC4F3$EstimatedValueAtHorizonBase[NumberOfAssets+1+i]
  RiskMeasuresC4F3$EstimatedValueAtHorizonSpread1[NumberOfAssets+1+i] <- -RiskMeasuresC4F3$EstimatedValueAtHorizonSpread1[NumberOfAssets+1+i]
  RiskMeasuresC4F3$EstimatedValueAtHorizonSpread2[NumberOfAssets+1+i] <- -RiskMeasuresC4F3$EstimatedValueAtHorizonSpread2[NumberOfAssets+1+i]
  RiskMeasuresC4F3$EstimatedValueAtHorizonSpread3[NumberOfAssets+1+i] <- -RiskMeasuresC4F3$EstimatedValueAtHorizonSpread3[NumberOfAssets+1+i]
}
write.xlsx(RiskMeasuresC4F3, "KM Static Risk Measures C4F3.xlsx")
#
# Factor Sensitivities
#
BRLevelChange <- HorizonCurves$Base[2] - InitialCurves$Base[2]
BRSlopeChange <- HorizonCurves$Base[4] - InitialCurves$Base[4]
BRCurve1Change <- HorizonCurves$Base[5] - InitialCurves$Base[5]
SP1LevelChange <- HorizonCurves$Spread1[2] - InitialCurves$Spread1[2]
SP1SlopeChange <- HorizonCurves$Spread1[4] - InitialCurves$Spread1[4]
SP1Curve1Change <- HorizonCurves$Spread1[5] - InitialCurves$Spread1[5]
SP2LevelChange <- HorizonCurves$Spread2[2] - InitialCurves$Spread2[2]
SP2SlopeChange <- HorizonCurves$Spread2[4] - InitialCurves$Spread2[4]
SP2Curve1Change <- HorizonCurves$Spread2[5] - InitialCurves$Spread2[5]
SP3LevelChange <- HorizonCurves$Spread3[2] - InitialCurves$Spread3[2]
SP3SlopeChange <- HorizonCurves$Spread3[4] - InitialCurves$Spread3[4]
SP3Curve1Change <- HorizonCurves$Spread3[5] - InitialCurves$Spread3[5]
FactorSensitivitiesC4F3 <- RiskMeasuresC4F3
keeps <- c("Names")
FactorSensitivitiesC4F3 <- FactorSensitivitiesC4F3[keeps]
FactorSensitivitiesC4F3$BaseDurationLevel <- -RiskMeasuresC4F3$BaseDurationLevel * (BRLevelChange/100.0) * RiskMeasuresC4F3$EstimatedValueAtHorizon
FactorSensitivitiesC4F3$BaseDurationSlope <- -RiskMeasuresC4F3$BaseDurationSlope * (BRSlopeChange/100.0) * RiskMeasuresC4F3$EstimatedValueAtHorizon  
FactorSensitivitiesC4F3$BaseDurationCurve1 <- -RiskMeasuresC4F3$BaseDurationCurve1 * (BRCurve1Change/100.0) * RiskMeasuresC4F3$EstimatedValueAtHorizon  
FactorSensitivitiesC4F3$BaseConvexityLevel <- 0.5*RiskMeasuresC4F3$BaseConvexityLevel * (BRLevelChange/100.0)^2 * RiskMeasuresC4F3$EstimatedValueAtHorizon
FactorSensitivitiesC4F3$BaseConvexitySlope <- 0.5*RiskMeasuresC4F3$BaseConvexitySlope * (BRSlopeChange/100.0)^2 * RiskMeasuresC4F3$EstimatedValueAtHorizon  
FactorSensitivitiesC4F3$BaseConvexityCurve1 <- 0.5*RiskMeasuresC4F3$BaseConvexityCurve1 * (BRCurve1Change/100.0)^2 * RiskMeasuresC4F3$EstimatedValueAtHorizon  
FactorSensitivitiesC4F3$BaseCrossConvexityCCLS <- RiskMeasuresC4F3$BaseCrossConvexityCCLS * (BRLevelChange/100.0) * (BRSlopeChange/100.0) * RiskMeasuresC4F3$EstimatedValueAtHorizon
FactorSensitivitiesC4F3$BaseCrossConvexityCCLC1 <- RiskMeasuresC4F3$BaseCrossConvexityCCLC1 * (BRLevelChange/100.0) * (BRCurve1Change/100.0) * RiskMeasuresC4F3$EstimatedValueAtHorizon  
FactorSensitivitiesC4F3$BaseCrossConvexityCCSC1 <- RiskMeasuresC4F3$BaseCrossConvexityCCSC1 * (BRSlopeChange/100.0) * (BRCurve1Change/100.0) * RiskMeasuresC4F3$EstimatedValueAtHorizon  
FactorSensitivitiesC4F3$Spread1DurationLevel <- -RiskMeasuresC4F3$Spread1DurationLevel * (SP1LevelChange/100.0) * RiskMeasuresC4F3$EstimatedValueAtHorizon
FactorSensitivitiesC4F3$Spread1DurationSlope <- -RiskMeasuresC4F3$Spread1DurationSlope * (SP1SlopeChange/100.0) * RiskMeasuresC4F3$EstimatedValueAtHorizon  
FactorSensitivitiesC4F3$Spread1DurationCurve1 <- -RiskMeasuresC4F3$Spread1DurationCurve1 * (SP1Curve1Change/100.0) * RiskMeasuresC4F3$EstimatedValueAtHorizon  
FactorSensitivitiesC4F3$Spread1ConvexityLevel <- 0.5*RiskMeasuresC4F3$Spread1ConvexityLevel * (SP1LevelChange/100.0)^2 * RiskMeasuresC4F3$EstimatedValueAtHorizon
FactorSensitivitiesC4F3$Spread1ConvexitySlope <- 0.5*RiskMeasuresC4F3$Spread1ConvexitySlope * (SP1SlopeChange/100.0)^2 * RiskMeasuresC4F3$EstimatedValueAtHorizon  
FactorSensitivitiesC4F3$Spread1ConvexityCurve1 <- 0.5*RiskMeasuresC4F3$Spread1ConvexityCurve1 * (SP1Curve1Change/100.0)^2 * RiskMeasuresC4F3$EstimatedValueAtHorizon  
FactorSensitivitiesC4F3$Spread1CrossConvexityCCLS <- RiskMeasuresC4F3$Spread1CrossConvexityCCLS * (SP1LevelChange/100.0)* (SP1SlopeChange/100.0) * RiskMeasuresC4F3$EstimatedValueAtHorizon
FactorSensitivitiesC4F3$Spread1CrossConvexityCCLC1 <- RiskMeasuresC4F3$Spread1CrossConvexityCCLC1 * (SP1LevelChange/100.0) * (SP1Curve1Change/100.0) * RiskMeasuresC4F3$EstimatedValueAtHorizon  
FactorSensitivitiesC4F3$Spread1CrossConvexityCCSC1 <- RiskMeasuresC4F3$Spread1CrossConvexityCCSC1 * (SP1SlopeChange/100.0) * (SP1Curve1Change/100.0) * RiskMeasuresC4F3$EstimatedValueAtHorizon  
FactorSensitivitiesC4F3$Spread2DurationLevel <- -RiskMeasuresC4F3$Spread2DurationLevel * (SP2LevelChange/100.0) * RiskMeasuresC4F3$EstimatedValueAtHorizon
FactorSensitivitiesC4F3$Spread2DurationSlope <- -RiskMeasuresC4F3$Spread2DurationSlope * (SP2SlopeChange/100.0) * RiskMeasuresC4F3$EstimatedValueAtHorizon  
FactorSensitivitiesC4F3$Spread2DurationCurve1 <- -RiskMeasuresC4F3$Spread2DurationCurve1 * (SP2Curve1Change/100.0) * RiskMeasuresC4F3$EstimatedValueAtHorizon  
FactorSensitivitiesC4F3$Spread2ConvexityLevel <- 0.5*RiskMeasuresC4F3$Spread2ConvexityLevel * (SP2LevelChange/100.0)^2 * RiskMeasuresC4F3$EstimatedValueAtHorizon
FactorSensitivitiesC4F3$Spread2ConvexitySlope <- 0.5*RiskMeasuresC4F3$Spread2ConvexitySlope * (SP2SlopeChange/100.0)^2 * RiskMeasuresC4F3$EstimatedValueAtHorizon  
FactorSensitivitiesC4F3$Spread2ConvexityCurve1 <- 0.5*RiskMeasuresC4F3$Spread2ConvexityCurve1 * (SP2Curve1Change/100.0)^2 * RiskMeasuresC4F3$EstimatedValueAtHorizon  
FactorSensitivitiesC4F3$Spread2CrossConvexityCCLS <- RiskMeasuresC4F3$Spread2CrossConvexityCCLS * (SP2LevelChange/100.0)* (SP2SlopeChange/100.0) * RiskMeasuresC4F3$EstimatedValueAtHorizon
FactorSensitivitiesC4F3$Spread2CrossConvexityCCLC1 <- RiskMeasuresC4F3$Spread2CrossConvexityCCLC1 * (SP2LevelChange/100.0) * (SP2Curve1Change/100.0) * RiskMeasuresC4F3$EstimatedValueAtHorizon  
FactorSensitivitiesC4F3$Spread2CrossConvexityCCSC1 <- RiskMeasuresC4F3$Spread2CrossConvexityCCSC1 * (SP2SlopeChange/100.0) * (SP2Curve1Change/100.0) * RiskMeasuresC4F3$EstimatedValueAtHorizon  
FactorSensitivitiesC4F3$Spread3DurationLevel <- -RiskMeasuresC4F3$Spread3DurationLevel * (SP3LevelChange/100.0) * RiskMeasuresC4F3$EstimatedValueAtHorizon
FactorSensitivitiesC4F3$Spread3DurationSlope <- -RiskMeasuresC4F3$Spread3DurationSlope * (SP3SlopeChange/100.0) * RiskMeasuresC4F3$EstimatedValueAtHorizon  
FactorSensitivitiesC4F3$Spread3DurationCurve1 <- -RiskMeasuresC4F3$Spread3DurationCurve1 * (SP3Curve1Change/100.0) * RiskMeasuresC4F3$EstimatedValueAtHorizon  
FactorSensitivitiesC4F3$Spread3ConvexityLevel <- 0.5*RiskMeasuresC4F3$Spread3ConvexityLevel * (SP3LevelChange/100.0)^2 * RiskMeasuresC4F3$EstimatedValueAtHorizon
FactorSensitivitiesC4F3$Spread3ConvexitySlope <- 0.5*RiskMeasuresC4F3$Spread3ConvexitySlope * (SP3SlopeChange/100.0)^2 * RiskMeasuresC4F3$EstimatedValueAtHorizon  
FactorSensitivitiesC4F3$Spread3ConvexityCurve1 <- 0.5*RiskMeasuresC4F3$Spread3ConvexityCurve1 * (SP3Curve1Change/100.0)^2 * RiskMeasuresC4F3$EstimatedValueAtHorizon  
FactorSensitivitiesC4F3$Spread3CrossConvexityCCLS <- RiskMeasuresC4F3$Spread3CrossConvexityCCLS * (SP3LevelChange/100.0)* (SP3SlopeChange/100.0) * RiskMeasuresC4F3$EstimatedValueAtHorizon
FactorSensitivitiesC4F3$Spread3CrossConvexityCCLC1 <- RiskMeasuresC4F3$Spread3CrossConvexityCCLC1 * (SP3LevelChange/100.0) * (SP3Curve1Change/100.0) * RiskMeasuresC4F3$EstimatedValueAtHorizon  
FactorSensitivitiesC4F3$Spread3CrossConvexityCCSC1 <- RiskMeasuresC4F3$Spread3CrossConvexityCCSC1 * (SP3SlopeChange/100.0) * (SP3Curve1Change/100.0) * RiskMeasuresC4F3$EstimatedValueAtHorizon  
write.xlsx(FactorSensitivitiesC4F3, "KM Factor Sensitivities C4F3.xlsx")
#
# Balance Sheet Attribution Analysis
#
AttributionC4F3 <- RiskMeasuresC4F3
keeps <- c("Names", "StatedValue", "EstimatedValue", "EstimatedValueAtHorizon", "EstimatedValueAtHorizonAll",
  "EstimatedValueAtHorizonBase", "EstimatedValueAtHorizonSpread1", "EstimatedValueAtHorizonSpread2", "EstimatedValueAtHorizonSpread3")
AttributionC4F3 = AttributionC4F3[keeps]
ChangeAll <- abs(AttributionC4F3$EstimatedValueAtHorizonAll) - abs(AttributionC4F3$StatedValue) 
AttributionC4F3$ChangeAll <- round(ChangeAll, 2)
AttributionC4F3$PercentAll <- round(100.0 * ChangeAll / abs(AttributionC4F3$StatedValue), 2)
ChangeHAAll <- abs(AttributionC4F3$EstimatedValueAtHorizonAll) - abs(AttributionC4F3$EstimatedValueAtHorizon)
AttributionC4F3$ChangeHAAll <- round(ChangeHAAll, 2)
AttributionC4F3$PercentHAAll <- round(100.0 * ChangeHAAll / abs(AttributionC4F3$EstimatedValueAtHorizon), 2)
ChangeHOnly <- abs(AttributionC4F3$EstimatedValueAtHorizon) - abs(AttributionC4F3$StatedValue)
AttributionC4F3$ChangeHOnly <- round(ChangeHOnly, 2)
AttributionC4F3$PercentHOnly <- round(100.0 * ChangeHOnly / abs(AttributionC4F3$StatedValue), 2)
ChangeBase <- abs(AttributionC4F3$EstimatedValueAtHorizonBase) - abs(AttributionC4F3$EstimatedValueAtHorizon) 
AttributionC4F3$ChangeBase <- round(ChangeBase, 2)
AttributionC4F3$PercentBase <- round(100.0 * ChangeBase / abs(AttributionC4F3$EstimatedValueAtHorizon), 2)
ChangeSpread1 <- abs(AttributionC4F3$EstimatedValueAtHorizonSpread1) - abs(AttributionC4F3$EstimatedValueAtHorizon) 
AttributionC4F3$ChangeSpread1 <- round(ChangeSpread1, 2)
AttributionC4F3$PercentSpread1 <- round(100.0 * ChangeSpread1 / abs(AttributionC4F3$EstimatedValueAtHorizon), 2)
ChangeSpread2 <- abs(AttributionC4F3$EstimatedValueAtHorizonSpread2) - abs(AttributionC4F3$EstimatedValueAtHorizon)
AttributionC4F3$ChangeSpread2 <- round(ChangeSpread2, 2)
AttributionC4F3$PercentSpread2 <- round(100.0 * ChangeSpread2 / abs(AttributionC4F3$EstimatedValueAtHorizon), 2)
ChangeInteraction <- ChangeAll - ChangeBase - ChangeSpread1 - ChangeSpread2 - ChangeHOnly
ChangeSpread3 <- abs(AttributionC4F3$EstimatedValueAtHorizonSpread3) - abs(AttributionC4F3$EstimatedValueAtHorizon)
AttributionC4F3$ChangeSpread3 <- round(ChangeSpread3, 2)
AttributionC4F3$PercentSpread3 <- round(100.0 * ChangeSpread3 / abs(AttributionC4F3$EstimatedValueAtHorizon), 2)
ChangeInteraction <- ChangeAll - ChangeBase - ChangeSpread1 - ChangeSpread2 - ChangeSpread3 - ChangeHOnly
AttributionC4F3$ChangeInteraction <- round(ChangeInteraction, 2)
AttributionC4F3$PercentInteraction <- round(100.0 * ChangeInteraction / abs(AttributionC4F3$EstimatedValueAtHorizon),2)
write.xlsx(AttributionC4F3, "KM Attribution Measures C4F3.xlsx")
#
# Further decompositions
#


#
# Formatted output
#
# Market Value Balance Sheet
MVBalanceSheet <- AttributionC4F3
keeps <- c("Names","EstimatedValue")
MVBalanceSheet = MVBalanceSheet[keeps]
MVBalanceSheet$Value <- round(abs(MVBalanceSheet$EstimatedValue), 2)
MVBalanceSheet$EstimatedValue <- NULL
MVBalanceSheet$Value <- paste0("$",formatC(as.numeric(MVBalanceSheet$Value),format="f",digits=0,big.mark=","))
write.xlsx(MVBalanceSheet, "KM Market Value Balance Sheet C4F3.xlsx")
# Duration and Convexity
DurationAndConvexity <- RiskMeasuresC4F3
DurationAndConvexity$SRDuration <- round(DurationAndConvexity$BaseDurationLevel, 2)
DurationAndConvexity$SRConvexity <- round(DurationAndConvexity$BaseConvexityLevel, 2)
DurationAndConvexity$SP1Duration <- round(DurationAndConvexity$Spread1DurationLevel, 2)
DurationAndConvexity$SP1Convexity <- round(DurationAndConvexity$Spread1ConvexityLevel, 2)
DurationAndConvexity$SP2Duration <- round(DurationAndConvexity$Spread2DurationLevel, 2)
DurationAndConvexity$SP2Convexity <- round(DurationAndConvexity$Spread2ConvexityLevel, 2)
DurationAndConvexity$SP3Duration <- round(DurationAndConvexity$Spread3DurationLevel, 2)
DurationAndConvexity$SP3Convexity <- round(DurationAndConvexity$Spread3ConvexityLevel, 2)
keeps <- c("Names","SRDuration", "SRConvexity", "SP1Duration", "SP1Convexity", "SP2Duration", "SP2Convexity", 
  "SP3Duration", "SP3Convexity")
DurationAndConvexity = DurationAndConvexity[keeps]
DurationAndConvexity$SRDuration <- formatC(as.numeric(DurationAndConvexity$SRDuration),format="f",digits=2,big.mark=",")
DurationAndConvexity$SRConvexity <- formatC(as.numeric(DurationAndConvexity$SRConvexity),format="f",digits=2,big.mark=",")
DurationAndConvexity$SP1Duration <- formatC(as.numeric(DurationAndConvexity$SP1Duration),format="f",digits=2,big.mark=",")
DurationAndConvexity$SP1Convexity <- formatC(as.numeric(DurationAndConvexity$SP1Convexity),format="f",digits=2,big.mark=",")
DurationAndConvexity$SP2Duration <- formatC(as.numeric(DurationAndConvexity$SP2Duration),format="f",digits=2,big.mark=",")
DurationAndConvexity$SP2Convexity <- formatC(as.numeric(DurationAndConvexity$SP2Convexity),format="f",digits=2,big.mark=",")
DurationAndConvexity$SP3Duration <- formatC(as.numeric(DurationAndConvexity$SP3Duration),format="f",digits=2,big.mark=",")
DurationAndConvexity$SP3Convexity <- formatC(as.numeric(DurationAndConvexity$SP3Convexity),format="f",digits=2,big.mark=",")
write.xlsx(DurationAndConvexity, "KM Level Duration and Convexity Only (Three Spreads) C4F3.xlsx")
# LSC Parameters 
LSCParameters = data.frame(matrix(vector(), 4, 13, dimnames=list(c(), 
  c("Parameter", "BRInitial", "BRHorizon", "BRDifference", "SP1Initial", "SP1Horizon", "SP1Difference",
    "SP2Initial", "SP2Horizon", "SP2Difference", "SP3Initial", "SP3Horizon", "SP3Difference"
  ))), stringsAsFactors=F)
LSCParameters$Parameter[1] <- "Level"
LSCParameters$Parameter[2] <- "Slope"
LSCParameters$Parameter[3] <- "Curvature"
LSCParameters$Parameter[4] <- "Scalar"
LSCParameters$BRInitial[1] <- paste0(formatC(as.numeric(InitialCurves$Base[2]),format="f",digits=2,big.mark=","),"%")
LSCParameters$BRInitial[2] <- paste0(formatC(as.numeric(InitialCurves$Base[4]),format="f",digits=2,big.mark=","),"%")
LSCParameters$BRInitial[3] <- paste0(formatC(as.numeric(InitialCurves$Base[5]),format="f",digits=2,big.mark=","),"%")
LSCParameters$BRInitial[4] <- paste0(formatC(as.numeric(InitialCurves$Base[3]),format="f",digits=2,big.mark=","),"%")
LSCParameters$BRHorizon[1] <- paste0(formatC(as.numeric(HorizonCurves$Base[2]),format="f",digits=2,big.mark=","),"%")
LSCParameters$BRHorizon[2] <- paste0(formatC(as.numeric(HorizonCurves$Base[4]),format="f",digits=2,big.mark=","),"%")
LSCParameters$BRHorizon[3] <- paste0(formatC(as.numeric(HorizonCurves$Base[5]),format="f",digits=2,big.mark=","),"%")
LSCParameters$BRHorizon[4] <- paste0(formatC(as.numeric(HorizonCurves$Base[3]),format="f",digits=2,big.mark=","),"%")
LSCParameters$BRDifference[1] <- paste0(formatC(as.numeric(HorizonCurves$Base[2] - InitialCurves$Base[2]),format="f",digits=2,big.mark=","),"%")
LSCParameters$BRDifference[2] <- paste0(formatC(as.numeric(HorizonCurves$Base[4] - InitialCurves$Base[4]),format="f",digits=2,big.mark=","),"%")
LSCParameters$BRDifference[3] <- paste0(formatC(as.numeric(HorizonCurves$Base[5] - InitialCurves$Base[5]),format="f",digits=2,big.mark=","),"%")
LSCParameters$BRDifference[4] <- paste0(formatC(as.numeric(HorizonCurves$Base[3] - InitialCurves$Base[3]),format="f",digits=2,big.mark=","),"%")
LSCParameters$SP1Initial[1] <- paste0(formatC(as.numeric(InitialCurves$Spread1[2]),format="f",digits=2,big.mark=","),"%")
LSCParameters$SP1Initial[2] <- paste0(formatC(as.numeric(InitialCurves$Spread1[4]),format="f",digits=2,big.mark=","),"%")
LSCParameters$SP1Initial[3] <- paste0(formatC(as.numeric(InitialCurves$Spread1[5]),format="f",digits=2,big.mark=","),"%")
LSCParameters$SP1Initial[4] <- paste0(formatC(as.numeric(InitialCurves$Spread1[3]),format="f",digits=2,big.mark=","),"%")
LSCParameters$SP1Horizon[1] <- paste0(formatC(as.numeric(HorizonCurves$Spread1[2]),format="f",digits=2,big.mark=","),"%")
LSCParameters$SP1Horizon[2] <- paste0(formatC(as.numeric(HorizonCurves$Spread1[4]),format="f",digits=2,big.mark=","),"%")
LSCParameters$SP1Horizon[3] <- paste0(formatC(as.numeric(HorizonCurves$Spread1[5]),format="f",digits=2,big.mark=","),"%")
LSCParameters$SP1Horizon[4] <- paste0(formatC(as.numeric(HorizonCurves$Spread1[3]),format="f",digits=2,big.mark=","),"%")
LSCParameters$SP1Difference[1] <- paste0(formatC(as.numeric(HorizonCurves$Spread1[2] - InitialCurves$Spread1[2]),format="f",digits=2,big.mark=","),"%")
LSCParameters$SP1Difference[2] <- paste0(formatC(as.numeric(HorizonCurves$Spread1[4] - InitialCurves$Spread1[4]),format="f",digits=2,big.mark=","),"%")
LSCParameters$SP1Difference[3] <- paste0(formatC(as.numeric(HorizonCurves$Spread1[5] - InitialCurves$Spread1[5]),format="f",digits=2,big.mark=","),"%")
LSCParameters$SP1Difference[4] <- paste0(formatC(as.numeric(HorizonCurves$Spread1[3] - InitialCurves$Spread1[3]),format="f",digits=2,big.mark=","),"%")
LSCParameters$SP2Initial[1] <- paste0(formatC(as.numeric(InitialCurves$Spread2[2]),format="f",digits=2,big.mark=","),"%")
LSCParameters$SP2Initial[2] <- paste0(formatC(as.numeric(InitialCurves$Spread2[4]),format="f",digits=2,big.mark=","),"%")
LSCParameters$SP2Initial[3] <- paste0(formatC(as.numeric(InitialCurves$Spread2[5]),format="f",digits=2,big.mark=","),"%")
LSCParameters$SP2Initial[4] <- paste0(formatC(as.numeric(InitialCurves$Spread2[3]),format="f",digits=2,big.mark=","),"%")
LSCParameters$SP2Horizon[1] <- paste0(formatC(as.numeric(HorizonCurves$Spread2[2]),format="f",digits=2,big.mark=","),"%")
LSCParameters$SP2Horizon[2] <- paste0(formatC(as.numeric(HorizonCurves$Spread2[4]),format="f",digits=2,big.mark=","),"%")
LSCParameters$SP2Horizon[3] <- paste0(formatC(as.numeric(HorizonCurves$Spread2[5]),format="f",digits=2,big.mark=","),"%")
LSCParameters$SP2Horizon[4] <- paste0(formatC(as.numeric(HorizonCurves$Spread2[3]),format="f",digits=2,big.mark=","),"%")
LSCParameters$SP2Difference[1] <- paste0(formatC(as.numeric(HorizonCurves$Spread2[2] - InitialCurves$Spread2[2]),format="f",digits=2,big.mark=","),"%")
LSCParameters$SP2Difference[2] <- paste0(formatC(as.numeric(HorizonCurves$Spread2[4] - InitialCurves$Spread2[4]),format="f",digits=2,big.mark=","),"%")
LSCParameters$SP2Difference[3] <- paste0(formatC(as.numeric(HorizonCurves$Spread2[5] - InitialCurves$Spread2[5]),format="f",digits=2,big.mark=","),"%")
LSCParameters$SP2Difference[4] <- paste0(formatC(as.numeric(HorizonCurves$Spread2[3] - InitialCurves$Spread2[3]),format="f",digits=2,big.mark=","),"%")
LSCParameters$SP3Initial[1] <- paste0(formatC(as.numeric(InitialCurves$Spread3[2]),format="f",digits=2,big.mark=","),"%")
LSCParameters$SP3Initial[2] <- paste0(formatC(as.numeric(InitialCurves$Spread3[4]),format="f",digits=2,big.mark=","),"%")
LSCParameters$SP3Initial[3] <- paste0(formatC(as.numeric(InitialCurves$Spread3[5]),format="f",digits=2,big.mark=","),"%")
LSCParameters$SP3Initial[4] <- paste0(formatC(as.numeric(InitialCurves$Spread3[3]),format="f",digits=2,big.mark=","),"%")
LSCParameters$SP3Horizon[1] <- paste0(formatC(as.numeric(HorizonCurves$Spread3[2]),format="f",digits=2,big.mark=","),"%")
LSCParameters$SP3Horizon[2] <- paste0(formatC(as.numeric(HorizonCurves$Spread3[4]),format="f",digits=2,big.mark=","),"%")
LSCParameters$SP3Horizon[3] <- paste0(formatC(as.numeric(HorizonCurves$Spread3[5]),format="f",digits=2,big.mark=","),"%")
LSCParameters$SP3Horizon[4] <- paste0(formatC(as.numeric(HorizonCurves$Spread3[3]),format="f",digits=2,big.mark=","),"%")
LSCParameters$SP3Difference[1] <- paste0(formatC(as.numeric(HorizonCurves$Spread3[2] - InitialCurves$Spread3[2]),format="f",digits=2,big.mark=","),"%")
LSCParameters$SP3Difference[2] <- paste0(formatC(as.numeric(HorizonCurves$Spread3[4] - InitialCurves$Spread3[4]),format="f",digits=2,big.mark=","),"%")
LSCParameters$SP3Difference[3] <- paste0(formatC(as.numeric(HorizonCurves$Spread3[5] - InitialCurves$Spread3[5]),format="f",digits=2,big.mark=","),"%")
LSCParameters$SP3Difference[4] <- paste0(formatC(as.numeric(HorizonCurves$Spread3[3] - InitialCurves$Spread3[3]),format="f",digits=2,big.mark=","),"%")
write.xlsx(LSCParameters, "KM LSC Parameters (Two Spreads) C4F3.xlsx")
# Balance Sheet Change (Table 23)
# Market Value Balance Sheet
MVChangeBalanceSheet <- AttributionC4F3
keeps <- c("Names","EstimatedValue", "EstimatedValueAtHorizonAll")
MVChangeBalanceSheet = MVChangeBalanceSheet[keeps]
MVChangeBalanceSheet$ActualChange <- MVChangeBalanceSheet$EstimatedValueAtHorizonAll - MVChangeBalanceSheet$EstimatedValue
MVChangeBalanceSheet$PercentageChange <- 
  MVChangeBalanceSheet$ActualChange <- paste0("$",formatC(round(MVChangeBalanceSheet$ActualChange, 2),
  format="f",digits=2,big.mark=","))
MVChangeBalanceSheet$PercentageChange <- paste0(formatC(round(100.0*(MVChangeBalanceSheet$EstimatedValueAtHorizonAll -
  MVChangeBalanceSheet$EstimatedValue)/MVChangeBalanceSheet$EstimatedValue, 2),format="f",digits=2,big.mark=","),"%")
MVChangeBalanceSheet$InitialValue <- paste0("$",formatC(round(MVChangeBalanceSheet$EstimatedValue, 2),
  format="f",digits=2,big.mark=","))
MVChangeBalanceSheet$HorizonValue <- paste0("$",formatC(round(MVChangeBalanceSheet$EstimatedValueAtHorizonAll, 2),
  format="f",digits=2,big.mark=","))
MVChangeBalanceSheet$EstimatedValue <- NULL
MVChangeBalanceSheet$EstimatedValueAtHorizonAll <- NULL
keeps <- c("Names","InitialValue", "HorizonValue", "ActualChange", "PercentageChange")
MVChangeBalanceSheet = MVChangeBalanceSheet[keeps]
write.xlsx(MVChangeBalanceSheet, "KM Balance Sheet Change C4F3.xlsx")
# Net Worth Risk Measures (Table 24a)
NetWorthRiskMeasures = data.frame(matrix(vector(), 3, 13, dimnames=list(c(), 
  c("Parameter", "BRLevel", "BRSlope", "BRCurve1", "SP1Level", "SP1Slope", "SP1Curve1",
    "SP2Level", "SP2Slope", "SP2Curve1", "SP3Level", "SP3Slope", "SP3Curve1"
    ))), stringsAsFactors=F)
NetWorthRiskMeasures$Parameter[1] <- "Duration"
NetWorthRiskMeasures$Parameter[2] <- "Convexity"
NetWorthRiskMeasures$Parameter[3] <- "Cross-Convexity"
NetWorthRiskMeasures$BRLevel[1] <- formatC(as.numeric(RiskMeasuresC4F3$BaseDurationLevel[NetWorthRowNumber]),format="f",digits=2,big.mark=",")
NetWorthRiskMeasures$BRLevel[2] <- formatC(as.numeric(RiskMeasuresC4F3$BaseConvexityLevel[NetWorthRowNumber]),format="f",digits=2,big.mark=",")
NetWorthRiskMeasures$BRLevel[3] <- formatC(as.numeric(RiskMeasuresC4F3$BaseCrossConvexityCCLS[NetWorthRowNumber]),format="f",digits=2,big.mark=",")
NetWorthRiskMeasures$BRSlope[1] <- formatC(as.numeric(RiskMeasuresC4F3$BaseDurationSlope[NetWorthRowNumber]),format="f",digits=2,big.mark=",")
NetWorthRiskMeasures$BRSlope[2] <- formatC(as.numeric(RiskMeasuresC4F3$BaseConvexitySlope[NetWorthRowNumber]),format="f",digits=2,big.mark=",")
NetWorthRiskMeasures$BRSlope[3] <- formatC(as.numeric(RiskMeasuresC4F3$BaseCrossConvexityCCSC1[NetWorthRowNumber]),format="f",digits=2,big.mark=",")
NetWorthRiskMeasures$BRCurve1[1] <- formatC(as.numeric(RiskMeasuresC4F3$BaseDurationCurve1[NetWorthRowNumber]),format="f",digits=2,big.mark=",")
NetWorthRiskMeasures$BRCurve1[2] <- formatC(as.numeric(RiskMeasuresC4F3$BaseConvexityCurve1[NetWorthRowNumber]),format="f",digits=2,big.mark=",")
NetWorthRiskMeasures$BRCurve1[3] <- formatC(as.numeric(RiskMeasuresC4F3$BaseCrossConvexityCCLC1[NetWorthRowNumber]),format="f",digits=2,big.mark=",")
NetWorthRiskMeasures$SP1Level[1] <- formatC(as.numeric(RiskMeasuresC4F3$Spread1DurationLevel[NetWorthRowNumber]),format="f",digits=2,big.mark=",")
NetWorthRiskMeasures$SP1Level[2] <- formatC(as.numeric(RiskMeasuresC4F3$Spread1ConvexityLevel[NetWorthRowNumber]),format="f",digits=2,big.mark=",")
NetWorthRiskMeasures$SP1Level[3] <- formatC(as.numeric(RiskMeasuresC4F3$Spread1CrossConvexityCCLS[NetWorthRowNumber]),format="f",digits=2,big.mark=",")
NetWorthRiskMeasures$SP1Slope[1] <- formatC(as.numeric(RiskMeasuresC4F3$Spread1DurationSlope[NetWorthRowNumber]),format="f",digits=2,big.mark=",")
NetWorthRiskMeasures$SP1Slope[2] <- formatC(as.numeric(RiskMeasuresC4F3$Spread1ConvexitySlope[NetWorthRowNumber]),format="f",digits=2,big.mark=",")
NetWorthRiskMeasures$SP1Slope[3] <- formatC(as.numeric(RiskMeasuresC4F3$Spread1CrossConvexityCCSC1[NetWorthRowNumber]),format="f",digits=2,big.mark=",")
NetWorthRiskMeasures$SP1Curve1[1] <- formatC(as.numeric(RiskMeasuresC4F3$Spread1DurationCurve1[NetWorthRowNumber]),format="f",digits=2,big.mark=",")
NetWorthRiskMeasures$SP1Curve1[2] <- formatC(as.numeric(RiskMeasuresC4F3$Spread1ConvexityCurve1[NetWorthRowNumber]),format="f",digits=2,big.mark=",")
NetWorthRiskMeasures$SP1Curve1[3] <- formatC(as.numeric(RiskMeasuresC4F3$Spread1CrossConvexityCCLC1[NetWorthRowNumber]),format="f",digits=2,big.mark=",")
NetWorthRiskMeasures$SP2Level[1] <- formatC(as.numeric(RiskMeasuresC4F3$Spread2DurationLevel[NetWorthRowNumber]),format="f",digits=2,big.mark=",")
NetWorthRiskMeasures$SP2Level[2] <- formatC(as.numeric(RiskMeasuresC4F3$Spread2ConvexityLevel[NetWorthRowNumber]),format="f",digits=2,big.mark=",")
NetWorthRiskMeasures$SP2Level[3] <- formatC(as.numeric(RiskMeasuresC4F3$Spread2CrossConvexityCCLS[NetWorthRowNumber]),format="f",digits=2,big.mark=",")
NetWorthRiskMeasures$SP2Slope[1] <- formatC(as.numeric(RiskMeasuresC4F3$Spread2DurationSlope[NetWorthRowNumber]),format="f",digits=2,big.mark=",")
NetWorthRiskMeasures$SP2Slope[2] <- formatC(as.numeric(RiskMeasuresC4F3$Spread2ConvexitySlope[NetWorthRowNumber]),format="f",digits=2,big.mark=",")
NetWorthRiskMeasures$SP2Slope[3] <- formatC(as.numeric(RiskMeasuresC4F3$Spread2CrossConvexityCCSC1[NetWorthRowNumber]),format="f",digits=2,big.mark=",")
NetWorthRiskMeasures$SP2Curve1[1] <- formatC(as.numeric(RiskMeasuresC4F3$Spread2DurationCurve1[NetWorthRowNumber]),format="f",digits=2,big.mark=",")
NetWorthRiskMeasures$SP2Curve1[2] <- formatC(as.numeric(RiskMeasuresC4F3$Spread2ConvexityCurve1[NetWorthRowNumber]),format="f",digits=2,big.mark=",")
NetWorthRiskMeasures$SP2Curve1[3] <- formatC(as.numeric(RiskMeasuresC4F3$Spread2CrossConvexityCCLC1[NetWorthRowNumber]),format="f",digits=2,big.mark=",")
NetWorthRiskMeasures$SP3Level[1] <- formatC(as.numeric(RiskMeasuresC4F3$Spread3DurationLevel[NetWorthRowNumber]),format="f",digits=2,big.mark=",")
NetWorthRiskMeasures$SP3Level[2] <- formatC(as.numeric(RiskMeasuresC4F3$Spread3ConvexityLevel[NetWorthRowNumber]),format="f",digits=2,big.mark=",")
NetWorthRiskMeasures$SP3Level[3] <- formatC(as.numeric(RiskMeasuresC4F3$Spread3CrossConvexityCCLS[NetWorthRowNumber]),format="f",digits=2,big.mark=",")
NetWorthRiskMeasures$SP3Slope[1] <- formatC(as.numeric(RiskMeasuresC4F3$Spread3DurationSlope[NetWorthRowNumber]),format="f",digits=2,big.mark=",")
NetWorthRiskMeasures$SP3Slope[2] <- formatC(as.numeric(RiskMeasuresC4F3$Spread3ConvexitySlope[NetWorthRowNumber]),format="f",digits=2,big.mark=",")
NetWorthRiskMeasures$SP3Slope[3] <- formatC(as.numeric(RiskMeasuresC4F3$Spread3CrossConvexityCCSC1[NetWorthRowNumber]),format="f",digits=2,big.mark=",")
NetWorthRiskMeasures$SP3Curve1[1] <- formatC(as.numeric(RiskMeasuresC4F3$Spread3DurationCurve1[NetWorthRowNumber]),format="f",digits=2,big.mark=",")
NetWorthRiskMeasures$SP3Curve1[2] <- formatC(as.numeric(RiskMeasuresC4F3$Spread3ConvexityCurve1[NetWorthRowNumber]),format="f",digits=2,big.mark=",")
NetWorthRiskMeasures$SP3Curve1[3] <- formatC(as.numeric(RiskMeasuresC4F3$Spread3CrossConvexityCCLC1[NetWorthRowNumber]),format="f",digits=2,big.mark=",")
write.xlsx(NetWorthRiskMeasures, "KM Net Worth Risk Measures C4F3.xlsx")
# Net Worth Factor Sensitivities (Table 24b, add one column for BR and SPR1 ($ Change))
# Add one row at bottom ($ Totals)
NetWorthFactorSensitivities = data.frame(matrix(vector(), 4, 15, dimnames=list(c(), 
  c("Parameter", "BRLevel", "BRSlope", "BRCurve1", "BRTotal", "SP1Level", "SP1Slope", "SP1Curve1", "SP1Total",
    "SP2Slope", "SP2Curve1", "SP2Total", "SP3Slope", "SP3Curve1", "SP3Total"
  ))), stringsAsFactors=F)
NetWorthFactorSensitivities$Parameter[1] <- "Duration"
NetWorthFactorSensitivities$Parameter[2] <- "Convexity"
NetWorthFactorSensitivities$Parameter[3] <- "Cross-Convexity"
NetWorthFactorSensitivities$Parameter[4] <- "Total"
BDL <- as.numeric(FactorSensitivitiesC4F3$BaseDurationLevel[NetWorthRowNumber])
BCL <- as.numeric(FactorSensitivitiesC4F3$BaseConvexityLevel[NetWorthRowNumber])
BCCL <- as.numeric(FactorSensitivitiesC4F3$BaseCrossConvexityCCLS[NetWorthRowNumber])
SBL <- BDL + BCL + BCCL # Sum Base Level
NetWorthFactorSensitivities$BRLevel[1] <- formatC(BDL,format="f",digits=2,big.mark=",")
NetWorthFactorSensitivities$BRLevel[2] <- formatC(BCL,format="f",digits=2,big.mark=",")
NetWorthFactorSensitivities$BRLevel[3] <- formatC(BCCL,format="f",digits=2,big.mark=",")
NetWorthFactorSensitivities$BRLevel[4] <- formatC(SBL,format="f",digits=2,big.mark=",")
BDS <- as.numeric(FactorSensitivitiesC4F3$BaseDurationSlope[NetWorthRowNumber])
BCS <- as.numeric(FactorSensitivitiesC4F3$BaseConvexitySlope[NetWorthRowNumber])
BCCS <- as.numeric(FactorSensitivitiesC4F3$BaseCrossConvexityCCSC1[NetWorthRowNumber])
SBS <- BDS + BCS + BCCS # Sum Base Slope
NetWorthFactorSensitivities$BRSlope[1] <- formatC(BDS,format="f",digits=2,big.mark=",")
NetWorthFactorSensitivities$BRSlope[2] <- formatC(BCS,format="f",digits=2,big.mark=",")
NetWorthFactorSensitivities$BRSlope[3] <- formatC(BCCS,format="f",digits=2,big.mark=",")
NetWorthFactorSensitivities$BRSlope[4] <- formatC(SBS,format="f",digits=2,big.mark=",")
BDC1 <- as.numeric(FactorSensitivitiesC4F3$BaseDurationCurve1[NetWorthRowNumber])
BCC1 <- as.numeric(FactorSensitivitiesC4F3$BaseConvexityCurve1[NetWorthRowNumber])
BCCC1 <- as.numeric(FactorSensitivitiesC4F3$BaseCrossConvexityCCLC1[NetWorthRowNumber])
SBC1 <- BDC1 + BCC1 + BCCC1 # Sum Base Curve1
NetWorthFactorSensitivities$BRCurve1[1] <- formatC(BDC1,format="f",digits=2,big.mark=",")
NetWorthFactorSensitivities$BRCurve1[2] <- formatC(BCC1,format="f",digits=2,big.mark=",")
NetWorthFactorSensitivities$BRCurve1[3] <- formatC(BCCC1,format="f",digits=2,big.mark=",")
NetWorthFactorSensitivities$BRCurve1[4] <- formatC(SBC1,format="f",digits=2,big.mark=",")
# Totals
BTD <- BDL + BDS + BDC1
BTC <- BCL + BCS + BCC1
BTCC <- BCCL + BCCS + BCCC1
GTB <- BTD + BTC + BTCC # Grand total
NetWorthFactorSensitivities$BRTotal[1] <- formatC(BTD,format="f",digits=2,big.mark=",")
NetWorthFactorSensitivities$BRTotal[2] <- formatC(BTC,format="f",digits=2,big.mark=",")
NetWorthFactorSensitivities$BRTotal[3] <- formatC(BTCC,format="f",digits=2,big.mark=",")
NetWorthFactorSensitivities$BRTotal[4] <- formatC(GTB,format="f",digits=2,big.mark=",")
# Spread1
SPDL <- as.numeric(FactorSensitivitiesC4F3$Spread1DurationLevel[NetWorthRowNumber])
SPCL <- as.numeric(FactorSensitivitiesC4F3$Spread1ConvexityLevel[NetWorthRowNumber])
SPCCL <- as.numeric(FactorSensitivitiesC4F3$Spread1CrossConvexityCCLS[NetWorthRowNumber])
SSPL <- SPDL + SPCL + SPCCL # Sum Spread1 Level
NetWorthFactorSensitivities$SP1Level[1] <- formatC(SPDL,format="f",digits=2,big.mark=",")
NetWorthFactorSensitivities$SP1Level[2] <- formatC(SPCL,format="f",digits=2,big.mark=",")
NetWorthFactorSensitivities$SP1Level[3] <- formatC(SPCCL,format="f",digits=2,big.mark=",")
NetWorthFactorSensitivities$SP1Level[4] <- formatC(SSPL,format="f",digits=2,big.mark=",")
SPDS <- as.numeric(FactorSensitivitiesC4F3$Spread1DurationSlope[NetWorthRowNumber])
SPCS <- as.numeric(FactorSensitivitiesC4F3$Spread1ConvexitySlope[NetWorthRowNumber])
SPCCS <- as.numeric(FactorSensitivitiesC4F3$Spread1CrossConvexityCCSC1[NetWorthRowNumber])
SSPS <- SPDS + SPCS + SPCCS # Sum Spread1 Slope
NetWorthFactorSensitivities$SP1Slope[1] <- formatC(SPDS,format="f",digits=2,big.mark=",")
NetWorthFactorSensitivities$SP1Slope[2] <- formatC(SPCS,format="f",digits=2,big.mark=",")
NetWorthFactorSensitivities$SP1Slope[3] <- formatC(SPCCS,format="f",digits=2,big.mark=",")
NetWorthFactorSensitivities$SP1Slope[4] <- formatC(SSPS,format="f",digits=2,big.mark=",")
SPDC1 <- as.numeric(FactorSensitivitiesC4F3$Spread1DurationCurve1[NetWorthRowNumber])
SPCC1 <- as.numeric(FactorSensitivitiesC4F3$Spread1ConvexityCurve1[NetWorthRowNumber])
SPCCC1 <- as.numeric(FactorSensitivitiesC4F3$Spread1CrossConvexityCCLC1[NetWorthRowNumber])
SSPC1 <- SPDC1 + SPCC1 + SPCCC1 # Sum Spread1 Curve1
NetWorthFactorSensitivities$SP1Curve1[1] <- formatC(SPDC1,format="f",digits=2,big.mark=",")
NetWorthFactorSensitivities$SP1Curve1[2] <- formatC(SPCC1,format="f",digits=2,big.mark=",")
NetWorthFactorSensitivities$SP1Curve1[3] <- formatC(SPCCC1,format="f",digits=2,big.mark=",")
NetWorthFactorSensitivities$SP1Curve1[4] <- formatC(SSPC1,format="f",digits=2,big.mark=",")
# Totals
SP1TD <- SPDL + SPDS + SPDC1
SP1TC <- SPCL + SPCS + SPCC1
SP1TCC <- SPCCL + SPCCS + SPCCC1
GTSP1 <- SP1TD + SP1TC + SP1TCC # Grand total
NetWorthFactorSensitivities$SP1Total[1] <- formatC(SP1TD,format="f",digits=2,big.mark=",")
NetWorthFactorSensitivities$SP1Total[2] <- formatC(SP1TC,format="f",digits=2,big.mark=",")
NetWorthFactorSensitivities$SP1Total[3] <- formatC(SP1TCC,format="f",digits=2,big.mark=",")
NetWorthFactorSensitivities$SP1Total[4] <- formatC(GTSP1,format="f",digits=2,big.mark=",")
# Spread2
SP2DL <- as.numeric(FactorSensitivitiesC4F3$Spread2DurationLevel[NetWorthRowNumber])
SP2CL <- as.numeric(FactorSensitivitiesC4F3$Spread2ConvexityLevel[NetWorthRowNumber])
SP2CCL <- as.numeric(FactorSensitivitiesC4F3$Spread2CrossConvexityCCLS[NetWorthRowNumber])
SSP2L <- SP2DL + SP2CL + SP2CCL # Sum Spread1 Level
NetWorthFactorSensitivities$SP2Level[1] <- formatC(SP2DL,format="f",digits=2,big.mark=",")
NetWorthFactorSensitivities$SP2Level[2] <- formatC(SP2CL,format="f",digits=2,big.mark=",")
NetWorthFactorSensitivities$SP2Level[3] <- formatC(SP2CCL,format="f",digits=2,big.mark=",")
NetWorthFactorSensitivities$SP2Level[4] <- formatC(SSP2L,format="f",digits=2,big.mark=",")
SP2DS <- as.numeric(FactorSensitivitiesC4F3$Spread2DurationSlope[NetWorthRowNumber])
SP2CS <- as.numeric(FactorSensitivitiesC4F3$Spread2ConvexitySlope[NetWorthRowNumber])
SP2CCS <- as.numeric(FactorSensitivitiesC4F3$Spread2CrossConvexityCCSC1[NetWorthRowNumber])
SSP2S <- SP2DS + SP2CS + SP2CCS # Sum Spread1 Slope
NetWorthFactorSensitivities$SP2Slope[1] <- formatC(SP2DS,format="f",digits=2,big.mark=",")
NetWorthFactorSensitivities$SP2Slope[2] <- formatC(SP2CS,format="f",digits=2,big.mark=",")
NetWorthFactorSensitivities$SP2Slope[3] <- formatC(SP2CCS,format="f",digits=2,big.mark=",")
NetWorthFactorSensitivities$SP2Slope[4] <- formatC(SSP2S,format="f",digits=2,big.mark=",")
SP2DC1 <- as.numeric(FactorSensitivitiesC4F3$Spread2DurationCurve1[NetWorthRowNumber])
SP2CC1 <- as.numeric(FactorSensitivitiesC4F3$Spread2ConvexityCurve1[NetWorthRowNumber])
SP2CCC1 <- as.numeric(FactorSensitivitiesC4F3$Spread2CrossConvexityCCLC1[NetWorthRowNumber])
SSP2C1 <- SP2DC1 + SP2CC1 + SP2CCC1 # Sum Spread1 Curve1
NetWorthFactorSensitivities$SP2Curve1[1] <- formatC(SP2DC1,format="f",digits=2,big.mark=",")
NetWorthFactorSensitivities$SP2Curve1[2] <- formatC(SP2CC1,format="f",digits=2,big.mark=",")
NetWorthFactorSensitivities$SP2Curve1[3] <- formatC(SP2CCC1,format="f",digits=2,big.mark=",")
NetWorthFactorSensitivities$SP2Curve1[4] <- formatC(SSP2C1,format="f",digits=2,big.mark=",")
# Totals
SP2TD <- SP2DL + SP2DS + SP2DC1
SP2TC <- SP2CL + SP2CS + SP2CC1
SP2TCC <- SP2CCL + SP2CCS + SP2CCC1
GTSP2 <- SP2TD + SP2TC + SP2TCC # Grand total
NetWorthFactorSensitivities$SP2Total[1] <- formatC(SP2TD,format="f",digits=2,big.mark=",")
NetWorthFactorSensitivities$SP2Total[2] <- formatC(SP2TC,format="f",digits=2,big.mark=",")
NetWorthFactorSensitivities$SP2Total[3] <- formatC(SP2TCC,format="f",digits=2,big.mark=",")
NetWorthFactorSensitivities$SP2Total[4] <- formatC(GTSP2,format="f",digits=2,big.mark=",")
# Spread3
SP3DL <- as.numeric(FactorSensitivitiesC4F3$Spread3DurationLevel[NetWorthRowNumber])
SP3CL <- as.numeric(FactorSensitivitiesC4F3$Spread3ConvexityLevel[NetWorthRowNumber])
SP3CCL <- as.numeric(FactorSensitivitiesC4F3$Spread3CrossConvexityCCLS[NetWorthRowNumber])
SSP3L <- SP3DL + SP3CL + SP3CCL # Sum Spread1 Level
NetWorthFactorSensitivities$SP3Level[1] <- formatC(SP3DL,format="f",digits=2,big.mark=",")
NetWorthFactorSensitivities$SP3Level[2] <- formatC(SP3CL,format="f",digits=2,big.mark=",")
NetWorthFactorSensitivities$SP3Level[3] <- formatC(SP3CCL,format="f",digits=2,big.mark=",")
NetWorthFactorSensitivities$SP3Level[4] <- formatC(SSP3L,format="f",digits=2,big.mark=",")
SP3DS <- as.numeric(FactorSensitivitiesC4F3$Spread3DurationSlope[NetWorthRowNumber])
SP3CS <- as.numeric(FactorSensitivitiesC4F3$Spread3ConvexitySlope[NetWorthRowNumber])
SP3CCS <- as.numeric(FactorSensitivitiesC4F3$Spread3CrossConvexityCCSC1[NetWorthRowNumber])
SSP3S <- SP3DS + SP3CS + SP3CCS # Sum Spread1 Slope
NetWorthFactorSensitivities$SP3Slope[1] <- formatC(SP3DS,format="f",digits=2,big.mark=",")
NetWorthFactorSensitivities$SP3Slope[2] <- formatC(SP3CS,format="f",digits=2,big.mark=",")
NetWorthFactorSensitivities$SP3Slope[3] <- formatC(SP3CCS,format="f",digits=2,big.mark=",")
NetWorthFactorSensitivities$SP3Slope[4] <- formatC(SSP3S,format="f",digits=2,big.mark=",")
SP3DC1 <- as.numeric(FactorSensitivitiesC4F3$Spread3DurationCurve1[NetWorthRowNumber])
SP3CC1 <- as.numeric(FactorSensitivitiesC4F3$Spread3ConvexityCurve1[NetWorthRowNumber])
SP3CCC1 <- as.numeric(FactorSensitivitiesC4F3$Spread3CrossConvexityCCLC1[NetWorthRowNumber])
SSP3C1 <- SP3DC1 + SP3CC1 + SP3CCC1 # Sum Spread1 Curve1
NetWorthFactorSensitivities$SP3Curve1[1] <- formatC(SP3DC1,format="f",digits=2,big.mark=",")
NetWorthFactorSensitivities$SP3Curve1[2] <- formatC(SP3CC1,format="f",digits=2,big.mark=",")
NetWorthFactorSensitivities$SP3Curve1[3] <- formatC(SP3CCC1,format="f",digits=2,big.mark=",")
NetWorthFactorSensitivities$SP3Curve1[4] <- formatC(SSP3C1,format="f",digits=2,big.mark=",")
# Totals
SP3TD <- SP3DL + SP3DS + SP3DC1
SP3TC <- SP3CL + SP3CS + SP3CC1
SP3TCC <- SP3CCL + SP3CCS + SP3CCC1
GTSP3 <- SP3TD + SP3TC + SP3TCC # Grand total
NetWorthFactorSensitivities$SP3Total[1] <- formatC(SP3TD,format="f",digits=2,big.mark=",")
NetWorthFactorSensitivities$SP3Total[2] <- formatC(SP3TC,format="f",digits=2,big.mark=",")
NetWorthFactorSensitivities$SP3Total[3] <- formatC(SP3TCC,format="f",digits=2,big.mark=",")
NetWorthFactorSensitivities$SP3Total[4] <- formatC(GTSP3,format="f",digits=2,big.mark=",")
write.xlsx(NetWorthFactorSensitivities, "KM Net Worth Factor Sensitivities C4F3.xlsx")
# Net Worth Factor Sensitivities (Table 24b, add one column for BR and SPR1 ($ Change))
# Add one row at bottom ($ Totals)
NetWorthPFactorSensitivities = data.frame(matrix(vector(), 4, 15, dimnames=list(c(), 
   c("Parameter", "BRLevel", "BRSlope", "BRCurve1", "BRTotal", "SP1Level", "SP1Slope", "SP1Curve1", "SP1Total",
     "SP2Slope", "SP2Curve1", "SP2Total", "SP3Slope", "SP3Curve1", "SP3Total"
   ))), stringsAsFactors=F)
NetWorthPFactorSensitivities$Parameter[1] <- "Duration"
NetWorthPFactorSensitivities$Parameter[2] <- "Convexity"
NetWorthPFactorSensitivities$Parameter[3] <- "Cross-Convexity"
NetWorthPFactorSensitivities$Parameter[4] <- "Total"
EstimatedNW <- as.numeric(AttributionC4F3$EstimatedValue[NetWorthRowNumber]) # Estimated net worth at time 0
BDL <- as.numeric(100.0*FactorSensitivitiesC4F3$BaseDurationLevel[NetWorthRowNumber]/EstimatedNW)
BCL <- as.numeric(100.0*FactorSensitivitiesC4F3$BaseConvexityLevel[NetWorthRowNumber]/EstimatedNW)
BCCL <- as.numeric(100.0*FactorSensitivitiesC4F3$BaseCrossConvexityCCLS[NetWorthRowNumber]/EstimatedNW)
SBL <- BDL + BCL + BCCL # Sum Base Level
NetWorthPFactorSensitivities$BRLevel[1] <- paste0(formatC(BDL,format="f",digits=2,big.mark=","), "%")
NetWorthPFactorSensitivities$BRLevel[2] <- paste0(formatC(BCL,format="f",digits=2,big.mark=","), "%")
NetWorthPFactorSensitivities$BRLevel[3] <- paste0(formatC(BCCL,format="f",digits=2,big.mark=","), "%")
NetWorthPFactorSensitivities$BRLevel[4] <- paste0(formatC(SBL,format="f",digits=2,big.mark=","), "%")
BDS <- as.numeric(100.0*FactorSensitivitiesC4F3$BaseDurationSlope[NetWorthRowNumber]/EstimatedNW)
BCS <- as.numeric(100.0*FactorSensitivitiesC4F3$BaseConvexitySlope[NetWorthRowNumber]/EstimatedNW)
BCCS <- as.numeric(100.0*FactorSensitivitiesC4F3$BaseCrossConvexityCCSC1[NetWorthRowNumber]/EstimatedNW)
SBS <- BDS + BCS + BCCS # Sum Base Slope
NetWorthPFactorSensitivities$BRSlope[1] <- paste0(formatC(BDS,format="f",digits=2,big.mark=","), "%")
NetWorthPFactorSensitivities$BRSlope[2] <- paste0(formatC(BCS,format="f",digits=2,big.mark=","), "%")
NetWorthPFactorSensitivities$BRSlope[3] <- paste0(formatC(BCCS,format="f",digits=2,big.mark=","), "%")
NetWorthPFactorSensitivities$BRSlope[4] <- paste0(formatC(SBS,format="f",digits=2,big.mark=","), "%")
BDC1 <- as.numeric(100.0*FactorSensitivitiesC4F3$BaseDurationCurve1[NetWorthRowNumber]/EstimatedNW)
BCC1 <- as.numeric(100.0*FactorSensitivitiesC4F3$BaseConvexityCurve1[NetWorthRowNumber]/EstimatedNW)
BCCC1 <- as.numeric(100.0*FactorSensitivitiesC4F3$BaseCrossConvexityCCLC1[NetWorthRowNumber]/EstimatedNW)
SBC1 <- BDC1 + BCC1 + BCCC1 # Sum Base Curve1
NetWorthPFactorSensitivities$BRCurve1[1] <- paste0(formatC(BDC1,format="f",digits=2,big.mark=","), "%")
NetWorthPFactorSensitivities$BRCurve1[2] <- paste0(formatC(BCC1,format="f",digits=2,big.mark=","), "%")
NetWorthPFactorSensitivities$BRCurve1[3] <- paste0(formatC(BCCC1,format="f",digits=2,big.mark=","), "%")
NetWorthPFactorSensitivities$BRCurve1[4] <- paste0(formatC(SBC1,format="f",digits=2,big.mark=","), "%")
# Totals
BTD <- BDL + BDS + BDC1
BTC <- BCL + BCS + BCC1
BTCC <- BCCL + BCCS + BCCC1
GTB <- BTD + BTC + BTCC # Grand total
NetWorthPFactorSensitivities$BRTotal[1] <- paste0(formatC(BTD,format="f",digits=2,big.mark=","), "%")
NetWorthPFactorSensitivities$BRTotal[2] <- paste0(formatC(BTC,format="f",digits=2,big.mark=","), "%")
NetWorthPFactorSensitivities$BRTotal[3] <- paste0(formatC(BTCC,format="f",digits=2,big.mark=","), "%")
NetWorthPFactorSensitivities$BRTotal[4] <- paste0(formatC(GTB,format="f",digits=2,big.mark=","), "%")
# Spread1
SPDL <- as.numeric(100.0*FactorSensitivitiesC4F3$Spread1DurationLevel[NetWorthRowNumber]/EstimatedNW)
SPCL <- as.numeric(100.0*FactorSensitivitiesC4F3$Spread1ConvexityLevel[NetWorthRowNumber]/EstimatedNW)
SPCCL <- as.numeric(100.0*FactorSensitivitiesC4F3$Spread1CrossConvexityCCLS[NetWorthRowNumber]/EstimatedNW)
SSPL <- SPDL + SPCL + SPCCL # Sum Spread1 Level
NetWorthPFactorSensitivities$SP1Level[1] <- paste0(formatC(SPDL,format="f",digits=2,big.mark=","), "%")
NetWorthPFactorSensitivities$SP1Level[2] <- paste0(formatC(SPCL,format="f",digits=2,big.mark=","), "%")
NetWorthPFactorSensitivities$SP1Level[3] <- paste0(formatC(SPCCL,format="f",digits=2,big.mark=","), "%")
NetWorthPFactorSensitivities$SP1Level[4] <- paste0(formatC(SSPL,format="f",digits=2,big.mark=","), "%")
SPDS <- as.numeric(100.0*FactorSensitivitiesC4F3$Spread1DurationSlope[NetWorthRowNumber]/EstimatedNW)
SPCS <- as.numeric(100.0*FactorSensitivitiesC4F3$Spread1ConvexitySlope[NetWorthRowNumber]/EstimatedNW)
SPCCS <- as.numeric(100.0*FactorSensitivitiesC4F3$Spread1CrossConvexityCCSC1[NetWorthRowNumber]/EstimatedNW)
SSPS <- SPDS + SPCS + SPCCS # Sum Spread1 Slope
NetWorthPFactorSensitivities$SP1Slope[1] <- paste0(formatC(SPDS,format="f",digits=2,big.mark=","), "%")
NetWorthPFactorSensitivities$SP1Slope[2] <- paste0(formatC(SPCS,format="f",digits=2,big.mark=","), "%")
NetWorthPFactorSensitivities$SP1Slope[3] <- paste0(formatC(SPCCS,format="f",digits=2,big.mark=","), "%")
NetWorthPFactorSensitivities$SP1Slope[4] <- paste0(formatC(SSPS,format="f",digits=2,big.mark=","), "%")
SPDC1 <- as.numeric(100.0*FactorSensitivitiesC4F3$Spread1DurationCurve1[NetWorthRowNumber]/EstimatedNW)
SPCC1 <- as.numeric(100.0*FactorSensitivitiesC4F3$Spread1ConvexityCurve1[NetWorthRowNumber]/EstimatedNW)
SPCCC1 <- as.numeric(100.0*FactorSensitivitiesC4F3$Spread1CrossConvexityCCLC1[NetWorthRowNumber]/EstimatedNW)
SSPC1 <- SPDC1 + SPCC1 + SPCCC1 # Sum Spread1 Curve1
NetWorthPFactorSensitivities$SP1Curve1[1] <- paste0(formatC(SPDC1,format="f",digits=2,big.mark=","), "%")
NetWorthPFactorSensitivities$SP1Curve1[2] <- paste0(formatC(SPCC1,format="f",digits=2,big.mark=","), "%")
NetWorthPFactorSensitivities$SP1Curve1[3] <- paste0(formatC(SPCCC1,format="f",digits=2,big.mark=","), "%")
NetWorthPFactorSensitivities$SP1Curve1[4] <- paste0(formatC(SSPC1,format="f",digits=2,big.mark=","), "%")
# Totals
SP1TD <- SPDL + SPDS + SPDC1
SP1TC <- SPCL + SPCS + SPCC1
SP1TCC <- SPCCL + SPCCS + SPCCC1
GTSP1 <- SP1TD + SP1TC + SP1TCC # Grand total
NetWorthPFactorSensitivities$SP1Total[1] <- paste0(formatC(SP1TD,format="f",digits=2,big.mark=","), "%")
NetWorthPFactorSensitivities$SP1Total[2] <- paste0(formatC(SP1TC,format="f",digits=2,big.mark=","), "%")
NetWorthPFactorSensitivities$SP1Total[3] <- paste0(formatC(SP1TCC,format="f",digits=2,big.mark=","), "%")
NetWorthPFactorSensitivities$SP1Total[4] <- paste0(formatC(GTSP1,format="f",digits=2,big.mark=","), "%")
# Spread2
SP2DL <- as.numeric(100.0*FactorSensitivitiesC4F3$Spread2DurationLevel[NetWorthRowNumber]/EstimatedNW)
SP2CL <- as.numeric(100.0*FactorSensitivitiesC4F3$Spread2ConvexityLevel[NetWorthRowNumber]/EstimatedNW)
SP2CCL <- as.numeric(100.0*FactorSensitivitiesC4F3$Spread2CrossConvexityCCLS[NetWorthRowNumber]/EstimatedNW)
SSP2L <- SP2DL + SP2CL + SP2CCL # Sum Spread1 Level
NetWorthPFactorSensitivities$SP2Level[1] <- paste0(formatC(SP2DL,format="f",digits=2,big.mark=","), "%")
NetWorthPFactorSensitivities$SP2Level[2] <- paste0(formatC(SP2CL,format="f",digits=2,big.mark=","), "%")
NetWorthPFactorSensitivities$SP2Level[3] <- paste0(formatC(SP2CCL,format="f",digits=2,big.mark=","), "%")
NetWorthPFactorSensitivities$SP2Level[4] <- paste0(formatC(SSP2L,format="f",digits=2,big.mark=","), "%")
SP2DS <- as.numeric(100.0*FactorSensitivitiesC4F3$Spread2DurationSlope[NetWorthRowNumber]/EstimatedNW)
SP2CS <- as.numeric(100.0*FactorSensitivitiesC4F3$Spread2ConvexitySlope[NetWorthRowNumber]/EstimatedNW)
SP2CCS <- as.numeric(100.0*FactorSensitivitiesC4F3$Spread2CrossConvexityCCSC1[NetWorthRowNumber]/EstimatedNW)
SSP2S <- SP2DS + SP2CS + SP2CCS # Sum Spread1 Slope
NetWorthPFactorSensitivities$SP2Slope[1] <- paste0(formatC(SP2DS,format="f",digits=2,big.mark=","), "%")
NetWorthPFactorSensitivities$SP2Slope[2] <- paste0(formatC(SP2CS,format="f",digits=2,big.mark=","), "%")
NetWorthPFactorSensitivities$SP2Slope[3] <- paste0(formatC(SP2CCS,format="f",digits=2,big.mark=","), "%")
NetWorthPFactorSensitivities$SP2Slope[4] <- paste0(formatC(SSP2S,format="f",digits=2,big.mark=","), "%")
SP2DC1 <- as.numeric(100.0*FactorSensitivitiesC4F3$Spread2DurationCurve1[NetWorthRowNumber]/EstimatedNW)
SP2CC1 <- as.numeric(100.0*FactorSensitivitiesC4F3$Spread2ConvexityCurve1[NetWorthRowNumber]/EstimatedNW)
SP2CCC1 <- as.numeric(100.0*FactorSensitivitiesC4F3$Spread2CrossConvexityCCLC1[NetWorthRowNumber]/EstimatedNW)
SSP2C1 <- SP2DC1 + SP2CC1 + SP2CCC1 # Sum Spread1 Curve1
NetWorthPFactorSensitivities$SP2Curve1[1] <- paste0(formatC(SP2DC1,format="f",digits=2,big.mark=","), "%")
NetWorthPFactorSensitivities$SP2Curve1[2] <- paste0(formatC(SP2CC1,format="f",digits=2,big.mark=","), "%")
NetWorthPFactorSensitivities$SP2Curve1[3] <- paste0(formatC(SP2CCC1,format="f",digits=2,big.mark=","), "%")
NetWorthPFactorSensitivities$SP2Curve1[4] <- paste0(formatC(SSP2C1,format="f",digits=2,big.mark=","), "%")
# Totals
SP2TD <- SP2DL + SP2DS + SP2DC1
SP2TC <- SP2CL + SP2CS + SP2CC1
SP2TCC <- SP2CCL + SP2CCS + SP2CCC1
GTSP2 <- SP2TD + SP2TC + SP2TCC # Grand total
NetWorthPFactorSensitivities$SP2Total[1] <- paste0(formatC(SP2TD,format="f",digits=2,big.mark=","), "%")
NetWorthPFactorSensitivities$SP2Total[2] <- paste0(formatC(SP2TC,format="f",digits=2,big.mark=","), "%")
NetWorthPFactorSensitivities$SP2Total[3] <- paste0(formatC(SP2TCC,format="f",digits=2,big.mark=","), "%")
NetWorthPFactorSensitivities$SP2Total[4] <- paste0(formatC(GTSP2,format="f",digits=2,big.mark=","), "%")
# Spread3
SP3DL <- as.numeric(100.0*FactorSensitivitiesC4F3$Spread3DurationLevel[NetWorthRowNumber]/EstimatedNW)
SP3CL <- as.numeric(100.0*FactorSensitivitiesC4F3$Spread3ConvexityLevel[NetWorthRowNumber]/EstimatedNW)
SP3CCL <- as.numeric(100.0*FactorSensitivitiesC4F3$Spread3CrossConvexityCCLS[NetWorthRowNumber]/EstimatedNW)
SSP3L <- SP3DL + SP3CL + SP3CCL # Sum Spread1 Level
NetWorthPFactorSensitivities$SP3Level[1] <- paste0(formatC(SP3DL,format="f",digits=2,big.mark=","), "%")
NetWorthPFactorSensitivities$SP3Level[2] <- paste0(formatC(SP3CL,format="f",digits=2,big.mark=","), "%")
NetWorthPFactorSensitivities$SP3Level[3] <- paste0(formatC(SP3CCL,format="f",digits=2,big.mark=","), "%")
NetWorthPFactorSensitivities$SP3Level[4] <- paste0(formatC(SSP3L,format="f",digits=2,big.mark=","), "%")
SP3DS <- as.numeric(100.0*FactorSensitivitiesC4F3$Spread3DurationSlope[NetWorthRowNumber]/EstimatedNW)
SP3CS <- as.numeric(100.0*FactorSensitivitiesC4F3$Spread3ConvexitySlope[NetWorthRowNumber]/EstimatedNW)
SP3CCS <- as.numeric(100.0*FactorSensitivitiesC4F3$Spread3CrossConvexityCCSC1[NetWorthRowNumber]/EstimatedNW)
SSP3S <- SP3DS + SP3CS + SP3CCS # Sum Spread1 Slope
NetWorthPFactorSensitivities$SP3Slope[1] <- paste0(formatC(SP3DS,format="f",digits=2,big.mark=","), "%")
NetWorthPFactorSensitivities$SP3Slope[2] <- paste0(formatC(SP3CS,format="f",digits=2,big.mark=","), "%")
NetWorthPFactorSensitivities$SP3Slope[3] <- paste0(formatC(SP3CCS,format="f",digits=2,big.mark=","), "%")
NetWorthPFactorSensitivities$SP3Slope[4] <- paste0(formatC(SSP3S,format="f",digits=2,big.mark=","), "%")
SP3DC1 <- as.numeric(100.0*FactorSensitivitiesC4F3$Spread3DurationCurve1[NetWorthRowNumber]/EstimatedNW)
SP3CC1 <- as.numeric(100.0*FactorSensitivitiesC4F3$Spread3ConvexityCurve1[NetWorthRowNumber]/EstimatedNW)
SP3CCC1 <- as.numeric(100.0*FactorSensitivitiesC4F3$Spread3CrossConvexityCCLC1[NetWorthRowNumber]/EstimatedNW)
SSP3C1 <- SP3DC1 + SP3CC1 + SP3CCC1 # Sum Spread1 Curve1
NetWorthPFactorSensitivities$SP3Curve1[1] <- paste0(formatC(SP3DC1,format="f",digits=2,big.mark=","), "%")
NetWorthPFactorSensitivities$SP3Curve1[2] <- paste0(formatC(SP3CC1,format="f",digits=2,big.mark=","), "%")
NetWorthPFactorSensitivities$SP3Curve1[3] <- paste0(formatC(SP3CCC1,format="f",digits=2,big.mark=","), "%")
NetWorthPFactorSensitivities$SP3Curve1[4] <- paste0(formatC(SSP3C1,format="f",digits=2,big.mark=","), "%")
# Totals
SP3TD <- SP3DL + SP3DS + SP3DC1
SP3TC <- SP3CL + SP3CS + SP3CC1
SP3TCC <- SP3CCL + SP3CCS + SP3CCC1
GTSP3 <- SP3TD + SP3TC + SP3TCC # Grand total
NetWorthPFactorSensitivities$SP3Total[1] <- paste0(formatC(SP3TD,format="f",digits=2,big.mark=","), "%")
NetWorthPFactorSensitivities$SP3Total[2] <- paste0(formatC(SP3TC,format="f",digits=2,big.mark=","), "%")
NetWorthPFactorSensitivities$SP3Total[3] <- paste0(formatC(SP3TCC,format="f",digits=2,big.mark=","), "%")
NetWorthPFactorSensitivities$SP3Total[4] <- paste0(formatC(GTSP3,format="f",digits=2,big.mark=","), "%")
write.xlsx(NetWorthPFactorSensitivities, "KM Net Worth Percent Factor Sensitivities C4F3.xlsx")
#
# Surplus Decomposition (Table 24c)
#
NetWorthSurplusDecomposition = data.frame(matrix(vector(), 7, 3, dimnames=list(c(), 
  c("Parameter", "DollarChange", "PercentChange"))), stringsAsFactors=F)
NetWorthSurplusDecomposition$Parameter[1] <- "Actual"
NetWorthSurplusDecomposition$Parameter[2] <- "Horizon"
NetWorthSurplusDecomposition$Parameter[3] <- "BaseRate"
NetWorthSurplusDecomposition$Parameter[4] <- "Spread1"
NetWorthSurplusDecomposition$Parameter[5] <- "Spread2"
NetWorthSurplusDecomposition$Parameter[6] <- "Spread3"
NetWorthSurplusDecomposition$Parameter[7] <- "Interaction"
ADC <- RiskMeasuresC4F3$EstimatedValueAtHorizonAll[NetWorthRowNumber] - RiskMeasuresC4F3$StatedValue[NetWorthRowNumber]
APC <- 100.0*(ADC/RiskMeasuresC4F3$EstimatedValue[NetWorthRowNumber])
HDC <- RiskMeasuresC4F3$EstimatedValueAtHorizon[NetWorthRowNumber] - RiskMeasuresC4F3$EstimatedValue[NetWorthRowNumber]
HPC <- 100.0*(HDC/RiskMeasuresC4F3$EstimatedValue[NetWorthRowNumber])
BRDC <- RiskMeasuresC4F3$EstimatedValueAtHorizonBase[NetWorthRowNumber] - RiskMeasuresC4F3$EstimatedValueAtHorizon[NetWorthRowNumber]
BRPC <- 100.0*(BRDC/RiskMeasuresC4F3$EstimatedValue[NetWorthRowNumber])
SP1DC <- RiskMeasuresC4F3$EstimatedValueAtHorizonSpread1[NetWorthRowNumber] - RiskMeasuresC4F3$EstimatedValueAtHorizon[NetWorthRowNumber]
SP1PC <- 100.0*(SP1DC/RiskMeasuresC4F3$EstimatedValue[NetWorthRowNumber])
SP2DC <- RiskMeasuresC4F3$EstimatedValueAtHorizonSpread2[NetWorthRowNumber] - RiskMeasuresC4F3$EstimatedValueAtHorizon[NetWorthRowNumber]
SP2PC <- 100.0*(SP2DC/RiskMeasuresC4F3$EstimatedValue[NetWorthRowNumber])
SP3DC <- RiskMeasuresC4F3$EstimatedValueAtHorizonSpread3[NetWorthRowNumber] - RiskMeasuresC4F3$EstimatedValueAtHorizon[NetWorthRowNumber]
SP3PC <- 100.0*(SP3DC/RiskMeasuresC4F3$EstimatedValue[NetWorthRowNumber])
IDC <- ADC - HDC - BRDC - SP1DC - SP2DC - SP3DC
IPC <- 100.0*((ADC - HDC - BRDC - SP1DC - SP2DC - SP3DC)/RiskMeasuresC4F3$EstimatedValue[NetWorthRowNumber])
NetWorthSurplusDecomposition$DollarChange[1] <- paste0("$",formatC(ADC,format="f",digits=2,big.mark=","))
NetWorthSurplusDecomposition$PercentChange[1] <- paste0(formatC(APC,format="f",digits=2,big.mark=","), "%")
NetWorthSurplusDecomposition$DollarChange[2] <- paste0("$",formatC(HDC,format="f",digits=2,big.mark=","))
NetWorthSurplusDecomposition$PercentChange[2] <- paste0(formatC(HPC,format="f",digits=2,big.mark=","), "%")
NetWorthSurplusDecomposition$DollarChange[3] <- paste0("$",formatC(BRDC,format="f",digits=2,big.mark=","))
NetWorthSurplusDecomposition$PercentChange[3] <- paste0(formatC(BRPC,format="f",digits=2,big.mark=","), "%")
NetWorthSurplusDecomposition$DollarChange[4] <- paste0("$",formatC(SP1DC,format="f",digits=2,big.mark=","))
NetWorthSurplusDecomposition$PercentChange[4] <- paste0(formatC(SP1PC,format="f",digits=2,big.mark=","), "%")
NetWorthSurplusDecomposition$DollarChange[5] <- paste0("$",formatC(SP2DC,format="f",digits=2,big.mark=","))
NetWorthSurplusDecomposition$PercentChange[5] <- paste0(formatC(SP2PC,format="f",digits=2,big.mark=","), "%")
NetWorthSurplusDecomposition$DollarChange[6] <- paste0("$",formatC(SP3DC,format="f",digits=2,big.mark=","))
NetWorthSurplusDecomposition$PercentChange[6] <- paste0(formatC(SP3PC,format="f",digits=2,big.mark=","), "%")
NetWorthSurplusDecomposition$DollarChange[7] <- paste0("$",formatC(IDC,format="f",digits=2,big.mark=","))
NetWorthSurplusDecomposition$PercentChange[7] <- paste0(formatC(IPC,format="f",digits=2,big.mark=","), "%")
write.xlsx(NetWorthSurplusDecomposition, "KM Net Worth Surplus Decomposition C4F3.xlsx")
