# KM Reports C2F3.R

RiskMeasuresCurves2Factors3 <- Reduce(function(x, y) merge(x, y, all=TRUE), 
  list(dfReportedBalanceSheet, dfPVBalanceSheet, dfPVBalanceSheetAtHorizonInitial,
  dfPVBalanceSheetAtHorizonBase, dfPVBalanceSheetAtHorizonSpread1, dfPVBalanceSheetAtHorizonAll,   
  dfBaseDurationLevel, dfBaseDurationSlope, dfBaseDurationCurve1,
  dfBaseConvexityLevel, dfBaseConvexitySlope, dfBaseConvexityCurve1,
  dfBaseCrossConvexityCCLS, dfBaseCrossConvexityCCLC1, dfBaseCrossConvexityCCSC1,
  dfSpread1DurationLevel, dfSpread1DurationSlope, dfSpread1DurationCurve1,
  dfSpread1ConvexityLevel, dfSpread1ConvexitySlope, dfSpread1ConvexityCurve1,
  dfSpread1CrossConvexityCCLS, dfSpread1CrossConvexityCCLC1, dfSpread1CrossConvexityCCSC1
  ))
# Add Names
RiskMeasuresCurves2Factors3$Names <- "NA"
NumberOfInstruments <- NumberOfAssets + NumberOfLiabilities
for(i in 1:(NumberOfInstruments+3)){
  if(i < (NumberOfInstruments+1)){
    RiskMeasuresCurves2Factors3$Names[i] <- KMInputs$Number[i + 6]
  }
  if(i == (NumberOfInstruments+1))RiskMeasuresCurves2Factors3$Names[i] <- "Net Worth"
  if(i == (NumberOfInstruments+2))RiskMeasuresCurves2Factors3$Names[i] <- "Total Assets"
  if(i == (NumberOfInstruments+3))RiskMeasuresCurves2Factors3$Names[i] <- "Total Liabilities"
}
RiskMeasuresCurves2Factors3$NamesIndex <- NA
for(i in 1:NumberOfAssets){
  RiskMeasuresCurves2Factors3$NamesIndex[i] <- i
}
for(i in 1:NumberOfLiabilities){
  RiskMeasuresCurves2Factors3$NamesIndex[NumberOfAssets + i] <- NumberOfAssets + 1 + i
}
j <- NumberOfAssets + 1 + NumberOfLiabilities
RiskMeasuresCurves2Factors3$NamesIndex[j] <- j + 2
RiskMeasuresCurves2Factors3$NamesIndex[j+1] <- NumberOfAssets + 1
RiskMeasuresCurves2Factors3$NamesIndex[j+2] <- j + 1
TA <- RiskMeasuresCurves2Factors3[NumberOfInstruments+2,]
TA$Names <- "Total Liab/Eq"
TA$NamesIndex <- j+3
TA
RiskMeasuresCurves2Factors3 <- rbind(RiskMeasuresCurves2Factors3, y = c(TA))
# Reorder data frames
#arrange(RiskMeasuresCurves2Factors3, NamesIndex)
RiskMeasuresCurves2Factors3 <- RiskMeasuresCurves2Factors3[order(RiskMeasuresCurves2Factors3$NamesIndex), , drop = FALSE]
# Reorder by column name
RiskMeasuresCurves2Factors3$Instrument <- NULL
RiskMeasuresCurves2Factors3$NamesIndex <- NULL
refcols <- c("Names", "StatedValue", "EstimatedValue", "EstimatedValueAtHorizon", "EstimatedValueAtHorizonAll",
  "EstimatedValueAtHorizonBase", "EstimatedValueAtHorizonSpread1", 
  "BaseDurationLevel", "BaseDurationSlope", "BaseDurationCurve1", 
  "BaseConvexityLevel", "BaseConvexitySlope", "BaseConvexityCurve1",                            
  "BaseCrossConvexityCCLS", "BaseCrossConvexityCCLC1", "BaseCrossConvexityCCSC1", 
  "Spread1DurationLevel", "Spread1DurationSlope", "Spread1DurationCurve1", 
  "Spread1ConvexityLevel", "Spread1ConvexitySlope", "Spread1ConvexityCurve1",                            
  "Spread1CrossConvexityCCLS", "Spread1CrossConvexityCCLC1", "Spread1CrossConvexityCCSC1")
RiskMeasuresCurves2Factors3 <- RiskMeasuresCurves2Factors3[,refcols]
# Convert liabilities to positive values
N <- NumberOfLiabilities+2
for(i in 1:N){
  RiskMeasuresCurves2Factors3$StatedValue[NumberOfAssets+1+i] <- -RiskMeasuresCurves2Factors3$StatedValue[NumberOfAssets+1+i]
  RiskMeasuresCurves2Factors3$EstimatedValue[NumberOfAssets+1+i] <- -RiskMeasuresCurves2Factors3$EstimatedValue[NumberOfAssets+1+i]
  RiskMeasuresCurves2Factors3$EstimatedValueAtHorizon[NumberOfAssets+1+i] <- -RiskMeasuresCurves2Factors3$EstimatedValueAtHorizon[NumberOfAssets+1+i]
  RiskMeasuresCurves2Factors3$EstimatedValueAtHorizonAll[NumberOfAssets+1+i] <- -RiskMeasuresCurves2Factors3$EstimatedValueAtHorizonAll[NumberOfAssets+1+i]
  RiskMeasuresCurves2Factors3$EstimatedValueAtHorizonBase[NumberOfAssets+1+i] <- -RiskMeasuresCurves2Factors3$EstimatedValueAtHorizonBase[NumberOfAssets+1+i]
  RiskMeasuresCurves2Factors3$EstimatedValueAtHorizonSpread1[NumberOfAssets+1+i] <- -RiskMeasuresCurves2Factors3$EstimatedValueAtHorizonSpread1[NumberOfAssets+1+i]
}
write.xlsx(RiskMeasuresCurves2Factors3, "KM Static Risk Measures.xlsx")
#
# Factor Sensitivities
#
BRLevelChange <- HorizonCurves$Base[2] - InitialCurves$Base[2]
BRSlopeChange <- HorizonCurves$Base[4] - InitialCurves$Base[4]
BRCurve1Change <- HorizonCurves$Base[5] - InitialCurves$Base[5]
SP1LevelChange <- HorizonCurves$Spread1[2] - InitialCurves$Spread1[2]
SP1SlopeChange <- HorizonCurves$Spread1[4] - InitialCurves$Spread1[4]
SP1Curve1Change <- HorizonCurves$Spread1[5] - InitialCurves$Spread1[5]
FactorSensitivitiesC2F3 <- RiskMeasuresCurves2Factors3
keeps <- c("Names")
FactorSensitivitiesC2F3 <- FactorSensitivitiesC2F3[keeps]
FactorSensitivitiesC2F3$BaseDurationLevel <- -RiskMeasuresCurves2Factors3$BaseDurationLevel * (BRLevelChange/100.0) * RiskMeasuresCurves2Factors3$EstimatedValueAtHorizon
FactorSensitivitiesC2F3$BaseDurationSlope <- -RiskMeasuresCurves2Factors3$BaseDurationSlope * (BRSlopeChange/100.0) * RiskMeasuresCurves2Factors3$EstimatedValueAtHorizon  
FactorSensitivitiesC2F3$BaseDurationCurve1 <- -RiskMeasuresCurves2Factors3$BaseDurationCurve1 * (BRCurve1Change/100.0) * RiskMeasuresCurves2Factors3$EstimatedValueAtHorizon  
FactorSensitivitiesC2F3$BaseConvexityLevel <- 0.5*RiskMeasuresCurves2Factors3$BaseConvexityLevel * (BRLevelChange/100.0)^2 * RiskMeasuresCurves2Factors3$EstimatedValueAtHorizon
FactorSensitivitiesC2F3$BaseConvexitySlope <- 0.5*RiskMeasuresCurves2Factors3$BaseConvexitySlope * (BRSlopeChange/100.0)^2 * RiskMeasuresCurves2Factors3$EstimatedValueAtHorizon  
FactorSensitivitiesC2F3$BaseConvexityCurve1 <- 0.5*RiskMeasuresCurves2Factors3$BaseConvexityCurve1 * (BRCurve1Change/100.0)^2 * RiskMeasuresCurves2Factors3$EstimatedValueAtHorizon  
FactorSensitivitiesC2F3$BaseCrossConvexityCCLS <- RiskMeasuresCurves2Factors3$BaseCrossConvexityCCLS * (BRLevelChange/100.0) * (BRSlopeChange/100.0) * RiskMeasuresCurves2Factors3$EstimatedValueAtHorizon
FactorSensitivitiesC2F3$BaseCrossConvexityCCLC1 <- RiskMeasuresCurves2Factors3$BaseCrossConvexityCCLC1 * (BRLevelChange/100.0) * (BRCurve1Change/100.0) * RiskMeasuresCurves2Factors3$EstimatedValueAtHorizon  
FactorSensitivitiesC2F3$BaseCrossConvexityCCSC1 <- RiskMeasuresCurves2Factors3$BaseCrossConvexityCCSC1 * (BRSlopeChange/100.0) * (BRCurve1Change/100.0) * RiskMeasuresCurves2Factors3$EstimatedValueAtHorizon  
FactorSensitivitiesC2F3$Spread1DurationLevel <- -RiskMeasuresCurves2Factors3$Spread1DurationLevel * (SP1LevelChange/100.0) * RiskMeasuresCurves2Factors3$EstimatedValueAtHorizon
FactorSensitivitiesC2F3$Spread1DurationSlope <- -RiskMeasuresCurves2Factors3$Spread1DurationSlope * (SP1SlopeChange/100.0) * RiskMeasuresCurves2Factors3$EstimatedValueAtHorizon  
FactorSensitivitiesC2F3$Spread1DurationCurve1 <- -RiskMeasuresCurves2Factors3$Spread1DurationCurve1 * (SP1Curve1Change/100.0) * RiskMeasuresCurves2Factors3$EstimatedValueAtHorizon  
FactorSensitivitiesC2F3$Spread1ConvexityLevel <- 0.5*RiskMeasuresCurves2Factors3$Spread1ConvexityLevel * (SP1LevelChange/100.0)^2 * RiskMeasuresCurves2Factors3$EstimatedValueAtHorizon
FactorSensitivitiesC2F3$Spread1ConvexitySlope <- 0.5*RiskMeasuresCurves2Factors3$Spread1ConvexitySlope * (SP1SlopeChange/100.0)^2 * RiskMeasuresCurves2Factors3$EstimatedValueAtHorizon  
FactorSensitivitiesC2F3$Spread1ConvexityCurve1 <- 0.5*RiskMeasuresCurves2Factors3$Spread1ConvexityCurve1 * (SP1Curve1Change/100.0)^2 * RiskMeasuresCurves2Factors3$EstimatedValueAtHorizon  
FactorSensitivitiesC2F3$Spread1CrossConvexityCCLS <- RiskMeasuresCurves2Factors3$Spread1CrossConvexityCCLS * (SP1LevelChange/100.0)* (SP1SlopeChange/100.0) * RiskMeasuresCurves2Factors3$EstimatedValueAtHorizon
FactorSensitivitiesC2F3$Spread1CrossConvexityCCLC1 <- RiskMeasuresCurves2Factors3$Spread1CrossConvexityCCLC1 * (SP1LevelChange/100.0) * (SP1Curve1Change/100.0) * RiskMeasuresCurves2Factors3$EstimatedValueAtHorizon  
FactorSensitivitiesC2F3$Spread1CrossConvexityCCSC1 <- RiskMeasuresCurves2Factors3$Spread1CrossConvexityCCSC1 * (SP1SlopeChange/100.0) * (SP1Curve1Change/100.0) * RiskMeasuresCurves2Factors3$EstimatedValueAtHorizon  
write.xlsx(FactorSensitivitiesC2F3, "KM Factor Sensitivities.xlsx")
#
# Balance Sheet Attribution Analysis
#
AttributionC2F3 <- RiskMeasuresCurves2Factors3
keeps <- c("Names", "StatedValue", "EstimatedValue", "EstimatedValueAtHorizon", "EstimatedValueAtHorizonAll",
  "EstimatedValueAtHorizonBase", "EstimatedValueAtHorizonSpread1")
AttributionC2F3 = AttributionC2F3[keeps]
#AttributionC2F3$EstimatedValue <- NULL
ChangeAll <- abs(AttributionC2F3$EstimatedValueAtHorizonAll) - abs(AttributionC2F3$StatedValue) 
AttributionC2F3$ChangeAll <- round(ChangeAll, 2)
AttributionC2F3$PercentAll <- round(100.0 * ChangeAll / abs(AttributionC2F3$StatedValue), 2)
ChangeHAAll <- abs(AttributionC2F3$EstimatedValueAtHorizonAll) - abs(AttributionC2F3$EstimatedValueAtHorizon)
AttributionC2F3$ChangeHAAll <- round(ChangeHAAll, 2)
AttributionC2F3$PercentHAAll <- round(100.0 * ChangeHAAll / abs(AttributionC2F3$EstimatedValueAtHorizon), 2)
ChangeHOnly <- abs(AttributionC2F3$EstimatedValueAtHorizon) - abs(AttributionC2F3$StatedValue)
AttributionC2F3$ChangeHOnly <- round(ChangeHOnly, 2)
AttributionC2F3$PercentHOnly <- round(100.0 * ChangeHOnly / abs(AttributionC2F3$StatedValue), 2)
ChangeBase <- abs(AttributionC2F3$EstimatedValueAtHorizonBase) - abs(AttributionC2F3$EstimatedValueAtHorizon) 
AttributionC2F3$ChangeBase <- round(ChangeBase, 2)
AttributionC2F3$PercentBase <- round(100.0 * ChangeBase / abs(AttributionC2F3$EstimatedValueAtHorizon), 2)
ChangeSpread1 <- abs(AttributionC2F3$EstimatedValueAtHorizonSpread1) - abs(AttributionC2F3$EstimatedValueAtHorizon) 
AttributionC2F3$ChangeSpread1 <- round(ChangeSpread1, 2)
AttributionC2F3$PercentSpread1 <- round(100.0 * ChangeSpread1 / abs(AttributionC2F3$EstimatedValueAtHorizon), 2)
# ChangeSpread2 <- abs(AttributionC2F3$EstimatedValueAtHorizonSpread2) - abs(AttributionC2F3$EstimatedValueAtHorizon)
# AttributionC2F3$ChangeSpread2 <- round(ChangeSpread2, 2)
# AttributionC2F3$PercentSpread2 <- round(100.0 * ChangeSpread2 / abs(AttributionC2F3$EstimatedValueAtHorizon), 2)
ChangeInteraction <- ChangeAll - ChangeBase - ChangeSpread1 - ChangeHOnly
AttributionC2F3$ChangeInteraction <- round(ChangeInteraction, 2)
AttributionC2F3$PercentInteraction <- round(100.0 * ChangeInteraction / abs(AttributionC2F3$EstimatedValueAtHorizon),2)
write.xlsx(AttributionC2F3, "KM Attribution Measures.xlsx")
#
# Further decompositions
#


#
# Formatted output
#
# Market Value Balance Sheet
MVBalanceSheet <- AttributionC2F3
keeps <- c("Names","EstimatedValue")
MVBalanceSheet = MVBalanceSheet[keeps]
MVBalanceSheet$Value <- round(abs(MVBalanceSheet$EstimatedValue), 2)
MVBalanceSheet$EstimatedValue <- NULL
MVBalanceSheet$Value <- paste0("$",formatC(as.numeric(MVBalanceSheet$Value),format="f",digits=0,big.mark=","))
write.xlsx(MVBalanceSheet, "KM Market Value Balance Sheet.xlsx")
# Duration and Convexity
DurationAndConvexity <- RiskMeasuresCurves2Factors3
DurationAndConvexity$SRDuration <- round(DurationAndConvexity$BaseDurationLevel, 2)
DurationAndConvexity$SRConvexity <- round(DurationAndConvexity$BaseConvexityLevel, 2)
DurationAndConvexity$SP1Duration <- round(DurationAndConvexity$Spread1DurationLevel, 2)
DurationAndConvexity$SP1Convexity <- round(DurationAndConvexity$Spread1ConvexityLevel, 2)
keeps <- c("Names","SRDuration", "SRConvexity", "SP1Duration", "SP1Convexity")
DurationAndConvexity = DurationAndConvexity[keeps]
DurationAndConvexity$SRDuration <- formatC(as.numeric(DurationAndConvexity$SRDuration),format="f",digits=2,big.mark=",")
DurationAndConvexity$SRConvexity <- formatC(as.numeric(DurationAndConvexity$SRConvexity),format="f",digits=2,big.mark=",")
DurationAndConvexity$SP1Duration <- formatC(as.numeric(DurationAndConvexity$SP1Duration),format="f",digits=2,big.mark=",")
DurationAndConvexity$SP1Convexity <- formatC(as.numeric(DurationAndConvexity$SP1Convexity),format="f",digits=2,big.mark=",")
write.xlsx(DurationAndConvexity, "KM Level Duration and Convexity Only (One Spread).xlsx")
# LSC Parameters (Base and Spread1 Only)
LSCParameters = data.frame(matrix(vector(), 4, 7, dimnames=list(c(), 
  c("Parameter", "BRInitial", "BRHorizon", "BRDifference", "SP1Initial", "SP1Horizon", "SP1Difference"
  ))), stringsAsFactors=F)
LSCParameters$Parameter[1] <- "Level"
LSCParameters$Parameter[2] <- "Slope"
LSCParameters$Parameter[3] <- "Curvature"
LSCParameters$Parameter[4] <- "Scalar"
LSCParameters$BRInitial[1] <- paste0(formatC(as.numeric(InitialCurves$Base[2]),format="f",digits=2,big.mark=","),"%")
LSCParameters$BRInitial[2] <- paste0(formatC(as.numeric(InitialCurves$Base[4]),format="f",digits=2,big.mark=","),"%")
LSCParameters$BRInitial[3] <- paste0(formatC(as.numeric(InitialCurves$Base[5]),format="f",digits=2,big.mark=","),"%")
LSCParameters$BRInitial[4] <- paste0(formatC(as.numeric(InitialCurves$Base[3]),format="f",digits=2,big.mark=","),"%")
LSCParameters$BRHorizon[1] <- paste0(formatC(as.numeric(HorizonCurves$Base[2]),format="f",digits=2,big.mark=","),"%")
LSCParameters$BRHorizon[2] <- paste0(formatC(as.numeric(HorizonCurves$Base[4]),format="f",digits=2,big.mark=","),"%")
LSCParameters$BRHorizon[3] <- paste0(formatC(as.numeric(HorizonCurves$Base[5]),format="f",digits=2,big.mark=","),"%")
LSCParameters$BRHorizon[4] <- paste0(formatC(as.numeric(HorizonCurves$Base[3]),format="f",digits=2,big.mark=","),"%")
LSCParameters$BRDifference[1] <- paste0(formatC(as.numeric(HorizonCurves$Base[2] - InitialCurves$Base[2]),format="f",digits=2,big.mark=","),"%")
LSCParameters$BRDifference[2] <- paste0(formatC(as.numeric(HorizonCurves$Base[4] - InitialCurves$Base[4]),format="f",digits=2,big.mark=","),"%")
LSCParameters$BRDifference[3] <- paste0(formatC(as.numeric(HorizonCurves$Base[5] - InitialCurves$Base[5]),format="f",digits=2,big.mark=","),"%")
LSCParameters$BRDifference[4] <- paste0(formatC(as.numeric(HorizonCurves$Base[3] - InitialCurves$Base[3]),format="f",digits=2,big.mark=","),"%")
LSCParameters$SP1Initial[1] <- paste0(formatC(as.numeric(InitialCurves$Spread1[2]),format="f",digits=2,big.mark=","),"%")
LSCParameters$SP1Initial[2] <- paste0(formatC(as.numeric(InitialCurves$Spread1[4]),format="f",digits=2,big.mark=","),"%")
LSCParameters$SP1Initial[3] <- paste0(formatC(as.numeric(InitialCurves$Spread1[5]),format="f",digits=2,big.mark=","),"%")
LSCParameters$SP1Initial[4] <- paste0(formatC(as.numeric(InitialCurves$Spread1[3]),format="f",digits=2,big.mark=","),"%")
LSCParameters$SP1Horizon[1] <- paste0(formatC(as.numeric(HorizonCurves$Spread1[2]),format="f",digits=2,big.mark=","),"%")
LSCParameters$SP1Horizon[2] <- paste0(formatC(as.numeric(HorizonCurves$Spread1[4]),format="f",digits=2,big.mark=","),"%")
LSCParameters$SP1Horizon[3] <- paste0(formatC(as.numeric(HorizonCurves$Spread1[5]),format="f",digits=2,big.mark=","),"%")
LSCParameters$SP1Horizon[4] <- paste0(formatC(as.numeric(HorizonCurves$Spread1[3]),format="f",digits=2,big.mark=","),"%")
LSCParameters$SP1Difference[1] <- paste0(formatC(as.numeric(HorizonCurves$Spread1[2] - InitialCurves$Spread1[2]),format="f",digits=2,big.mark=","),"%")
LSCParameters$SP1Difference[2] <- paste0(formatC(as.numeric(HorizonCurves$Spread1[4] - InitialCurves$Spread1[4]),format="f",digits=2,big.mark=","),"%")
LSCParameters$SP1Difference[3] <- paste0(formatC(as.numeric(HorizonCurves$Spread1[5] - InitialCurves$Spread1[5]),format="f",digits=2,big.mark=","),"%")
LSCParameters$SP1Difference[4] <- paste0(formatC(as.numeric(HorizonCurves$Spread1[3] - InitialCurves$Spread1[3]),format="f",digits=2,big.mark=","),"%")
write.xlsx(LSCParameters, "KM LSC Parameters (One Spread).xlsx")
# Balance Sheet Change (Table 23)
# Market Value Balance Sheet
MVChangeBalanceSheet <- AttributionC2F3
keeps <- c("Names","EstimatedValue", "EstimatedValueAtHorizonAll")
MVChangeBalanceSheet = MVChangeBalanceSheet[keeps]
MVChangeBalanceSheet$ActualChange <- MVChangeBalanceSheet$EstimatedValueAtHorizonAll - MVChangeBalanceSheet$EstimatedValue
MVChangeBalanceSheet$PercentageChange <- 
  MVChangeBalanceSheet$ActualChange <- paste0("$",formatC(round(MVChangeBalanceSheet$ActualChange, 2),
  format="f",digits=2,big.mark=","))
MVChangeBalanceSheet$PercentageChange <- paste0(formatC(round(100.0*(MVChangeBalanceSheet$EstimatedValueAtHorizonAll -
  MVChangeBalanceSheet$EstimatedValue)/MVChangeBalanceSheet$EstimatedValue, 2),format="f",digits=2,big.mark=","),"%")
MVChangeBalanceSheet$InitialValue <- paste0("$",formatC(round(MVChangeBalanceSheet$EstimatedValue, 2),
  format="f",digits=2,big.mark=","))
MVChangeBalanceSheet$HorizonValue <- paste0("$",formatC(round(MVChangeBalanceSheet$EstimatedValueAtHorizonAll, 2),
  format="f",digits=2,big.mark=","))
MVChangeBalanceSheet$EstimatedValue <- NULL
MVChangeBalanceSheet$EstimatedValueAtHorizonAll <- NULL
keeps <- c("Names","InitialValue", "HorizonValue", "ActualChange", "PercentageChange")
MVChangeBalanceSheet = MVChangeBalanceSheet[keeps]
write.xlsx(MVChangeBalanceSheet, "KM Balance Sheet Change.xlsx")
# Net Worth Risk Measures (Table 24a)
NetWorthRiskMeasures = data.frame(matrix(vector(), 3, 7, dimnames=list(c(), 
  c("Parameter", "BRLevel", "BRSlope", "BRCurve1", "SP1Level", "SP1Slope", "SP1Curve1"
  ))), stringsAsFactors=F)
NetWorthRiskMeasures$Parameter[1] <- "Duration"
NetWorthRiskMeasures$Parameter[2] <- "Convexity"
NetWorthRiskMeasures$Parameter[3] <- "Cross-Convexity"
NetWorthRiskMeasures$BRLevel[1] <- formatC(as.numeric(RiskMeasuresCurves2Factors3$BaseDurationLevel[12]),format="f",digits=2,big.mark=",")
NetWorthRiskMeasures$BRLevel[2] <- formatC(as.numeric(RiskMeasuresCurves2Factors3$BaseConvexityLevel[12]),format="f",digits=2,big.mark=",")
NetWorthRiskMeasures$BRLevel[3] <- formatC(as.numeric(RiskMeasuresCurves2Factors3$BaseCrossConvexityCCLS[12]),format="f",digits=2,big.mark=",")
NetWorthRiskMeasures$BRSlope[1] <- formatC(as.numeric(RiskMeasuresCurves2Factors3$BaseDurationSlope[12]),format="f",digits=2,big.mark=",")
NetWorthRiskMeasures$BRSlope[2] <- formatC(as.numeric(RiskMeasuresCurves2Factors3$BaseConvexitySlope[12]),format="f",digits=2,big.mark=",")
NetWorthRiskMeasures$BRSlope[3] <- formatC(as.numeric(RiskMeasuresCurves2Factors3$BaseCrossConvexityCCSC1[12]),format="f",digits=2,big.mark=",")
NetWorthRiskMeasures$BRCurve1[1] <- formatC(as.numeric(RiskMeasuresCurves2Factors3$BaseDurationCurve1[12]),format="f",digits=2,big.mark=",")
NetWorthRiskMeasures$BRCurve1[2] <- formatC(as.numeric(RiskMeasuresCurves2Factors3$BaseConvexityCurve1[12]),format="f",digits=2,big.mark=",")
NetWorthRiskMeasures$BRCurve1[3] <- formatC(as.numeric(RiskMeasuresCurves2Factors3$BaseCrossConvexityCCLC1[12]),format="f",digits=2,big.mark=",")
NetWorthRiskMeasures$SP1Level[1] <- formatC(as.numeric(RiskMeasuresCurves2Factors3$Spread1DurationLevel[12]),format="f",digits=2,big.mark=",")
NetWorthRiskMeasures$SP1Level[2] <- formatC(as.numeric(RiskMeasuresCurves2Factors3$Spread1ConvexityLevel[12]),format="f",digits=2,big.mark=",")
NetWorthRiskMeasures$SP1Level[3] <- formatC(as.numeric(RiskMeasuresCurves2Factors3$Spread1CrossConvexityCCLS[12]),format="f",digits=2,big.mark=",")
NetWorthRiskMeasures$SP1Slope[1] <- formatC(as.numeric(RiskMeasuresCurves2Factors3$Spread1DurationSlope[12]),format="f",digits=2,big.mark=",")
NetWorthRiskMeasures$SP1Slope[2] <- formatC(as.numeric(RiskMeasuresCurves2Factors3$Spread1ConvexitySlope[12]),format="f",digits=2,big.mark=",")
NetWorthRiskMeasures$SP1Slope[3] <- formatC(as.numeric(RiskMeasuresCurves2Factors3$Spread1CrossConvexityCCSC1[12]),format="f",digits=2,big.mark=",")
NetWorthRiskMeasures$SP1Curve1[1] <- formatC(as.numeric(RiskMeasuresCurves2Factors3$Spread1DurationCurve1[12]),format="f",digits=2,big.mark=",")
NetWorthRiskMeasures$SP1Curve1[2] <- formatC(as.numeric(RiskMeasuresCurves2Factors3$Spread1ConvexityCurve1[12]),format="f",digits=2,big.mark=",")
NetWorthRiskMeasures$SP1Curve1[3] <- formatC(as.numeric(RiskMeasuresCurves2Factors3$Spread1CrossConvexityCCLC1[12]),format="f",digits=2,big.mark=",")
write.xlsx(NetWorthRiskMeasures, "KM Net Worth Risk Measures.xlsx")
# Net Worth Factor Sensitivities (Table 24b, add one column for BR and SPR1 ($ Change))
# Add one row at bottom ($ Totals)
NetWorthFactorSensitivities = data.frame(matrix(vector(), 4, 9, dimnames=list(c(), 
  c("Parameter", "BRLevel", "BRSlope", "BRCurve1", "BRTotal", "SP1Level", "SP1Slope", "SP1Curve1", "SP1Total"
  ))), stringsAsFactors=F)
NetWorthFactorSensitivities$Parameter[1] <- "Duration"
NetWorthFactorSensitivities$Parameter[2] <- "Convexity"
NetWorthFactorSensitivities$Parameter[3] <- "Cross-Convexity"
NetWorthFactorSensitivities$Parameter[4] <- "Total"
BDL <- as.numeric(FactorSensitivitiesC2F3$BaseDurationLevel[12])
BCL <- as.numeric(FactorSensitivitiesC2F3$BaseConvexityLevel[12])
BCCL <- as.numeric(FactorSensitivitiesC2F3$BaseCrossConvexityCCLS[12])
SBL <- BDL + BCL + BCCL # Sum Base Level
NetWorthFactorSensitivities$BRLevel[1] <- formatC(BDL,format="f",digits=2,big.mark=",")
NetWorthFactorSensitivities$BRLevel[2] <- formatC(BCL,format="f",digits=2,big.mark=",")
NetWorthFactorSensitivities$BRLevel[3] <- formatC(BCCL,format="f",digits=2,big.mark=",")
NetWorthFactorSensitivities$BRLevel[4] <- formatC(SBL,format="f",digits=2,big.mark=",")
BDS <- as.numeric(FactorSensitivitiesC2F3$BaseDurationSlope[12])
BCS <- as.numeric(FactorSensitivitiesC2F3$BaseConvexitySlope[12])
BCCS <- as.numeric(FactorSensitivitiesC2F3$BaseCrossConvexityCCSC1[12])
SBS <- BDS + BCS + BCCS # Sum Base Slope
NetWorthFactorSensitivities$BRSlope[1] <- formatC(BDS,format="f",digits=2,big.mark=",")
NetWorthFactorSensitivities$BRSlope[2] <- formatC(BCS,format="f",digits=2,big.mark=",")
NetWorthFactorSensitivities$BRSlope[3] <- formatC(BCCS,format="f",digits=2,big.mark=",")
NetWorthFactorSensitivities$BRSlope[4] <- formatC(SBS,format="f",digits=2,big.mark=",")
BDC1 <- as.numeric(FactorSensitivitiesC2F3$BaseDurationCurve1[12])
BCC1 <- as.numeric(FactorSensitivitiesC2F3$BaseConvexityCurve1[12])
BCCC1 <- as.numeric(FactorSensitivitiesC2F3$BaseCrossConvexityCCLC1[12])
SBC1 <- BDC1 + BCC1 + BCCC1 # Sum Base Curve1
NetWorthFactorSensitivities$BRCurve1[1] <- formatC(BDC1,format="f",digits=2,big.mark=",")
NetWorthFactorSensitivities$BRCurve1[2] <- formatC(BCC1,format="f",digits=2,big.mark=",")
NetWorthFactorSensitivities$BRCurve1[3] <- formatC(BCCC1,format="f",digits=2,big.mark=",")
NetWorthFactorSensitivities$BRCurve1[4] <- formatC(SBC1,format="f",digits=2,big.mark=",")
# Totals
BTD <- BDL + BDS + BDC1
BTC <- BCL + BCS + BCC1
BTCC <- BCCL + BCCS + BCCC1
GTB <- BTD + BTC + BTCC # Grand total
NetWorthFactorSensitivities$BRTotal[1] <- formatC(BTD,format="f",digits=2,big.mark=",")
NetWorthFactorSensitivities$BRTotal[2] <- formatC(BTC,format="f",digits=2,big.mark=",")
NetWorthFactorSensitivities$BRTotal[3] <- formatC(BTCC,format="f",digits=2,big.mark=",")
NetWorthFactorSensitivities$BRTotal[4] <- formatC(GTB,format="f",digits=2,big.mark=",")
# Spread1
SPDL <- as.numeric(FactorSensitivitiesC2F3$Spread1DurationLevel[12])
SPCL <- as.numeric(FactorSensitivitiesC2F3$Spread1ConvexityLevel[12])
SPCCL <- as.numeric(FactorSensitivitiesC2F3$Spread1CrossConvexityCCLS[12])
SSPL <- SPDL + SPCL + SPCCL # Sum Spread1 Level
NetWorthFactorSensitivities$SP1Level[1] <- formatC(SPDL,format="f",digits=2,big.mark=",")
NetWorthFactorSensitivities$SP1Level[2] <- formatC(SPCL,format="f",digits=2,big.mark=",")
NetWorthFactorSensitivities$SP1Level[3] <- formatC(SPCCL,format="f",digits=2,big.mark=",")
NetWorthFactorSensitivities$SP1Level[4] <- formatC(SSPL,format="f",digits=2,big.mark=",")
SPDS <- as.numeric(FactorSensitivitiesC2F3$Spread1DurationSlope[12])
SPCS <- as.numeric(FactorSensitivitiesC2F3$Spread1ConvexitySlope[12])
SPCCS <- as.numeric(FactorSensitivitiesC2F3$Spread1CrossConvexityCCSC1[12])
SSPS <- SPDS + SPCS + SPCCS # Sum Spread1 Slope
NetWorthFactorSensitivities$SP1Slope[1] <- formatC(SPDS,format="f",digits=2,big.mark=",")
NetWorthFactorSensitivities$SP1Slope[2] <- formatC(SPCS,format="f",digits=2,big.mark=",")
NetWorthFactorSensitivities$SP1Slope[3] <- formatC(SPCCS,format="f",digits=2,big.mark=",")
NetWorthFactorSensitivities$SP1Slope[4] <- formatC(SSPS,format="f",digits=2,big.mark=",")
SPDC1 <- as.numeric(FactorSensitivitiesC2F3$Spread1DurationCurve1[12])
SPCC1 <- as.numeric(FactorSensitivitiesC2F3$Spread1ConvexityCurve1[12])
SPCCC1 <- as.numeric(FactorSensitivitiesC2F3$Spread1CrossConvexityCCLC1[12])
SSPC1 <- SPDC1 + SPCC1 + SPCCC1 # Sum Spread1 Curve1
NetWorthFactorSensitivities$SP1Curve1[1] <- formatC(SPDC1,format="f",digits=2,big.mark=",")
NetWorthFactorSensitivities$SP1Curve1[2] <- formatC(SPCC1,format="f",digits=2,big.mark=",")
NetWorthFactorSensitivities$SP1Curve1[3] <- formatC(SPCCC1,format="f",digits=2,big.mark=",")
NetWorthFactorSensitivities$SP1Curve1[4] <- formatC(SSPC1,format="f",digits=2,big.mark=",")
# Totals
SP1TD <- SPDL + SPDS + SPDC1
SP1TC <- SPCL + SPCS + SPCC1
SP1TCC <- SPCCL + SPCCS + SPCCC1
GTSP1 <- SP1TD + SP1TC + SP1TCC # Grand total
NetWorthFactorSensitivities$SP1Total[1] <- formatC(SP1TD,format="f",digits=2,big.mark=",")
NetWorthFactorSensitivities$SP1Total[2] <- formatC(SP1TC,format="f",digits=2,big.mark=",")
NetWorthFactorSensitivities$SP1Total[3] <- formatC(SP1TCC,format="f",digits=2,big.mark=",")
NetWorthFactorSensitivities$SP1Total[4] <- formatC(GTSP1,format="f",digits=2,big.mark=",")
write.xlsx(NetWorthFactorSensitivities, "KM Net Worth Factor Sensitivities.xlsx")
# Net Worth Factor Sensitivities (in % of NW) (Table 24b, add one column for BR and SPR1 (% Change))
# Add one row at bottom (% Totals) (Assuming + initial NW)
NetWorthRiskMeasures = data.frame(matrix(vector(), 3, 7, dimnames=list(c(), 
  c("Parameter", "BRLevel", "BRSlope", "BRCurve1", "SP1Level", "SP1Slope", "SP1Curve1"
  ))), stringsAsFactors=F)
NetWorthRiskMeasures$Parameter[1] <- "Duration"
NetWorthRiskMeasures$Parameter[2] <- "Convexity"
NetWorthRiskMeasures$Parameter[3] <- "Cross-Convexity"
NetWorthRiskMeasures$BRLevel[1] <- formatC(as.numeric(RiskMeasuresCurves2Factors3$BaseDurationLevel[12]),format="f",digits=2,big.mark=",")
NetWorthRiskMeasures$BRLevel[2] <- formatC(as.numeric(RiskMeasuresCurves2Factors3$BaseConvexityLevel[12]),format="f",digits=2,big.mark=",")
NetWorthRiskMeasures$BRLevel[3] <- formatC(as.numeric(RiskMeasuresCurves2Factors3$BaseCrossConvexityCCLS[12]),format="f",digits=2,big.mark=",")
NetWorthRiskMeasures$BRSlope[1] <- formatC(as.numeric(RiskMeasuresCurves2Factors3$BaseDurationSlope[12]),format="f",digits=2,big.mark=",")
NetWorthRiskMeasures$BRSlope[2] <- formatC(as.numeric(RiskMeasuresCurves2Factors3$BaseConvexitySlope[12]),format="f",digits=2,big.mark=",")
NetWorthRiskMeasures$BRSlope[3] <- formatC(as.numeric(RiskMeasuresCurves2Factors3$BaseCrossConvexityCCSC1[12]),format="f",digits=2,big.mark=",")
NetWorthRiskMeasures$BRCurve1[1] <- formatC(as.numeric(RiskMeasuresCurves2Factors3$BaseDurationCurve1[12]),format="f",digits=2,big.mark=",")
NetWorthRiskMeasures$BRCurve1[2] <- formatC(as.numeric(RiskMeasuresCurves2Factors3$BaseConvexityCurve1[12]),format="f",digits=2,big.mark=",")
NetWorthRiskMeasures$BRCurve1[3] <- formatC(as.numeric(RiskMeasuresCurves2Factors3$BaseCrossConvexityCCLC1[12]),format="f",digits=2,big.mark=",")
NetWorthRiskMeasures$SP1Level[1] <- formatC(as.numeric(RiskMeasuresCurves2Factors3$Spread1DurationLevel[12]),format="f",digits=2,big.mark=",")
NetWorthRiskMeasures$SP1Level[2] <- formatC(as.numeric(RiskMeasuresCurves2Factors3$Spread1ConvexityLevel[12]),format="f",digits=2,big.mark=",")
NetWorthRiskMeasures$SP1Level[3] <- formatC(as.numeric(RiskMeasuresCurves2Factors3$Spread1CrossConvexityCCLS[12]),format="f",digits=2,big.mark=",")
NetWorthRiskMeasures$SP1Slope[1] <- formatC(as.numeric(RiskMeasuresCurves2Factors3$Spread1DurationSlope[12]),format="f",digits=2,big.mark=",")
NetWorthRiskMeasures$SP1Slope[2] <- formatC(as.numeric(RiskMeasuresCurves2Factors3$Spread1ConvexitySlope[12]),format="f",digits=2,big.mark=",")
NetWorthRiskMeasures$SP1Slope[3] <- formatC(as.numeric(RiskMeasuresCurves2Factors3$Spread1CrossConvexityCCSC1[12]),format="f",digits=2,big.mark=",")
NetWorthRiskMeasures$SP1Curve1[1] <- formatC(as.numeric(RiskMeasuresCurves2Factors3$Spread1DurationCurve1[12]),format="f",digits=2,big.mark=",")
NetWorthRiskMeasures$SP1Curve1[2] <- formatC(as.numeric(RiskMeasuresCurves2Factors3$Spread1ConvexityCurve1[12]),format="f",digits=2,big.mark=",")
NetWorthRiskMeasures$SP1Curve1[3] <- formatC(as.numeric(RiskMeasuresCurves2Factors3$Spread1CrossConvexityCCLC1[12]),format="f",digits=2,big.mark=",")
write.xlsx(NetWorthRiskMeasures, "KM Net Worth Risk Measures.xlsx")
# Net Worth Factor Sensitivities (Table 24b, add one column for BR and SPR1 ($ Change))
# Add one row at bottom ($ Totals)
NetWorthPFactorSensitivities = data.frame(matrix(vector(), 4, 9, dimnames=list(c(), 
   c("Parameter", "BRLevel", "BRSlope", "BRCurve1", "BRTotal", "SP1Level", "SP1Slope", "SP1Curve1", "SP1Total"
   ))), stringsAsFactors=F)
NetWorthPFactorSensitivities$Parameter[1] <- "Duration"
NetWorthPFactorSensitivities$Parameter[2] <- "Convexity"
NetWorthPFactorSensitivities$Parameter[3] <- "Cross-Convexity"
NetWorthPFactorSensitivities$Parameter[4] <- "Total"
EstimatedNW <- as.numeric(AttributionC2F3$EstimatedValue[12]) # Estimated net worth at time 0
BDL <- as.numeric(100.0*FactorSensitivitiesC2F3$BaseDurationLevel[12]/EstimatedNW)
BCL <- as.numeric(100.0*FactorSensitivitiesC2F3$BaseConvexityLevel[12]/EstimatedNW)
BCCL <- as.numeric(100.0*FactorSensitivitiesC2F3$BaseCrossConvexityCCLS[12]/EstimatedNW)
SBL <- BDL + BCL + BCCL # Sum Base Level
NetWorthPFactorSensitivities$BRLevel[1] <- paste0(formatC(BDL,format="f",digits=2,big.mark=","), "%")
NetWorthPFactorSensitivities$BRLevel[2] <- paste0(formatC(BCL,format="f",digits=2,big.mark=","), "%")
NetWorthPFactorSensitivities$BRLevel[3] <- paste0(formatC(BCCL,format="f",digits=2,big.mark=","), "%")
NetWorthPFactorSensitivities$BRLevel[4] <- paste0(formatC(SBL,format="f",digits=2,big.mark=","), "%")
BDS <- as.numeric(100.0*FactorSensitivitiesC2F3$BaseDurationSlope[12]/EstimatedNW)
BCS <- as.numeric(100.0*FactorSensitivitiesC2F3$BaseConvexitySlope[12]/EstimatedNW)
BCCS <- as.numeric(100.0*FactorSensitivitiesC2F3$BaseCrossConvexityCCSC1[12]/EstimatedNW)
SBS <- BDS + BCS + BCCS # Sum Base Slope
NetWorthPFactorSensitivities$BRSlope[1] <- paste0(formatC(BDS,format="f",digits=2,big.mark=","), "%")
NetWorthPFactorSensitivities$BRSlope[2] <- paste0(formatC(BCS,format="f",digits=2,big.mark=","), "%")
NetWorthPFactorSensitivities$BRSlope[3] <- paste0(formatC(BCCS,format="f",digits=2,big.mark=","), "%")
NetWorthPFactorSensitivities$BRSlope[4] <- paste0(formatC(SBS,format="f",digits=2,big.mark=","), "%")
BDC1 <- as.numeric(100.0*FactorSensitivitiesC2F3$BaseDurationCurve1[12]/EstimatedNW)
BCC1 <- as.numeric(100.0*FactorSensitivitiesC2F3$BaseConvexityCurve1[12]/EstimatedNW)
BCCC1 <- as.numeric(100.0*FactorSensitivitiesC2F3$BaseCrossConvexityCCLC1[12]/EstimatedNW)
SBC1 <- BDC1 + BCC1 + BCCC1 # Sum Base Curve1
NetWorthPFactorSensitivities$BRCurve1[1] <- paste0(formatC(BDC1,format="f",digits=2,big.mark=","), "%")
NetWorthPFactorSensitivities$BRCurve1[2] <- paste0(formatC(BCC1,format="f",digits=2,big.mark=","), "%")
NetWorthPFactorSensitivities$BRCurve1[3] <- paste0(formatC(BCCC1,format="f",digits=2,big.mark=","), "%")
NetWorthPFactorSensitivities$BRCurve1[4] <- paste0(formatC(SBC1,format="f",digits=2,big.mark=","), "%")
# Totals
BTD <- BDL + BDS + BDC1
BTC <- BCL + BCS + BCC1
BTCC <- BCCL + BCCS + BCCC1
GTB <- BTD + BTC + BTCC # Grand total
NetWorthPFactorSensitivities$BRTotal[1] <- paste0(formatC(BTD,format="f",digits=2,big.mark=","), "%")
NetWorthPFactorSensitivities$BRTotal[2] <- paste0(formatC(BTC,format="f",digits=2,big.mark=","), "%")
NetWorthPFactorSensitivities$BRTotal[3] <- paste0(formatC(BTCC,format="f",digits=2,big.mark=","), "%")
NetWorthPFactorSensitivities$BRTotal[4] <- paste0(formatC(GTB,format="f",digits=2,big.mark=","), "%")
# Spread1
SPDL <- as.numeric(100.0*FactorSensitivitiesC2F3$Spread1DurationLevel[12]/EstimatedNW)
SPCL <- as.numeric(100.0*FactorSensitivitiesC2F3$Spread1ConvexityLevel[12]/EstimatedNW)
SPCCL <- as.numeric(100.0*FactorSensitivitiesC2F3$Spread1CrossConvexityCCLS[12]/EstimatedNW)
SSPL <- SPDL + SPCL + SPCCL # Sum Spread1 Level
NetWorthPFactorSensitivities$SP1Level[1] <- paste0(formatC(SPDL,format="f",digits=2,big.mark=","), "%")
NetWorthPFactorSensitivities$SP1Level[2] <- paste0(formatC(SPCL,format="f",digits=2,big.mark=","), "%")
NetWorthPFactorSensitivities$SP1Level[3] <- paste0(formatC(SPCCL,format="f",digits=2,big.mark=","), "%")
NetWorthPFactorSensitivities$SP1Level[4] <- paste0(formatC(SSPL,format="f",digits=2,big.mark=","), "%")
SPDS <- as.numeric(100.0*FactorSensitivitiesC2F3$Spread1DurationSlope[12]/EstimatedNW)
SPCS <- as.numeric(100.0*FactorSensitivitiesC2F3$Spread1ConvexitySlope[12]/EstimatedNW)
SPCCS <- as.numeric(100.0*FactorSensitivitiesC2F3$Spread1CrossConvexityCCSC1[12]/EstimatedNW)
SSPS <- SPDS + SPCS + SPCCS # Sum Spread1 Slope
NetWorthPFactorSensitivities$SP1Slope[1] <- paste0(formatC(SPDS,format="f",digits=2,big.mark=","), "%")
NetWorthPFactorSensitivities$SP1Slope[2] <- paste0(formatC(SPCS,format="f",digits=2,big.mark=","), "%")
NetWorthPFactorSensitivities$SP1Slope[3] <- paste0(formatC(SPCCS,format="f",digits=2,big.mark=","), "%")
NetWorthPFactorSensitivities$SP1Slope[4] <- paste0(formatC(SSPS,format="f",digits=2,big.mark=","), "%")
SPDC1 <- as.numeric(100.0*FactorSensitivitiesC2F3$Spread1DurationCurve1[12]/EstimatedNW)
SPCC1 <- as.numeric(100.0*FactorSensitivitiesC2F3$Spread1ConvexityCurve1[12]/EstimatedNW)
SPCCC1 <- as.numeric(100.0*FactorSensitivitiesC2F3$Spread1CrossConvexityCCLC1[12]/EstimatedNW)
SSPC1 <- SPDC1 + SPCC1 + SPCCC1 # Sum Spread1 Curve1
NetWorthPFactorSensitivities$SP1Curve1[1] <- paste0(formatC(SPDC1,format="f",digits=2,big.mark=","), "%")
NetWorthPFactorSensitivities$SP1Curve1[2] <- paste0(formatC(SPCC1,format="f",digits=2,big.mark=","), "%")
NetWorthPFactorSensitivities$SP1Curve1[3] <- paste0(formatC(SPCCC1,format="f",digits=2,big.mark=","), "%")
NetWorthPFactorSensitivities$SP1Curve1[4] <- paste0(formatC(SSPC1,format="f",digits=2,big.mark=","), "%")
# Totals
SP1TD <- SPDL + SPDS + SPDC1
SP1TC <- SPCL + SPCS + SPCC1
SP1TCC <- SPCCL + SPCCS + SPCCC1
GTSP1 <- SP1TD + SP1TC + SP1TCC # Grand total
NetWorthPFactorSensitivities$SP1Total[1] <- paste0(formatC(SP1TD,format="f",digits=2,big.mark=","), "%")
NetWorthPFactorSensitivities$SP1Total[2] <- paste0(formatC(SP1TC,format="f",digits=2,big.mark=","), "%")
NetWorthPFactorSensitivities$SP1Total[3] <- paste0(formatC(SP1TCC,format="f",digits=2,big.mark=","), "%")
NetWorthPFactorSensitivities$SP1Total[4] <- paste0(formatC(GTSP1,format="f",digits=2,big.mark=","), "%")
write.xlsx(NetWorthPFactorSensitivities, "KM Net Worth Percent Factor Sensitivities.xlsx")
#
# Surplus Decomposition (Table 24c)
#
NetWorthSurplusDecomposition = data.frame(matrix(vector(), 5, 3, dimnames=list(c(), 
  c("Parameter", "DollarChange", "PercentChange"))), stringsAsFactors=F)
NetWorthSurplusDecomposition$Parameter[1] <- "Actual"
NetWorthSurplusDecomposition$Parameter[2] <- "Horizon"
NetWorthSurplusDecomposition$Parameter[3] <- "BaseRate"
NetWorthSurplusDecomposition$Parameter[4] <- "Spread1"
NetWorthSurplusDecomposition$Parameter[5] <- "Interaction"
ADC <- RiskMeasuresCurves2Factors3$EstimatedValueAtHorizonAll[12] - RiskMeasuresCurves2Factors3$StatedValue[12]
APC <- 100.0*(ADC/RiskMeasuresCurves2Factors3$EstimatedValue[12])
HDC <- RiskMeasuresCurves2Factors3$EstimatedValueAtHorizon[12] - RiskMeasuresCurves2Factors3$EstimatedValue[12]
HPC <- 100.0*(HDC/RiskMeasuresCurves2Factors3$EstimatedValue[12])
BRDC <- RiskMeasuresCurves2Factors3$EstimatedValueAtHorizonBase[12] - RiskMeasuresCurves2Factors3$EstimatedValueAtHorizon[12]
BRPC <- 100.0*(BRDC/RiskMeasuresCurves2Factors3$EstimatedValue[12])
SP1DC <- RiskMeasuresCurves2Factors3$EstimatedValueAtHorizonSpread1[12] - RiskMeasuresCurves2Factors3$EstimatedValueAtHorizon[12]
SP1PC <- 100.0*(SP1DC/RiskMeasuresCurves2Factors3$EstimatedValue[12])
IDC <- ADC - HDC - BRDC - SP1DC
IPC <- 100.0*((ADC - HDC - BRDC - SP1DC)/RiskMeasuresCurves2Factors3$EstimatedValue[12])
NetWorthSurplusDecomposition$DollarChange[1] <- paste0("$",formatC(ADC,format="f",digits=2,big.mark=","))
NetWorthSurplusDecomposition$PercentChange[1] <- paste0(formatC(APC,format="f",digits=2,big.mark=","), "%")
NetWorthSurplusDecomposition$DollarChange[2] <- paste0("$",formatC(HDC,format="f",digits=2,big.mark=","))
NetWorthSurplusDecomposition$PercentChange[2] <- paste0(formatC(HPC,format="f",digits=2,big.mark=","), "%")
NetWorthSurplusDecomposition$DollarChange[3] <- paste0("$",formatC(BRDC,format="f",digits=2,big.mark=","))
NetWorthSurplusDecomposition$PercentChange[3] <- paste0(formatC(BRPC,format="f",digits=2,big.mark=","), "%")
NetWorthSurplusDecomposition$DollarChange[4] <- paste0("$",formatC(SP1DC,format="f",digits=2,big.mark=","))
NetWorthSurplusDecomposition$PercentChange[4] <- paste0(formatC(SP1PC,format="f",digits=2,big.mark=","), "%")
NetWorthSurplusDecomposition$DollarChange[5] <- paste0("$",formatC(IDC,format="f",digits=2,big.mark=","))
NetWorthSurplusDecomposition$PercentChange[5] <- paste0(formatC(IPC,format="f",digits=2,big.mark=","), "%")
NetWorthSurplusDecomposition
write.xlsx(NetWorthSurplusDecomposition, "KM Net Worth Surplus Decomposition.xlsx")




