# KM Spread1 Rate Static Risk Measures.R
# Spread1 rate static risk measures
L <- InitialCurves$Spread1[2]
k1 <- InitialCurves$Spread1[3]
S <- InitialCurves$Spread1[4]
C1 <- InitialCurves$Spread1[5]
k2 <- InitialCurves$Spread1[6]
C2 <- InitialCurves$Spread1[7]
k3 <- InitialCurves$Spread1[8]
C3 <- InitialCurves$Spread1[9]
k4 <- InitialCurves$Spread1[10]
C4 <- InitialCurves$Spread1[11]
k5 <- InitialCurves$Spread1[12]
C5 <- InitialCurves$Spread1[13]
# Spread1 rate maturity coefficients at Horizon
M <- dfStaticRiskMeasures$Maturity-Horizon
LengthM = length(M)
for(i in 1:LengthM){ # Cannot have zero in LSC model
  if(M[i] == 0)M[i] <- 0.000001
}
x1 <- (k1/M)*(1.0 - exp(-M/k1))
x2 <- x1 - exp(-M/k1)
x3 <- (k2/M) * (1.0 - exp(-M/k2)) - exp(-M/k2)
x4 <- (k3/M) * (1.0 - exp(-M/k3)) - exp(-M/k3)
x5 <- (k4/M) * (1.0 - exp(-M/k4)) - exp(-M/k4)
x6 <- (k5/M) * (1.0 - exp(-M/k5)) - exp(-M/k5)
W <- dfStaticRiskMeasures$Weight
CW <- dfStaticRiskMeasures$WSpread1 # Weight of particular curve
#
# Spread1 Duration
#
dfStaticRiskMeasures$Spread1DurationLevel <- M * 1.0 * W * CW
dfStaticRiskMeasures$Spread1DurationSlope <- M * x1 * W * CW

# dfStaticRiskMeasures
# W
# CW
# M
# dfStaticRiskMeasures$Spread1DurationSlope

dfStaticRiskMeasures$Spread1DurationCurve1 <- M * x2 * W * CW
dfStaticRiskMeasures$Spread1DurationCurve2 <- M * x3 * W * CW
dfStaticRiskMeasures$Spread1DurationCurve3 <- M * x4 * W * CW
dfStaticRiskMeasures$Spread1DurationCurve4 <- M * x5 * W * CW
dfStaticRiskMeasures$Spread1DurationCurve5 <- M * x6 * W * CW
# Level
dfSpread1DurationLevel <- ddply(dfStaticRiskMeasures, .(Instrument), summarize, 
  dfStaticRiskMeasures=sum(Spread1DurationLevel))
dfSpread1DurationLevel$Spread1DurationLevel <- dfSpread1DurationLevel$dfStaticRiskMeasures
dfSpread1DurationLevel$dfStaticRiskMeasures <- NULL
# Compute Static Risk Measure for Net Worth
dfSpread1DurationLevel <- rbind(dfSpread1DurationLevel, y = c(MaxInstruments+1, NA))
dfSpread1DurationLevel <- rbind(dfSpread1DurationLevel, y = c(MaxInstruments+2, NA))
dfSpread1DurationLevel <- rbind(dfSpread1DurationLevel, y = c(MaxInstruments+3, NA))
TA <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+2]
TL <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+3]
SRMA <- 0.0
for(i in 1:NumberOfAssets){
  SRMA <- SRMA + dfSpread1DurationLevel$Spread1DurationLevel[i] * (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[i]/TA)
}
SRML <- 0.0
for(i in 1:NumberOfLiabilities){
  SRML <- SRML + dfSpread1DurationLevel$Spread1DurationLevel[NumberOfAssets+i] * 
    (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[NumberOfAssets+i]/TL)
}
if(TA == -TL){
  dfSpread1DurationLevel$Spread1DurationLevel[MaxInstruments+1] <- NA
} else {
  dfSpread1DurationLevel$Spread1DurationLevel[MaxInstruments+1] <- (SRMA*TA + SRML*TL)/(TA + TL)
}
dfSpread1DurationLevel$Spread1DurationLevel[MaxInstruments+2] <- SRMA
dfSpread1DurationLevel$Spread1DurationLevel[MaxInstruments+3] <- SRML
dfSpread1DurationLevel
# Slope
dfSpread1DurationSlope <- ddply(dfStaticRiskMeasures, .(Instrument), summarize, 
                             dfStaticRiskMeasures=sum(Spread1DurationSlope))
dfSpread1DurationSlope$Spread1DurationSlope <- dfSpread1DurationSlope$dfStaticRiskMeasures
dfSpread1DurationSlope$dfStaticRiskMeasures <- NULL
# Compute Static Risk Measure for Net Worth
dfSpread1DurationSlope <- rbind(dfSpread1DurationSlope, y = c(MaxInstruments+1, NA))
dfSpread1DurationSlope <- rbind(dfSpread1DurationSlope, y = c(MaxInstruments+2, NA))
dfSpread1DurationSlope <- rbind(dfSpread1DurationSlope, y = c(MaxInstruments+3, NA))
TA <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+2]
TL <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+3]
SRMA <- 0.0
for(i in 1:NumberOfAssets){
  SRMA <- SRMA + dfSpread1DurationSlope$Spread1DurationSlope[i] * (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[i]/TA)
}
SRML <- 0.0
for(i in 1:NumberOfLiabilities){
  SRML <- SRML + dfSpread1DurationSlope$Spread1DurationSlope[NumberOfAssets+i] * 
    (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[NumberOfAssets+i]/TL)
}
if(TA == -TL){
  dfSpread1DurationSlope$Spread1DurationSlope[MaxInstruments+1] <- NA
} else {
  dfSpread1DurationSlope$Spread1DurationSlope[MaxInstruments+1] <- (SRMA*TA + SRML*TL)/(TA + TL)
}
dfSpread1DurationSlope$Spread1DurationSlope[MaxInstruments+2] <- SRMA
dfSpread1DurationSlope$Spread1DurationSlope[MaxInstruments+3] <- SRML
dfSpread1DurationSlope
# Curvature 1
dfSpread1DurationCurve1 <- ddply(dfStaticRiskMeasures, .(Instrument), summarize, 
                              dfStaticRiskMeasures=sum(Spread1DurationCurve1))
dfSpread1DurationCurve1$Spread1DurationCurve1 <- dfSpread1DurationCurve1$dfStaticRiskMeasures
dfSpread1DurationCurve1$dfStaticRiskMeasures <- NULL
# Compute Static Risk Measure for Net Worth
dfSpread1DurationCurve1 <- rbind(dfSpread1DurationCurve1, y = c(MaxInstruments+1, NA))
dfSpread1DurationCurve1 <- rbind(dfSpread1DurationCurve1, y = c(MaxInstruments+2, NA))
dfSpread1DurationCurve1 <- rbind(dfSpread1DurationCurve1, y = c(MaxInstruments+3, NA))
TA <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+2]
TL <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+3]
SRMA <- 0.0
for(i in 1:NumberOfAssets){
  SRMA <- SRMA + dfSpread1DurationCurve1$Spread1DurationCurve1[i] * (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[i]/TA)
}
SRML <- 0.0
for(i in 1:NumberOfLiabilities){
  SRML <- SRML + dfSpread1DurationCurve1$Spread1DurationCurve1[NumberOfAssets+i] * 
    (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[NumberOfAssets+i]/TL)
}
if(TA == -TL){
  dfSpread1DurationCurve1$Spread1DurationCurve1[MaxInstruments+1] <- NA
} else {
  dfSpread1DurationCurve1$Spread1DurationCurve1[MaxInstruments+1] <- (SRMA*TA + SRML*TL)/(TA + TL)
}
dfSpread1DurationCurve1$Spread1DurationCurve1[MaxInstruments+2] <- SRMA
dfSpread1DurationCurve1$Spread1DurationCurve1[MaxInstruments+3] <- SRML
dfSpread1DurationCurve1
# Curvature 2
dfSpread1DurationCurve2 <- ddply(dfStaticRiskMeasures, .(Instrument), summarize, 
                              dfStaticRiskMeasures=sum(Spread1DurationCurve2))
dfSpread1DurationCurve2$Spread1DurationCurve2 <- dfSpread1DurationCurve2$dfStaticRiskMeasures
dfSpread1DurationCurve2$dfStaticRiskMeasures <- NULL
# Compute Static Risk Measure for Net Worth
dfSpread1DurationCurve2 <- rbind(dfSpread1DurationCurve2, y = c(MaxInstruments+1, NA))
dfSpread1DurationCurve2 <- rbind(dfSpread1DurationCurve2, y = c(MaxInstruments+2, NA))
dfSpread1DurationCurve2 <- rbind(dfSpread1DurationCurve2, y = c(MaxInstruments+3, NA))
TA <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+2]
TL <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+3]
SRMA <- 0.0
for(i in 1:NumberOfAssets){
  SRMA <- SRMA + dfSpread1DurationCurve2$Spread1DurationCurve2[i] * (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[i]/TA)
}
SRML <- 0.0
for(i in 1:NumberOfLiabilities){
  SRML <- SRML + dfSpread1DurationCurve2$Spread1DurationCurve2[NumberOfAssets+i] * 
    (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[NumberOfAssets+i]/TL)
}
if(TA == -TL){
  dfSpread1DurationCurve2$Spread1DurationCurve2[MaxInstruments+1] <- NA
} else {
  dfSpread1DurationCurve2$Spread1DurationCurve2[MaxInstruments+1] <- (SRMA*TA + SRML*TL)/(TA + TL)
}
dfSpread1DurationCurve2$Spread1DurationCurve2[MaxInstruments+2] <- SRMA
dfSpread1DurationCurve2$Spread1DurationCurve2[MaxInstruments+3] <- SRML
# Curvature 3
dfSpread1DurationCurve3 <- ddply(dfStaticRiskMeasures, .(Instrument), summarize, 
                              dfStaticRiskMeasures=sum(Spread1DurationCurve3))
dfSpread1DurationCurve3$Spread1DurationCurve3 <- dfSpread1DurationCurve3$dfStaticRiskMeasures
dfSpread1DurationCurve3$dfStaticRiskMeasures <- NULL
# Compute Static Risk Measure for Net Worth
dfSpread1DurationCurve3 <- rbind(dfSpread1DurationCurve3, y = c(MaxInstruments+1, NA))
dfSpread1DurationCurve3 <- rbind(dfSpread1DurationCurve3, y = c(MaxInstruments+2, NA))
dfSpread1DurationCurve3 <- rbind(dfSpread1DurationCurve3, y = c(MaxInstruments+3, NA))
TA <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+2]
TL <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+3]
SRMA <- 0.0
for(i in 1:NumberOfAssets){
  SRMA <- SRMA + dfSpread1DurationCurve3$Spread1DurationCurve3[i] * (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[i]/TA)
}
SRML <- 0.0
for(i in 1:NumberOfLiabilities){
  SRML <- SRML + dfSpread1DurationCurve3$Spread1DurationCurve3[NumberOfAssets+i] * 
    (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[NumberOfAssets+i]/TL)
}
if(TA == -TL){
  dfSpread1DurationCurve3$Spread1DurationCurve3[MaxInstruments+1] <- NA
} else {
  dfSpread1DurationCurve3$Spread1DurationCurve3[MaxInstruments+1] <- (SRMA*TA + SRML*TL)/(TA + TL)
}
dfSpread1DurationCurve3$Spread1DurationCurve3[MaxInstruments+2] <- SRMA
dfSpread1DurationCurve3$Spread1DurationCurve3[MaxInstruments+3] <- SRML
# Curvature 4
dfSpread1DurationCurve4 <- ddply(dfStaticRiskMeasures, .(Instrument), summarize, 
                              dfStaticRiskMeasures=sum(Spread1DurationCurve4))
dfSpread1DurationCurve4$Spread1DurationCurve4 <- dfSpread1DurationCurve4$dfStaticRiskMeasures
dfSpread1DurationCurve4$dfStaticRiskMeasures <- NULL
# Compute Static Risk Measure for Net Worth
dfSpread1DurationCurve4 <- rbind(dfSpread1DurationCurve4, y = c(MaxInstruments+1, NA))
dfSpread1DurationCurve4 <- rbind(dfSpread1DurationCurve4, y = c(MaxInstruments+2, NA))
dfSpread1DurationCurve4 <- rbind(dfSpread1DurationCurve4, y = c(MaxInstruments+3, NA))
TA <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+2]
TL <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+3]
SRMA <- 0.0
for(i in 1:NumberOfAssets){
  SRMA <- SRMA + dfSpread1DurationCurve4$Spread1DurationCurve4[i] * (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[i]/TA)
}
SRML <- 0.0
for(i in 1:NumberOfLiabilities){
  SRML <- SRML + dfSpread1DurationCurve4$Spread1DurationCurve4[NumberOfAssets+i] * 
    (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[NumberOfAssets+i]/TL)
}
if(TA == -TL){
  dfSpread1DurationCurve4$Spread1DurationCurve4[MaxInstruments+1] <- NA
} else {
  dfSpread1DurationCurve4$Spread1DurationCurve4[MaxInstruments+1] <- (SRMA*TA + SRML*TL)/(TA + TL)
}
dfSpread1DurationCurve4$Spread1DurationCurve4[MaxInstruments+2] <- SRMA
dfSpread1DurationCurve4$Spread1DurationCurve4[MaxInstruments+3] <- SRML
# Curvature 5
dfSpread1DurationCurve5 <- ddply(dfStaticRiskMeasures, .(Instrument), summarize, 
                              dfStaticRiskMeasures=sum(Spread1DurationCurve5))
dfSpread1DurationCurve5$Spread1DurationCurve5 <- dfSpread1DurationCurve5$dfStaticRiskMeasures
dfSpread1DurationCurve5$dfStaticRiskMeasures <- NULL
# Compute Static Risk Measure for Net Worth
dfSpread1DurationCurve5 <- rbind(dfSpread1DurationCurve5, y = c(MaxInstruments+1, NA))
dfSpread1DurationCurve5 <- rbind(dfSpread1DurationCurve5, y = c(MaxInstruments+2, NA))
dfSpread1DurationCurve5 <- rbind(dfSpread1DurationCurve5, y = c(MaxInstruments+3, NA))
TA <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+2]
TL <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+3]
SRMA <- 0.0
for(i in 1:NumberOfAssets){
  SRMA <- SRMA + dfSpread1DurationCurve5$Spread1DurationCurve5[i] * (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[i]/TA)
}
SRML <- 0.0
for(i in 1:NumberOfLiabilities){
  SRML <- SRML + dfSpread1DurationCurve5$Spread1DurationCurve5[NumberOfAssets+i] * 
    (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[NumberOfAssets+i]/TL)
}
if(TA == -TL){
  dfSpread1DurationCurve5$Spread1DurationCurve5[MaxInstruments+1] <- NA
} else {
  dfSpread1DurationCurve5$Spread1DurationCurve5[MaxInstruments+1] <- (SRMA*TA + SRML*TL)/(TA + TL)
}
dfSpread1DurationCurve5$Spread1DurationCurve5[MaxInstruments+2] <- SRMA
dfSpread1DurationCurve5$Spread1DurationCurve5[MaxInstruments+3] <- SRML
# dfPVBalanceSheet
# dfPVBalanceSheetAtHorizon
# dfSpread1DurationLevel
# dfSpread1DurationSlope
# dfSpread1DurationCurve1
# dfSpread1DurationCurve2
# dfSpread1DurationCurve3
# dfSpread1DurationCurve4
# dfSpread1DurationCurve5
#
# Spread1 Convexity
#
dfStaticRiskMeasures$Spread1ConvexityLevel <- (M^2) * 1.0 * W * CW
dfStaticRiskMeasures$Spread1ConvexitySlope <- (M^2) * (x1^2) * W * CW
dfStaticRiskMeasures$Spread1ConvexityCurve1 <- (M^2) * (x2^2) * W * CW
dfStaticRiskMeasures$Spread1ConvexityCurve2 <- (M^2) * (x3^2) * W * CW
dfStaticRiskMeasures$Spread1ConvexityCurve3 <- (M^2) * (x4^2) * W * CW
dfStaticRiskMeasures$Spread1ConvexityCurve4 <- (M^2) * (x5^2) * W * CW
dfStaticRiskMeasures$Spread1ConvexityCurve5 <- (M^2) * (x6^2) * W * CW
# Level
dfSpread1ConvexityLevel <- ddply(dfStaticRiskMeasures, .(Instrument), summarize, 
  dfStaticRiskMeasures=sum(Spread1ConvexityLevel))
dfSpread1ConvexityLevel$Spread1ConvexityLevel <- dfSpread1ConvexityLevel$dfStaticRiskMeasures
dfSpread1ConvexityLevel$dfStaticRiskMeasures <- NULL
# Compute Static Risk Measure for Net Worth
dfSpread1ConvexityLevel <- rbind(dfSpread1ConvexityLevel, y = c(MaxInstruments+1, NA))
dfSpread1ConvexityLevel <- rbind(dfSpread1ConvexityLevel, y = c(MaxInstruments+2, NA))
dfSpread1ConvexityLevel <- rbind(dfSpread1ConvexityLevel, y = c(MaxInstruments+3, NA))
TA <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+2]
TL <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+3]
SRMA <- 0.0
for(i in 1:NumberOfAssets){
  SRMA <- SRMA + dfSpread1ConvexityLevel$Spread1ConvexityLevel[i] * (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[i]/TA)
}
SRML <- 0.0
for(i in 1:NumberOfLiabilities){
  SRML <- SRML + dfSpread1ConvexityLevel$Spread1ConvexityLevel[NumberOfAssets+i] * 
    (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[NumberOfAssets+i]/TL)
}
if(TA == -TL){
  dfSpread1ConvexityLevel$Spread1ConvexityLevel[MaxInstruments+1] <- NA
} else {
  dfSpread1ConvexityLevel$Spread1ConvexityLevel[MaxInstruments+1] <- (SRMA*TA + SRML*TL)/(TA + TL)
}
dfSpread1ConvexityLevel$Spread1ConvexityLevel[MaxInstruments+2] <- SRMA
dfSpread1ConvexityLevel$Spread1ConvexityLevel[MaxInstruments+3] <- SRML
dfSpread1ConvexityLevel
# Slope
dfSpread1ConvexitySlope <- ddply(dfStaticRiskMeasures, .(Instrument), summarize, 
                             dfStaticRiskMeasures=sum(Spread1ConvexitySlope))
dfSpread1ConvexitySlope$Spread1ConvexitySlope <- dfSpread1ConvexitySlope$dfStaticRiskMeasures
dfSpread1ConvexitySlope$dfStaticRiskMeasures <- NULL
# Compute Static Risk Measure for Net Worth
dfSpread1ConvexitySlope <- rbind(dfSpread1ConvexitySlope, y = c(MaxInstruments+1, NA))
dfSpread1ConvexitySlope <- rbind(dfSpread1ConvexitySlope, y = c(MaxInstruments+2, NA))
dfSpread1ConvexitySlope <- rbind(dfSpread1ConvexitySlope, y = c(MaxInstruments+3, NA))
TA <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+2]
TL <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+3]
SRMA <- 0.0
for(i in 1:NumberOfAssets){
  SRMA <- SRMA + dfSpread1ConvexitySlope$Spread1ConvexitySlope[i] * (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[i]/TA)
}
SRML <- 0.0
for(i in 1:NumberOfLiabilities){
  SRML <- SRML + dfSpread1ConvexitySlope$Spread1ConvexitySlope[NumberOfAssets+i] * 
    (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[NumberOfAssets+i]/TL)
}
if(TA == -TL){
  dfSpread1ConvexitySlope$Spread1ConvexitySlope[MaxInstruments+1] <- NA
} else {
  dfSpread1ConvexitySlope$Spread1ConvexitySlope[MaxInstruments+1] <- (SRMA*TA + SRML*TL)/(TA + TL)
}
dfSpread1ConvexitySlope$Spread1ConvexitySlope[MaxInstruments+2] <- SRMA
dfSpread1ConvexitySlope$Spread1ConvexitySlope[MaxInstruments+3] <- SRML
dfSpread1ConvexitySlope
# Curvature 1
dfSpread1ConvexityCurve1 <- ddply(dfStaticRiskMeasures, .(Instrument), summarize, 
                              dfStaticRiskMeasures=sum(Spread1ConvexityCurve1))
dfSpread1ConvexityCurve1$Spread1ConvexityCurve1 <- dfSpread1ConvexityCurve1$dfStaticRiskMeasures
dfSpread1ConvexityCurve1$dfStaticRiskMeasures <- NULL
# Compute Static Risk Measure for Net Worth
dfSpread1ConvexityCurve1 <- rbind(dfSpread1ConvexityCurve1, y = c(MaxInstruments+1, NA))
dfSpread1ConvexityCurve1 <- rbind(dfSpread1ConvexityCurve1, y = c(MaxInstruments+2, NA))
dfSpread1ConvexityCurve1 <- rbind(dfSpread1ConvexityCurve1, y = c(MaxInstruments+3, NA))
TA <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+2]
TL <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+3]
SRMA <- 0.0
for(i in 1:NumberOfAssets){
  SRMA <- SRMA + dfSpread1ConvexityCurve1$Spread1ConvexityCurve1[i] * (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[i]/TA)
}
SRML <- 0.0
for(i in 1:NumberOfLiabilities){
  SRML <- SRML + dfSpread1ConvexityCurve1$Spread1ConvexityCurve1[NumberOfAssets+i] * 
    (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[NumberOfAssets+i]/TL)
}
if(TA == -TL){
  dfSpread1ConvexityCurve1$Spread1ConvexityCurve1[MaxInstruments+1] <- NA
} else {
  dfSpread1ConvexityCurve1$Spread1ConvexityCurve1[MaxInstruments+1] <- (SRMA*TA + SRML*TL)/(TA + TL)
}
dfSpread1ConvexityCurve1$Spread1ConvexityCurve1[MaxInstruments+2] <- SRMA
dfSpread1ConvexityCurve1$Spread1ConvexityCurve1[MaxInstruments+3] <- SRML
dfSpread1ConvexityCurve1
# Curvature 2
dfSpread1ConvexityCurve2 <- ddply(dfStaticRiskMeasures, .(Instrument), summarize, 
                              dfStaticRiskMeasures=sum(Spread1ConvexityCurve2))
dfSpread1ConvexityCurve2$Spread1ConvexityCurve2 <- dfSpread1ConvexityCurve2$dfStaticRiskMeasures
dfSpread1ConvexityCurve2$dfStaticRiskMeasures <- NULL
# Compute Static Risk Measure for Net Worth
dfSpread1ConvexityCurve2 <- rbind(dfSpread1ConvexityCurve2, y = c(MaxInstruments+1, NA))
dfSpread1ConvexityCurve2 <- rbind(dfSpread1ConvexityCurve2, y = c(MaxInstruments+2, NA))
dfSpread1ConvexityCurve2 <- rbind(dfSpread1ConvexityCurve2, y = c(MaxInstruments+3, NA))
TA <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+2]
TL <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+3]
SRMA <- 0.0
for(i in 1:NumberOfAssets){
  SRMA <- SRMA + dfSpread1ConvexityCurve2$Spread1ConvexityCurve2[i] * (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[i]/TA)
}
SRML <- 0.0
for(i in 1:NumberOfLiabilities){
  SRML <- SRML + dfSpread1ConvexityCurve2$Spread1ConvexityCurve2[NumberOfAssets+i] * 
    (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[NumberOfAssets+i]/TL)
}
if(TA == -TL){
  dfSpread1ConvexityCurve2$Spread1ConvexityCurve2[MaxInstruments+1] <- NA
} else {
  dfSpread1ConvexityCurve2$Spread1ConvexityCurve2[MaxInstruments+1] <- (SRMA*TA + SRML*TL)/(TA + TL)
}
dfSpread1ConvexityCurve2$Spread1ConvexityCurve2[MaxInstruments+2] <- SRMA
dfSpread1ConvexityCurve2$Spread1ConvexityCurve2[MaxInstruments+3] <- SRML
# Curvature 3
dfSpread1ConvexityCurve3 <- ddply(dfStaticRiskMeasures, .(Instrument), summarize, 
                              dfStaticRiskMeasures=sum(Spread1ConvexityCurve3))
dfSpread1ConvexityCurve3$Spread1ConvexityCurve3 <- dfSpread1ConvexityCurve3$dfStaticRiskMeasures
dfSpread1ConvexityCurve3$dfStaticRiskMeasures <- NULL
# Compute Static Risk Measure for Net Worth
dfSpread1ConvexityCurve3 <- rbind(dfSpread1ConvexityCurve3, y = c(MaxInstruments+1, NA))
dfSpread1ConvexityCurve3 <- rbind(dfSpread1ConvexityCurve3, y = c(MaxInstruments+2, NA))
dfSpread1ConvexityCurve3 <- rbind(dfSpread1ConvexityCurve3, y = c(MaxInstruments+3, NA))
TA <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+2]
TL <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+3]
SRMA <- 0.0
for(i in 1:NumberOfAssets){
  SRMA <- SRMA + dfSpread1ConvexityCurve3$Spread1ConvexityCurve3[i] * (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[i]/TA)
}
SRML <- 0.0
for(i in 1:NumberOfLiabilities){
  SRML <- SRML + dfSpread1ConvexityCurve3$Spread1ConvexityCurve3[NumberOfAssets+i] * 
    (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[NumberOfAssets+i]/TL)
}
if(TA == -TL){
  dfSpread1ConvexityCurve3$Spread1ConvexityCurve3[MaxInstruments+1] <- NA
} else {
  dfSpread1ConvexityCurve3$Spread1ConvexityCurve3[MaxInstruments+1] <- (SRMA*TA + SRML*TL)/(TA + TL)
}
dfSpread1ConvexityCurve3$Spread1ConvexityCurve3[MaxInstruments+2] <- SRMA
dfSpread1ConvexityCurve3$Spread1ConvexityCurve3[MaxInstruments+3] <- SRML
# Curvature 4
dfSpread1ConvexityCurve4 <- ddply(dfStaticRiskMeasures, .(Instrument), summarize, 
                              dfStaticRiskMeasures=sum(Spread1ConvexityCurve4))
dfSpread1ConvexityCurve4$Spread1ConvexityCurve4 <- dfSpread1ConvexityCurve4$dfStaticRiskMeasures
dfSpread1ConvexityCurve4$dfStaticRiskMeasures <- NULL
# Compute Static Risk Measure for Net Worth
dfSpread1ConvexityCurve4 <- rbind(dfSpread1ConvexityCurve4, y = c(MaxInstruments+1, NA))
dfSpread1ConvexityCurve4 <- rbind(dfSpread1ConvexityCurve4, y = c(MaxInstruments+2, NA))
dfSpread1ConvexityCurve4 <- rbind(dfSpread1ConvexityCurve4, y = c(MaxInstruments+3, NA))
TA <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+2]
TL <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+3]
SRMA <- 0.0
for(i in 1:NumberOfAssets){
  SRMA <- SRMA + dfSpread1ConvexityCurve4$Spread1ConvexityCurve4[i] * (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[i]/TA)
}
SRML <- 0.0
for(i in 1:NumberOfLiabilities){
  SRML <- SRML + dfSpread1ConvexityCurve4$Spread1ConvexityCurve4[NumberOfAssets+i] * 
    (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[NumberOfAssets+i]/TL)
}
if(TA == -TL){
  dfSpread1ConvexityCurve4$Spread1ConvexityCurve4[MaxInstruments+1] <- NA
} else {
  dfSpread1ConvexityCurve4$Spread1ConvexityCurve4[MaxInstruments+1] <- (SRMA*TA + SRML*TL)/(TA + TL)
}
dfSpread1ConvexityCurve4$Spread1ConvexityCurve4[MaxInstruments+2] <- SRMA
dfSpread1ConvexityCurve4$Spread1ConvexityCurve4[MaxInstruments+3] <- SRML
# Curvature 5
dfSpread1ConvexityCurve5 <- ddply(dfStaticRiskMeasures, .(Instrument), summarize, 
                              dfStaticRiskMeasures=sum(Spread1ConvexityCurve5))
dfSpread1ConvexityCurve5$Spread1ConvexityCurve5 <- dfSpread1ConvexityCurve5$dfStaticRiskMeasures
dfSpread1ConvexityCurve5$dfStaticRiskMeasures <- NULL
# Compute Static Risk Measure for Net Worth
dfSpread1ConvexityCurve5 <- rbind(dfSpread1ConvexityCurve5, y = c(MaxInstruments+1, NA))
dfSpread1ConvexityCurve5 <- rbind(dfSpread1ConvexityCurve5, y = c(MaxInstruments+2, NA))
dfSpread1ConvexityCurve5 <- rbind(dfSpread1ConvexityCurve5, y = c(MaxInstruments+3, NA))
TA <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+2]
TL <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+3]
SRMA <- 0.0
for(i in 1:NumberOfAssets){
  SRMA <- SRMA + dfSpread1ConvexityCurve5$Spread1ConvexityCurve5[i] * (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[i]/TA)
}
SRML <- 0.0
for(i in 1:NumberOfLiabilities){
  SRML <- SRML + dfSpread1ConvexityCurve5$Spread1ConvexityCurve5[NumberOfAssets+i] * 
    (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[NumberOfAssets+i]/TL)
}
if(TA == -TL){
  dfSpread1ConvexityCurve5$Spread1ConvexityCurve5[MaxInstruments+1] <- NA
} else {
  dfSpread1ConvexityCurve5$Spread1ConvexityCurve5[MaxInstruments+1] <- (SRMA*TA + SRML*TL)/(TA + TL)
}
dfSpread1ConvexityCurve5$Spread1ConvexityCurve5[MaxInstruments+2] <- SRMA
dfSpread1ConvexityCurve5$Spread1ConvexityCurve5[MaxInstruments+3] <- SRML
# dfPVBalanceSheet
# dfPVBalanceSheetAtHorizon
# dfSpread1ConvexityLevel
# dfSpread1ConvexitySlope
# dfSpread1ConvexityCurve1
# dfSpread1ConvexityCurve2
# dfSpread1ConvexityCurve3
# dfSpread1ConvexityCurve4
# dfSpread1ConvexityCurve5
#
# Spread1 Cross Convexiities (19!)
#
# Level x _____
dfStaticRiskMeasures$Spread1CrossConvexityCCLS <- (M^2) * 1.0 * x1 * W * CW
dfStaticRiskMeasures$Spread1CrossConvexityCCLC1 <- (M^2) * 1.0 * x2 * W * CW
dfStaticRiskMeasures$Spread1CrossConvexityCCLC2 <- (M^2) * 1.0 * x3 * W * CW
dfStaticRiskMeasures$Spread1CrossConvexityCCLC3 <- (M^2) * 1.0 * x4 * W * CW
dfStaticRiskMeasures$Spread1CrossConvexityCCLC4 <- (M^2) * 1.0 * x5 * W * CW
dfStaticRiskMeasures$Spread1CrossConvexityCCLC5 <- (M^2) * 1.0 * x6 * W * CW
# Slope x _____
dfStaticRiskMeasures$Spread1CrossConvexityCCSC1 <- (M^2) * x1 * x2 * W * CW
dfStaticRiskMeasures$Spread1CrossConvexityCCSC2 <- (M^2) * x1 * x3 * W * CW
dfStaticRiskMeasures$Spread1CrossConvexityCCSC3 <- (M^2) * x1 * x4 * W * CW
dfStaticRiskMeasures$Spread1CrossConvexityCCSC4 <- (M^2) * x1 * x5 * W * CW
dfStaticRiskMeasures$Spread1CrossConvexityCCSC5 <- (M^2) * x1 * x6 * W * CW
# Curve1 x _____
dfStaticRiskMeasures$Spread1CrossConvexityCCC1C2 <- (M^2) * x2 * x3 * W * CW
dfStaticRiskMeasures$Spread1CrossConvexityCCC1C3 <- (M^2) * x2 * x4 * W * CW
dfStaticRiskMeasures$Spread1CrossConvexityCCC1C4 <- (M^2) * x2 * x5 * W * CW
dfStaticRiskMeasures$Spread1CrossConvexityCCC1C5 <- (M^2) * x2 * x6 * W * CW
# Curve2 x _____
dfStaticRiskMeasures$Spread1CrossConvexityCCC2C3 <- (M^2) * x3 * x4 * W * CW
dfStaticRiskMeasures$Spread1CrossConvexityCCC2C4 <- (M^2) * x3 * x5 * W * CW
dfStaticRiskMeasures$Spread1CrossConvexityCCC2C5 <- (M^2) * x3 * x6 * W * CW
# Curve4 x _____
dfStaticRiskMeasures$Spread1CrossConvexityCCC3C4 <- (M^2) * x4 * x5 * W * CW
dfStaticRiskMeasures$Spread1CrossConvexityCCC3C5 <- (M^2) * x4 * x6 * W * CW
# Curve5 x _____
dfStaticRiskMeasures$Spread1CrossConvexityCCC4C5 <- (M^2) * x5 * x6 * W * CW
# Level x Slope (CCLS)
dfSpread1CrossConvexityCCLS <- ddply(dfStaticRiskMeasures, .(Instrument), summarize, 
                             dfStaticRiskMeasures=sum(Spread1CrossConvexityCCLS))
dfSpread1CrossConvexityCCLS$Spread1CrossConvexityCCLS <- dfSpread1CrossConvexityCCLS$dfStaticRiskMeasures
dfSpread1CrossConvexityCCLS$dfStaticRiskMeasures <- NULL
# Compute Static Risk Measure for Net Worth
dfSpread1CrossConvexityCCLS <- rbind(dfSpread1CrossConvexityCCLS, y = c(MaxInstruments+1, NA))
dfSpread1CrossConvexityCCLS <- rbind(dfSpread1CrossConvexityCCLS, y = c(MaxInstruments+2, NA))
dfSpread1CrossConvexityCCLS <- rbind(dfSpread1CrossConvexityCCLS, y = c(MaxInstruments+3, NA))
TA <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+2]
TL <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+3]
SRMA <- 0.0
for(i in 1:NumberOfAssets){
  SRMA <- SRMA + dfSpread1CrossConvexityCCLS$Spread1CrossConvexityCCLS[i] * (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[i]/TA)
}
SRML <- 0.0
for(i in 1:NumberOfLiabilities){
  SRML <- SRML + dfSpread1CrossConvexityCCLS$Spread1CrossConvexityCCLS[NumberOfAssets+i] * 
    (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[NumberOfAssets+i]/TL)
}
if(TA == -TL){
  dfSpread1CrossConvexityCCLS$Spread1CrossConvexityCCLS[MaxInstruments+1] <- NA
} else {
  dfSpread1CrossConvexityCCLS$Spread1CrossConvexityCCLS[MaxInstruments+1] <- (SRMA*TA + SRML*TL)/(TA + TL)
}
dfSpread1CrossConvexityCCLS$Spread1CrossConvexityCCLS[MaxInstruments+2] <- SRMA
dfSpread1CrossConvexityCCLS$Spread1CrossConvexityCCLS[MaxInstruments+3] <- SRML



# Level x Curve1 (CCLC1)
dfSpread1CrossConvexityCCLC1 <- ddply(dfStaticRiskMeasures, .(Instrument), summarize, 
                            dfStaticRiskMeasures=sum(Spread1CrossConvexityCCLC1))
dfSpread1CrossConvexityCCLC1$Spread1CrossConvexityCCLC1 <- dfSpread1CrossConvexityCCLC1$dfStaticRiskMeasures
dfSpread1CrossConvexityCCLC1$dfStaticRiskMeasures <- NULL
# Compute Static Risk Measure for Net Worth
dfSpread1CrossConvexityCCLC1 <- rbind(dfSpread1CrossConvexityCCLC1, y = c(MaxInstruments+1, NA))
dfSpread1CrossConvexityCCLC1 <- rbind(dfSpread1CrossConvexityCCLC1, y = c(MaxInstruments+2, NA))
dfSpread1CrossConvexityCCLC1 <- rbind(dfSpread1CrossConvexityCCLC1, y = c(MaxInstruments+3, NA))
TA <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+2]
TL <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+3]
SRMA <- 0.0
for(i in 1:NumberOfAssets){
  SRMA <- SRMA + dfSpread1CrossConvexityCCLC1$Spread1CrossConvexityCCLC1[i] * (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[i]/TA)
}
SRML <- 0.0
for(i in 1:NumberOfLiabilities){
  SRML <- SRML + dfSpread1CrossConvexityCCLC1$Spread1CrossConvexityCCLC1[NumberOfAssets+i] * 
    (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[NumberOfAssets+i]/TL)
}
if(TA == -TL){
  dfSpread1CrossConvexityCCLC1$Spread1CrossConvexityCCLC1[MaxInstruments+1] <- NA
} else {
  dfSpread1CrossConvexityCCLC1$Spread1CrossConvexityCCLC1[MaxInstruments+1] <- (SRMA*TA + SRML*TL)/(TA + TL)
}
dfSpread1CrossConvexityCCLC1$Spread1CrossConvexityCCLC1[MaxInstruments+2] <- SRMA
dfSpread1CrossConvexityCCLC1$Spread1CrossConvexityCCLC1[MaxInstruments+3] <- SRML
# Level x Curve2 (CCLC2)
dfSpread1CrossConvexityCCLC2 <- ddply(dfStaticRiskMeasures, .(Instrument), summarize, 
                             dfStaticRiskMeasures=sum(Spread1CrossConvexityCCLC2))
dfSpread1CrossConvexityCCLC2$Spread1CrossConvexityCCLC2 <- dfSpread1CrossConvexityCCLC2$dfStaticRiskMeasures
dfSpread1CrossConvexityCCLC2$dfStaticRiskMeasures <- NULL
# Compute Static Risk Measure for Net Worth
dfSpread1CrossConvexityCCLC2 <- rbind(dfSpread1CrossConvexityCCLC2, y = c(MaxInstruments+1, NA))
dfSpread1CrossConvexityCCLC2 <- rbind(dfSpread1CrossConvexityCCLC2, y = c(MaxInstruments+2, NA))
dfSpread1CrossConvexityCCLC2 <- rbind(dfSpread1CrossConvexityCCLC2, y = c(MaxInstruments+3, NA))
TA <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+2]
TL <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+3]
SRMA <- 0.0
for(i in 1:NumberOfAssets){
  SRMA <- SRMA + dfSpread1CrossConvexityCCLC2$Spread1CrossConvexityCCLC2[i] * (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[i]/TA)
}
SRML <- 0.0
for(i in 1:NumberOfLiabilities){
  SRML <- SRML + dfSpread1CrossConvexityCCLC2$Spread1CrossConvexityCCLC2[NumberOfAssets+i] * 
    (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[NumberOfAssets+i]/TL)
}
if(TA == -TL){
  dfSpread1CrossConvexityCCLC2$Spread1CrossConvexityCCLC2[MaxInstruments+1] <- NA
} else {
  dfSpread1CrossConvexityCCLC2$Spread1CrossConvexityCCLC2[MaxInstruments+1] <- (SRMA*TA + SRML*TL)/(TA + TL)
}
dfSpread1CrossConvexityCCLC2$Spread1CrossConvexityCCLC2[MaxInstruments+2] <- SRMA
dfSpread1CrossConvexityCCLC2$Spread1CrossConvexityCCLC2[MaxInstruments+3] <- SRML
# Level x Curve3 (CCLC3)
dfSpread1CrossConvexityCCLC3 <- ddply(dfStaticRiskMeasures, .(Instrument), summarize, 
                             dfStaticRiskMeasures=sum(Spread1CrossConvexityCCLC3))
dfSpread1CrossConvexityCCLC3$Spread1CrossConvexityCCLC3 <- dfSpread1CrossConvexityCCLC3$dfStaticRiskMeasures
dfSpread1CrossConvexityCCLC3$dfStaticRiskMeasures <- NULL
# Compute Static Risk Measure for Net Worth
dfSpread1CrossConvexityCCLC3 <- rbind(dfSpread1CrossConvexityCCLC3, y = c(MaxInstruments+1, NA))
dfSpread1CrossConvexityCCLC3 <- rbind(dfSpread1CrossConvexityCCLC3, y = c(MaxInstruments+2, NA))
dfSpread1CrossConvexityCCLC3 <- rbind(dfSpread1CrossConvexityCCLC3, y = c(MaxInstruments+3, NA))
TA <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+2]
TL <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+3]
SRMA <- 0.0
for(i in 1:NumberOfAssets){
  SRMA <- SRMA + dfSpread1CrossConvexityCCLC3$Spread1CrossConvexityCCLC3[i] * (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[i]/TA)
}
SRML <- 0.0
for(i in 1:NumberOfLiabilities){
  SRML <- SRML + dfSpread1CrossConvexityCCLC3$Spread1CrossConvexityCCLC3[NumberOfAssets+i] * 
    (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[NumberOfAssets+i]/TL)
}
if(TA == -TL){
  dfSpread1CrossConvexityCCLC3$Spread1CrossConvexityCCLC3[MaxInstruments+1] <- NA
} else {
  dfSpread1CrossConvexityCCLC3$Spread1CrossConvexityCCLC3[MaxInstruments+1] <- (SRMA*TA + SRML*TL)/(TA + TL)
}
dfSpread1CrossConvexityCCLC3$Spread1CrossConvexityCCLC3[MaxInstruments+2] <- SRMA
dfSpread1CrossConvexityCCLC3$Spread1CrossConvexityCCLC3[MaxInstruments+3] <- SRML
# Level x Curve4 (CCLC4)
dfSpread1CrossConvexityCCLC4 <- ddply(dfStaticRiskMeasures, .(Instrument), summarize, 
                             dfStaticRiskMeasures=sum(Spread1CrossConvexityCCLC4))
dfSpread1CrossConvexityCCLC4$Spread1CrossConvexityCCLC4 <- dfSpread1CrossConvexityCCLC4$dfStaticRiskMeasures
dfSpread1CrossConvexityCCLC4$dfStaticRiskMeasures <- NULL
# Compute Static Risk Measure for Net Worth
dfSpread1CrossConvexityCCLC4 <- rbind(dfSpread1CrossConvexityCCLC4, y = c(MaxInstruments+1, NA))
dfSpread1CrossConvexityCCLC4 <- rbind(dfSpread1CrossConvexityCCLC4, y = c(MaxInstruments+2, NA))
dfSpread1CrossConvexityCCLC4 <- rbind(dfSpread1CrossConvexityCCLC4, y = c(MaxInstruments+3, NA))
TA <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+2]
TL <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+3]
SRMA <- 0.0
for(i in 1:NumberOfAssets){
  SRMA <- SRMA + dfSpread1CrossConvexityCCLC4$Spread1CrossConvexityCCLC4[i] * (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[i]/TA)
}
SRML <- 0.0
for(i in 1:NumberOfLiabilities){
  SRML <- SRML + dfSpread1CrossConvexityCCLC4$Spread1CrossConvexityCCLC4[NumberOfAssets+i] * 
    (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[NumberOfAssets+i]/TL)
}
if(TA == -TL){
  dfSpread1CrossConvexityCCLC4$Spread1CrossConvexityCCLC4[MaxInstruments+1] <- NA
} else {
  dfSpread1CrossConvexityCCLC4$Spread1CrossConvexityCCLC4[MaxInstruments+1] <- (SRMA*TA + SRML*TL)/(TA + TL)
}
dfSpread1CrossConvexityCCLC4$Spread1CrossConvexityCCLC4[MaxInstruments+2] <- SRMA
dfSpread1CrossConvexityCCLC4$Spread1CrossConvexityCCLC4[MaxInstruments+3] <- SRML
# Level x Curve5 (CCLC5)
dfSpread1CrossConvexityCCLC5 <- ddply(dfStaticRiskMeasures, .(Instrument), summarize, 
                             dfStaticRiskMeasures=sum(Spread1CrossConvexityCCLC5))
dfSpread1CrossConvexityCCLC5$Spread1CrossConvexityCCLC5 <- dfSpread1CrossConvexityCCLC5$dfStaticRiskMeasures
dfSpread1CrossConvexityCCLC5$dfStaticRiskMeasures <- NULL
# Compute Static Risk Measure for Net Worth
dfSpread1CrossConvexityCCLC5 <- rbind(dfSpread1CrossConvexityCCLC5, y = c(MaxInstruments+1, NA))
dfSpread1CrossConvexityCCLC5 <- rbind(dfSpread1CrossConvexityCCLC5, y = c(MaxInstruments+2, NA))
dfSpread1CrossConvexityCCLC5 <- rbind(dfSpread1CrossConvexityCCLC5, y = c(MaxInstruments+3, NA))
TA <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+2]
TL <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+3]
SRMA <- 0.0
for(i in 1:NumberOfAssets){
  SRMA <- SRMA + dfSpread1CrossConvexityCCLC5$Spread1CrossConvexityCCLC5[i] * (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[i]/TA)
}
SRML <- 0.0
for(i in 1:NumberOfLiabilities){
  SRML <- SRML + dfSpread1CrossConvexityCCLC5$Spread1CrossConvexityCCLC5[NumberOfAssets+i] * 
    (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[NumberOfAssets+i]/TL)
}
if(TA == -TL){
  dfSpread1CrossConvexityCCLC5$Spread1CrossConvexityCCLC5[MaxInstruments+1] <- NA
} else {
  dfSpread1CrossConvexityCCLC5$Spread1CrossConvexityCCLC5[MaxInstruments+1] <- (SRMA*TA + SRML*TL)/(TA + TL)
}
dfSpread1CrossConvexityCCLC5$Spread1CrossConvexityCCLC5[MaxInstruments+2] <- SRMA
dfSpread1CrossConvexityCCLC5$Spread1CrossConvexityCCLC5[MaxInstruments+3] <- SRML
# dfSpread1CrossConvexityCCLS
# dfSpread1CrossConvexityCCLC1
# dfSpread1CrossConvexityCCLC2
# dfSpread1CrossConvexityCCLC3
# dfSpread1CrossConvexityCCLC4
# dfSpread1CrossConvexityCCLC5
# Slope x Curve1 (CCSC1)
dfSpread1CrossConvexityCCSC1 <- ddply(dfStaticRiskMeasures, .(Instrument), summarize, 
                             dfStaticRiskMeasures=sum(Spread1CrossConvexityCCSC1))
dfSpread1CrossConvexityCCSC1$Spread1CrossConvexityCCSC1 <- dfSpread1CrossConvexityCCSC1$dfStaticRiskMeasures
dfSpread1CrossConvexityCCSC1$dfStaticRiskMeasures <- NULL
# Compute Static Risk Measure for Net Worth
dfSpread1CrossConvexityCCSC1 <- rbind(dfSpread1CrossConvexityCCSC1, y = c(MaxInstruments+1, NA))
dfSpread1CrossConvexityCCSC1 <- rbind(dfSpread1CrossConvexityCCSC1, y = c(MaxInstruments+2, NA))
dfSpread1CrossConvexityCCSC1 <- rbind(dfSpread1CrossConvexityCCSC1, y = c(MaxInstruments+3, NA))
TA <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+2]
TL <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+3]
SRMA <- 0.0
for(i in 1:NumberOfAssets){
  SRMA <- SRMA + dfSpread1CrossConvexityCCSC1$Spread1CrossConvexityCCSC1[i] * (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[i]/TA)
}
SRML <- 0.0
for(i in 1:NumberOfLiabilities){
  SRML <- SRML + dfSpread1CrossConvexityCCSC1$Spread1CrossConvexityCCSC1[NumberOfAssets+i] * 
    (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[NumberOfAssets+i]/TL)
}
if(TA == -TL){
  dfSpread1CrossConvexityCCSC1$Spread1CrossConvexityCCSC1[MaxInstruments+1] <- NA
} else {
  dfSpread1CrossConvexityCCSC1$Spread1CrossConvexityCCSC1[MaxInstruments+1] <- (SRMA*TA + SRML*TL)/(TA + TL)
}
dfSpread1CrossConvexityCCSC1$Spread1CrossConvexityCCSC1[MaxInstruments+2] <- SRMA
dfSpread1CrossConvexityCCSC1$Spread1CrossConvexityCCSC1[MaxInstruments+3] <- SRML
# Level x Curve2 (CCSC2)
dfSpread1CrossConvexityCCSC2 <- ddply(dfStaticRiskMeasures, .(Instrument), summarize, 
                             dfStaticRiskMeasures=sum(Spread1CrossConvexityCCSC2))
dfSpread1CrossConvexityCCSC2$Spread1CrossConvexityCCSC2 <- dfSpread1CrossConvexityCCSC2$dfStaticRiskMeasures
dfSpread1CrossConvexityCCSC2$dfStaticRiskMeasures <- NULL
# Compute Static Risk Measure for Net Worth
dfSpread1CrossConvexityCCSC2 <- rbind(dfSpread1CrossConvexityCCSC2, y = c(MaxInstruments+1, NA))
dfSpread1CrossConvexityCCSC2 <- rbind(dfSpread1CrossConvexityCCSC2, y = c(MaxInstruments+2, NA))
dfSpread1CrossConvexityCCSC2 <- rbind(dfSpread1CrossConvexityCCSC2, y = c(MaxInstruments+3, NA))
TA <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+2]
TL <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+3]
SRMA <- 0.0
for(i in 1:NumberOfAssets){
  SRMA <- SRMA + dfSpread1CrossConvexityCCSC2$Spread1CrossConvexityCCSC2[i] * (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[i]/TA)
}
SRML <- 0.0
for(i in 1:NumberOfLiabilities){
  SRML <- SRML + dfSpread1CrossConvexityCCSC2$Spread1CrossConvexityCCSC2[NumberOfAssets+i] * 
    (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[NumberOfAssets+i]/TL)
}
if(TA == -TL){
  dfSpread1CrossConvexityCCSC2$Spread1CrossConvexityCCSC2[MaxInstruments+1] <- NA
} else {
  dfSpread1CrossConvexityCCSC2$Spread1CrossConvexityCCSC2[MaxInstruments+1] <- (SRMA*TA + SRML*TL)/(TA + TL)
}
dfSpread1CrossConvexityCCSC2$Spread1CrossConvexityCCSC2[MaxInstruments+2] <- SRMA
dfSpread1CrossConvexityCCSC2$Spread1CrossConvexityCCSC2[MaxInstruments+3] <- SRML
# Level x Curve3 (CCSC3)
dfSpread1CrossConvexityCCSC3 <- ddply(dfStaticRiskMeasures, .(Instrument), summarize, 
                             dfStaticRiskMeasures=sum(Spread1CrossConvexityCCSC3))
dfSpread1CrossConvexityCCSC3$Spread1CrossConvexityCCSC3 <- dfSpread1CrossConvexityCCSC3$dfStaticRiskMeasures
dfSpread1CrossConvexityCCSC3$dfStaticRiskMeasures <- NULL
# Compute Static Risk Measure for Net Worth
dfSpread1CrossConvexityCCSC3 <- rbind(dfSpread1CrossConvexityCCSC3, y = c(MaxInstruments+1, NA))
dfSpread1CrossConvexityCCSC3 <- rbind(dfSpread1CrossConvexityCCSC3, y = c(MaxInstruments+2, NA))
dfSpread1CrossConvexityCCSC3 <- rbind(dfSpread1CrossConvexityCCSC3, y = c(MaxInstruments+3, NA))
TA <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+2]
TL <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+3]
SRMA <- 0.0
for(i in 1:NumberOfAssets){
  SRMA <- SRMA + dfSpread1CrossConvexityCCSC3$Spread1CrossConvexityCCSC3[i] * (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[i]/TA)
}
SRML <- 0.0
for(i in 1:NumberOfLiabilities){
  SRML <- SRML + dfSpread1CrossConvexityCCSC3$Spread1CrossConvexityCCSC3[NumberOfAssets+i] * 
    (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[NumberOfAssets+i]/TL)
}
if(TA == -TL){
  dfSpread1CrossConvexityCCSC3$Spread1CrossConvexityCCSC3[MaxInstruments+1] <- NA
} else {
  dfSpread1CrossConvexityCCSC3$Spread1CrossConvexityCCSC3[MaxInstruments+1] <- (SRMA*TA + SRML*TL)/(TA + TL)
}
dfSpread1CrossConvexityCCSC3$Spread1CrossConvexityCCSC3[MaxInstruments+2] <- SRMA
dfSpread1CrossConvexityCCSC3$Spread1CrossConvexityCCSC3[MaxInstruments+3] <- SRML
# Level x Curve4 (CCSC4)
dfSpread1CrossConvexityCCSC4 <- ddply(dfStaticRiskMeasures, .(Instrument), summarize, 
                             dfStaticRiskMeasures=sum(Spread1CrossConvexityCCSC4))
dfSpread1CrossConvexityCCSC4$Spread1CrossConvexityCCSC4 <- dfSpread1CrossConvexityCCSC4$dfStaticRiskMeasures
dfSpread1CrossConvexityCCSC4$dfStaticRiskMeasures <- NULL
# Compute Static Risk Measure for Net Worth
dfSpread1CrossConvexityCCSC4 <- rbind(dfSpread1CrossConvexityCCSC4, y = c(MaxInstruments+1, NA))
dfSpread1CrossConvexityCCSC4 <- rbind(dfSpread1CrossConvexityCCSC4, y = c(MaxInstruments+2, NA))
dfSpread1CrossConvexityCCSC4 <- rbind(dfSpread1CrossConvexityCCSC4, y = c(MaxInstruments+3, NA))
TA <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+2]
TL <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+3]
SRMA <- 0.0
for(i in 1:NumberOfAssets){
  SRMA <- SRMA + dfSpread1CrossConvexityCCSC4$Spread1CrossConvexityCCSC4[i] * (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[i]/TA)
}
SRML <- 0.0
for(i in 1:NumberOfLiabilities){
  SRML <- SRML + dfSpread1CrossConvexityCCSC4$Spread1CrossConvexityCCSC4[NumberOfAssets+i] * 
    (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[NumberOfAssets+i]/TL)
}
if(TA == -TL){
  dfSpread1CrossConvexityCCSC4$Spread1CrossConvexityCCSC4[MaxInstruments+1] <- NA
} else {
  dfSpread1CrossConvexityCCSC4$Spread1CrossConvexityCCSC4[MaxInstruments+1] <- (SRMA*TA + SRML*TL)/(TA + TL)
}
dfSpread1CrossConvexityCCSC4$Spread1CrossConvexityCCSC4[MaxInstruments+2] <- SRMA
dfSpread1CrossConvexityCCSC4$Spread1CrossConvexityCCSC4[MaxInstruments+3] <- SRML
# Level x Curve5 (CCSC5)
dfSpread1CrossConvexityCCSC5 <- ddply(dfStaticRiskMeasures, .(Instrument), summarize, 
                             dfStaticRiskMeasures=sum(Spread1CrossConvexityCCSC5))
dfSpread1CrossConvexityCCSC5$Spread1CrossConvexityCCSC5 <- dfSpread1CrossConvexityCCSC5$dfStaticRiskMeasures
dfSpread1CrossConvexityCCSC5$dfStaticRiskMeasures <- NULL
# Compute Static Risk Measure for Net Worth
dfSpread1CrossConvexityCCSC5 <- rbind(dfSpread1CrossConvexityCCSC5, y = c(MaxInstruments+1, NA))
dfSpread1CrossConvexityCCSC5 <- rbind(dfSpread1CrossConvexityCCSC5, y = c(MaxInstruments+2, NA))
dfSpread1CrossConvexityCCSC5 <- rbind(dfSpread1CrossConvexityCCSC5, y = c(MaxInstruments+3, NA))
TA <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+2]
TL <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+3]
SRMA <- 0.0
for(i in 1:NumberOfAssets){
  SRMA <- SRMA + dfSpread1CrossConvexityCCSC5$Spread1CrossConvexityCCSC5[i] * (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[i]/TA)
}
SRML <- 0.0
for(i in 1:NumberOfLiabilities){
  SRML <- SRML + dfSpread1CrossConvexityCCSC5$Spread1CrossConvexityCCSC5[NumberOfAssets+i] * 
    (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[NumberOfAssets+i]/TL)
}
if(TA == -TL){
  dfSpread1CrossConvexityCCSC5$Spread1CrossConvexityCCSC5[MaxInstruments+1] <- NA
} else {
  dfSpread1CrossConvexityCCSC5$Spread1CrossConvexityCCSC5[MaxInstruments+1] <- (SRMA*TA + SRML*TL)/(TA + TL)
}
dfSpread1CrossConvexityCCSC5$Spread1CrossConvexityCCSC5[MaxInstruments+2] <- SRMA
dfSpread1CrossConvexityCCSC5$Spread1CrossConvexityCCSC5[MaxInstruments+3] <- SRML
# dfSpread1CrossConvexityCCSC1
# dfSpread1CrossConvexityCCSC2
# dfSpread1CrossConvexityCCSC3
# dfSpread1CrossConvexityCCSC4
# dfSpread1CrossConvexityCCSC5
# Curve1 x Curve2 (CCC1C2)
dfSpread1CrossConvexityCCC1C2 <- ddply(dfStaticRiskMeasures, .(Instrument), summarize, 
                             dfStaticRiskMeasures=sum(Spread1CrossConvexityCCC1C2))
dfSpread1CrossConvexityCCC1C2$Spread1CrossConvexityCCC1C2 <- dfSpread1CrossConvexityCCC1C2$dfStaticRiskMeasures
dfSpread1CrossConvexityCCC1C2$dfStaticRiskMeasures <- NULL
# Compute Static Risk Measure for Net Worth
dfSpread1CrossConvexityCCC1C2 <- rbind(dfSpread1CrossConvexityCCC1C2, y = c(MaxInstruments+1, NA))
dfSpread1CrossConvexityCCC1C2 <- rbind(dfSpread1CrossConvexityCCC1C2, y = c(MaxInstruments+2, NA))
dfSpread1CrossConvexityCCC1C2 <- rbind(dfSpread1CrossConvexityCCC1C2, y = c(MaxInstruments+3, NA))
TA <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+2]
TL <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+3]
SRMA <- 0.0
for(i in 1:NumberOfAssets){
  SRMA <- SRMA + dfSpread1CrossConvexityCCC1C2$Spread1CrossConvexityCCC1C2[i] * (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[i]/TA)
}
SRML <- 0.0
for(i in 1:NumberOfLiabilities){
  SRML <- SRML + dfSpread1CrossConvexityCCC1C2$Spread1CrossConvexityCCC1C2[NumberOfAssets+i] * 
    (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[NumberOfAssets+i]/TL)
}
if(TA == -TL){
  dfSpread1CrossConvexityCCC1C2$Spread1CrossConvexityCCC1C2[MaxInstruments+1] <- NA
} else {
  dfSpread1CrossConvexityCCC1C2$Spread1CrossConvexityCCC1C2[MaxInstruments+1] <- (SRMA*TA + SRML*TL)/(TA + TL)
}
dfSpread1CrossConvexityCCC1C2$Spread1CrossConvexityCCC1C2[MaxInstruments+2] <- SRMA
dfSpread1CrossConvexityCCC1C2$Spread1CrossConvexityCCC1C2[MaxInstruments+3] <- SRML
# Level x Curve3 (CCC1C3)
dfSpread1CrossConvexityCCC1C3 <- ddply(dfStaticRiskMeasures, .(Instrument), summarize, 
                             dfStaticRiskMeasures=sum(Spread1CrossConvexityCCC1C3))
dfSpread1CrossConvexityCCC1C3$Spread1CrossConvexityCCC1C3 <- dfSpread1CrossConvexityCCC1C3$dfStaticRiskMeasures
dfSpread1CrossConvexityCCC1C3$dfStaticRiskMeasures <- NULL
# Compute Static Risk Measure for Net Worth
dfSpread1CrossConvexityCCC1C3 <- rbind(dfSpread1CrossConvexityCCC1C3, y = c(MaxInstruments+1, NA))
dfSpread1CrossConvexityCCC1C3 <- rbind(dfSpread1CrossConvexityCCC1C3, y = c(MaxInstruments+2, NA))
dfSpread1CrossConvexityCCC1C3 <- rbind(dfSpread1CrossConvexityCCC1C3, y = c(MaxInstruments+3, NA))
TA <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+2]
TL <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+3]
SRMA <- 0.0
for(i in 1:NumberOfAssets){
  SRMA <- SRMA + dfSpread1CrossConvexityCCC1C3$Spread1CrossConvexityCCC1C3[i] * (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[i]/TA)
}
SRML <- 0.0
for(i in 1:NumberOfLiabilities){
  SRML <- SRML + dfSpread1CrossConvexityCCC1C3$Spread1CrossConvexityCCC1C3[NumberOfAssets+i] * 
    (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[NumberOfAssets+i]/TL)
}
if(TA == -TL){
  dfSpread1CrossConvexityCCC1C3$Spread1CrossConvexityCCC1C3[MaxInstruments+1] <- NA
} else {
  dfSpread1CrossConvexityCCC1C3$Spread1CrossConvexityCCC1C3[MaxInstruments+1] <- (SRMA*TA + SRML*TL)/(TA + TL)
}
dfSpread1CrossConvexityCCC1C3$Spread1CrossConvexityCCC1C3[MaxInstruments+2] <- SRMA
dfSpread1CrossConvexityCCC1C3$Spread1CrossConvexityCCC1C3[MaxInstruments+3] <- SRML
# Level x Curve4 (CCC1C4)
dfSpread1CrossConvexityCCC1C4 <- ddply(dfStaticRiskMeasures, .(Instrument), summarize, 
                             dfStaticRiskMeasures=sum(Spread1CrossConvexityCCC1C4))
dfSpread1CrossConvexityCCC1C4$Spread1CrossConvexityCCC1C4 <- dfSpread1CrossConvexityCCC1C4$dfStaticRiskMeasures
dfSpread1CrossConvexityCCC1C4$dfStaticRiskMeasures <- NULL
# Compute Static Risk Measure for Net Worth
dfSpread1CrossConvexityCCC1C4 <- rbind(dfSpread1CrossConvexityCCC1C4, y = c(MaxInstruments+1, NA))
dfSpread1CrossConvexityCCC1C4 <- rbind(dfSpread1CrossConvexityCCC1C4, y = c(MaxInstruments+2, NA))
dfSpread1CrossConvexityCCC1C4 <- rbind(dfSpread1CrossConvexityCCC1C4, y = c(MaxInstruments+3, NA))
TA <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+2]
TL <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+3]
SRMA <- 0.0
for(i in 1:NumberOfAssets){
  SRMA <- SRMA + dfSpread1CrossConvexityCCC1C4$Spread1CrossConvexityCCC1C4[i] * (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[i]/TA)
}
SRML <- 0.0
for(i in 1:NumberOfLiabilities){
  SRML <- SRML + dfSpread1CrossConvexityCCC1C4$Spread1CrossConvexityCCC1C4[NumberOfAssets+i] * 
    (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[NumberOfAssets+i]/TL)
}
if(TA == -TL){
  dfSpread1CrossConvexityCCC1C4$Spread1CrossConvexityCCC1C4[MaxInstruments+1] <- NA
} else {
  dfSpread1CrossConvexityCCC1C4$Spread1CrossConvexityCCC1C4[MaxInstruments+1] <- (SRMA*TA + SRML*TL)/(TA + TL)
}
dfSpread1CrossConvexityCCC1C4$Spread1CrossConvexityCCC1C4[MaxInstruments+2] <- SRMA
dfSpread1CrossConvexityCCC1C4$Spread1CrossConvexityCCC1C4[MaxInstruments+3] <- SRML
# Level x Curve5 (CCC1C5)
dfSpread1CrossConvexityCCC1C5 <- ddply(dfStaticRiskMeasures, .(Instrument), summarize, 
                             dfStaticRiskMeasures=sum(Spread1CrossConvexityCCC1C5))
dfSpread1CrossConvexityCCC1C5$Spread1CrossConvexityCCC1C5 <- dfSpread1CrossConvexityCCC1C5$dfStaticRiskMeasures
dfSpread1CrossConvexityCCC1C5$dfStaticRiskMeasures <- NULL
# Compute Static Risk Measure for Net Worth
dfSpread1CrossConvexityCCC1C5 <- rbind(dfSpread1CrossConvexityCCC1C5, y = c(MaxInstruments+1, NA))
dfSpread1CrossConvexityCCC1C5 <- rbind(dfSpread1CrossConvexityCCC1C5, y = c(MaxInstruments+2, NA))
dfSpread1CrossConvexityCCC1C5 <- rbind(dfSpread1CrossConvexityCCC1C5, y = c(MaxInstruments+3, NA))
TA <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+2]
TL <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+3]
SRMA <- 0.0
for(i in 1:NumberOfAssets){
  SRMA <- SRMA + dfSpread1CrossConvexityCCC1C5$Spread1CrossConvexityCCC1C5[i] * (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[i]/TA)
}
SRML <- 0.0
for(i in 1:NumberOfLiabilities){
  SRML <- SRML + dfSpread1CrossConvexityCCC1C5$Spread1CrossConvexityCCC1C5[NumberOfAssets+i] * 
    (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[NumberOfAssets+i]/TL)
}
if(TA == -TL){
  dfSpread1CrossConvexityCCC1C5$Spread1CrossConvexityCCC1C5[MaxInstruments+1] <- NA
} else {
  dfSpread1CrossConvexityCCC1C5$Spread1CrossConvexityCCC1C5[MaxInstruments+1] <- (SRMA*TA + SRML*TL)/(TA + TL)
}
dfSpread1CrossConvexityCCC1C5$Spread1CrossConvexityCCC1C5[MaxInstruments+2] <- SRMA
dfSpread1CrossConvexityCCC1C5$Spread1CrossConvexityCCC1C5[MaxInstruments+3] <- SRML
# dfSpread1CrossConvexityCCC1C2
# dfSpread1CrossConvexityCCC1C3
# dfSpread1CrossConvexityCCC1C4
# dfSpread1CrossConvexityCCC1C5
# Curve2 x Curve3 (CCC2C3)
dfSpread1CrossConvexityCCC2C3 <- ddply(dfStaticRiskMeasures, .(Instrument), summarize, 
                              dfStaticRiskMeasures=sum(Spread1CrossConvexityCCC2C3))
dfSpread1CrossConvexityCCC2C3$Spread1CrossConvexityCCC2C3 <- dfSpread1CrossConvexityCCC2C3$dfStaticRiskMeasures
dfSpread1CrossConvexityCCC2C3$dfStaticRiskMeasures <- NULL
# Compute Static Risk Measure for Net Worth
dfSpread1CrossConvexityCCC2C3 <- rbind(dfSpread1CrossConvexityCCC2C3, y = c(MaxInstruments+1, NA))
dfSpread1CrossConvexityCCC2C3 <- rbind(dfSpread1CrossConvexityCCC2C3, y = c(MaxInstruments+2, NA))
dfSpread1CrossConvexityCCC2C3 <- rbind(dfSpread1CrossConvexityCCC2C3, y = c(MaxInstruments+3, NA))
TA <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+2]
TL <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+3]
SRMA <- 0.0
for(i in 1:NumberOfAssets){
  SRMA <- SRMA + dfSpread1CrossConvexityCCC2C3$Spread1CrossConvexityCCC2C3[i] * (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[i]/TA)
}
SRML <- 0.0
for(i in 1:NumberOfLiabilities){
  SRML <- SRML + dfSpread1CrossConvexityCCC2C3$Spread1CrossConvexityCCC2C3[NumberOfAssets+i] * 
    (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[NumberOfAssets+i]/TL)
}
if(TA == -TL){
  dfSpread1CrossConvexityCCC2C3$Spread1CrossConvexityCCC2C3[MaxInstruments+1] <- NA
} else {
  dfSpread1CrossConvexityCCC2C3$Spread1CrossConvexityCCC2C3[MaxInstruments+1] <- (SRMA*TA + SRML*TL)/(TA + TL)
}
dfSpread1CrossConvexityCCC2C3$Spread1CrossConvexityCCC2C3[MaxInstruments+2] <- SRMA
dfSpread1CrossConvexityCCC2C3$Spread1CrossConvexityCCC2C3[MaxInstruments+3] <- SRML
# _____ x Curve4 (CCC2C4)
dfSpread1CrossConvexityCCC2C4 <- ddply(dfStaticRiskMeasures, .(Instrument), summarize, 
                              dfStaticRiskMeasures=sum(Spread1CrossConvexityCCC2C4))
dfSpread1CrossConvexityCCC2C4$Spread1CrossConvexityCCC2C4 <- dfSpread1CrossConvexityCCC2C4$dfStaticRiskMeasures
dfSpread1CrossConvexityCCC2C4$dfStaticRiskMeasures <- NULL
# Compute Static Risk Measure for Net Worth
dfSpread1CrossConvexityCCC2C4 <- rbind(dfSpread1CrossConvexityCCC2C4, y = c(MaxInstruments+1, NA))
dfSpread1CrossConvexityCCC2C4 <- rbind(dfSpread1CrossConvexityCCC2C4, y = c(MaxInstruments+2, NA))
dfSpread1CrossConvexityCCC2C4 <- rbind(dfSpread1CrossConvexityCCC2C4, y = c(MaxInstruments+3, NA))
TA <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+2]
TL <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+3]
SRMA <- 0.0
for(i in 1:NumberOfAssets){
  SRMA <- SRMA + dfSpread1CrossConvexityCCC2C4$Spread1CrossConvexityCCC2C4[i] * (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[i]/TA)
}
SRML <- 0.0
for(i in 1:NumberOfLiabilities){
  SRML <- SRML + dfSpread1CrossConvexityCCC2C4$Spread1CrossConvexityCCC2C4[NumberOfAssets+i] * 
    (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[NumberOfAssets+i]/TL)
}
if(TA == -TL){
  dfSpread1CrossConvexityCCC2C4$Spread1CrossConvexityCCC2C4[MaxInstruments+1] <- NA
} else {
  dfSpread1CrossConvexityCCC2C4$Spread1CrossConvexityCCC2C4[MaxInstruments+1] <- (SRMA*TA + SRML*TL)/(TA + TL)
}
dfSpread1CrossConvexityCCC2C4$Spread1CrossConvexityCCC2C4[MaxInstruments+2] <- SRMA
dfSpread1CrossConvexityCCC2C4$Spread1CrossConvexityCCC2C4[MaxInstruments+3] <- SRML
# _____ x Curve5 (CCC2C5)
dfSpread1CrossConvexityCCC2C5 <- ddply(dfStaticRiskMeasures, .(Instrument), summarize, 
                              dfStaticRiskMeasures=sum(Spread1CrossConvexityCCC2C5))
dfSpread1CrossConvexityCCC2C5$Spread1CrossConvexityCCC2C5 <- dfSpread1CrossConvexityCCC2C5$dfStaticRiskMeasures
dfSpread1CrossConvexityCCC2C5$dfStaticRiskMeasures <- NULL
# Compute Static Risk Measure for Net Worth
dfSpread1CrossConvexityCCC2C5 <- rbind(dfSpread1CrossConvexityCCC2C5, y = c(MaxInstruments+1, NA))
dfSpread1CrossConvexityCCC2C5 <- rbind(dfSpread1CrossConvexityCCC2C5, y = c(MaxInstruments+2, NA))
dfSpread1CrossConvexityCCC2C5 <- rbind(dfSpread1CrossConvexityCCC2C5, y = c(MaxInstruments+3, NA))
TA <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+2]
TL <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+3]
SRMA <- 0.0
for(i in 1:NumberOfAssets){
  SRMA <- SRMA + dfSpread1CrossConvexityCCC2C5$Spread1CrossConvexityCCC2C5[i] * (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[i]/TA)
}
SRML <- 0.0
for(i in 1:NumberOfLiabilities){
  SRML <- SRML + dfSpread1CrossConvexityCCC2C5$Spread1CrossConvexityCCC2C5[NumberOfAssets+i] * 
    (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[NumberOfAssets+i]/TL)
}
if(TA == -TL){
  dfSpread1CrossConvexityCCC2C5$Spread1CrossConvexityCCC2C5[MaxInstruments+1] <- NA
} else {
  dfSpread1CrossConvexityCCC2C5$Spread1CrossConvexityCCC2C5[MaxInstruments+1] <- (SRMA*TA + SRML*TL)/(TA + TL)
}
dfSpread1CrossConvexityCCC2C5$Spread1CrossConvexityCCC2C5[MaxInstruments+2] <- SRMA
dfSpread1CrossConvexityCCC2C5$Spread1CrossConvexityCCC2C5[MaxInstruments+3] <- SRML
# dfSpread1CrossConvexityCCC2C3
# dfSpread1CrossConvexityCCC2C4
# dfSpread1CrossConvexityCCC2C5
# Curve3 x Curve4 (CCC3C4)
dfSpread1CrossConvexityCCC3C4 <- ddply(dfStaticRiskMeasures, .(Instrument), summarize, 
                              dfStaticRiskMeasures=sum(Spread1CrossConvexityCCC3C4))
dfSpread1CrossConvexityCCC3C4$Spread1CrossConvexityCCC3C4 <- dfSpread1CrossConvexityCCC3C4$dfStaticRiskMeasures
dfSpread1CrossConvexityCCC3C4$dfStaticRiskMeasures <- NULL
# Compute Static Risk Measure for Net Worth
dfSpread1CrossConvexityCCC3C4 <- rbind(dfSpread1CrossConvexityCCC3C4, y = c(MaxInstruments+1, NA))
dfSpread1CrossConvexityCCC3C4 <- rbind(dfSpread1CrossConvexityCCC3C4, y = c(MaxInstruments+2, NA))
dfSpread1CrossConvexityCCC3C4 <- rbind(dfSpread1CrossConvexityCCC3C4, y = c(MaxInstruments+3, NA))
TA <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+2]
TL <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+3]
SRMA <- 0.0
for(i in 1:NumberOfAssets){
  SRMA <- SRMA + dfSpread1CrossConvexityCCC3C4$Spread1CrossConvexityCCC3C4[i] * (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[i]/TA)
}
SRML <- 0.0
for(i in 1:NumberOfLiabilities){
  SRML <- SRML + dfSpread1CrossConvexityCCC3C4$Spread1CrossConvexityCCC3C4[NumberOfAssets+i] * 
    (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[NumberOfAssets+i]/TL)
}
if(TA == -TL){
  dfSpread1CrossConvexityCCC3C4$Spread1CrossConvexityCCC3C4[MaxInstruments+1] <- NA
} else {
  dfSpread1CrossConvexityCCC3C4$Spread1CrossConvexityCCC3C4[MaxInstruments+1] <- (SRMA*TA + SRML*TL)/(TA + TL)
}
dfSpread1CrossConvexityCCC3C4$Spread1CrossConvexityCCC3C4[MaxInstruments+2] <- SRMA
dfSpread1CrossConvexityCCC3C4$Spread1CrossConvexityCCC3C4[MaxInstruments+3] <- SRML
# _____ x Curve5 (CCC3C5)
dfSpread1CrossConvexityCCC3C5 <- ddply(dfStaticRiskMeasures, .(Instrument), summarize, 
                              dfStaticRiskMeasures=sum(Spread1CrossConvexityCCC3C5))
dfSpread1CrossConvexityCCC3C5$Spread1CrossConvexityCCC3C5 <- dfSpread1CrossConvexityCCC3C5$dfStaticRiskMeasures
dfSpread1CrossConvexityCCC3C5$dfStaticRiskMeasures <- NULL
# Compute Static Risk Measure for Net Worth
dfSpread1CrossConvexityCCC3C5 <- rbind(dfSpread1CrossConvexityCCC3C5, y = c(MaxInstruments+1, NA))
dfSpread1CrossConvexityCCC3C5 <- rbind(dfSpread1CrossConvexityCCC3C5, y = c(MaxInstruments+2, NA))
dfSpread1CrossConvexityCCC3C5 <- rbind(dfSpread1CrossConvexityCCC3C5, y = c(MaxInstruments+3, NA))
TA <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+2]
TL <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+3]
SRMA <- 0.0
for(i in 1:NumberOfAssets){
  SRMA <- SRMA + dfSpread1CrossConvexityCCC3C5$Spread1CrossConvexityCCC3C5[i] * (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[i]/TA)
}
SRML <- 0.0
for(i in 1:NumberOfLiabilities){
  SRML <- SRML + dfSpread1CrossConvexityCCC3C5$Spread1CrossConvexityCCC3C5[NumberOfAssets+i] * 
    (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[NumberOfAssets+i]/TL)
}
if(TA == -TL){
  dfSpread1CrossConvexityCCC3C5$Spread1CrossConvexityCCC3C5[MaxInstruments+1] <- NA
} else {
  dfSpread1CrossConvexityCCC3C5$Spread1CrossConvexityCCC3C5[MaxInstruments+1] <- (SRMA*TA + SRML*TL)/(TA + TL)
}
dfSpread1CrossConvexityCCC3C5$Spread1CrossConvexityCCC3C5[MaxInstruments+2] <- SRMA
dfSpread1CrossConvexityCCC3C5$Spread1CrossConvexityCCC3C5[MaxInstruments+3] <- SRML
# dfSpread1CrossConvexityCCC3C4
# dfSpread1CrossConvexityCCC3C5
# Curve4 x Curve5 (CCC4C5)
dfSpread1CrossConvexityCCC4C5 <- ddply(dfStaticRiskMeasures, .(Instrument), summarize, 
                              dfStaticRiskMeasures=sum(Spread1CrossConvexityCCC4C5))
dfSpread1CrossConvexityCCC4C5$Spread1CrossConvexityCCC4C5 <- dfSpread1CrossConvexityCCC4C5$dfStaticRiskMeasures
dfSpread1CrossConvexityCCC4C5$dfStaticRiskMeasures <- NULL
# Compute Static Risk Measure for Net Worth
dfSpread1CrossConvexityCCC4C5 <- rbind(dfSpread1CrossConvexityCCC4C5, y = c(MaxInstruments+1, NA))
dfSpread1CrossConvexityCCC4C5 <- rbind(dfSpread1CrossConvexityCCC4C5, y = c(MaxInstruments+2, NA))
dfSpread1CrossConvexityCCC4C5 <- rbind(dfSpread1CrossConvexityCCC4C5, y = c(MaxInstruments+3, NA))
TA <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+2]
TL <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+3]
SRMA <- 0.0
for(i in 1:NumberOfAssets){
  SRMA <- SRMA + dfSpread1CrossConvexityCCC4C5$Spread1CrossConvexityCCC4C5[i] * (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[i]/TA)
}
SRML <- 0.0
for(i in 1:NumberOfLiabilities){
  SRML <- SRML + dfSpread1CrossConvexityCCC4C5$Spread1CrossConvexityCCC4C5[NumberOfAssets+i] * 
    (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[NumberOfAssets+i]/TL)
}
if(TA == -TL){
  dfSpread1CrossConvexityCCC4C5$Spread1CrossConvexityCCC4C5[MaxInstruments+1] <- NA
} else {
  dfSpread1CrossConvexityCCC4C5$Spread1CrossConvexityCCC4C5[MaxInstruments+1] <- (SRMA*TA + SRML*TL)/(TA + TL)
}
dfSpread1CrossConvexityCCC4C5$Spread1CrossConvexityCCC4C5[MaxInstruments+2] <- SRMA
dfSpread1CrossConvexityCCC4C5$Spread1CrossConvexityCCC4C5[MaxInstruments+3] <- SRML
# dfSpread1CrossConvexityCCC4C5


