# KM Spread2 Rate Static Risk Measures.R
# Spread2 rate static risk measures
L <- InitialCurves$Spread2[2]
k1 <- InitialCurves$Spread2[3]
S <- InitialCurves$Spread2[4]
C1 <- InitialCurves$Spread2[5]
k2 <- InitialCurves$Spread2[6]
C2 <- InitialCurves$Spread2[7]
k3 <- InitialCurves$Spread2[8]
C3 <- InitialCurves$Spread2[9]
k4 <- InitialCurves$Spread2[10]
C4 <- InitialCurves$Spread2[11]
k5 <- InitialCurves$Spread2[12]
C5 <- InitialCurves$Spread2[13]
# Spread2 rate maturity coefficients at Horizon
M <- dfStaticRiskMeasures$Maturity-Horizon
LengthM = length(M)
for(i in 1:LengthM){ # Cannot have zero in LSC model
  if(M[i] == 0)M[i] <- 0.000001
}
x1 <- (k1/M)*(1.0 - exp(-M/k1))
x2 <- x1 - exp(-M/k1)
x3 <- (k2/M) * (1.0 - exp(-M/k2)) - exp(-M/k2)
x4 <- (k3/M) * (1.0 - exp(-M/k3)) - exp(-M/k3)
x5 <- (k4/M) * (1.0 - exp(-M/k4)) - exp(-M/k4)
x6 <- (k5/M) * (1.0 - exp(-M/k5)) - exp(-M/k5)
W <- dfStaticRiskMeasures$Weight
CW <- dfStaticRiskMeasures$WSpread2 # Weight of particular curve
#
# Spread2 Duration
#
dfStaticRiskMeasures$Spread2DurationLevel <- M * 1.0 * W * CW
dfStaticRiskMeasures$Spread2DurationSlope <- M * x1 * W * CW
dfStaticRiskMeasures$Spread2DurationCurve1 <- M * x2 * W * CW
dfStaticRiskMeasures$Spread2DurationCurve2 <- M * x3 * W * CW
dfStaticRiskMeasures$Spread2DurationCurve3 <- M * x4 * W * CW
dfStaticRiskMeasures$Spread2DurationCurve4 <- M * x5 * W * CW
dfStaticRiskMeasures$Spread2DurationCurve5 <- M * x6 * W * CW
# Level
dfSpread2DurationLevel <- ddply(dfStaticRiskMeasures, .(Instrument), summarize, 
  dfStaticRiskMeasures=sum(Spread2DurationLevel))
dfSpread2DurationLevel$Spread2DurationLevel <- dfSpread2DurationLevel$dfStaticRiskMeasures
dfSpread2DurationLevel$dfStaticRiskMeasures <- NULL
# Compute Static Risk Measure for Net Worth
dfSpread2DurationLevel <- rbind(dfSpread2DurationLevel, y = c(MaxInstruments+1, NA))
dfSpread2DurationLevel <- rbind(dfSpread2DurationLevel, y = c(MaxInstruments+2, NA))
dfSpread2DurationLevel <- rbind(dfSpread2DurationLevel, y = c(MaxInstruments+3, NA))
TA <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+2]
TL <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+3]
SRMA <- 0.0
for(i in 1:NumberOfAssets){
  SRMA <- SRMA + dfSpread2DurationLevel$Spread2DurationLevel[i] * (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[i]/TA)
}
SRML <- 0.0
for(i in 1:NumberOfLiabilities){
  SRML <- SRML + dfSpread2DurationLevel$Spread2DurationLevel[NumberOfAssets+i] * 
    (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[NumberOfAssets+i]/TL)
}
if(TA == -TL){
  dfSpread2DurationLevel$Spread2DurationLevel[MaxInstruments+1] <- NA
} else {
  dfSpread2DurationLevel$Spread2DurationLevel[MaxInstruments+1] <- (SRMA*TA + SRML*TL)/(TA + TL)
}
dfSpread2DurationLevel$Spread2DurationLevel[MaxInstruments+2] <- SRMA
dfSpread2DurationLevel$Spread2DurationLevel[MaxInstruments+3] <- SRML
dfSpread2DurationLevel
# Slope
dfSpread2DurationSlope <- ddply(dfStaticRiskMeasures, .(Instrument), summarize, 
                             dfStaticRiskMeasures=sum(Spread2DurationSlope))
dfSpread2DurationSlope$Spread2DurationSlope <- dfSpread2DurationSlope$dfStaticRiskMeasures
dfSpread2DurationSlope$dfStaticRiskMeasures <- NULL
# Compute Static Risk Measure for Net Worth
dfSpread2DurationSlope <- rbind(dfSpread2DurationSlope, y = c(MaxInstruments+1, NA))
dfSpread2DurationSlope <- rbind(dfSpread2DurationSlope, y = c(MaxInstruments+2, NA))
dfSpread2DurationSlope <- rbind(dfSpread2DurationSlope, y = c(MaxInstruments+3, NA))
TA <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+2]
TL <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+3]
SRMA <- 0.0
for(i in 1:NumberOfAssets){
  SRMA <- SRMA + dfSpread2DurationSlope$Spread2DurationSlope[i] * (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[i]/TA)
}
SRML <- 0.0
for(i in 1:NumberOfLiabilities){
  SRML <- SRML + dfSpread2DurationSlope$Spread2DurationSlope[NumberOfAssets+i] * 
    (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[NumberOfAssets+i]/TL)
}
if(TA == -TL){
  dfSpread2DurationSlope$Spread2DurationSlope[MaxInstruments+1] <- NA
} else {
  dfSpread2DurationSlope$Spread2DurationSlope[MaxInstruments+1] <- (SRMA*TA + SRML*TL)/(TA + TL)
}
dfSpread2DurationSlope$Spread2DurationSlope[MaxInstruments+2] <- SRMA
dfSpread2DurationSlope$Spread2DurationSlope[MaxInstruments+3] <- SRML
dfSpread2DurationSlope
# Curvature 1
dfSpread2DurationCurve1 <- ddply(dfStaticRiskMeasures, .(Instrument), summarize, 
                              dfStaticRiskMeasures=sum(Spread2DurationCurve1))
dfSpread2DurationCurve1$Spread2DurationCurve1 <- dfSpread2DurationCurve1$dfStaticRiskMeasures
dfSpread2DurationCurve1$dfStaticRiskMeasures <- NULL
# Compute Static Risk Measure for Net Worth
dfSpread2DurationCurve1 <- rbind(dfSpread2DurationCurve1, y = c(MaxInstruments+1, NA))
dfSpread2DurationCurve1 <- rbind(dfSpread2DurationCurve1, y = c(MaxInstruments+2, NA))
dfSpread2DurationCurve1 <- rbind(dfSpread2DurationCurve1, y = c(MaxInstruments+3, NA))
TA <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+2]
TL <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+3]
SRMA <- 0.0
for(i in 1:NumberOfAssets){
  SRMA <- SRMA + dfSpread2DurationCurve1$Spread2DurationCurve1[i] * (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[i]/TA)
}
SRML <- 0.0
for(i in 1:NumberOfLiabilities){
  SRML <- SRML + dfSpread2DurationCurve1$Spread2DurationCurve1[NumberOfAssets+i] * 
    (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[NumberOfAssets+i]/TL)
}
if(TA == -TL){
  dfSpread2DurationCurve1$Spread2DurationCurve1[MaxInstruments+1] <- NA
} else {
  dfSpread2DurationCurve1$Spread2DurationCurve1[MaxInstruments+1] <- (SRMA*TA + SRML*TL)/(TA + TL)
}
dfSpread2DurationCurve1$Spread2DurationCurve1[MaxInstruments+2] <- SRMA
dfSpread2DurationCurve1$Spread2DurationCurve1[MaxInstruments+3] <- SRML
dfSpread2DurationCurve1
# Curvature 2
dfSpread2DurationCurve2 <- ddply(dfStaticRiskMeasures, .(Instrument), summarize, 
                              dfStaticRiskMeasures=sum(Spread2DurationCurve2))
dfSpread2DurationCurve2$Spread2DurationCurve2 <- dfSpread2DurationCurve2$dfStaticRiskMeasures
dfSpread2DurationCurve2$dfStaticRiskMeasures <- NULL
# Compute Static Risk Measure for Net Worth
dfSpread2DurationCurve2 <- rbind(dfSpread2DurationCurve2, y = c(MaxInstruments+1, NA))
dfSpread2DurationCurve2 <- rbind(dfSpread2DurationCurve2, y = c(MaxInstruments+2, NA))
dfSpread2DurationCurve2 <- rbind(dfSpread2DurationCurve2, y = c(MaxInstruments+3, NA))
TA <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+2]
TL <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+3]
SRMA <- 0.0
for(i in 1:NumberOfAssets){
  SRMA <- SRMA + dfSpread2DurationCurve2$Spread2DurationCurve2[i] * (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[i]/TA)
}
SRML <- 0.0
for(i in 1:NumberOfLiabilities){
  SRML <- SRML + dfSpread2DurationCurve2$Spread2DurationCurve2[NumberOfAssets+i] * 
    (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[NumberOfAssets+i]/TL)
}
if(TA == -TL){
  dfSpread2DurationCurve2$Spread2DurationCurve2[MaxInstruments+1] <- NA
} else {
  dfSpread2DurationCurve2$Spread2DurationCurve2[MaxInstruments+1] <- (SRMA*TA + SRML*TL)/(TA + TL)
}
dfSpread2DurationCurve2$Spread2DurationCurve2[MaxInstruments+2] <- SRMA
dfSpread2DurationCurve2$Spread2DurationCurve2[MaxInstruments+3] <- SRML
# Curvature 3
dfSpread2DurationCurve3 <- ddply(dfStaticRiskMeasures, .(Instrument), summarize, 
                              dfStaticRiskMeasures=sum(Spread2DurationCurve3))
dfSpread2DurationCurve3$Spread2DurationCurve3 <- dfSpread2DurationCurve3$dfStaticRiskMeasures
dfSpread2DurationCurve3$dfStaticRiskMeasures <- NULL
# Compute Static Risk Measure for Net Worth
dfSpread2DurationCurve3 <- rbind(dfSpread2DurationCurve3, y = c(MaxInstruments+1, NA))
dfSpread2DurationCurve3 <- rbind(dfSpread2DurationCurve3, y = c(MaxInstruments+2, NA))
dfSpread2DurationCurve3 <- rbind(dfSpread2DurationCurve3, y = c(MaxInstruments+3, NA))
TA <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+2]
TL <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+3]
SRMA <- 0.0
for(i in 1:NumberOfAssets){
  SRMA <- SRMA + dfSpread2DurationCurve3$Spread2DurationCurve3[i] * (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[i]/TA)
}
SRML <- 0.0
for(i in 1:NumberOfLiabilities){
  SRML <- SRML + dfSpread2DurationCurve3$Spread2DurationCurve3[NumberOfAssets+i] * 
    (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[NumberOfAssets+i]/TL)
}
if(TA == -TL){
  dfSpread2DurationCurve3$Spread2DurationCurve3[MaxInstruments+1] <- NA
} else {
  dfSpread2DurationCurve3$Spread2DurationCurve3[MaxInstruments+1] <- (SRMA*TA + SRML*TL)/(TA + TL)
}
dfSpread2DurationCurve3$Spread2DurationCurve3[MaxInstruments+2] <- SRMA
dfSpread2DurationCurve3$Spread2DurationCurve3[MaxInstruments+3] <- SRML
# Curvature 4
dfSpread2DurationCurve4 <- ddply(dfStaticRiskMeasures, .(Instrument), summarize, 
                              dfStaticRiskMeasures=sum(Spread2DurationCurve4))
dfSpread2DurationCurve4$Spread2DurationCurve4 <- dfSpread2DurationCurve4$dfStaticRiskMeasures
dfSpread2DurationCurve4$dfStaticRiskMeasures <- NULL
# Compute Static Risk Measure for Net Worth
dfSpread2DurationCurve4 <- rbind(dfSpread2DurationCurve4, y = c(MaxInstruments+1, NA))
dfSpread2DurationCurve4 <- rbind(dfSpread2DurationCurve4, y = c(MaxInstruments+2, NA))
dfSpread2DurationCurve4 <- rbind(dfSpread2DurationCurve4, y = c(MaxInstruments+3, NA))
TA <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+2]
TL <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+3]
SRMA <- 0.0
for(i in 1:NumberOfAssets){
  SRMA <- SRMA + dfSpread2DurationCurve4$Spread2DurationCurve4[i] * (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[i]/TA)
}
SRML <- 0.0
for(i in 1:NumberOfLiabilities){
  SRML <- SRML + dfSpread2DurationCurve4$Spread2DurationCurve4[NumberOfAssets+i] * 
    (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[NumberOfAssets+i]/TL)
}
if(TA == -TL){
  dfSpread2DurationCurve4$Spread2DurationCurve4[MaxInstruments+1] <- NA
} else {
  dfSpread2DurationCurve4$Spread2DurationCurve4[MaxInstruments+1] <- (SRMA*TA + SRML*TL)/(TA + TL)
}
dfSpread2DurationCurve4$Spread2DurationCurve4[MaxInstruments+2] <- SRMA
dfSpread2DurationCurve4$Spread2DurationCurve4[MaxInstruments+3] <- SRML
# Curvature 5
dfSpread2DurationCurve5 <- ddply(dfStaticRiskMeasures, .(Instrument), summarize, 
                              dfStaticRiskMeasures=sum(Spread2DurationCurve5))
dfSpread2DurationCurve5$Spread2DurationCurve5 <- dfSpread2DurationCurve5$dfStaticRiskMeasures
dfSpread2DurationCurve5$dfStaticRiskMeasures <- NULL
# Compute Static Risk Measure for Net Worth
dfSpread2DurationCurve5 <- rbind(dfSpread2DurationCurve5, y = c(MaxInstruments+1, NA))
dfSpread2DurationCurve5 <- rbind(dfSpread2DurationCurve5, y = c(MaxInstruments+2, NA))
dfSpread2DurationCurve5 <- rbind(dfSpread2DurationCurve5, y = c(MaxInstruments+3, NA))
TA <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+2]
TL <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+3]
SRMA <- 0.0
for(i in 1:NumberOfAssets){
  SRMA <- SRMA + dfSpread2DurationCurve5$Spread2DurationCurve5[i] * (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[i]/TA)
}
SRML <- 0.0
for(i in 1:NumberOfLiabilities){
  SRML <- SRML + dfSpread2DurationCurve5$Spread2DurationCurve5[NumberOfAssets+i] * 
    (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[NumberOfAssets+i]/TL)
}
if(TA == -TL){
  dfSpread2DurationCurve5$Spread2DurationCurve5[MaxInstruments+1] <- NA
} else {
  dfSpread2DurationCurve5$Spread2DurationCurve5[MaxInstruments+1] <- (SRMA*TA + SRML*TL)/(TA + TL)
}
dfSpread2DurationCurve5$Spread2DurationCurve5[MaxInstruments+2] <- SRMA
dfSpread2DurationCurve5$Spread2DurationCurve5[MaxInstruments+3] <- SRML
# dfPVBalanceSheet
# dfPVBalanceSheetAtHorizon
# dfSpread2DurationLevel
# dfSpread2DurationSlope
# dfSpread2DurationCurve1
# dfSpread2DurationCurve2
# dfSpread2DurationCurve3
# dfSpread2DurationCurve4
# dfSpread2DurationCurve5
#
# Spread2 Convexity
#
dfStaticRiskMeasures$Spread2ConvexityLevel <- (M^2) * 1.0 * W * CW
dfStaticRiskMeasures$Spread2ConvexitySlope <- (M^2) * (x1^2) * W * CW
dfStaticRiskMeasures$Spread2ConvexityCurve1 <- (M^2) * (x2^2) * W * CW
dfStaticRiskMeasures$Spread2ConvexityCurve2 <- (M^2) * (x3^2) * W * CW
dfStaticRiskMeasures$Spread2ConvexityCurve3 <- (M^2) * (x4^2) * W * CW
dfStaticRiskMeasures$Spread2ConvexityCurve4 <- (M^2) * (x5^2) * W * CW
dfStaticRiskMeasures$Spread2ConvexityCurve5 <- (M^2) * (x6^2) * W * CW
# Level
dfSpread2ConvexityLevel <- ddply(dfStaticRiskMeasures, .(Instrument), summarize, 
  dfStaticRiskMeasures=sum(Spread2ConvexityLevel))
dfSpread2ConvexityLevel$Spread2ConvexityLevel <- dfSpread2ConvexityLevel$dfStaticRiskMeasures
dfSpread2ConvexityLevel$dfStaticRiskMeasures <- NULL
# Compute Static Risk Measure for Net Worth
dfSpread2ConvexityLevel <- rbind(dfSpread2ConvexityLevel, y = c(MaxInstruments+1, NA))
dfSpread2ConvexityLevel <- rbind(dfSpread2ConvexityLevel, y = c(MaxInstruments+2, NA))
dfSpread2ConvexityLevel <- rbind(dfSpread2ConvexityLevel, y = c(MaxInstruments+3, NA))
TA <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+2]
TL <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+3]
SRMA <- 0.0
for(i in 1:NumberOfAssets){
  SRMA <- SRMA + dfSpread2ConvexityLevel$Spread2ConvexityLevel[i] * (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[i]/TA)
}
SRML <- 0.0
for(i in 1:NumberOfLiabilities){
  SRML <- SRML + dfSpread2ConvexityLevel$Spread2ConvexityLevel[NumberOfAssets+i] * 
    (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[NumberOfAssets+i]/TL)
}
if(TA == -TL){
  dfSpread2ConvexityLevel$Spread2ConvexityLevel[MaxInstruments+1] <- NA
} else {
  dfSpread2ConvexityLevel$Spread2ConvexityLevel[MaxInstruments+1] <- (SRMA*TA + SRML*TL)/(TA + TL)
}
dfSpread2ConvexityLevel$Spread2ConvexityLevel[MaxInstruments+2] <- SRMA
dfSpread2ConvexityLevel$Spread2ConvexityLevel[MaxInstruments+3] <- SRML
dfSpread2ConvexityLevel
# Slope
dfSpread2ConvexitySlope <- ddply(dfStaticRiskMeasures, .(Instrument), summarize, 
                             dfStaticRiskMeasures=sum(Spread2ConvexitySlope))
dfSpread2ConvexitySlope$Spread2ConvexitySlope <- dfSpread2ConvexitySlope$dfStaticRiskMeasures
dfSpread2ConvexitySlope$dfStaticRiskMeasures <- NULL
# Compute Static Risk Measure for Net Worth
dfSpread2ConvexitySlope <- rbind(dfSpread2ConvexitySlope, y = c(MaxInstruments+1, NA))
dfSpread2ConvexitySlope <- rbind(dfSpread2ConvexitySlope, y = c(MaxInstruments+2, NA))
dfSpread2ConvexitySlope <- rbind(dfSpread2ConvexitySlope, y = c(MaxInstruments+3, NA))
TA <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+2]
TL <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+3]
SRMA <- 0.0
for(i in 1:NumberOfAssets){
  SRMA <- SRMA + dfSpread2ConvexitySlope$Spread2ConvexitySlope[i] * (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[i]/TA)
}
SRML <- 0.0
for(i in 1:NumberOfLiabilities){
  SRML <- SRML + dfSpread2ConvexitySlope$Spread2ConvexitySlope[NumberOfAssets+i] * 
    (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[NumberOfAssets+i]/TL)
}
if(TA == -TL){
  dfSpread2ConvexitySlope$Spread2ConvexitySlope[MaxInstruments+1] <- NA
} else {
  dfSpread2ConvexitySlope$Spread2ConvexitySlope[MaxInstruments+1] <- (SRMA*TA + SRML*TL)/(TA + TL)
}
dfSpread2ConvexitySlope$Spread2ConvexitySlope[MaxInstruments+2] <- SRMA
dfSpread2ConvexitySlope$Spread2ConvexitySlope[MaxInstruments+3] <- SRML
dfSpread2ConvexitySlope
# Curvature 1
dfSpread2ConvexityCurve1 <- ddply(dfStaticRiskMeasures, .(Instrument), summarize, 
                              dfStaticRiskMeasures=sum(Spread2ConvexityCurve1))
dfSpread2ConvexityCurve1$Spread2ConvexityCurve1 <- dfSpread2ConvexityCurve1$dfStaticRiskMeasures
dfSpread2ConvexityCurve1$dfStaticRiskMeasures <- NULL
# Compute Static Risk Measure for Net Worth
dfSpread2ConvexityCurve1 <- rbind(dfSpread2ConvexityCurve1, y = c(MaxInstruments+1, NA))
dfSpread2ConvexityCurve1 <- rbind(dfSpread2ConvexityCurve1, y = c(MaxInstruments+2, NA))
dfSpread2ConvexityCurve1 <- rbind(dfSpread2ConvexityCurve1, y = c(MaxInstruments+3, NA))
TA <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+2]
TL <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+3]
SRMA <- 0.0
for(i in 1:NumberOfAssets){
  SRMA <- SRMA + dfSpread2ConvexityCurve1$Spread2ConvexityCurve1[i] * (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[i]/TA)
}
SRML <- 0.0
for(i in 1:NumberOfLiabilities){
  SRML <- SRML + dfSpread2ConvexityCurve1$Spread2ConvexityCurve1[NumberOfAssets+i] * 
    (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[NumberOfAssets+i]/TL)
}
if(TA == -TL){
  dfSpread2ConvexityCurve1$Spread2ConvexityCurve1[MaxInstruments+1] <- NA
} else {
  dfSpread2ConvexityCurve1$Spread2ConvexityCurve1[MaxInstruments+1] <- (SRMA*TA + SRML*TL)/(TA + TL)
}
dfSpread2ConvexityCurve1$Spread2ConvexityCurve1[MaxInstruments+2] <- SRMA
dfSpread2ConvexityCurve1$Spread2ConvexityCurve1[MaxInstruments+3] <- SRML
dfSpread2ConvexityCurve1
# Curvature 2
dfSpread2ConvexityCurve2 <- ddply(dfStaticRiskMeasures, .(Instrument), summarize, 
                              dfStaticRiskMeasures=sum(Spread2ConvexityCurve2))
dfSpread2ConvexityCurve2$Spread2ConvexityCurve2 <- dfSpread2ConvexityCurve2$dfStaticRiskMeasures
dfSpread2ConvexityCurve2$dfStaticRiskMeasures <- NULL
# Compute Static Risk Measure for Net Worth
dfSpread2ConvexityCurve2 <- rbind(dfSpread2ConvexityCurve2, y = c(MaxInstruments+1, NA))
dfSpread2ConvexityCurve2 <- rbind(dfSpread2ConvexityCurve2, y = c(MaxInstruments+2, NA))
dfSpread2ConvexityCurve2 <- rbind(dfSpread2ConvexityCurve2, y = c(MaxInstruments+3, NA))
TA <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+2]
TL <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+3]
SRMA <- 0.0
for(i in 1:NumberOfAssets){
  SRMA <- SRMA + dfSpread2ConvexityCurve2$Spread2ConvexityCurve2[i] * (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[i]/TA)
}
SRML <- 0.0
for(i in 1:NumberOfLiabilities){
  SRML <- SRML + dfSpread2ConvexityCurve2$Spread2ConvexityCurve2[NumberOfAssets+i] * 
    (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[NumberOfAssets+i]/TL)
}
if(TA == -TL){
  dfSpread2ConvexityCurve2$Spread2ConvexityCurve2[MaxInstruments+1] <- NA
} else {
  dfSpread2ConvexityCurve2$Spread2ConvexityCurve2[MaxInstruments+1] <- (SRMA*TA + SRML*TL)/(TA + TL)
}
dfSpread2ConvexityCurve2$Spread2ConvexityCurve2[MaxInstruments+2] <- SRMA
dfSpread2ConvexityCurve2$Spread2ConvexityCurve2[MaxInstruments+3] <- SRML
# Curvature 3
dfSpread2ConvexityCurve3 <- ddply(dfStaticRiskMeasures, .(Instrument), summarize, 
                              dfStaticRiskMeasures=sum(Spread2ConvexityCurve3))
dfSpread2ConvexityCurve3$Spread2ConvexityCurve3 <- dfSpread2ConvexityCurve3$dfStaticRiskMeasures
dfSpread2ConvexityCurve3$dfStaticRiskMeasures <- NULL
# Compute Static Risk Measure for Net Worth
dfSpread2ConvexityCurve3 <- rbind(dfSpread2ConvexityCurve3, y = c(MaxInstruments+1, NA))
dfSpread2ConvexityCurve3 <- rbind(dfSpread2ConvexityCurve3, y = c(MaxInstruments+2, NA))
dfSpread2ConvexityCurve3 <- rbind(dfSpread2ConvexityCurve3, y = c(MaxInstruments+3, NA))
TA <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+2]
TL <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+3]
SRMA <- 0.0
for(i in 1:NumberOfAssets){
  SRMA <- SRMA + dfSpread2ConvexityCurve3$Spread2ConvexityCurve3[i] * (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[i]/TA)
}
SRML <- 0.0
for(i in 1:NumberOfLiabilities){
  SRML <- SRML + dfSpread2ConvexityCurve3$Spread2ConvexityCurve3[NumberOfAssets+i] * 
    (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[NumberOfAssets+i]/TL)
}
if(TA == -TL){
  dfSpread2ConvexityCurve3$Spread2ConvexityCurve3[MaxInstruments+1] <- NA
} else {
  dfSpread2ConvexityCurve3$Spread2ConvexityCurve3[MaxInstruments+1] <- (SRMA*TA + SRML*TL)/(TA + TL)
}
dfSpread2ConvexityCurve3$Spread2ConvexityCurve3[MaxInstruments+2] <- SRMA
dfSpread2ConvexityCurve3$Spread2ConvexityCurve3[MaxInstruments+3] <- SRML
# Curvature 4
dfSpread2ConvexityCurve4 <- ddply(dfStaticRiskMeasures, .(Instrument), summarize, 
                              dfStaticRiskMeasures=sum(Spread2ConvexityCurve4))
dfSpread2ConvexityCurve4$Spread2ConvexityCurve4 <- dfSpread2ConvexityCurve4$dfStaticRiskMeasures
dfSpread2ConvexityCurve4$dfStaticRiskMeasures <- NULL
# Compute Static Risk Measure for Net Worth
dfSpread2ConvexityCurve4 <- rbind(dfSpread2ConvexityCurve4, y = c(MaxInstruments+1, NA))
dfSpread2ConvexityCurve4 <- rbind(dfSpread2ConvexityCurve4, y = c(MaxInstruments+2, NA))
dfSpread2ConvexityCurve4 <- rbind(dfSpread2ConvexityCurve4, y = c(MaxInstruments+3, NA))
TA <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+2]
TL <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+3]
SRMA <- 0.0
for(i in 1:NumberOfAssets){
  SRMA <- SRMA + dfSpread2ConvexityCurve4$Spread2ConvexityCurve4[i] * (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[i]/TA)
}
SRML <- 0.0
for(i in 1:NumberOfLiabilities){
  SRML <- SRML + dfSpread2ConvexityCurve4$Spread2ConvexityCurve4[NumberOfAssets+i] * 
    (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[NumberOfAssets+i]/TL)
}
if(TA == -TL){
  dfSpread2ConvexityCurve4$Spread2ConvexityCurve4[MaxInstruments+1] <- NA
} else {
  dfSpread2ConvexityCurve4$Spread2ConvexityCurve4[MaxInstruments+1] <- (SRMA*TA + SRML*TL)/(TA + TL)
}
dfSpread2ConvexityCurve4$Spread2ConvexityCurve4[MaxInstruments+2] <- SRMA
dfSpread2ConvexityCurve4$Spread2ConvexityCurve4[MaxInstruments+3] <- SRML
# Curvature 5
dfSpread2ConvexityCurve5 <- ddply(dfStaticRiskMeasures, .(Instrument), summarize, 
                              dfStaticRiskMeasures=sum(Spread2ConvexityCurve5))
dfSpread2ConvexityCurve5$Spread2ConvexityCurve5 <- dfSpread2ConvexityCurve5$dfStaticRiskMeasures
dfSpread2ConvexityCurve5$dfStaticRiskMeasures <- NULL
# Compute Static Risk Measure for Net Worth
dfSpread2ConvexityCurve5 <- rbind(dfSpread2ConvexityCurve5, y = c(MaxInstruments+1, NA))
dfSpread2ConvexityCurve5 <- rbind(dfSpread2ConvexityCurve5, y = c(MaxInstruments+2, NA))
dfSpread2ConvexityCurve5 <- rbind(dfSpread2ConvexityCurve5, y = c(MaxInstruments+3, NA))
TA <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+2]
TL <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+3]
SRMA <- 0.0
for(i in 1:NumberOfAssets){
  SRMA <- SRMA + dfSpread2ConvexityCurve5$Spread2ConvexityCurve5[i] * (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[i]/TA)
}
SRML <- 0.0
for(i in 1:NumberOfLiabilities){
  SRML <- SRML + dfSpread2ConvexityCurve5$Spread2ConvexityCurve5[NumberOfAssets+i] * 
    (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[NumberOfAssets+i]/TL)
}
if(TA == -TL){
  dfSpread2ConvexityCurve5$Spread2ConvexityCurve5[MaxInstruments+1] <- NA
} else {
  dfSpread2ConvexityCurve5$Spread2ConvexityCurve5[MaxInstruments+1] <- (SRMA*TA + SRML*TL)/(TA + TL)
}
dfSpread2ConvexityCurve5$Spread2ConvexityCurve5[MaxInstruments+2] <- SRMA
dfSpread2ConvexityCurve5$Spread2ConvexityCurve5[MaxInstruments+3] <- SRML
# dfPVBalanceSheet
# dfPVBalanceSheetAtHorizon
# dfSpread2ConvexityLevel
# dfSpread2ConvexitySlope
# dfSpread2ConvexityCurve1
# dfSpread2ConvexityCurve2
# dfSpread2ConvexityCurve3
# dfSpread2ConvexityCurve4
# dfSpread2ConvexityCurve5
#
# Spread2 Cross Convexiities (19!)
#
# Level x _____
dfStaticRiskMeasures$Spread2CrossConvexityCCLS <- (M^2) * 1.0 * x1 * W * CW
dfStaticRiskMeasures$Spread2CrossConvexityCCLC1 <- (M^2) * 1.0 * x2 * W * CW
dfStaticRiskMeasures$Spread2CrossConvexityCCLC2 <- (M^2) * 1.0 * x3 * W * CW
dfStaticRiskMeasures$Spread2CrossConvexityCCLC3 <- (M^2) * 1.0 * x4 * W * CW
dfStaticRiskMeasures$Spread2CrossConvexityCCLC4 <- (M^2) * 1.0 * x5 * W * CW
dfStaticRiskMeasures$Spread2CrossConvexityCCLC5 <- (M^2) * 1.0 * x6 * W * CW
# Slope x _____
dfStaticRiskMeasures$Spread2CrossConvexityCCSC1 <- (M^2) * x1 * x2 * W * CW
dfStaticRiskMeasures$Spread2CrossConvexityCCSC2 <- (M^2) * x1 * x3 * W * CW
dfStaticRiskMeasures$Spread2CrossConvexityCCSC3 <- (M^2) * x1 * x4 * W * CW
dfStaticRiskMeasures$Spread2CrossConvexityCCSC4 <- (M^2) * x1 * x5 * W * CW
dfStaticRiskMeasures$Spread2CrossConvexityCCSC5 <- (M^2) * x1 * x6 * W * CW
# Curve1 x _____
dfStaticRiskMeasures$Spread2CrossConvexityCCC1C2 <- (M^2) * x2 * x3 * W * CW
dfStaticRiskMeasures$Spread2CrossConvexityCCC1C3 <- (M^2) * x2 * x4 * W * CW
dfStaticRiskMeasures$Spread2CrossConvexityCCC1C4 <- (M^2) * x2 * x5 * W * CW
dfStaticRiskMeasures$Spread2CrossConvexityCCC1C5 <- (M^2) * x2 * x6 * W * CW
# Curve2 x _____
dfStaticRiskMeasures$Spread2CrossConvexityCCC2C3 <- (M^2) * x3 * x4 * W * CW
dfStaticRiskMeasures$Spread2CrossConvexityCCC2C4 <- (M^2) * x3 * x5 * W * CW
dfStaticRiskMeasures$Spread2CrossConvexityCCC2C5 <- (M^2) * x3 * x6 * W * CW
# Curve4 x _____
dfStaticRiskMeasures$Spread2CrossConvexityCCC3C4 <- (M^2) * x4 * x5 * W * CW
dfStaticRiskMeasures$Spread2CrossConvexityCCC3C5 <- (M^2) * x4 * x6 * W * CW
# Curve5 x _____
dfStaticRiskMeasures$Spread2CrossConvexityCCC4C5 <- (M^2) * x5 * x6 * W * CW
# Level x Slope (CCLS)
dfSpread2CrossConvexityCCLS <- ddply(dfStaticRiskMeasures, .(Instrument), summarize, 
                             dfStaticRiskMeasures=sum(Spread2CrossConvexityCCLS))
dfSpread2CrossConvexityCCLS$Spread2CrossConvexityCCLS <- dfSpread2CrossConvexityCCLS$dfStaticRiskMeasures
dfSpread2CrossConvexityCCLS$dfStaticRiskMeasures <- NULL
# Compute Static Risk Measure for Net Worth
dfSpread2CrossConvexityCCLS <- rbind(dfSpread2CrossConvexityCCLS, y = c(MaxInstruments+1, NA))
dfSpread2CrossConvexityCCLS <- rbind(dfSpread2CrossConvexityCCLS, y = c(MaxInstruments+2, NA))
dfSpread2CrossConvexityCCLS <- rbind(dfSpread2CrossConvexityCCLS, y = c(MaxInstruments+3, NA))
TA <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+2]
TL <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+3]
SRMA <- 0.0
for(i in 1:NumberOfAssets){
  SRMA <- SRMA + dfSpread2CrossConvexityCCLS$Spread2CrossConvexityCCLS[i] * (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[i]/TA)
}
SRML <- 0.0
for(i in 1:NumberOfLiabilities){
  SRML <- SRML + dfSpread2CrossConvexityCCLS$Spread2CrossConvexityCCLS[NumberOfAssets+i] * 
    (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[NumberOfAssets+i]/TL)
}
if(TA == -TL){
  dfSpread2CrossConvexityCCLS$Spread2CrossConvexityCCLS[MaxInstruments+1] <- NA
} else {
  dfSpread2CrossConvexityCCLS$Spread2CrossConvexityCCLS[MaxInstruments+1] <- (SRMA*TA + SRML*TL)/(TA + TL)
}
dfSpread2CrossConvexityCCLS$Spread2CrossConvexityCCLS[MaxInstruments+2] <- SRMA
dfSpread2CrossConvexityCCLS$Spread2CrossConvexityCCLS[MaxInstruments+3] <- SRML



# Level x Curve1 (CCLC1)
dfSpread2CrossConvexityCCLC1 <- ddply(dfStaticRiskMeasures, .(Instrument), summarize, 
                            dfStaticRiskMeasures=sum(Spread2CrossConvexityCCLC1))
dfSpread2CrossConvexityCCLC1$Spread2CrossConvexityCCLC1 <- dfSpread2CrossConvexityCCLC1$dfStaticRiskMeasures
dfSpread2CrossConvexityCCLC1$dfStaticRiskMeasures <- NULL
# Compute Static Risk Measure for Net Worth
dfSpread2CrossConvexityCCLC1 <- rbind(dfSpread2CrossConvexityCCLC1, y = c(MaxInstruments+1, NA))
dfSpread2CrossConvexityCCLC1 <- rbind(dfSpread2CrossConvexityCCLC1, y = c(MaxInstruments+2, NA))
dfSpread2CrossConvexityCCLC1 <- rbind(dfSpread2CrossConvexityCCLC1, y = c(MaxInstruments+3, NA))
TA <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+2]
TL <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+3]
SRMA <- 0.0
for(i in 1:NumberOfAssets){
  SRMA <- SRMA + dfSpread2CrossConvexityCCLC1$Spread2CrossConvexityCCLC1[i] * (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[i]/TA)
}
SRML <- 0.0
for(i in 1:NumberOfLiabilities){
  SRML <- SRML + dfSpread2CrossConvexityCCLC1$Spread2CrossConvexityCCLC1[NumberOfAssets+i] * 
    (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[NumberOfAssets+i]/TL)
}
if(TA == -TL){
  dfSpread2CrossConvexityCCLC1$Spread2CrossConvexityCCLC1[MaxInstruments+1] <- NA
} else {
  dfSpread2CrossConvexityCCLC1$Spread2CrossConvexityCCLC1[MaxInstruments+1] <- (SRMA*TA + SRML*TL)/(TA + TL)
}
dfSpread2CrossConvexityCCLC1$Spread2CrossConvexityCCLC1[MaxInstruments+2] <- SRMA
dfSpread2CrossConvexityCCLC1$Spread2CrossConvexityCCLC1[MaxInstruments+3] <- SRML
# Level x Curve2 (CCLC2)
dfSpread2CrossConvexityCCLC2 <- ddply(dfStaticRiskMeasures, .(Instrument), summarize, 
                             dfStaticRiskMeasures=sum(Spread2CrossConvexityCCLC2))
dfSpread2CrossConvexityCCLC2$Spread2CrossConvexityCCLC2 <- dfSpread2CrossConvexityCCLC2$dfStaticRiskMeasures
dfSpread2CrossConvexityCCLC2$dfStaticRiskMeasures <- NULL
# Compute Static Risk Measure for Net Worth
dfSpread2CrossConvexityCCLC2 <- rbind(dfSpread2CrossConvexityCCLC2, y = c(MaxInstruments+1, NA))
dfSpread2CrossConvexityCCLC2 <- rbind(dfSpread2CrossConvexityCCLC2, y = c(MaxInstruments+2, NA))
dfSpread2CrossConvexityCCLC2 <- rbind(dfSpread2CrossConvexityCCLC2, y = c(MaxInstruments+3, NA))
TA <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+2]
TL <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+3]
SRMA <- 0.0
for(i in 1:NumberOfAssets){
  SRMA <- SRMA + dfSpread2CrossConvexityCCLC2$Spread2CrossConvexityCCLC2[i] * (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[i]/TA)
}
SRML <- 0.0
for(i in 1:NumberOfLiabilities){
  SRML <- SRML + dfSpread2CrossConvexityCCLC2$Spread2CrossConvexityCCLC2[NumberOfAssets+i] * 
    (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[NumberOfAssets+i]/TL)
}
if(TA == -TL){
  dfSpread2CrossConvexityCCLC2$Spread2CrossConvexityCCLC2[MaxInstruments+1] <- NA
} else {
  dfSpread2CrossConvexityCCLC2$Spread2CrossConvexityCCLC2[MaxInstruments+1] <- (SRMA*TA + SRML*TL)/(TA + TL)
}
dfSpread2CrossConvexityCCLC2$Spread2CrossConvexityCCLC2[MaxInstruments+2] <- SRMA
dfSpread2CrossConvexityCCLC2$Spread2CrossConvexityCCLC2[MaxInstruments+3] <- SRML
# Level x Curve3 (CCLC3)
dfSpread2CrossConvexityCCLC3 <- ddply(dfStaticRiskMeasures, .(Instrument), summarize, 
                             dfStaticRiskMeasures=sum(Spread2CrossConvexityCCLC3))
dfSpread2CrossConvexityCCLC3$Spread2CrossConvexityCCLC3 <- dfSpread2CrossConvexityCCLC3$dfStaticRiskMeasures
dfSpread2CrossConvexityCCLC3$dfStaticRiskMeasures <- NULL
# Compute Static Risk Measure for Net Worth
dfSpread2CrossConvexityCCLC3 <- rbind(dfSpread2CrossConvexityCCLC3, y = c(MaxInstruments+1, NA))
dfSpread2CrossConvexityCCLC3 <- rbind(dfSpread2CrossConvexityCCLC3, y = c(MaxInstruments+2, NA))
dfSpread2CrossConvexityCCLC3 <- rbind(dfSpread2CrossConvexityCCLC3, y = c(MaxInstruments+3, NA))
TA <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+2]
TL <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+3]
SRMA <- 0.0
for(i in 1:NumberOfAssets){
  SRMA <- SRMA + dfSpread2CrossConvexityCCLC3$Spread2CrossConvexityCCLC3[i] * (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[i]/TA)
}
SRML <- 0.0
for(i in 1:NumberOfLiabilities){
  SRML <- SRML + dfSpread2CrossConvexityCCLC3$Spread2CrossConvexityCCLC3[NumberOfAssets+i] * 
    (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[NumberOfAssets+i]/TL)
}
if(TA == -TL){
  dfSpread2CrossConvexityCCLC3$Spread2CrossConvexityCCLC3[MaxInstruments+1] <- NA
} else {
  dfSpread2CrossConvexityCCLC3$Spread2CrossConvexityCCLC3[MaxInstruments+1] <- (SRMA*TA + SRML*TL)/(TA + TL)
}
dfSpread2CrossConvexityCCLC3$Spread2CrossConvexityCCLC3[MaxInstruments+2] <- SRMA
dfSpread2CrossConvexityCCLC3$Spread2CrossConvexityCCLC3[MaxInstruments+3] <- SRML
# Level x Curve4 (CCLC4)
dfSpread2CrossConvexityCCLC4 <- ddply(dfStaticRiskMeasures, .(Instrument), summarize, 
                             dfStaticRiskMeasures=sum(Spread2CrossConvexityCCLC4))
dfSpread2CrossConvexityCCLC4$Spread2CrossConvexityCCLC4 <- dfSpread2CrossConvexityCCLC4$dfStaticRiskMeasures
dfSpread2CrossConvexityCCLC4$dfStaticRiskMeasures <- NULL
# Compute Static Risk Measure for Net Worth
dfSpread2CrossConvexityCCLC4 <- rbind(dfSpread2CrossConvexityCCLC4, y = c(MaxInstruments+1, NA))
dfSpread2CrossConvexityCCLC4 <- rbind(dfSpread2CrossConvexityCCLC4, y = c(MaxInstruments+2, NA))
dfSpread2CrossConvexityCCLC4 <- rbind(dfSpread2CrossConvexityCCLC4, y = c(MaxInstruments+3, NA))
TA <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+2]
TL <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+3]
SRMA <- 0.0
for(i in 1:NumberOfAssets){
  SRMA <- SRMA + dfSpread2CrossConvexityCCLC4$Spread2CrossConvexityCCLC4[i] * (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[i]/TA)
}
SRML <- 0.0
for(i in 1:NumberOfLiabilities){
  SRML <- SRML + dfSpread2CrossConvexityCCLC4$Spread2CrossConvexityCCLC4[NumberOfAssets+i] * 
    (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[NumberOfAssets+i]/TL)
}
if(TA == -TL){
  dfSpread2CrossConvexityCCLC4$Spread2CrossConvexityCCLC4[MaxInstruments+1] <- NA
} else {
  dfSpread2CrossConvexityCCLC4$Spread2CrossConvexityCCLC4[MaxInstruments+1] <- (SRMA*TA + SRML*TL)/(TA + TL)
}
dfSpread2CrossConvexityCCLC4$Spread2CrossConvexityCCLC4[MaxInstruments+2] <- SRMA
dfSpread2CrossConvexityCCLC4$Spread2CrossConvexityCCLC4[MaxInstruments+3] <- SRML
# Level x Curve5 (CCLC5)
dfSpread2CrossConvexityCCLC5 <- ddply(dfStaticRiskMeasures, .(Instrument), summarize, 
                             dfStaticRiskMeasures=sum(Spread2CrossConvexityCCLC5))
dfSpread2CrossConvexityCCLC5$Spread2CrossConvexityCCLC5 <- dfSpread2CrossConvexityCCLC5$dfStaticRiskMeasures
dfSpread2CrossConvexityCCLC5$dfStaticRiskMeasures <- NULL
# Compute Static Risk Measure for Net Worth
dfSpread2CrossConvexityCCLC5 <- rbind(dfSpread2CrossConvexityCCLC5, y = c(MaxInstruments+1, NA))
dfSpread2CrossConvexityCCLC5 <- rbind(dfSpread2CrossConvexityCCLC5, y = c(MaxInstruments+2, NA))
dfSpread2CrossConvexityCCLC5 <- rbind(dfSpread2CrossConvexityCCLC5, y = c(MaxInstruments+3, NA))
TA <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+2]
TL <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+3]
SRMA <- 0.0
for(i in 1:NumberOfAssets){
  SRMA <- SRMA + dfSpread2CrossConvexityCCLC5$Spread2CrossConvexityCCLC5[i] * (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[i]/TA)
}
SRML <- 0.0
for(i in 1:NumberOfLiabilities){
  SRML <- SRML + dfSpread2CrossConvexityCCLC5$Spread2CrossConvexityCCLC5[NumberOfAssets+i] * 
    (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[NumberOfAssets+i]/TL)
}
if(TA == -TL){
  dfSpread2CrossConvexityCCLC5$Spread2CrossConvexityCCLC5[MaxInstruments+1] <- NA
} else {
  dfSpread2CrossConvexityCCLC5$Spread2CrossConvexityCCLC5[MaxInstruments+1] <- (SRMA*TA + SRML*TL)/(TA + TL)
}
dfSpread2CrossConvexityCCLC5$Spread2CrossConvexityCCLC5[MaxInstruments+2] <- SRMA
dfSpread2CrossConvexityCCLC5$Spread2CrossConvexityCCLC5[MaxInstruments+3] <- SRML
# dfSpread2CrossConvexityCCLS
# dfSpread2CrossConvexityCCLC1
# dfSpread2CrossConvexityCCLC2
# dfSpread2CrossConvexityCCLC3
# dfSpread2CrossConvexityCCLC4
# dfSpread2CrossConvexityCCLC5
# Slope x Curve1 (CCSC1)
dfSpread2CrossConvexityCCSC1 <- ddply(dfStaticRiskMeasures, .(Instrument), summarize, 
                             dfStaticRiskMeasures=sum(Spread2CrossConvexityCCSC1))
dfSpread2CrossConvexityCCSC1$Spread2CrossConvexityCCSC1 <- dfSpread2CrossConvexityCCSC1$dfStaticRiskMeasures
dfSpread2CrossConvexityCCSC1$dfStaticRiskMeasures <- NULL
# Compute Static Risk Measure for Net Worth
dfSpread2CrossConvexityCCSC1 <- rbind(dfSpread2CrossConvexityCCSC1, y = c(MaxInstruments+1, NA))
dfSpread2CrossConvexityCCSC1 <- rbind(dfSpread2CrossConvexityCCSC1, y = c(MaxInstruments+2, NA))
dfSpread2CrossConvexityCCSC1 <- rbind(dfSpread2CrossConvexityCCSC1, y = c(MaxInstruments+3, NA))
TA <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+2]
TL <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+3]
SRMA <- 0.0
for(i in 1:NumberOfAssets){
  SRMA <- SRMA + dfSpread2CrossConvexityCCSC1$Spread2CrossConvexityCCSC1[i] * (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[i]/TA)
}
SRML <- 0.0
for(i in 1:NumberOfLiabilities){
  SRML <- SRML + dfSpread2CrossConvexityCCSC1$Spread2CrossConvexityCCSC1[NumberOfAssets+i] * 
    (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[NumberOfAssets+i]/TL)
}
if(TA == -TL){
  dfSpread2CrossConvexityCCSC1$Spread2CrossConvexityCCSC1[MaxInstruments+1] <- NA
} else {
  dfSpread2CrossConvexityCCSC1$Spread2CrossConvexityCCSC1[MaxInstruments+1] <- (SRMA*TA + SRML*TL)/(TA + TL)
}
dfSpread2CrossConvexityCCSC1$Spread2CrossConvexityCCSC1[MaxInstruments+2] <- SRMA
dfSpread2CrossConvexityCCSC1$Spread2CrossConvexityCCSC1[MaxInstruments+3] <- SRML
# Level x Curve2 (CCSC2)
dfSpread2CrossConvexityCCSC2 <- ddply(dfStaticRiskMeasures, .(Instrument), summarize, 
                             dfStaticRiskMeasures=sum(Spread2CrossConvexityCCSC2))
dfSpread2CrossConvexityCCSC2$Spread2CrossConvexityCCSC2 <- dfSpread2CrossConvexityCCSC2$dfStaticRiskMeasures
dfSpread2CrossConvexityCCSC2$dfStaticRiskMeasures <- NULL
# Compute Static Risk Measure for Net Worth
dfSpread2CrossConvexityCCSC2 <- rbind(dfSpread2CrossConvexityCCSC2, y = c(MaxInstruments+1, NA))
dfSpread2CrossConvexityCCSC2 <- rbind(dfSpread2CrossConvexityCCSC2, y = c(MaxInstruments+2, NA))
dfSpread2CrossConvexityCCSC2 <- rbind(dfSpread2CrossConvexityCCSC2, y = c(MaxInstruments+3, NA))
TA <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+2]
TL <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+3]
SRMA <- 0.0
for(i in 1:NumberOfAssets){
  SRMA <- SRMA + dfSpread2CrossConvexityCCSC2$Spread2CrossConvexityCCSC2[i] * (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[i]/TA)
}
SRML <- 0.0
for(i in 1:NumberOfLiabilities){
  SRML <- SRML + dfSpread2CrossConvexityCCSC2$Spread2CrossConvexityCCSC2[NumberOfAssets+i] * 
    (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[NumberOfAssets+i]/TL)
}
if(TA == -TL){
  dfSpread2CrossConvexityCCSC2$Spread2CrossConvexityCCSC2[MaxInstruments+1] <- NA
} else {
  dfSpread2CrossConvexityCCSC2$Spread2CrossConvexityCCSC2[MaxInstruments+1] <- (SRMA*TA + SRML*TL)/(TA + TL)
}
dfSpread2CrossConvexityCCSC2$Spread2CrossConvexityCCSC2[MaxInstruments+2] <- SRMA
dfSpread2CrossConvexityCCSC2$Spread2CrossConvexityCCSC2[MaxInstruments+3] <- SRML
# Level x Curve3 (CCSC3)
dfSpread2CrossConvexityCCSC3 <- ddply(dfStaticRiskMeasures, .(Instrument), summarize, 
                             dfStaticRiskMeasures=sum(Spread2CrossConvexityCCSC3))
dfSpread2CrossConvexityCCSC3$Spread2CrossConvexityCCSC3 <- dfSpread2CrossConvexityCCSC3$dfStaticRiskMeasures
dfSpread2CrossConvexityCCSC3$dfStaticRiskMeasures <- NULL
# Compute Static Risk Measure for Net Worth
dfSpread2CrossConvexityCCSC3 <- rbind(dfSpread2CrossConvexityCCSC3, y = c(MaxInstruments+1, NA))
dfSpread2CrossConvexityCCSC3 <- rbind(dfSpread2CrossConvexityCCSC3, y = c(MaxInstruments+2, NA))
dfSpread2CrossConvexityCCSC3 <- rbind(dfSpread2CrossConvexityCCSC3, y = c(MaxInstruments+3, NA))
TA <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+2]
TL <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+3]
SRMA <- 0.0
for(i in 1:NumberOfAssets){
  SRMA <- SRMA + dfSpread2CrossConvexityCCSC3$Spread2CrossConvexityCCSC3[i] * (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[i]/TA)
}
SRML <- 0.0
for(i in 1:NumberOfLiabilities){
  SRML <- SRML + dfSpread2CrossConvexityCCSC3$Spread2CrossConvexityCCSC3[NumberOfAssets+i] * 
    (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[NumberOfAssets+i]/TL)
}
if(TA == -TL){
  dfSpread2CrossConvexityCCSC3$Spread2CrossConvexityCCSC3[MaxInstruments+1] <- NA
} else {
  dfSpread2CrossConvexityCCSC3$Spread2CrossConvexityCCSC3[MaxInstruments+1] <- (SRMA*TA + SRML*TL)/(TA + TL)
}
dfSpread2CrossConvexityCCSC3$Spread2CrossConvexityCCSC3[MaxInstruments+2] <- SRMA
dfSpread2CrossConvexityCCSC3$Spread2CrossConvexityCCSC3[MaxInstruments+3] <- SRML
# Level x Curve4 (CCSC4)
dfSpread2CrossConvexityCCSC4 <- ddply(dfStaticRiskMeasures, .(Instrument), summarize, 
                             dfStaticRiskMeasures=sum(Spread2CrossConvexityCCSC4))
dfSpread2CrossConvexityCCSC4$Spread2CrossConvexityCCSC4 <- dfSpread2CrossConvexityCCSC4$dfStaticRiskMeasures
dfSpread2CrossConvexityCCSC4$dfStaticRiskMeasures <- NULL
# Compute Static Risk Measure for Net Worth
dfSpread2CrossConvexityCCSC4 <- rbind(dfSpread2CrossConvexityCCSC4, y = c(MaxInstruments+1, NA))
dfSpread2CrossConvexityCCSC4 <- rbind(dfSpread2CrossConvexityCCSC4, y = c(MaxInstruments+2, NA))
dfSpread2CrossConvexityCCSC4 <- rbind(dfSpread2CrossConvexityCCSC4, y = c(MaxInstruments+3, NA))
TA <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+2]
TL <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+3]
SRMA <- 0.0
for(i in 1:NumberOfAssets){
  SRMA <- SRMA + dfSpread2CrossConvexityCCSC4$Spread2CrossConvexityCCSC4[i] * (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[i]/TA)
}
SRML <- 0.0
for(i in 1:NumberOfLiabilities){
  SRML <- SRML + dfSpread2CrossConvexityCCSC4$Spread2CrossConvexityCCSC4[NumberOfAssets+i] * 
    (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[NumberOfAssets+i]/TL)
}
if(TA == -TL){
  dfSpread2CrossConvexityCCSC4$Spread2CrossConvexityCCSC4[MaxInstruments+1] <- NA
} else {
  dfSpread2CrossConvexityCCSC4$Spread2CrossConvexityCCSC4[MaxInstruments+1] <- (SRMA*TA + SRML*TL)/(TA + TL)
}
dfSpread2CrossConvexityCCSC4$Spread2CrossConvexityCCSC4[MaxInstruments+2] <- SRMA
dfSpread2CrossConvexityCCSC4$Spread2CrossConvexityCCSC4[MaxInstruments+3] <- SRML
# Level x Curve5 (CCSC5)
dfSpread2CrossConvexityCCSC5 <- ddply(dfStaticRiskMeasures, .(Instrument), summarize, 
                             dfStaticRiskMeasures=sum(Spread2CrossConvexityCCSC5))
dfSpread2CrossConvexityCCSC5$Spread2CrossConvexityCCSC5 <- dfSpread2CrossConvexityCCSC5$dfStaticRiskMeasures
dfSpread2CrossConvexityCCSC5$dfStaticRiskMeasures <- NULL
# Compute Static Risk Measure for Net Worth
dfSpread2CrossConvexityCCSC5 <- rbind(dfSpread2CrossConvexityCCSC5, y = c(MaxInstruments+1, NA))
dfSpread2CrossConvexityCCSC5 <- rbind(dfSpread2CrossConvexityCCSC5, y = c(MaxInstruments+2, NA))
dfSpread2CrossConvexityCCSC5 <- rbind(dfSpread2CrossConvexityCCSC5, y = c(MaxInstruments+3, NA))
TA <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+2]
TL <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+3]
SRMA <- 0.0
for(i in 1:NumberOfAssets){
  SRMA <- SRMA + dfSpread2CrossConvexityCCSC5$Spread2CrossConvexityCCSC5[i] * (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[i]/TA)
}
SRML <- 0.0
for(i in 1:NumberOfLiabilities){
  SRML <- SRML + dfSpread2CrossConvexityCCSC5$Spread2CrossConvexityCCSC5[NumberOfAssets+i] * 
    (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[NumberOfAssets+i]/TL)
}
if(TA == -TL){
  dfSpread2CrossConvexityCCSC5$Spread2CrossConvexityCCSC5[MaxInstruments+1] <- NA
} else {
  dfSpread2CrossConvexityCCSC5$Spread2CrossConvexityCCSC5[MaxInstruments+1] <- (SRMA*TA + SRML*TL)/(TA + TL)
}
dfSpread2CrossConvexityCCSC5$Spread2CrossConvexityCCSC5[MaxInstruments+2] <- SRMA
dfSpread2CrossConvexityCCSC5$Spread2CrossConvexityCCSC5[MaxInstruments+3] <- SRML
# dfSpread2CrossConvexityCCSC1
# dfSpread2CrossConvexityCCSC2
# dfSpread2CrossConvexityCCSC3
# dfSpread2CrossConvexityCCSC4
# dfSpread2CrossConvexityCCSC5
# Curve1 x Curve2 (CCC1C2)
dfSpread2CrossConvexityCCC1C2 <- ddply(dfStaticRiskMeasures, .(Instrument), summarize, 
                             dfStaticRiskMeasures=sum(Spread2CrossConvexityCCC1C2))
dfSpread2CrossConvexityCCC1C2$Spread2CrossConvexityCCC1C2 <- dfSpread2CrossConvexityCCC1C2$dfStaticRiskMeasures
dfSpread2CrossConvexityCCC1C2$dfStaticRiskMeasures <- NULL
# Compute Static Risk Measure for Net Worth
dfSpread2CrossConvexityCCC1C2 <- rbind(dfSpread2CrossConvexityCCC1C2, y = c(MaxInstruments+1, NA))
dfSpread2CrossConvexityCCC1C2 <- rbind(dfSpread2CrossConvexityCCC1C2, y = c(MaxInstruments+2, NA))
dfSpread2CrossConvexityCCC1C2 <- rbind(dfSpread2CrossConvexityCCC1C2, y = c(MaxInstruments+3, NA))
TA <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+2]
TL <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+3]
SRMA <- 0.0
for(i in 1:NumberOfAssets){
  SRMA <- SRMA + dfSpread2CrossConvexityCCC1C2$Spread2CrossConvexityCCC1C2[i] * (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[i]/TA)
}
SRML <- 0.0
for(i in 1:NumberOfLiabilities){
  SRML <- SRML + dfSpread2CrossConvexityCCC1C2$Spread2CrossConvexityCCC1C2[NumberOfAssets+i] * 
    (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[NumberOfAssets+i]/TL)
}
if(TA == -TL){
  dfSpread2CrossConvexityCCC1C2$Spread2CrossConvexityCCC1C2[MaxInstruments+1] <- NA
} else {
  dfSpread2CrossConvexityCCC1C2$Spread2CrossConvexityCCC1C2[MaxInstruments+1] <- (SRMA*TA + SRML*TL)/(TA + TL)
}
dfSpread2CrossConvexityCCC1C2$Spread2CrossConvexityCCC1C2[MaxInstruments+2] <- SRMA
dfSpread2CrossConvexityCCC1C2$Spread2CrossConvexityCCC1C2[MaxInstruments+3] <- SRML
# Level x Curve3 (CCC1C3)
dfSpread2CrossConvexityCCC1C3 <- ddply(dfStaticRiskMeasures, .(Instrument), summarize, 
                             dfStaticRiskMeasures=sum(Spread2CrossConvexityCCC1C3))
dfSpread2CrossConvexityCCC1C3$Spread2CrossConvexityCCC1C3 <- dfSpread2CrossConvexityCCC1C3$dfStaticRiskMeasures
dfSpread2CrossConvexityCCC1C3$dfStaticRiskMeasures <- NULL
# Compute Static Risk Measure for Net Worth
dfSpread2CrossConvexityCCC1C3 <- rbind(dfSpread2CrossConvexityCCC1C3, y = c(MaxInstruments+1, NA))
dfSpread2CrossConvexityCCC1C3 <- rbind(dfSpread2CrossConvexityCCC1C3, y = c(MaxInstruments+2, NA))
dfSpread2CrossConvexityCCC1C3 <- rbind(dfSpread2CrossConvexityCCC1C3, y = c(MaxInstruments+3, NA))
TA <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+2]
TL <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+3]
SRMA <- 0.0
for(i in 1:NumberOfAssets){
  SRMA <- SRMA + dfSpread2CrossConvexityCCC1C3$Spread2CrossConvexityCCC1C3[i] * (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[i]/TA)
}
SRML <- 0.0
for(i in 1:NumberOfLiabilities){
  SRML <- SRML + dfSpread2CrossConvexityCCC1C3$Spread2CrossConvexityCCC1C3[NumberOfAssets+i] * 
    (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[NumberOfAssets+i]/TL)
}
if(TA == -TL){
  dfSpread2CrossConvexityCCC1C3$Spread2CrossConvexityCCC1C3[MaxInstruments+1] <- NA
} else {
  dfSpread2CrossConvexityCCC1C3$Spread2CrossConvexityCCC1C3[MaxInstruments+1] <- (SRMA*TA + SRML*TL)/(TA + TL)
}
dfSpread2CrossConvexityCCC1C3$Spread2CrossConvexityCCC1C3[MaxInstruments+2] <- SRMA
dfSpread2CrossConvexityCCC1C3$Spread2CrossConvexityCCC1C3[MaxInstruments+3] <- SRML
# Level x Curve4 (CCC1C4)
dfSpread2CrossConvexityCCC1C4 <- ddply(dfStaticRiskMeasures, .(Instrument), summarize, 
                             dfStaticRiskMeasures=sum(Spread2CrossConvexityCCC1C4))
dfSpread2CrossConvexityCCC1C4$Spread2CrossConvexityCCC1C4 <- dfSpread2CrossConvexityCCC1C4$dfStaticRiskMeasures
dfSpread2CrossConvexityCCC1C4$dfStaticRiskMeasures <- NULL
# Compute Static Risk Measure for Net Worth
dfSpread2CrossConvexityCCC1C4 <- rbind(dfSpread2CrossConvexityCCC1C4, y = c(MaxInstruments+1, NA))
dfSpread2CrossConvexityCCC1C4 <- rbind(dfSpread2CrossConvexityCCC1C4, y = c(MaxInstruments+2, NA))
dfSpread2CrossConvexityCCC1C4 <- rbind(dfSpread2CrossConvexityCCC1C4, y = c(MaxInstruments+3, NA))
TA <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+2]
TL <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+3]
SRMA <- 0.0
for(i in 1:NumberOfAssets){
  SRMA <- SRMA + dfSpread2CrossConvexityCCC1C4$Spread2CrossConvexityCCC1C4[i] * (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[i]/TA)
}
SRML <- 0.0
for(i in 1:NumberOfLiabilities){
  SRML <- SRML + dfSpread2CrossConvexityCCC1C4$Spread2CrossConvexityCCC1C4[NumberOfAssets+i] * 
    (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[NumberOfAssets+i]/TL)
}
if(TA == -TL){
  dfSpread2CrossConvexityCCC1C4$Spread2CrossConvexityCCC1C4[MaxInstruments+1] <- NA
} else {
  dfSpread2CrossConvexityCCC1C4$Spread2CrossConvexityCCC1C4[MaxInstruments+1] <- (SRMA*TA + SRML*TL)/(TA + TL)
}
dfSpread2CrossConvexityCCC1C4$Spread2CrossConvexityCCC1C4[MaxInstruments+2] <- SRMA
dfSpread2CrossConvexityCCC1C4$Spread2CrossConvexityCCC1C4[MaxInstruments+3] <- SRML
# Level x Curve5 (CCC1C5)
dfSpread2CrossConvexityCCC1C5 <- ddply(dfStaticRiskMeasures, .(Instrument), summarize, 
                             dfStaticRiskMeasures=sum(Spread2CrossConvexityCCC1C5))
dfSpread2CrossConvexityCCC1C5$Spread2CrossConvexityCCC1C5 <- dfSpread2CrossConvexityCCC1C5$dfStaticRiskMeasures
dfSpread2CrossConvexityCCC1C5$dfStaticRiskMeasures <- NULL
# Compute Static Risk Measure for Net Worth
dfSpread2CrossConvexityCCC1C5 <- rbind(dfSpread2CrossConvexityCCC1C5, y = c(MaxInstruments+1, NA))
dfSpread2CrossConvexityCCC1C5 <- rbind(dfSpread2CrossConvexityCCC1C5, y = c(MaxInstruments+2, NA))
dfSpread2CrossConvexityCCC1C5 <- rbind(dfSpread2CrossConvexityCCC1C5, y = c(MaxInstruments+3, NA))
TA <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+2]
TL <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+3]
SRMA <- 0.0
for(i in 1:NumberOfAssets){
  SRMA <- SRMA + dfSpread2CrossConvexityCCC1C5$Spread2CrossConvexityCCC1C5[i] * (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[i]/TA)
}
SRML <- 0.0
for(i in 1:NumberOfLiabilities){
  SRML <- SRML + dfSpread2CrossConvexityCCC1C5$Spread2CrossConvexityCCC1C5[NumberOfAssets+i] * 
    (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[NumberOfAssets+i]/TL)
}
if(TA == -TL){
  dfSpread2CrossConvexityCCC1C5$Spread2CrossConvexityCCC1C5[MaxInstruments+1] <- NA
} else {
  dfSpread2CrossConvexityCCC1C5$Spread2CrossConvexityCCC1C5[MaxInstruments+1] <- (SRMA*TA + SRML*TL)/(TA + TL)
}
dfSpread2CrossConvexityCCC1C5$Spread2CrossConvexityCCC1C5[MaxInstruments+2] <- SRMA
dfSpread2CrossConvexityCCC1C5$Spread2CrossConvexityCCC1C5[MaxInstruments+3] <- SRML
# dfSpread2CrossConvexityCCC1C2
# dfSpread2CrossConvexityCCC1C3
# dfSpread2CrossConvexityCCC1C4
# dfSpread2CrossConvexityCCC1C5
# Curve2 x Curve3 (CCC2C3)
dfSpread2CrossConvexityCCC2C3 <- ddply(dfStaticRiskMeasures, .(Instrument), summarize, 
                              dfStaticRiskMeasures=sum(Spread2CrossConvexityCCC2C3))
dfSpread2CrossConvexityCCC2C3$Spread2CrossConvexityCCC2C3 <- dfSpread2CrossConvexityCCC2C3$dfStaticRiskMeasures
dfSpread2CrossConvexityCCC2C3$dfStaticRiskMeasures <- NULL
# Compute Static Risk Measure for Net Worth
dfSpread2CrossConvexityCCC2C3 <- rbind(dfSpread2CrossConvexityCCC2C3, y = c(MaxInstruments+1, NA))
dfSpread2CrossConvexityCCC2C3 <- rbind(dfSpread2CrossConvexityCCC2C3, y = c(MaxInstruments+2, NA))
dfSpread2CrossConvexityCCC2C3 <- rbind(dfSpread2CrossConvexityCCC2C3, y = c(MaxInstruments+3, NA))
TA <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+2]
TL <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+3]
SRMA <- 0.0
for(i in 1:NumberOfAssets){
  SRMA <- SRMA + dfSpread2CrossConvexityCCC2C3$Spread2CrossConvexityCCC2C3[i] * (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[i]/TA)
}
SRML <- 0.0
for(i in 1:NumberOfLiabilities){
  SRML <- SRML + dfSpread2CrossConvexityCCC2C3$Spread2CrossConvexityCCC2C3[NumberOfAssets+i] * 
    (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[NumberOfAssets+i]/TL)
}
if(TA == -TL){
  dfSpread2CrossConvexityCCC2C3$Spread2CrossConvexityCCC2C3[MaxInstruments+1] <- NA
} else {
  dfSpread2CrossConvexityCCC2C3$Spread2CrossConvexityCCC2C3[MaxInstruments+1] <- (SRMA*TA + SRML*TL)/(TA + TL)
}
dfSpread2CrossConvexityCCC2C3$Spread2CrossConvexityCCC2C3[MaxInstruments+2] <- SRMA
dfSpread2CrossConvexityCCC2C3$Spread2CrossConvexityCCC2C3[MaxInstruments+3] <- SRML
# _____ x Curve4 (CCC2C4)
dfSpread2CrossConvexityCCC2C4 <- ddply(dfStaticRiskMeasures, .(Instrument), summarize, 
                              dfStaticRiskMeasures=sum(Spread2CrossConvexityCCC2C4))
dfSpread2CrossConvexityCCC2C4$Spread2CrossConvexityCCC2C4 <- dfSpread2CrossConvexityCCC2C4$dfStaticRiskMeasures
dfSpread2CrossConvexityCCC2C4$dfStaticRiskMeasures <- NULL
# Compute Static Risk Measure for Net Worth
dfSpread2CrossConvexityCCC2C4 <- rbind(dfSpread2CrossConvexityCCC2C4, y = c(MaxInstruments+1, NA))
dfSpread2CrossConvexityCCC2C4 <- rbind(dfSpread2CrossConvexityCCC2C4, y = c(MaxInstruments+2, NA))
dfSpread2CrossConvexityCCC2C4 <- rbind(dfSpread2CrossConvexityCCC2C4, y = c(MaxInstruments+3, NA))
TA <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+2]
TL <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+3]
SRMA <- 0.0
for(i in 1:NumberOfAssets){
  SRMA <- SRMA + dfSpread2CrossConvexityCCC2C4$Spread2CrossConvexityCCC2C4[i] * (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[i]/TA)
}
SRML <- 0.0
for(i in 1:NumberOfLiabilities){
  SRML <- SRML + dfSpread2CrossConvexityCCC2C4$Spread2CrossConvexityCCC2C4[NumberOfAssets+i] * 
    (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[NumberOfAssets+i]/TL)
}
if(TA == -TL){
  dfSpread2CrossConvexityCCC2C4$Spread2CrossConvexityCCC2C4[MaxInstruments+1] <- NA
} else {
  dfSpread2CrossConvexityCCC2C4$Spread2CrossConvexityCCC2C4[MaxInstruments+1] <- (SRMA*TA + SRML*TL)/(TA + TL)
}
dfSpread2CrossConvexityCCC2C4$Spread2CrossConvexityCCC2C4[MaxInstruments+2] <- SRMA
dfSpread2CrossConvexityCCC2C4$Spread2CrossConvexityCCC2C4[MaxInstruments+3] <- SRML
# _____ x Curve5 (CCC2C5)
dfSpread2CrossConvexityCCC2C5 <- ddply(dfStaticRiskMeasures, .(Instrument), summarize, 
                              dfStaticRiskMeasures=sum(Spread2CrossConvexityCCC2C5))
dfSpread2CrossConvexityCCC2C5$Spread2CrossConvexityCCC2C5 <- dfSpread2CrossConvexityCCC2C5$dfStaticRiskMeasures
dfSpread2CrossConvexityCCC2C5$dfStaticRiskMeasures <- NULL
# Compute Static Risk Measure for Net Worth
dfSpread2CrossConvexityCCC2C5 <- rbind(dfSpread2CrossConvexityCCC2C5, y = c(MaxInstruments+1, NA))
dfSpread2CrossConvexityCCC2C5 <- rbind(dfSpread2CrossConvexityCCC2C5, y = c(MaxInstruments+2, NA))
dfSpread2CrossConvexityCCC2C5 <- rbind(dfSpread2CrossConvexityCCC2C5, y = c(MaxInstruments+3, NA))
TA <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+2]
TL <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+3]
SRMA <- 0.0
for(i in 1:NumberOfAssets){
  SRMA <- SRMA + dfSpread2CrossConvexityCCC2C5$Spread2CrossConvexityCCC2C5[i] * (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[i]/TA)
}
SRML <- 0.0
for(i in 1:NumberOfLiabilities){
  SRML <- SRML + dfSpread2CrossConvexityCCC2C5$Spread2CrossConvexityCCC2C5[NumberOfAssets+i] * 
    (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[NumberOfAssets+i]/TL)
}
if(TA == -TL){
  dfSpread2CrossConvexityCCC2C5$Spread2CrossConvexityCCC2C5[MaxInstruments+1] <- NA
} else {
  dfSpread2CrossConvexityCCC2C5$Spread2CrossConvexityCCC2C5[MaxInstruments+1] <- (SRMA*TA + SRML*TL)/(TA + TL)
}
dfSpread2CrossConvexityCCC2C5$Spread2CrossConvexityCCC2C5[MaxInstruments+2] <- SRMA
dfSpread2CrossConvexityCCC2C5$Spread2CrossConvexityCCC2C5[MaxInstruments+3] <- SRML
# dfSpread2CrossConvexityCCC2C3
# dfSpread2CrossConvexityCCC2C4
# dfSpread2CrossConvexityCCC2C5
# Curve3 x Curve4 (CCC3C4)
dfSpread2CrossConvexityCCC3C4 <- ddply(dfStaticRiskMeasures, .(Instrument), summarize, 
                              dfStaticRiskMeasures=sum(Spread2CrossConvexityCCC3C4))
dfSpread2CrossConvexityCCC3C4$Spread2CrossConvexityCCC3C4 <- dfSpread2CrossConvexityCCC3C4$dfStaticRiskMeasures
dfSpread2CrossConvexityCCC3C4$dfStaticRiskMeasures <- NULL
# Compute Static Risk Measure for Net Worth
dfSpread2CrossConvexityCCC3C4 <- rbind(dfSpread2CrossConvexityCCC3C4, y = c(MaxInstruments+1, NA))
dfSpread2CrossConvexityCCC3C4 <- rbind(dfSpread2CrossConvexityCCC3C4, y = c(MaxInstruments+2, NA))
dfSpread2CrossConvexityCCC3C4 <- rbind(dfSpread2CrossConvexityCCC3C4, y = c(MaxInstruments+3, NA))
TA <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+2]
TL <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+3]
SRMA <- 0.0
for(i in 1:NumberOfAssets){
  SRMA <- SRMA + dfSpread2CrossConvexityCCC3C4$Spread2CrossConvexityCCC3C4[i] * (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[i]/TA)
}
SRML <- 0.0
for(i in 1:NumberOfLiabilities){
  SRML <- SRML + dfSpread2CrossConvexityCCC3C4$Spread2CrossConvexityCCC3C4[NumberOfAssets+i] * 
    (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[NumberOfAssets+i]/TL)
}
if(TA == -TL){
  dfSpread2CrossConvexityCCC3C4$Spread2CrossConvexityCCC3C4[MaxInstruments+1] <- NA
} else {
  dfSpread2CrossConvexityCCC3C4$Spread2CrossConvexityCCC3C4[MaxInstruments+1] <- (SRMA*TA + SRML*TL)/(TA + TL)
}
dfSpread2CrossConvexityCCC3C4$Spread2CrossConvexityCCC3C4[MaxInstruments+2] <- SRMA
dfSpread2CrossConvexityCCC3C4$Spread2CrossConvexityCCC3C4[MaxInstruments+3] <- SRML
# _____ x Curve5 (CCC3C5)
dfSpread2CrossConvexityCCC3C5 <- ddply(dfStaticRiskMeasures, .(Instrument), summarize, 
                              dfStaticRiskMeasures=sum(Spread2CrossConvexityCCC3C5))
dfSpread2CrossConvexityCCC3C5$Spread2CrossConvexityCCC3C5 <- dfSpread2CrossConvexityCCC3C5$dfStaticRiskMeasures
dfSpread2CrossConvexityCCC3C5$dfStaticRiskMeasures <- NULL
# Compute Static Risk Measure for Net Worth
dfSpread2CrossConvexityCCC3C5 <- rbind(dfSpread2CrossConvexityCCC3C5, y = c(MaxInstruments+1, NA))
dfSpread2CrossConvexityCCC3C5 <- rbind(dfSpread2CrossConvexityCCC3C5, y = c(MaxInstruments+2, NA))
dfSpread2CrossConvexityCCC3C5 <- rbind(dfSpread2CrossConvexityCCC3C5, y = c(MaxInstruments+3, NA))
TA <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+2]
TL <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+3]
SRMA <- 0.0
for(i in 1:NumberOfAssets){
  SRMA <- SRMA + dfSpread2CrossConvexityCCC3C5$Spread2CrossConvexityCCC3C5[i] * (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[i]/TA)
}
SRML <- 0.0
for(i in 1:NumberOfLiabilities){
  SRML <- SRML + dfSpread2CrossConvexityCCC3C5$Spread2CrossConvexityCCC3C5[NumberOfAssets+i] * 
    (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[NumberOfAssets+i]/TL)
}
if(TA == -TL){
  dfSpread2CrossConvexityCCC3C5$Spread2CrossConvexityCCC3C5[MaxInstruments+1] <- NA
} else {
  dfSpread2CrossConvexityCCC3C5$Spread2CrossConvexityCCC3C5[MaxInstruments+1] <- (SRMA*TA + SRML*TL)/(TA + TL)
}
dfSpread2CrossConvexityCCC3C5$Spread2CrossConvexityCCC3C5[MaxInstruments+2] <- SRMA
dfSpread2CrossConvexityCCC3C5$Spread2CrossConvexityCCC3C5[MaxInstruments+3] <- SRML
# dfSpread2CrossConvexityCCC3C4
# dfSpread2CrossConvexityCCC3C5
# Curve4 x Curve5 (CCC4C5)
dfSpread2CrossConvexityCCC4C5 <- ddply(dfStaticRiskMeasures, .(Instrument), summarize, 
                              dfStaticRiskMeasures=sum(Spread2CrossConvexityCCC4C5))
dfSpread2CrossConvexityCCC4C5$Spread2CrossConvexityCCC4C5 <- dfSpread2CrossConvexityCCC4C5$dfStaticRiskMeasures
dfSpread2CrossConvexityCCC4C5$dfStaticRiskMeasures <- NULL
# Compute Static Risk Measure for Net Worth
dfSpread2CrossConvexityCCC4C5 <- rbind(dfSpread2CrossConvexityCCC4C5, y = c(MaxInstruments+1, NA))
dfSpread2CrossConvexityCCC4C5 <- rbind(dfSpread2CrossConvexityCCC4C5, y = c(MaxInstruments+2, NA))
dfSpread2CrossConvexityCCC4C5 <- rbind(dfSpread2CrossConvexityCCC4C5, y = c(MaxInstruments+3, NA))
TA <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+2]
TL <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+3]
SRMA <- 0.0
for(i in 1:NumberOfAssets){
  SRMA <- SRMA + dfSpread2CrossConvexityCCC4C5$Spread2CrossConvexityCCC4C5[i] * (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[i]/TA)
}
SRML <- 0.0
for(i in 1:NumberOfLiabilities){
  SRML <- SRML + dfSpread2CrossConvexityCCC4C5$Spread2CrossConvexityCCC4C5[NumberOfAssets+i] * 
    (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[NumberOfAssets+i]/TL)
}
if(TA == -TL){
  dfSpread2CrossConvexityCCC4C5$Spread2CrossConvexityCCC4C5[MaxInstruments+1] <- NA
} else {
  dfSpread2CrossConvexityCCC4C5$Spread2CrossConvexityCCC4C5[MaxInstruments+1] <- (SRMA*TA + SRML*TL)/(TA + TL)
}
dfSpread2CrossConvexityCCC4C5$Spread2CrossConvexityCCC4C5[MaxInstruments+2] <- SRMA
dfSpread2CrossConvexityCCC4C5$Spread2CrossConvexityCCC4C5[MaxInstruments+3] <- SRML
# dfSpread2CrossConvexityCCC4C5


