# KM Spread3 Rate Static Risk Measures.R
# Spread3 rate static risk measures
L <- InitialCurves$Spread3[2]
k1 <- InitialCurves$Spread3[3]
S <- InitialCurves$Spread3[4]
C1 <- InitialCurves$Spread3[5]
k2 <- InitialCurves$Spread3[6]
C2 <- InitialCurves$Spread3[7]
k3 <- InitialCurves$Spread3[8]
C3 <- InitialCurves$Spread3[9]
k4 <- InitialCurves$Spread3[10]
C4 <- InitialCurves$Spread3[11]
k5 <- InitialCurves$Spread3[12]
C5 <- InitialCurves$Spread3[13]
# Spread3 rate maturity coefficients at Horizon
M <- dfStaticRiskMeasures$Maturity-Horizon
LengthM = length(M)
for(i in 1:LengthM){ # Cannot have zero in LSC model
  if(M[i] == 0)M[i] <- 0.000001
}
x1 <- (k1/M)*(1.0 - exp(-M/k1))
x2 <- x1 - exp(-M/k1)
x3 <- (k2/M) * (1.0 - exp(-M/k2)) - exp(-M/k2)
x4 <- (k3/M) * (1.0 - exp(-M/k3)) - exp(-M/k3)
x5 <- (k4/M) * (1.0 - exp(-M/k4)) - exp(-M/k4)
x6 <- (k5/M) * (1.0 - exp(-M/k5)) - exp(-M/k5)
W <- dfStaticRiskMeasures$Weight
CW <- dfStaticRiskMeasures$WSpread3 # Weight of particular curve
#
# Spread3 Duration
#
dfStaticRiskMeasures$Spread3DurationLevel <- M * 1.0 * W * CW
dfStaticRiskMeasures$Spread3DurationSlope <- M * x1 * W * CW
dfStaticRiskMeasures$Spread3DurationCurve1 <- M * x2 * W * CW
dfStaticRiskMeasures$Spread3DurationCurve2 <- M * x3 * W * CW
dfStaticRiskMeasures$Spread3DurationCurve3 <- M * x4 * W * CW
dfStaticRiskMeasures$Spread3DurationCurve4 <- M * x5 * W * CW
dfStaticRiskMeasures$Spread3DurationCurve5 <- M * x6 * W * CW
# Level
dfSpread3DurationLevel <- ddply(dfStaticRiskMeasures, .(Instrument), summarize, 
  dfStaticRiskMeasures=sum(Spread3DurationLevel))
dfSpread3DurationLevel$Spread3DurationLevel <- dfSpread3DurationLevel$dfStaticRiskMeasures
dfSpread3DurationLevel$dfStaticRiskMeasures <- NULL
# Compute Static Risk Measure for Net Worth
dfSpread3DurationLevel <- rbind(dfSpread3DurationLevel, y = c(MaxInstruments+1, NA))
dfSpread3DurationLevel <- rbind(dfSpread3DurationLevel, y = c(MaxInstruments+2, NA))
dfSpread3DurationLevel <- rbind(dfSpread3DurationLevel, y = c(MaxInstruments+3, NA))
TA <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+2]
TL <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+3]
SRMA <- 0.0
for(i in 1:NumberOfAssets){
  SRMA <- SRMA + dfSpread3DurationLevel$Spread3DurationLevel[i] * (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[i]/TA)
}
SRML <- 0.0
for(i in 1:NumberOfLiabilities){
  SRML <- SRML + dfSpread3DurationLevel$Spread3DurationLevel[NumberOfAssets+i] * 
    (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[NumberOfAssets+i]/TL)
}
if(TA == -TL){
  dfSpread3DurationLevel$Spread3DurationLevel[MaxInstruments+1] <- NA
} else {
  dfSpread3DurationLevel$Spread3DurationLevel[MaxInstruments+1] <- (SRMA*TA + SRML*TL)/(TA + TL)
}
dfSpread3DurationLevel$Spread3DurationLevel[MaxInstruments+2] <- SRMA
dfSpread3DurationLevel$Spread3DurationLevel[MaxInstruments+3] <- SRML
dfSpread3DurationLevel
# Slope
dfSpread3DurationSlope <- ddply(dfStaticRiskMeasures, .(Instrument), summarize, 
                             dfStaticRiskMeasures=sum(Spread3DurationSlope))
dfSpread3DurationSlope$Spread3DurationSlope <- dfSpread3DurationSlope$dfStaticRiskMeasures
dfSpread3DurationSlope$dfStaticRiskMeasures <- NULL
# Compute Static Risk Measure for Net Worth
dfSpread3DurationSlope <- rbind(dfSpread3DurationSlope, y = c(MaxInstruments+1, NA))
dfSpread3DurationSlope <- rbind(dfSpread3DurationSlope, y = c(MaxInstruments+2, NA))
dfSpread3DurationSlope <- rbind(dfSpread3DurationSlope, y = c(MaxInstruments+3, NA))
TA <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+2]
TL <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+3]
SRMA <- 0.0
for(i in 1:NumberOfAssets){
  SRMA <- SRMA + dfSpread3DurationSlope$Spread3DurationSlope[i] * (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[i]/TA)
}
SRML <- 0.0
for(i in 1:NumberOfLiabilities){
  SRML <- SRML + dfSpread3DurationSlope$Spread3DurationSlope[NumberOfAssets+i] * 
    (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[NumberOfAssets+i]/TL)
}
if(TA == -TL){
  dfSpread3DurationSlope$Spread3DurationSlope[MaxInstruments+1] <- NA
} else {
  dfSpread3DurationSlope$Spread3DurationSlope[MaxInstruments+1] <- (SRMA*TA + SRML*TL)/(TA + TL)
}
dfSpread3DurationSlope$Spread3DurationSlope[MaxInstruments+2] <- SRMA
dfSpread3DurationSlope$Spread3DurationSlope[MaxInstruments+3] <- SRML
dfSpread3DurationSlope
# Curvature 1
dfSpread3DurationCurve1 <- ddply(dfStaticRiskMeasures, .(Instrument), summarize, 
                              dfStaticRiskMeasures=sum(Spread3DurationCurve1))
dfSpread3DurationCurve1$Spread3DurationCurve1 <- dfSpread3DurationCurve1$dfStaticRiskMeasures
dfSpread3DurationCurve1$dfStaticRiskMeasures <- NULL
# Compute Static Risk Measure for Net Worth
dfSpread3DurationCurve1 <- rbind(dfSpread3DurationCurve1, y = c(MaxInstruments+1, NA))
dfSpread3DurationCurve1 <- rbind(dfSpread3DurationCurve1, y = c(MaxInstruments+2, NA))
dfSpread3DurationCurve1 <- rbind(dfSpread3DurationCurve1, y = c(MaxInstruments+3, NA))
TA <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+2]
TL <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+3]
SRMA <- 0.0
for(i in 1:NumberOfAssets){
  SRMA <- SRMA + dfSpread3DurationCurve1$Spread3DurationCurve1[i] * (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[i]/TA)
}
SRML <- 0.0
for(i in 1:NumberOfLiabilities){
  SRML <- SRML + dfSpread3DurationCurve1$Spread3DurationCurve1[NumberOfAssets+i] * 
    (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[NumberOfAssets+i]/TL)
}
if(TA == -TL){
  dfSpread3DurationCurve1$Spread3DurationCurve1[MaxInstruments+1] <- NA
} else {
  dfSpread3DurationCurve1$Spread3DurationCurve1[MaxInstruments+1] <- (SRMA*TA + SRML*TL)/(TA + TL)
}
dfSpread3DurationCurve1$Spread3DurationCurve1[MaxInstruments+2] <- SRMA
dfSpread3DurationCurve1$Spread3DurationCurve1[MaxInstruments+3] <- SRML
dfSpread3DurationCurve1
# Curvature 2
dfSpread3DurationCurve2 <- ddply(dfStaticRiskMeasures, .(Instrument), summarize, 
                              dfStaticRiskMeasures=sum(Spread3DurationCurve2))
dfSpread3DurationCurve2$Spread3DurationCurve2 <- dfSpread3DurationCurve2$dfStaticRiskMeasures
dfSpread3DurationCurve2$dfStaticRiskMeasures <- NULL
# Compute Static Risk Measure for Net Worth
dfSpread3DurationCurve2 <- rbind(dfSpread3DurationCurve2, y = c(MaxInstruments+1, NA))
dfSpread3DurationCurve2 <- rbind(dfSpread3DurationCurve2, y = c(MaxInstruments+2, NA))
dfSpread3DurationCurve2 <- rbind(dfSpread3DurationCurve2, y = c(MaxInstruments+3, NA))
TA <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+2]
TL <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+3]
SRMA <- 0.0
for(i in 1:NumberOfAssets){
  SRMA <- SRMA + dfSpread3DurationCurve2$Spread3DurationCurve2[i] * (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[i]/TA)
}
SRML <- 0.0
for(i in 1:NumberOfLiabilities){
  SRML <- SRML + dfSpread3DurationCurve2$Spread3DurationCurve2[NumberOfAssets+i] * 
    (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[NumberOfAssets+i]/TL)
}
if(TA == -TL){
  dfSpread3DurationCurve2$Spread3DurationCurve2[MaxInstruments+1] <- NA
} else {
  dfSpread3DurationCurve2$Spread3DurationCurve2[MaxInstruments+1] <- (SRMA*TA + SRML*TL)/(TA + TL)
}
dfSpread3DurationCurve2$Spread3DurationCurve2[MaxInstruments+2] <- SRMA
dfSpread3DurationCurve2$Spread3DurationCurve2[MaxInstruments+3] <- SRML
# Curvature 3
dfSpread3DurationCurve3 <- ddply(dfStaticRiskMeasures, .(Instrument), summarize, 
                              dfStaticRiskMeasures=sum(Spread3DurationCurve3))
dfSpread3DurationCurve3$Spread3DurationCurve3 <- dfSpread3DurationCurve3$dfStaticRiskMeasures
dfSpread3DurationCurve3$dfStaticRiskMeasures <- NULL
# Compute Static Risk Measure for Net Worth
dfSpread3DurationCurve3 <- rbind(dfSpread3DurationCurve3, y = c(MaxInstruments+1, NA))
dfSpread3DurationCurve3 <- rbind(dfSpread3DurationCurve3, y = c(MaxInstruments+2, NA))
dfSpread3DurationCurve3 <- rbind(dfSpread3DurationCurve3, y = c(MaxInstruments+3, NA))
TA <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+2]
TL <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+3]
SRMA <- 0.0
for(i in 1:NumberOfAssets){
  SRMA <- SRMA + dfSpread3DurationCurve3$Spread3DurationCurve3[i] * (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[i]/TA)
}
SRML <- 0.0
for(i in 1:NumberOfLiabilities){
  SRML <- SRML + dfSpread3DurationCurve3$Spread3DurationCurve3[NumberOfAssets+i] * 
    (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[NumberOfAssets+i]/TL)
}
if(TA == -TL){
  dfSpread3DurationCurve3$Spread3DurationCurve3[MaxInstruments+1] <- NA
} else {
  dfSpread3DurationCurve3$Spread3DurationCurve3[MaxInstruments+1] <- (SRMA*TA + SRML*TL)/(TA + TL)
}
dfSpread3DurationCurve3$Spread3DurationCurve3[MaxInstruments+2] <- SRMA
dfSpread3DurationCurve3$Spread3DurationCurve3[MaxInstruments+3] <- SRML
# Curvature 4
dfSpread3DurationCurve4 <- ddply(dfStaticRiskMeasures, .(Instrument), summarize, 
                              dfStaticRiskMeasures=sum(Spread3DurationCurve4))
dfSpread3DurationCurve4$Spread3DurationCurve4 <- dfSpread3DurationCurve4$dfStaticRiskMeasures
dfSpread3DurationCurve4$dfStaticRiskMeasures <- NULL
# Compute Static Risk Measure for Net Worth
dfSpread3DurationCurve4 <- rbind(dfSpread3DurationCurve4, y = c(MaxInstruments+1, NA))
dfSpread3DurationCurve4 <- rbind(dfSpread3DurationCurve4, y = c(MaxInstruments+2, NA))
dfSpread3DurationCurve4 <- rbind(dfSpread3DurationCurve4, y = c(MaxInstruments+3, NA))
TA <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+2]
TL <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+3]
SRMA <- 0.0
for(i in 1:NumberOfAssets){
  SRMA <- SRMA + dfSpread3DurationCurve4$Spread3DurationCurve4[i] * (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[i]/TA)
}
SRML <- 0.0
for(i in 1:NumberOfLiabilities){
  SRML <- SRML + dfSpread3DurationCurve4$Spread3DurationCurve4[NumberOfAssets+i] * 
    (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[NumberOfAssets+i]/TL)
}
if(TA == -TL){
  dfSpread3DurationCurve4$Spread3DurationCurve4[MaxInstruments+1] <- NA
} else {
  dfSpread3DurationCurve4$Spread3DurationCurve4[MaxInstruments+1] <- (SRMA*TA + SRML*TL)/(TA + TL)
}
dfSpread3DurationCurve4$Spread3DurationCurve4[MaxInstruments+2] <- SRMA
dfSpread3DurationCurve4$Spread3DurationCurve4[MaxInstruments+3] <- SRML
# Curvature 5
dfSpread3DurationCurve5 <- ddply(dfStaticRiskMeasures, .(Instrument), summarize, 
                              dfStaticRiskMeasures=sum(Spread3DurationCurve5))
dfSpread3DurationCurve5$Spread3DurationCurve5 <- dfSpread3DurationCurve5$dfStaticRiskMeasures
dfSpread3DurationCurve5$dfStaticRiskMeasures <- NULL
# Compute Static Risk Measure for Net Worth
dfSpread3DurationCurve5 <- rbind(dfSpread3DurationCurve5, y = c(MaxInstruments+1, NA))
dfSpread3DurationCurve5 <- rbind(dfSpread3DurationCurve5, y = c(MaxInstruments+2, NA))
dfSpread3DurationCurve5 <- rbind(dfSpread3DurationCurve5, y = c(MaxInstruments+3, NA))
TA <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+2]
TL <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+3]
SRMA <- 0.0
for(i in 1:NumberOfAssets){
  SRMA <- SRMA + dfSpread3DurationCurve5$Spread3DurationCurve5[i] * (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[i]/TA)
}
SRML <- 0.0
for(i in 1:NumberOfLiabilities){
  SRML <- SRML + dfSpread3DurationCurve5$Spread3DurationCurve5[NumberOfAssets+i] * 
    (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[NumberOfAssets+i]/TL)
}
if(TA == -TL){
  dfSpread3DurationCurve5$Spread3DurationCurve5[MaxInstruments+1] <- NA
} else {
  dfSpread3DurationCurve5$Spread3DurationCurve5[MaxInstruments+1] <- (SRMA*TA + SRML*TL)/(TA + TL)
}
dfSpread3DurationCurve5$Spread3DurationCurve5[MaxInstruments+2] <- SRMA
dfSpread3DurationCurve5$Spread3DurationCurve5[MaxInstruments+3] <- SRML
# dfPVBalanceSheet
# dfPVBalanceSheetAtHorizon
# dfSpread3DurationLevel
# dfSpread3DurationSlope
# dfSpread3DurationCurve1
# dfSpread3DurationCurve2
# dfSpread3DurationCurve3
# dfSpread3DurationCurve4
# dfSpread3DurationCurve5
#
# Spread3 Convexity
#
dfStaticRiskMeasures$Spread3ConvexityLevel <- (M^2) * 1.0 * W * CW
dfStaticRiskMeasures$Spread3ConvexitySlope <- (M^2) * (x1^2) * W * CW
dfStaticRiskMeasures$Spread3ConvexityCurve1 <- (M^2) * (x2^2) * W * CW
dfStaticRiskMeasures$Spread3ConvexityCurve2 <- (M^2) * (x3^2) * W * CW
dfStaticRiskMeasures$Spread3ConvexityCurve3 <- (M^2) * (x4^2) * W * CW
dfStaticRiskMeasures$Spread3ConvexityCurve4 <- (M^2) * (x5^2) * W * CW
dfStaticRiskMeasures$Spread3ConvexityCurve5 <- (M^2) * (x6^2) * W * CW
# Level
dfSpread3ConvexityLevel <- ddply(dfStaticRiskMeasures, .(Instrument), summarize, 
  dfStaticRiskMeasures=sum(Spread3ConvexityLevel))
dfSpread3ConvexityLevel$Spread3ConvexityLevel <- dfSpread3ConvexityLevel$dfStaticRiskMeasures
dfSpread3ConvexityLevel$dfStaticRiskMeasures <- NULL
# Compute Static Risk Measure for Net Worth
dfSpread3ConvexityLevel <- rbind(dfSpread3ConvexityLevel, y = c(MaxInstruments+1, NA))
dfSpread3ConvexityLevel <- rbind(dfSpread3ConvexityLevel, y = c(MaxInstruments+2, NA))
dfSpread3ConvexityLevel <- rbind(dfSpread3ConvexityLevel, y = c(MaxInstruments+3, NA))
TA <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+2]
TL <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+3]
SRMA <- 0.0
for(i in 1:NumberOfAssets){
  SRMA <- SRMA + dfSpread3ConvexityLevel$Spread3ConvexityLevel[i] * (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[i]/TA)
}
SRML <- 0.0
for(i in 1:NumberOfLiabilities){
  SRML <- SRML + dfSpread3ConvexityLevel$Spread3ConvexityLevel[NumberOfAssets+i] * 
    (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[NumberOfAssets+i]/TL)
}
if(TA == -TL){
  dfSpread3ConvexityLevel$Spread3ConvexityLevel[MaxInstruments+1] <- NA
} else {
  dfSpread3ConvexityLevel$Spread3ConvexityLevel[MaxInstruments+1] <- (SRMA*TA + SRML*TL)/(TA + TL)
}
dfSpread3ConvexityLevel$Spread3ConvexityLevel[MaxInstruments+2] <- SRMA
dfSpread3ConvexityLevel$Spread3ConvexityLevel[MaxInstruments+3] <- SRML
dfSpread3ConvexityLevel
# Slope
dfSpread3ConvexitySlope <- ddply(dfStaticRiskMeasures, .(Instrument), summarize, 
                             dfStaticRiskMeasures=sum(Spread3ConvexitySlope))
dfSpread3ConvexitySlope$Spread3ConvexitySlope <- dfSpread3ConvexitySlope$dfStaticRiskMeasures
dfSpread3ConvexitySlope$dfStaticRiskMeasures <- NULL
# Compute Static Risk Measure for Net Worth
dfSpread3ConvexitySlope <- rbind(dfSpread3ConvexitySlope, y = c(MaxInstruments+1, NA))
dfSpread3ConvexitySlope <- rbind(dfSpread3ConvexitySlope, y = c(MaxInstruments+2, NA))
dfSpread3ConvexitySlope <- rbind(dfSpread3ConvexitySlope, y = c(MaxInstruments+3, NA))
TA <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+2]
TL <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+3]
SRMA <- 0.0
for(i in 1:NumberOfAssets){
  SRMA <- SRMA + dfSpread3ConvexitySlope$Spread3ConvexitySlope[i] * (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[i]/TA)
}
SRML <- 0.0
for(i in 1:NumberOfLiabilities){
  SRML <- SRML + dfSpread3ConvexitySlope$Spread3ConvexitySlope[NumberOfAssets+i] * 
    (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[NumberOfAssets+i]/TL)
}
if(TA == -TL){
  dfSpread3ConvexitySlope$Spread3ConvexitySlope[MaxInstruments+1] <- NA
} else {
  dfSpread3ConvexitySlope$Spread3ConvexitySlope[MaxInstruments+1] <- (SRMA*TA + SRML*TL)/(TA + TL)
}
dfSpread3ConvexitySlope$Spread3ConvexitySlope[MaxInstruments+2] <- SRMA
dfSpread3ConvexitySlope$Spread3ConvexitySlope[MaxInstruments+3] <- SRML
dfSpread3ConvexitySlope
# Curvature 1
dfSpread3ConvexityCurve1 <- ddply(dfStaticRiskMeasures, .(Instrument), summarize, 
                              dfStaticRiskMeasures=sum(Spread3ConvexityCurve1))
dfSpread3ConvexityCurve1$Spread3ConvexityCurve1 <- dfSpread3ConvexityCurve1$dfStaticRiskMeasures
dfSpread3ConvexityCurve1$dfStaticRiskMeasures <- NULL
# Compute Static Risk Measure for Net Worth
dfSpread3ConvexityCurve1 <- rbind(dfSpread3ConvexityCurve1, y = c(MaxInstruments+1, NA))
dfSpread3ConvexityCurve1 <- rbind(dfSpread3ConvexityCurve1, y = c(MaxInstruments+2, NA))
dfSpread3ConvexityCurve1 <- rbind(dfSpread3ConvexityCurve1, y = c(MaxInstruments+3, NA))
TA <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+2]
TL <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+3]
SRMA <- 0.0
for(i in 1:NumberOfAssets){
  SRMA <- SRMA + dfSpread3ConvexityCurve1$Spread3ConvexityCurve1[i] * (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[i]/TA)
}
SRML <- 0.0
for(i in 1:NumberOfLiabilities){
  SRML <- SRML + dfSpread3ConvexityCurve1$Spread3ConvexityCurve1[NumberOfAssets+i] * 
    (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[NumberOfAssets+i]/TL)
}
if(TA == -TL){
  dfSpread3ConvexityCurve1$Spread3ConvexityCurve1[MaxInstruments+1] <- NA
} else {
  dfSpread3ConvexityCurve1$Spread3ConvexityCurve1[MaxInstruments+1] <- (SRMA*TA + SRML*TL)/(TA + TL)
}
dfSpread3ConvexityCurve1$Spread3ConvexityCurve1[MaxInstruments+2] <- SRMA
dfSpread3ConvexityCurve1$Spread3ConvexityCurve1[MaxInstruments+3] <- SRML
dfSpread3ConvexityCurve1
# Curvature 2
dfSpread3ConvexityCurve2 <- ddply(dfStaticRiskMeasures, .(Instrument), summarize, 
                              dfStaticRiskMeasures=sum(Spread3ConvexityCurve2))
dfSpread3ConvexityCurve2$Spread3ConvexityCurve2 <- dfSpread3ConvexityCurve2$dfStaticRiskMeasures
dfSpread3ConvexityCurve2$dfStaticRiskMeasures <- NULL
# Compute Static Risk Measure for Net Worth
dfSpread3ConvexityCurve2 <- rbind(dfSpread3ConvexityCurve2, y = c(MaxInstruments+1, NA))
dfSpread3ConvexityCurve2 <- rbind(dfSpread3ConvexityCurve2, y = c(MaxInstruments+2, NA))
dfSpread3ConvexityCurve2 <- rbind(dfSpread3ConvexityCurve2, y = c(MaxInstruments+3, NA))
TA <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+2]
TL <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+3]
SRMA <- 0.0
for(i in 1:NumberOfAssets){
  SRMA <- SRMA + dfSpread3ConvexityCurve2$Spread3ConvexityCurve2[i] * (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[i]/TA)
}
SRML <- 0.0
for(i in 1:NumberOfLiabilities){
  SRML <- SRML + dfSpread3ConvexityCurve2$Spread3ConvexityCurve2[NumberOfAssets+i] * 
    (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[NumberOfAssets+i]/TL)
}
if(TA == -TL){
  dfSpread3ConvexityCurve2$Spread3ConvexityCurve2[MaxInstruments+1] <- NA
} else {
  dfSpread3ConvexityCurve2$Spread3ConvexityCurve2[MaxInstruments+1] <- (SRMA*TA + SRML*TL)/(TA + TL)
}
dfSpread3ConvexityCurve2$Spread3ConvexityCurve2[MaxInstruments+2] <- SRMA
dfSpread3ConvexityCurve2$Spread3ConvexityCurve2[MaxInstruments+3] <- SRML
# Curvature 3
dfSpread3ConvexityCurve3 <- ddply(dfStaticRiskMeasures, .(Instrument), summarize, 
                              dfStaticRiskMeasures=sum(Spread3ConvexityCurve3))
dfSpread3ConvexityCurve3$Spread3ConvexityCurve3 <- dfSpread3ConvexityCurve3$dfStaticRiskMeasures
dfSpread3ConvexityCurve3$dfStaticRiskMeasures <- NULL
# Compute Static Risk Measure for Net Worth
dfSpread3ConvexityCurve3 <- rbind(dfSpread3ConvexityCurve3, y = c(MaxInstruments+1, NA))
dfSpread3ConvexityCurve3 <- rbind(dfSpread3ConvexityCurve3, y = c(MaxInstruments+2, NA))
dfSpread3ConvexityCurve3 <- rbind(dfSpread3ConvexityCurve3, y = c(MaxInstruments+3, NA))
TA <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+2]
TL <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+3]
SRMA <- 0.0
for(i in 1:NumberOfAssets){
  SRMA <- SRMA + dfSpread3ConvexityCurve3$Spread3ConvexityCurve3[i] * (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[i]/TA)
}
SRML <- 0.0
for(i in 1:NumberOfLiabilities){
  SRML <- SRML + dfSpread3ConvexityCurve3$Spread3ConvexityCurve3[NumberOfAssets+i] * 
    (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[NumberOfAssets+i]/TL)
}
if(TA == -TL){
  dfSpread3ConvexityCurve3$Spread3ConvexityCurve3[MaxInstruments+1] <- NA
} else {
  dfSpread3ConvexityCurve3$Spread3ConvexityCurve3[MaxInstruments+1] <- (SRMA*TA + SRML*TL)/(TA + TL)
}
dfSpread3ConvexityCurve3$Spread3ConvexityCurve3[MaxInstruments+2] <- SRMA
dfSpread3ConvexityCurve3$Spread3ConvexityCurve3[MaxInstruments+3] <- SRML
# Curvature 4
dfSpread3ConvexityCurve4 <- ddply(dfStaticRiskMeasures, .(Instrument), summarize, 
                              dfStaticRiskMeasures=sum(Spread3ConvexityCurve4))
dfSpread3ConvexityCurve4$Spread3ConvexityCurve4 <- dfSpread3ConvexityCurve4$dfStaticRiskMeasures
dfSpread3ConvexityCurve4$dfStaticRiskMeasures <- NULL
# Compute Static Risk Measure for Net Worth
dfSpread3ConvexityCurve4 <- rbind(dfSpread3ConvexityCurve4, y = c(MaxInstruments+1, NA))
dfSpread3ConvexityCurve4 <- rbind(dfSpread3ConvexityCurve4, y = c(MaxInstruments+2, NA))
dfSpread3ConvexityCurve4 <- rbind(dfSpread3ConvexityCurve4, y = c(MaxInstruments+3, NA))
TA <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+2]
TL <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+3]
SRMA <- 0.0
for(i in 1:NumberOfAssets){
  SRMA <- SRMA + dfSpread3ConvexityCurve4$Spread3ConvexityCurve4[i] * (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[i]/TA)
}
SRML <- 0.0
for(i in 1:NumberOfLiabilities){
  SRML <- SRML + dfSpread3ConvexityCurve4$Spread3ConvexityCurve4[NumberOfAssets+i] * 
    (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[NumberOfAssets+i]/TL)
}
if(TA == -TL){
  dfSpread3ConvexityCurve4$Spread3ConvexityCurve4[MaxInstruments+1] <- NA
} else {
  dfSpread3ConvexityCurve4$Spread3ConvexityCurve4[MaxInstruments+1] <- (SRMA*TA + SRML*TL)/(TA + TL)
}
dfSpread3ConvexityCurve4$Spread3ConvexityCurve4[MaxInstruments+2] <- SRMA
dfSpread3ConvexityCurve4$Spread3ConvexityCurve4[MaxInstruments+3] <- SRML
# Curvature 5
dfSpread3ConvexityCurve5 <- ddply(dfStaticRiskMeasures, .(Instrument), summarize, 
                              dfStaticRiskMeasures=sum(Spread3ConvexityCurve5))
dfSpread3ConvexityCurve5$Spread3ConvexityCurve5 <- dfSpread3ConvexityCurve5$dfStaticRiskMeasures
dfSpread3ConvexityCurve5$dfStaticRiskMeasures <- NULL
# Compute Static Risk Measure for Net Worth
dfSpread3ConvexityCurve5 <- rbind(dfSpread3ConvexityCurve5, y = c(MaxInstruments+1, NA))
dfSpread3ConvexityCurve5 <- rbind(dfSpread3ConvexityCurve5, y = c(MaxInstruments+2, NA))
dfSpread3ConvexityCurve5 <- rbind(dfSpread3ConvexityCurve5, y = c(MaxInstruments+3, NA))
TA <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+2]
TL <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+3]
SRMA <- 0.0
for(i in 1:NumberOfAssets){
  SRMA <- SRMA + dfSpread3ConvexityCurve5$Spread3ConvexityCurve5[i] * (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[i]/TA)
}
SRML <- 0.0
for(i in 1:NumberOfLiabilities){
  SRML <- SRML + dfSpread3ConvexityCurve5$Spread3ConvexityCurve5[NumberOfAssets+i] * 
    (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[NumberOfAssets+i]/TL)
}
if(TA == -TL){
  dfSpread3ConvexityCurve5$Spread3ConvexityCurve5[MaxInstruments+1] <- NA
} else {
  dfSpread3ConvexityCurve5$Spread3ConvexityCurve5[MaxInstruments+1] <- (SRMA*TA + SRML*TL)/(TA + TL)
}
dfSpread3ConvexityCurve5$Spread3ConvexityCurve5[MaxInstruments+2] <- SRMA
dfSpread3ConvexityCurve5$Spread3ConvexityCurve5[MaxInstruments+3] <- SRML
# dfPVBalanceSheet
# dfPVBalanceSheetAtHorizon
# dfSpread3ConvexityLevel
# dfSpread3ConvexitySlope
# dfSpread3ConvexityCurve1
# dfSpread3ConvexityCurve2
# dfSpread3ConvexityCurve3
# dfSpread3ConvexityCurve4
# dfSpread3ConvexityCurve5
#
# Spread3 Cross Convexiities (19!)
#
# Level x _____
dfStaticRiskMeasures$Spread3CrossConvexityCCLS <- (M^2) * 1.0 * x1 * W * CW
dfStaticRiskMeasures$Spread3CrossConvexityCCLC1 <- (M^2) * 1.0 * x2 * W * CW
dfStaticRiskMeasures$Spread3CrossConvexityCCLC2 <- (M^2) * 1.0 * x3 * W * CW
dfStaticRiskMeasures$Spread3CrossConvexityCCLC3 <- (M^2) * 1.0 * x4 * W * CW
dfStaticRiskMeasures$Spread3CrossConvexityCCLC4 <- (M^2) * 1.0 * x5 * W * CW
dfStaticRiskMeasures$Spread3CrossConvexityCCLC5 <- (M^2) * 1.0 * x6 * W * CW
# Slope x _____
dfStaticRiskMeasures$Spread3CrossConvexityCCSC1 <- (M^2) * x1 * x2 * W * CW
dfStaticRiskMeasures$Spread3CrossConvexityCCSC2 <- (M^2) * x1 * x3 * W * CW
dfStaticRiskMeasures$Spread3CrossConvexityCCSC3 <- (M^2) * x1 * x4 * W * CW
dfStaticRiskMeasures$Spread3CrossConvexityCCSC4 <- (M^2) * x1 * x5 * W * CW
dfStaticRiskMeasures$Spread3CrossConvexityCCSC5 <- (M^2) * x1 * x6 * W * CW
# Curve1 x _____
dfStaticRiskMeasures$Spread3CrossConvexityCCC1C2 <- (M^2) * x2 * x3 * W * CW
dfStaticRiskMeasures$Spread3CrossConvexityCCC1C3 <- (M^2) * x2 * x4 * W * CW
dfStaticRiskMeasures$Spread3CrossConvexityCCC1C4 <- (M^2) * x2 * x5 * W * CW
dfStaticRiskMeasures$Spread3CrossConvexityCCC1C5 <- (M^2) * x2 * x6 * W * CW
# Curve2 x _____
dfStaticRiskMeasures$Spread3CrossConvexityCCC2C3 <- (M^2) * x3 * x4 * W * CW
dfStaticRiskMeasures$Spread3CrossConvexityCCC2C4 <- (M^2) * x3 * x5 * W * CW
dfStaticRiskMeasures$Spread3CrossConvexityCCC2C5 <- (M^2) * x3 * x6 * W * CW
# Curve4 x _____
dfStaticRiskMeasures$Spread3CrossConvexityCCC3C4 <- (M^2) * x4 * x5 * W * CW
dfStaticRiskMeasures$Spread3CrossConvexityCCC3C5 <- (M^2) * x4 * x6 * W * CW
# Curve5 x _____
dfStaticRiskMeasures$Spread3CrossConvexityCCC4C5 <- (M^2) * x5 * x6 * W * CW
# Level x Slope (CCLS)
dfSpread3CrossConvexityCCLS <- ddply(dfStaticRiskMeasures, .(Instrument), summarize, 
                             dfStaticRiskMeasures=sum(Spread3CrossConvexityCCLS))
dfSpread3CrossConvexityCCLS$Spread3CrossConvexityCCLS <- dfSpread3CrossConvexityCCLS$dfStaticRiskMeasures
dfSpread3CrossConvexityCCLS$dfStaticRiskMeasures <- NULL
# Compute Static Risk Measure for Net Worth
dfSpread3CrossConvexityCCLS <- rbind(dfSpread3CrossConvexityCCLS, y = c(MaxInstruments+1, NA))
dfSpread3CrossConvexityCCLS <- rbind(dfSpread3CrossConvexityCCLS, y = c(MaxInstruments+2, NA))
dfSpread3CrossConvexityCCLS <- rbind(dfSpread3CrossConvexityCCLS, y = c(MaxInstruments+3, NA))
TA <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+2]
TL <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+3]
SRMA <- 0.0
for(i in 1:NumberOfAssets){
  SRMA <- SRMA + dfSpread3CrossConvexityCCLS$Spread3CrossConvexityCCLS[i] * (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[i]/TA)
}
SRML <- 0.0
for(i in 1:NumberOfLiabilities){
  SRML <- SRML + dfSpread3CrossConvexityCCLS$Spread3CrossConvexityCCLS[NumberOfAssets+i] * 
    (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[NumberOfAssets+i]/TL)
}
if(TA == -TL){
  dfSpread3CrossConvexityCCLS$Spread3CrossConvexityCCLS[MaxInstruments+1] <- NA
} else {
  dfSpread3CrossConvexityCCLS$Spread3CrossConvexityCCLS[MaxInstruments+1] <- (SRMA*TA + SRML*TL)/(TA + TL)
}
dfSpread3CrossConvexityCCLS$Spread3CrossConvexityCCLS[MaxInstruments+2] <- SRMA
dfSpread3CrossConvexityCCLS$Spread3CrossConvexityCCLS[MaxInstruments+3] <- SRML



# Level x Curve1 (CCLC1)
dfSpread3CrossConvexityCCLC1 <- ddply(dfStaticRiskMeasures, .(Instrument), summarize, 
                            dfStaticRiskMeasures=sum(Spread3CrossConvexityCCLC1))
dfSpread3CrossConvexityCCLC1$Spread3CrossConvexityCCLC1 <- dfSpread3CrossConvexityCCLC1$dfStaticRiskMeasures
dfSpread3CrossConvexityCCLC1$dfStaticRiskMeasures <- NULL
# Compute Static Risk Measure for Net Worth
dfSpread3CrossConvexityCCLC1 <- rbind(dfSpread3CrossConvexityCCLC1, y = c(MaxInstruments+1, NA))
dfSpread3CrossConvexityCCLC1 <- rbind(dfSpread3CrossConvexityCCLC1, y = c(MaxInstruments+2, NA))
dfSpread3CrossConvexityCCLC1 <- rbind(dfSpread3CrossConvexityCCLC1, y = c(MaxInstruments+3, NA))
TA <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+2]
TL <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+3]
SRMA <- 0.0
for(i in 1:NumberOfAssets){
  SRMA <- SRMA + dfSpread3CrossConvexityCCLC1$Spread3CrossConvexityCCLC1[i] * (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[i]/TA)
}
SRML <- 0.0
for(i in 1:NumberOfLiabilities){
  SRML <- SRML + dfSpread3CrossConvexityCCLC1$Spread3CrossConvexityCCLC1[NumberOfAssets+i] * 
    (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[NumberOfAssets+i]/TL)
}
if(TA == -TL){
  dfSpread3CrossConvexityCCLC1$Spread3CrossConvexityCCLC1[MaxInstruments+1] <- NA
} else {
  dfSpread3CrossConvexityCCLC1$Spread3CrossConvexityCCLC1[MaxInstruments+1] <- (SRMA*TA + SRML*TL)/(TA + TL)
}
dfSpread3CrossConvexityCCLC1$Spread3CrossConvexityCCLC1[MaxInstruments+2] <- SRMA
dfSpread3CrossConvexityCCLC1$Spread3CrossConvexityCCLC1[MaxInstruments+3] <- SRML
# Level x Curve2 (CCLC2)
dfSpread3CrossConvexityCCLC2 <- ddply(dfStaticRiskMeasures, .(Instrument), summarize, 
                             dfStaticRiskMeasures=sum(Spread3CrossConvexityCCLC2))
dfSpread3CrossConvexityCCLC2$Spread3CrossConvexityCCLC2 <- dfSpread3CrossConvexityCCLC2$dfStaticRiskMeasures
dfSpread3CrossConvexityCCLC2$dfStaticRiskMeasures <- NULL
# Compute Static Risk Measure for Net Worth
dfSpread3CrossConvexityCCLC2 <- rbind(dfSpread3CrossConvexityCCLC2, y = c(MaxInstruments+1, NA))
dfSpread3CrossConvexityCCLC2 <- rbind(dfSpread3CrossConvexityCCLC2, y = c(MaxInstruments+2, NA))
dfSpread3CrossConvexityCCLC2 <- rbind(dfSpread3CrossConvexityCCLC2, y = c(MaxInstruments+3, NA))
TA <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+2]
TL <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+3]
SRMA <- 0.0
for(i in 1:NumberOfAssets){
  SRMA <- SRMA + dfSpread3CrossConvexityCCLC2$Spread3CrossConvexityCCLC2[i] * (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[i]/TA)
}
SRML <- 0.0
for(i in 1:NumberOfLiabilities){
  SRML <- SRML + dfSpread3CrossConvexityCCLC2$Spread3CrossConvexityCCLC2[NumberOfAssets+i] * 
    (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[NumberOfAssets+i]/TL)
}
if(TA == -TL){
  dfSpread3CrossConvexityCCLC2$Spread3CrossConvexityCCLC2[MaxInstruments+1] <- NA
} else {
  dfSpread3CrossConvexityCCLC2$Spread3CrossConvexityCCLC2[MaxInstruments+1] <- (SRMA*TA + SRML*TL)/(TA + TL)
}
dfSpread3CrossConvexityCCLC2$Spread3CrossConvexityCCLC2[MaxInstruments+2] <- SRMA
dfSpread3CrossConvexityCCLC2$Spread3CrossConvexityCCLC2[MaxInstruments+3] <- SRML
# Level x Curve3 (CCLC3)
dfSpread3CrossConvexityCCLC3 <- ddply(dfStaticRiskMeasures, .(Instrument), summarize, 
                             dfStaticRiskMeasures=sum(Spread3CrossConvexityCCLC3))
dfSpread3CrossConvexityCCLC3$Spread3CrossConvexityCCLC3 <- dfSpread3CrossConvexityCCLC3$dfStaticRiskMeasures
dfSpread3CrossConvexityCCLC3$dfStaticRiskMeasures <- NULL
# Compute Static Risk Measure for Net Worth
dfSpread3CrossConvexityCCLC3 <- rbind(dfSpread3CrossConvexityCCLC3, y = c(MaxInstruments+1, NA))
dfSpread3CrossConvexityCCLC3 <- rbind(dfSpread3CrossConvexityCCLC3, y = c(MaxInstruments+2, NA))
dfSpread3CrossConvexityCCLC3 <- rbind(dfSpread3CrossConvexityCCLC3, y = c(MaxInstruments+3, NA))
TA <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+2]
TL <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+3]
SRMA <- 0.0
for(i in 1:NumberOfAssets){
  SRMA <- SRMA + dfSpread3CrossConvexityCCLC3$Spread3CrossConvexityCCLC3[i] * (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[i]/TA)
}
SRML <- 0.0
for(i in 1:NumberOfLiabilities){
  SRML <- SRML + dfSpread3CrossConvexityCCLC3$Spread3CrossConvexityCCLC3[NumberOfAssets+i] * 
    (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[NumberOfAssets+i]/TL)
}
if(TA == -TL){
  dfSpread3CrossConvexityCCLC3$Spread3CrossConvexityCCLC3[MaxInstruments+1] <- NA
} else {
  dfSpread3CrossConvexityCCLC3$Spread3CrossConvexityCCLC3[MaxInstruments+1] <- (SRMA*TA + SRML*TL)/(TA + TL)
}
dfSpread3CrossConvexityCCLC3$Spread3CrossConvexityCCLC3[MaxInstruments+2] <- SRMA
dfSpread3CrossConvexityCCLC3$Spread3CrossConvexityCCLC3[MaxInstruments+3] <- SRML
# Level x Curve4 (CCLC4)
dfSpread3CrossConvexityCCLC4 <- ddply(dfStaticRiskMeasures, .(Instrument), summarize, 
                             dfStaticRiskMeasures=sum(Spread3CrossConvexityCCLC4))
dfSpread3CrossConvexityCCLC4$Spread3CrossConvexityCCLC4 <- dfSpread3CrossConvexityCCLC4$dfStaticRiskMeasures
dfSpread3CrossConvexityCCLC4$dfStaticRiskMeasures <- NULL
# Compute Static Risk Measure for Net Worth
dfSpread3CrossConvexityCCLC4 <- rbind(dfSpread3CrossConvexityCCLC4, y = c(MaxInstruments+1, NA))
dfSpread3CrossConvexityCCLC4 <- rbind(dfSpread3CrossConvexityCCLC4, y = c(MaxInstruments+2, NA))
dfSpread3CrossConvexityCCLC4 <- rbind(dfSpread3CrossConvexityCCLC4, y = c(MaxInstruments+3, NA))
TA <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+2]
TL <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+3]
SRMA <- 0.0
for(i in 1:NumberOfAssets){
  SRMA <- SRMA + dfSpread3CrossConvexityCCLC4$Spread3CrossConvexityCCLC4[i] * (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[i]/TA)
}
SRML <- 0.0
for(i in 1:NumberOfLiabilities){
  SRML <- SRML + dfSpread3CrossConvexityCCLC4$Spread3CrossConvexityCCLC4[NumberOfAssets+i] * 
    (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[NumberOfAssets+i]/TL)
}
if(TA == -TL){
  dfSpread3CrossConvexityCCLC4$Spread3CrossConvexityCCLC4[MaxInstruments+1] <- NA
} else {
  dfSpread3CrossConvexityCCLC4$Spread3CrossConvexityCCLC4[MaxInstruments+1] <- (SRMA*TA + SRML*TL)/(TA + TL)
}
dfSpread3CrossConvexityCCLC4$Spread3CrossConvexityCCLC4[MaxInstruments+2] <- SRMA
dfSpread3CrossConvexityCCLC4$Spread3CrossConvexityCCLC4[MaxInstruments+3] <- SRML
# Level x Curve5 (CCLC5)
dfSpread3CrossConvexityCCLC5 <- ddply(dfStaticRiskMeasures, .(Instrument), summarize, 
                             dfStaticRiskMeasures=sum(Spread3CrossConvexityCCLC5))
dfSpread3CrossConvexityCCLC5$Spread3CrossConvexityCCLC5 <- dfSpread3CrossConvexityCCLC5$dfStaticRiskMeasures
dfSpread3CrossConvexityCCLC5$dfStaticRiskMeasures <- NULL
# Compute Static Risk Measure for Net Worth
dfSpread3CrossConvexityCCLC5 <- rbind(dfSpread3CrossConvexityCCLC5, y = c(MaxInstruments+1, NA))
dfSpread3CrossConvexityCCLC5 <- rbind(dfSpread3CrossConvexityCCLC5, y = c(MaxInstruments+2, NA))
dfSpread3CrossConvexityCCLC5 <- rbind(dfSpread3CrossConvexityCCLC5, y = c(MaxInstruments+3, NA))
TA <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+2]
TL <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+3]
SRMA <- 0.0
for(i in 1:NumberOfAssets){
  SRMA <- SRMA + dfSpread3CrossConvexityCCLC5$Spread3CrossConvexityCCLC5[i] * (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[i]/TA)
}
SRML <- 0.0
for(i in 1:NumberOfLiabilities){
  SRML <- SRML + dfSpread3CrossConvexityCCLC5$Spread3CrossConvexityCCLC5[NumberOfAssets+i] * 
    (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[NumberOfAssets+i]/TL)
}
if(TA == -TL){
  dfSpread3CrossConvexityCCLC5$Spread3CrossConvexityCCLC5[MaxInstruments+1] <- NA
} else {
  dfSpread3CrossConvexityCCLC5$Spread3CrossConvexityCCLC5[MaxInstruments+1] <- (SRMA*TA + SRML*TL)/(TA + TL)
}
dfSpread3CrossConvexityCCLC5$Spread3CrossConvexityCCLC5[MaxInstruments+2] <- SRMA
dfSpread3CrossConvexityCCLC5$Spread3CrossConvexityCCLC5[MaxInstruments+3] <- SRML
# dfSpread3CrossConvexityCCLS
# dfSpread3CrossConvexityCCLC1
# dfSpread3CrossConvexityCCLC2
# dfSpread3CrossConvexityCCLC3
# dfSpread3CrossConvexityCCLC4
# dfSpread3CrossConvexityCCLC5
# Slope x Curve1 (CCSC1)
dfSpread3CrossConvexityCCSC1 <- ddply(dfStaticRiskMeasures, .(Instrument), summarize, 
                             dfStaticRiskMeasures=sum(Spread3CrossConvexityCCSC1))
dfSpread3CrossConvexityCCSC1$Spread3CrossConvexityCCSC1 <- dfSpread3CrossConvexityCCSC1$dfStaticRiskMeasures
dfSpread3CrossConvexityCCSC1$dfStaticRiskMeasures <- NULL
# Compute Static Risk Measure for Net Worth
dfSpread3CrossConvexityCCSC1 <- rbind(dfSpread3CrossConvexityCCSC1, y = c(MaxInstruments+1, NA))
dfSpread3CrossConvexityCCSC1 <- rbind(dfSpread3CrossConvexityCCSC1, y = c(MaxInstruments+2, NA))
dfSpread3CrossConvexityCCSC1 <- rbind(dfSpread3CrossConvexityCCSC1, y = c(MaxInstruments+3, NA))
TA <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+2]
TL <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+3]
SRMA <- 0.0
for(i in 1:NumberOfAssets){
  SRMA <- SRMA + dfSpread3CrossConvexityCCSC1$Spread3CrossConvexityCCSC1[i] * (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[i]/TA)
}
SRML <- 0.0
for(i in 1:NumberOfLiabilities){
  SRML <- SRML + dfSpread3CrossConvexityCCSC1$Spread3CrossConvexityCCSC1[NumberOfAssets+i] * 
    (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[NumberOfAssets+i]/TL)
}
if(TA == -TL){
  dfSpread3CrossConvexityCCSC1$Spread3CrossConvexityCCSC1[MaxInstruments+1] <- NA
} else {
  dfSpread3CrossConvexityCCSC1$Spread3CrossConvexityCCSC1[MaxInstruments+1] <- (SRMA*TA + SRML*TL)/(TA + TL)
}
dfSpread3CrossConvexityCCSC1$Spread3CrossConvexityCCSC1[MaxInstruments+2] <- SRMA
dfSpread3CrossConvexityCCSC1$Spread3CrossConvexityCCSC1[MaxInstruments+3] <- SRML
# Level x Curve2 (CCSC2)
dfSpread3CrossConvexityCCSC2 <- ddply(dfStaticRiskMeasures, .(Instrument), summarize, 
                             dfStaticRiskMeasures=sum(Spread3CrossConvexityCCSC2))
dfSpread3CrossConvexityCCSC2$Spread3CrossConvexityCCSC2 <- dfSpread3CrossConvexityCCSC2$dfStaticRiskMeasures
dfSpread3CrossConvexityCCSC2$dfStaticRiskMeasures <- NULL
# Compute Static Risk Measure for Net Worth
dfSpread3CrossConvexityCCSC2 <- rbind(dfSpread3CrossConvexityCCSC2, y = c(MaxInstruments+1, NA))
dfSpread3CrossConvexityCCSC2 <- rbind(dfSpread3CrossConvexityCCSC2, y = c(MaxInstruments+2, NA))
dfSpread3CrossConvexityCCSC2 <- rbind(dfSpread3CrossConvexityCCSC2, y = c(MaxInstruments+3, NA))
TA <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+2]
TL <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+3]
SRMA <- 0.0
for(i in 1:NumberOfAssets){
  SRMA <- SRMA + dfSpread3CrossConvexityCCSC2$Spread3CrossConvexityCCSC2[i] * (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[i]/TA)
}
SRML <- 0.0
for(i in 1:NumberOfLiabilities){
  SRML <- SRML + dfSpread3CrossConvexityCCSC2$Spread3CrossConvexityCCSC2[NumberOfAssets+i] * 
    (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[NumberOfAssets+i]/TL)
}
if(TA == -TL){
  dfSpread3CrossConvexityCCSC2$Spread3CrossConvexityCCSC2[MaxInstruments+1] <- NA
} else {
  dfSpread3CrossConvexityCCSC2$Spread3CrossConvexityCCSC2[MaxInstruments+1] <- (SRMA*TA + SRML*TL)/(TA + TL)
}
dfSpread3CrossConvexityCCSC2$Spread3CrossConvexityCCSC2[MaxInstruments+2] <- SRMA
dfSpread3CrossConvexityCCSC2$Spread3CrossConvexityCCSC2[MaxInstruments+3] <- SRML
# Level x Curve3 (CCSC3)
dfSpread3CrossConvexityCCSC3 <- ddply(dfStaticRiskMeasures, .(Instrument), summarize, 
                             dfStaticRiskMeasures=sum(Spread3CrossConvexityCCSC3))
dfSpread3CrossConvexityCCSC3$Spread3CrossConvexityCCSC3 <- dfSpread3CrossConvexityCCSC3$dfStaticRiskMeasures
dfSpread3CrossConvexityCCSC3$dfStaticRiskMeasures <- NULL
# Compute Static Risk Measure for Net Worth
dfSpread3CrossConvexityCCSC3 <- rbind(dfSpread3CrossConvexityCCSC3, y = c(MaxInstruments+1, NA))
dfSpread3CrossConvexityCCSC3 <- rbind(dfSpread3CrossConvexityCCSC3, y = c(MaxInstruments+2, NA))
dfSpread3CrossConvexityCCSC3 <- rbind(dfSpread3CrossConvexityCCSC3, y = c(MaxInstruments+3, NA))
TA <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+2]
TL <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+3]
SRMA <- 0.0
for(i in 1:NumberOfAssets){
  SRMA <- SRMA + dfSpread3CrossConvexityCCSC3$Spread3CrossConvexityCCSC3[i] * (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[i]/TA)
}
SRML <- 0.0
for(i in 1:NumberOfLiabilities){
  SRML <- SRML + dfSpread3CrossConvexityCCSC3$Spread3CrossConvexityCCSC3[NumberOfAssets+i] * 
    (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[NumberOfAssets+i]/TL)
}
if(TA == -TL){
  dfSpread3CrossConvexityCCSC3$Spread3CrossConvexityCCSC3[MaxInstruments+1] <- NA
} else {
  dfSpread3CrossConvexityCCSC3$Spread3CrossConvexityCCSC3[MaxInstruments+1] <- (SRMA*TA + SRML*TL)/(TA + TL)
}
dfSpread3CrossConvexityCCSC3$Spread3CrossConvexityCCSC3[MaxInstruments+2] <- SRMA
dfSpread3CrossConvexityCCSC3$Spread3CrossConvexityCCSC3[MaxInstruments+3] <- SRML
# Level x Curve4 (CCSC4)
dfSpread3CrossConvexityCCSC4 <- ddply(dfStaticRiskMeasures, .(Instrument), summarize, 
                             dfStaticRiskMeasures=sum(Spread3CrossConvexityCCSC4))
dfSpread3CrossConvexityCCSC4$Spread3CrossConvexityCCSC4 <- dfSpread3CrossConvexityCCSC4$dfStaticRiskMeasures
dfSpread3CrossConvexityCCSC4$dfStaticRiskMeasures <- NULL
# Compute Static Risk Measure for Net Worth
dfSpread3CrossConvexityCCSC4 <- rbind(dfSpread3CrossConvexityCCSC4, y = c(MaxInstruments+1, NA))
dfSpread3CrossConvexityCCSC4 <- rbind(dfSpread3CrossConvexityCCSC4, y = c(MaxInstruments+2, NA))
dfSpread3CrossConvexityCCSC4 <- rbind(dfSpread3CrossConvexityCCSC4, y = c(MaxInstruments+3, NA))
TA <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+2]
TL <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+3]
SRMA <- 0.0
for(i in 1:NumberOfAssets){
  SRMA <- SRMA + dfSpread3CrossConvexityCCSC4$Spread3CrossConvexityCCSC4[i] * (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[i]/TA)
}
SRML <- 0.0
for(i in 1:NumberOfLiabilities){
  SRML <- SRML + dfSpread3CrossConvexityCCSC4$Spread3CrossConvexityCCSC4[NumberOfAssets+i] * 
    (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[NumberOfAssets+i]/TL)
}
if(TA == -TL){
  dfSpread3CrossConvexityCCSC4$Spread3CrossConvexityCCSC4[MaxInstruments+1] <- NA
} else {
  dfSpread3CrossConvexityCCSC4$Spread3CrossConvexityCCSC4[MaxInstruments+1] <- (SRMA*TA + SRML*TL)/(TA + TL)
}
dfSpread3CrossConvexityCCSC4$Spread3CrossConvexityCCSC4[MaxInstruments+2] <- SRMA
dfSpread3CrossConvexityCCSC4$Spread3CrossConvexityCCSC4[MaxInstruments+3] <- SRML
# Level x Curve5 (CCSC5)
dfSpread3CrossConvexityCCSC5 <- ddply(dfStaticRiskMeasures, .(Instrument), summarize, 
                             dfStaticRiskMeasures=sum(Spread3CrossConvexityCCSC5))
dfSpread3CrossConvexityCCSC5$Spread3CrossConvexityCCSC5 <- dfSpread3CrossConvexityCCSC5$dfStaticRiskMeasures
dfSpread3CrossConvexityCCSC5$dfStaticRiskMeasures <- NULL
# Compute Static Risk Measure for Net Worth
dfSpread3CrossConvexityCCSC5 <- rbind(dfSpread3CrossConvexityCCSC5, y = c(MaxInstruments+1, NA))
dfSpread3CrossConvexityCCSC5 <- rbind(dfSpread3CrossConvexityCCSC5, y = c(MaxInstruments+2, NA))
dfSpread3CrossConvexityCCSC5 <- rbind(dfSpread3CrossConvexityCCSC5, y = c(MaxInstruments+3, NA))
TA <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+2]
TL <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+3]
SRMA <- 0.0
for(i in 1:NumberOfAssets){
  SRMA <- SRMA + dfSpread3CrossConvexityCCSC5$Spread3CrossConvexityCCSC5[i] * (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[i]/TA)
}
SRML <- 0.0
for(i in 1:NumberOfLiabilities){
  SRML <- SRML + dfSpread3CrossConvexityCCSC5$Spread3CrossConvexityCCSC5[NumberOfAssets+i] * 
    (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[NumberOfAssets+i]/TL)
}
if(TA == -TL){
  dfSpread3CrossConvexityCCSC5$Spread3CrossConvexityCCSC5[MaxInstruments+1] <- NA
} else {
  dfSpread3CrossConvexityCCSC5$Spread3CrossConvexityCCSC5[MaxInstruments+1] <- (SRMA*TA + SRML*TL)/(TA + TL)
}
dfSpread3CrossConvexityCCSC5$Spread3CrossConvexityCCSC5[MaxInstruments+2] <- SRMA
dfSpread3CrossConvexityCCSC5$Spread3CrossConvexityCCSC5[MaxInstruments+3] <- SRML
# dfSpread3CrossConvexityCCSC1
# dfSpread3CrossConvexityCCSC2
# dfSpread3CrossConvexityCCSC3
# dfSpread3CrossConvexityCCSC4
# dfSpread3CrossConvexityCCSC5
# Curve1 x Curve2 (CCC1C2)
dfSpread3CrossConvexityCCC1C2 <- ddply(dfStaticRiskMeasures, .(Instrument), summarize, 
                             dfStaticRiskMeasures=sum(Spread3CrossConvexityCCC1C2))
dfSpread3CrossConvexityCCC1C2$Spread3CrossConvexityCCC1C2 <- dfSpread3CrossConvexityCCC1C2$dfStaticRiskMeasures
dfSpread3CrossConvexityCCC1C2$dfStaticRiskMeasures <- NULL
# Compute Static Risk Measure for Net Worth
dfSpread3CrossConvexityCCC1C2 <- rbind(dfSpread3CrossConvexityCCC1C2, y = c(MaxInstruments+1, NA))
dfSpread3CrossConvexityCCC1C2 <- rbind(dfSpread3CrossConvexityCCC1C2, y = c(MaxInstruments+2, NA))
dfSpread3CrossConvexityCCC1C2 <- rbind(dfSpread3CrossConvexityCCC1C2, y = c(MaxInstruments+3, NA))
TA <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+2]
TL <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+3]
SRMA <- 0.0
for(i in 1:NumberOfAssets){
  SRMA <- SRMA + dfSpread3CrossConvexityCCC1C2$Spread3CrossConvexityCCC1C2[i] * (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[i]/TA)
}
SRML <- 0.0
for(i in 1:NumberOfLiabilities){
  SRML <- SRML + dfSpread3CrossConvexityCCC1C2$Spread3CrossConvexityCCC1C2[NumberOfAssets+i] * 
    (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[NumberOfAssets+i]/TL)
}
if(TA == -TL){
  dfSpread3CrossConvexityCCC1C2$Spread3CrossConvexityCCC1C2[MaxInstruments+1] <- NA
} else {
  dfSpread3CrossConvexityCCC1C2$Spread3CrossConvexityCCC1C2[MaxInstruments+1] <- (SRMA*TA + SRML*TL)/(TA + TL)
}
dfSpread3CrossConvexityCCC1C2$Spread3CrossConvexityCCC1C2[MaxInstruments+2] <- SRMA
dfSpread3CrossConvexityCCC1C2$Spread3CrossConvexityCCC1C2[MaxInstruments+3] <- SRML
# Level x Curve3 (CCC1C3)
dfSpread3CrossConvexityCCC1C3 <- ddply(dfStaticRiskMeasures, .(Instrument), summarize, 
                             dfStaticRiskMeasures=sum(Spread3CrossConvexityCCC1C3))
dfSpread3CrossConvexityCCC1C3$Spread3CrossConvexityCCC1C3 <- dfSpread3CrossConvexityCCC1C3$dfStaticRiskMeasures
dfSpread3CrossConvexityCCC1C3$dfStaticRiskMeasures <- NULL
# Compute Static Risk Measure for Net Worth
dfSpread3CrossConvexityCCC1C3 <- rbind(dfSpread3CrossConvexityCCC1C3, y = c(MaxInstruments+1, NA))
dfSpread3CrossConvexityCCC1C3 <- rbind(dfSpread3CrossConvexityCCC1C3, y = c(MaxInstruments+2, NA))
dfSpread3CrossConvexityCCC1C3 <- rbind(dfSpread3CrossConvexityCCC1C3, y = c(MaxInstruments+3, NA))
TA <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+2]
TL <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+3]
SRMA <- 0.0
for(i in 1:NumberOfAssets){
  SRMA <- SRMA + dfSpread3CrossConvexityCCC1C3$Spread3CrossConvexityCCC1C3[i] * (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[i]/TA)
}
SRML <- 0.0
for(i in 1:NumberOfLiabilities){
  SRML <- SRML + dfSpread3CrossConvexityCCC1C3$Spread3CrossConvexityCCC1C3[NumberOfAssets+i] * 
    (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[NumberOfAssets+i]/TL)
}
if(TA == -TL){
  dfSpread3CrossConvexityCCC1C3$Spread3CrossConvexityCCC1C3[MaxInstruments+1] <- NA
} else {
  dfSpread3CrossConvexityCCC1C3$Spread3CrossConvexityCCC1C3[MaxInstruments+1] <- (SRMA*TA + SRML*TL)/(TA + TL)
}
dfSpread3CrossConvexityCCC1C3$Spread3CrossConvexityCCC1C3[MaxInstruments+2] <- SRMA
dfSpread3CrossConvexityCCC1C3$Spread3CrossConvexityCCC1C3[MaxInstruments+3] <- SRML
# Level x Curve4 (CCC1C4)
dfSpread3CrossConvexityCCC1C4 <- ddply(dfStaticRiskMeasures, .(Instrument), summarize, 
                             dfStaticRiskMeasures=sum(Spread3CrossConvexityCCC1C4))
dfSpread3CrossConvexityCCC1C4$Spread3CrossConvexityCCC1C4 <- dfSpread3CrossConvexityCCC1C4$dfStaticRiskMeasures
dfSpread3CrossConvexityCCC1C4$dfStaticRiskMeasures <- NULL
# Compute Static Risk Measure for Net Worth
dfSpread3CrossConvexityCCC1C4 <- rbind(dfSpread3CrossConvexityCCC1C4, y = c(MaxInstruments+1, NA))
dfSpread3CrossConvexityCCC1C4 <- rbind(dfSpread3CrossConvexityCCC1C4, y = c(MaxInstruments+2, NA))
dfSpread3CrossConvexityCCC1C4 <- rbind(dfSpread3CrossConvexityCCC1C4, y = c(MaxInstruments+3, NA))
TA <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+2]
TL <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+3]
SRMA <- 0.0
for(i in 1:NumberOfAssets){
  SRMA <- SRMA + dfSpread3CrossConvexityCCC1C4$Spread3CrossConvexityCCC1C4[i] * (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[i]/TA)
}
SRML <- 0.0
for(i in 1:NumberOfLiabilities){
  SRML <- SRML + dfSpread3CrossConvexityCCC1C4$Spread3CrossConvexityCCC1C4[NumberOfAssets+i] * 
    (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[NumberOfAssets+i]/TL)
}
if(TA == -TL){
  dfSpread3CrossConvexityCCC1C4$Spread3CrossConvexityCCC1C4[MaxInstruments+1] <- NA
} else {
  dfSpread3CrossConvexityCCC1C4$Spread3CrossConvexityCCC1C4[MaxInstruments+1] <- (SRMA*TA + SRML*TL)/(TA + TL)
}
dfSpread3CrossConvexityCCC1C4$Spread3CrossConvexityCCC1C4[MaxInstruments+2] <- SRMA
dfSpread3CrossConvexityCCC1C4$Spread3CrossConvexityCCC1C4[MaxInstruments+3] <- SRML
# Level x Curve5 (CCC1C5)
dfSpread3CrossConvexityCCC1C5 <- ddply(dfStaticRiskMeasures, .(Instrument), summarize, 
                             dfStaticRiskMeasures=sum(Spread3CrossConvexityCCC1C5))
dfSpread3CrossConvexityCCC1C5$Spread3CrossConvexityCCC1C5 <- dfSpread3CrossConvexityCCC1C5$dfStaticRiskMeasures
dfSpread3CrossConvexityCCC1C5$dfStaticRiskMeasures <- NULL
# Compute Static Risk Measure for Net Worth
dfSpread3CrossConvexityCCC1C5 <- rbind(dfSpread3CrossConvexityCCC1C5, y = c(MaxInstruments+1, NA))
dfSpread3CrossConvexityCCC1C5 <- rbind(dfSpread3CrossConvexityCCC1C5, y = c(MaxInstruments+2, NA))
dfSpread3CrossConvexityCCC1C5 <- rbind(dfSpread3CrossConvexityCCC1C5, y = c(MaxInstruments+3, NA))
TA <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+2]
TL <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+3]
SRMA <- 0.0
for(i in 1:NumberOfAssets){
  SRMA <- SRMA + dfSpread3CrossConvexityCCC1C5$Spread3CrossConvexityCCC1C5[i] * (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[i]/TA)
}
SRML <- 0.0
for(i in 1:NumberOfLiabilities){
  SRML <- SRML + dfSpread3CrossConvexityCCC1C5$Spread3CrossConvexityCCC1C5[NumberOfAssets+i] * 
    (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[NumberOfAssets+i]/TL)
}
if(TA == -TL){
  dfSpread3CrossConvexityCCC1C5$Spread3CrossConvexityCCC1C5[MaxInstruments+1] <- NA
} else {
  dfSpread3CrossConvexityCCC1C5$Spread3CrossConvexityCCC1C5[MaxInstruments+1] <- (SRMA*TA + SRML*TL)/(TA + TL)
}
dfSpread3CrossConvexityCCC1C5$Spread3CrossConvexityCCC1C5[MaxInstruments+2] <- SRMA
dfSpread3CrossConvexityCCC1C5$Spread3CrossConvexityCCC1C5[MaxInstruments+3] <- SRML
# dfSpread3CrossConvexityCCC1C2
# dfSpread3CrossConvexityCCC1C3
# dfSpread3CrossConvexityCCC1C4
# dfSpread3CrossConvexityCCC1C5
# Curve2 x Curve3 (CCC2C3)
dfSpread3CrossConvexityCCC2C3 <- ddply(dfStaticRiskMeasures, .(Instrument), summarize, 
                              dfStaticRiskMeasures=sum(Spread3CrossConvexityCCC2C3))
dfSpread3CrossConvexityCCC2C3$Spread3CrossConvexityCCC2C3 <- dfSpread3CrossConvexityCCC2C3$dfStaticRiskMeasures
dfSpread3CrossConvexityCCC2C3$dfStaticRiskMeasures <- NULL
# Compute Static Risk Measure for Net Worth
dfSpread3CrossConvexityCCC2C3 <- rbind(dfSpread3CrossConvexityCCC2C3, y = c(MaxInstruments+1, NA))
dfSpread3CrossConvexityCCC2C3 <- rbind(dfSpread3CrossConvexityCCC2C3, y = c(MaxInstruments+2, NA))
dfSpread3CrossConvexityCCC2C3 <- rbind(dfSpread3CrossConvexityCCC2C3, y = c(MaxInstruments+3, NA))
TA <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+2]
TL <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+3]
SRMA <- 0.0
for(i in 1:NumberOfAssets){
  SRMA <- SRMA + dfSpread3CrossConvexityCCC2C3$Spread3CrossConvexityCCC2C3[i] * (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[i]/TA)
}
SRML <- 0.0
for(i in 1:NumberOfLiabilities){
  SRML <- SRML + dfSpread3CrossConvexityCCC2C3$Spread3CrossConvexityCCC2C3[NumberOfAssets+i] * 
    (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[NumberOfAssets+i]/TL)
}
if(TA == -TL){
  dfSpread3CrossConvexityCCC2C3$Spread3CrossConvexityCCC2C3[MaxInstruments+1] <- NA
} else {
  dfSpread3CrossConvexityCCC2C3$Spread3CrossConvexityCCC2C3[MaxInstruments+1] <- (SRMA*TA + SRML*TL)/(TA + TL)
}
dfSpread3CrossConvexityCCC2C3$Spread3CrossConvexityCCC2C3[MaxInstruments+2] <- SRMA
dfSpread3CrossConvexityCCC2C3$Spread3CrossConvexityCCC2C3[MaxInstruments+3] <- SRML
# _____ x Curve4 (CCC2C4)
dfSpread3CrossConvexityCCC2C4 <- ddply(dfStaticRiskMeasures, .(Instrument), summarize, 
                              dfStaticRiskMeasures=sum(Spread3CrossConvexityCCC2C4))
dfSpread3CrossConvexityCCC2C4$Spread3CrossConvexityCCC2C4 <- dfSpread3CrossConvexityCCC2C4$dfStaticRiskMeasures
dfSpread3CrossConvexityCCC2C4$dfStaticRiskMeasures <- NULL
# Compute Static Risk Measure for Net Worth
dfSpread3CrossConvexityCCC2C4 <- rbind(dfSpread3CrossConvexityCCC2C4, y = c(MaxInstruments+1, NA))
dfSpread3CrossConvexityCCC2C4 <- rbind(dfSpread3CrossConvexityCCC2C4, y = c(MaxInstruments+2, NA))
dfSpread3CrossConvexityCCC2C4 <- rbind(dfSpread3CrossConvexityCCC2C4, y = c(MaxInstruments+3, NA))
TA <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+2]
TL <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+3]
SRMA <- 0.0
for(i in 1:NumberOfAssets){
  SRMA <- SRMA + dfSpread3CrossConvexityCCC2C4$Spread3CrossConvexityCCC2C4[i] * (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[i]/TA)
}
SRML <- 0.0
for(i in 1:NumberOfLiabilities){
  SRML <- SRML + dfSpread3CrossConvexityCCC2C4$Spread3CrossConvexityCCC2C4[NumberOfAssets+i] * 
    (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[NumberOfAssets+i]/TL)
}
if(TA == -TL){
  dfSpread3CrossConvexityCCC2C4$Spread3CrossConvexityCCC2C4[MaxInstruments+1] <- NA
} else {
  dfSpread3CrossConvexityCCC2C4$Spread3CrossConvexityCCC2C4[MaxInstruments+1] <- (SRMA*TA + SRML*TL)/(TA + TL)
}
dfSpread3CrossConvexityCCC2C4$Spread3CrossConvexityCCC2C4[MaxInstruments+2] <- SRMA
dfSpread3CrossConvexityCCC2C4$Spread3CrossConvexityCCC2C4[MaxInstruments+3] <- SRML
# _____ x Curve5 (CCC2C5)
dfSpread3CrossConvexityCCC2C5 <- ddply(dfStaticRiskMeasures, .(Instrument), summarize, 
                              dfStaticRiskMeasures=sum(Spread3CrossConvexityCCC2C5))
dfSpread3CrossConvexityCCC2C5$Spread3CrossConvexityCCC2C5 <- dfSpread3CrossConvexityCCC2C5$dfStaticRiskMeasures
dfSpread3CrossConvexityCCC2C5$dfStaticRiskMeasures <- NULL
# Compute Static Risk Measure for Net Worth
dfSpread3CrossConvexityCCC2C5 <- rbind(dfSpread3CrossConvexityCCC2C5, y = c(MaxInstruments+1, NA))
dfSpread3CrossConvexityCCC2C5 <- rbind(dfSpread3CrossConvexityCCC2C5, y = c(MaxInstruments+2, NA))
dfSpread3CrossConvexityCCC2C5 <- rbind(dfSpread3CrossConvexityCCC2C5, y = c(MaxInstruments+3, NA))
TA <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+2]
TL <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+3]
SRMA <- 0.0
for(i in 1:NumberOfAssets){
  SRMA <- SRMA + dfSpread3CrossConvexityCCC2C5$Spread3CrossConvexityCCC2C5[i] * (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[i]/TA)
}
SRML <- 0.0
for(i in 1:NumberOfLiabilities){
  SRML <- SRML + dfSpread3CrossConvexityCCC2C5$Spread3CrossConvexityCCC2C5[NumberOfAssets+i] * 
    (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[NumberOfAssets+i]/TL)
}
if(TA == -TL){
  dfSpread3CrossConvexityCCC2C5$Spread3CrossConvexityCCC2C5[MaxInstruments+1] <- NA
} else {
  dfSpread3CrossConvexityCCC2C5$Spread3CrossConvexityCCC2C5[MaxInstruments+1] <- (SRMA*TA + SRML*TL)/(TA + TL)
}
dfSpread3CrossConvexityCCC2C5$Spread3CrossConvexityCCC2C5[MaxInstruments+2] <- SRMA
dfSpread3CrossConvexityCCC2C5$Spread3CrossConvexityCCC2C5[MaxInstruments+3] <- SRML
# dfSpread3CrossConvexityCCC2C3
# dfSpread3CrossConvexityCCC2C4
# dfSpread3CrossConvexityCCC2C5
# Curve3 x Curve4 (CCC3C4)
dfSpread3CrossConvexityCCC3C4 <- ddply(dfStaticRiskMeasures, .(Instrument), summarize, 
                              dfStaticRiskMeasures=sum(Spread3CrossConvexityCCC3C4))
dfSpread3CrossConvexityCCC3C4$Spread3CrossConvexityCCC3C4 <- dfSpread3CrossConvexityCCC3C4$dfStaticRiskMeasures
dfSpread3CrossConvexityCCC3C4$dfStaticRiskMeasures <- NULL
# Compute Static Risk Measure for Net Worth
dfSpread3CrossConvexityCCC3C4 <- rbind(dfSpread3CrossConvexityCCC3C4, y = c(MaxInstruments+1, NA))
dfSpread3CrossConvexityCCC3C4 <- rbind(dfSpread3CrossConvexityCCC3C4, y = c(MaxInstruments+2, NA))
dfSpread3CrossConvexityCCC3C4 <- rbind(dfSpread3CrossConvexityCCC3C4, y = c(MaxInstruments+3, NA))
TA <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+2]
TL <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+3]
SRMA <- 0.0
for(i in 1:NumberOfAssets){
  SRMA <- SRMA + dfSpread3CrossConvexityCCC3C4$Spread3CrossConvexityCCC3C4[i] * (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[i]/TA)
}
SRML <- 0.0
for(i in 1:NumberOfLiabilities){
  SRML <- SRML + dfSpread3CrossConvexityCCC3C4$Spread3CrossConvexityCCC3C4[NumberOfAssets+i] * 
    (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[NumberOfAssets+i]/TL)
}
if(TA == -TL){
  dfSpread3CrossConvexityCCC3C4$Spread3CrossConvexityCCC3C4[MaxInstruments+1] <- NA
} else {
  dfSpread3CrossConvexityCCC3C4$Spread3CrossConvexityCCC3C4[MaxInstruments+1] <- (SRMA*TA + SRML*TL)/(TA + TL)
}
dfSpread3CrossConvexityCCC3C4$Spread3CrossConvexityCCC3C4[MaxInstruments+2] <- SRMA
dfSpread3CrossConvexityCCC3C4$Spread3CrossConvexityCCC3C4[MaxInstruments+3] <- SRML
# _____ x Curve5 (CCC3C5)
dfSpread3CrossConvexityCCC3C5 <- ddply(dfStaticRiskMeasures, .(Instrument), summarize, 
                              dfStaticRiskMeasures=sum(Spread3CrossConvexityCCC3C5))
dfSpread3CrossConvexityCCC3C5$Spread3CrossConvexityCCC3C5 <- dfSpread3CrossConvexityCCC3C5$dfStaticRiskMeasures
dfSpread3CrossConvexityCCC3C5$dfStaticRiskMeasures <- NULL
# Compute Static Risk Measure for Net Worth
dfSpread3CrossConvexityCCC3C5 <- rbind(dfSpread3CrossConvexityCCC3C5, y = c(MaxInstruments+1, NA))
dfSpread3CrossConvexityCCC3C5 <- rbind(dfSpread3CrossConvexityCCC3C5, y = c(MaxInstruments+2, NA))
dfSpread3CrossConvexityCCC3C5 <- rbind(dfSpread3CrossConvexityCCC3C5, y = c(MaxInstruments+3, NA))
TA <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+2]
TL <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+3]
SRMA <- 0.0
for(i in 1:NumberOfAssets){
  SRMA <- SRMA + dfSpread3CrossConvexityCCC3C5$Spread3CrossConvexityCCC3C5[i] * (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[i]/TA)
}
SRML <- 0.0
for(i in 1:NumberOfLiabilities){
  SRML <- SRML + dfSpread3CrossConvexityCCC3C5$Spread3CrossConvexityCCC3C5[NumberOfAssets+i] * 
    (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[NumberOfAssets+i]/TL)
}
if(TA == -TL){
  dfSpread3CrossConvexityCCC3C5$Spread3CrossConvexityCCC3C5[MaxInstruments+1] <- NA
} else {
  dfSpread3CrossConvexityCCC3C5$Spread3CrossConvexityCCC3C5[MaxInstruments+1] <- (SRMA*TA + SRML*TL)/(TA + TL)
}
dfSpread3CrossConvexityCCC3C5$Spread3CrossConvexityCCC3C5[MaxInstruments+2] <- SRMA
dfSpread3CrossConvexityCCC3C5$Spread3CrossConvexityCCC3C5[MaxInstruments+3] <- SRML
# dfSpread3CrossConvexityCCC3C4
# dfSpread3CrossConvexityCCC3C5
# Curve4 x Curve5 (CCC4C5)
dfSpread3CrossConvexityCCC4C5 <- ddply(dfStaticRiskMeasures, .(Instrument), summarize, 
                              dfStaticRiskMeasures=sum(Spread3CrossConvexityCCC4C5))
dfSpread3CrossConvexityCCC4C5$Spread3CrossConvexityCCC4C5 <- dfSpread3CrossConvexityCCC4C5$dfStaticRiskMeasures
dfSpread3CrossConvexityCCC4C5$dfStaticRiskMeasures <- NULL
# Compute Static Risk Measure for Net Worth
dfSpread3CrossConvexityCCC4C5 <- rbind(dfSpread3CrossConvexityCCC4C5, y = c(MaxInstruments+1, NA))
dfSpread3CrossConvexityCCC4C5 <- rbind(dfSpread3CrossConvexityCCC4C5, y = c(MaxInstruments+2, NA))
dfSpread3CrossConvexityCCC4C5 <- rbind(dfSpread3CrossConvexityCCC4C5, y = c(MaxInstruments+3, NA))
TA <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+2]
TL <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+3]
SRMA <- 0.0
for(i in 1:NumberOfAssets){
  SRMA <- SRMA + dfSpread3CrossConvexityCCC4C5$Spread3CrossConvexityCCC4C5[i] * (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[i]/TA)
}
SRML <- 0.0
for(i in 1:NumberOfLiabilities){
  SRML <- SRML + dfSpread3CrossConvexityCCC4C5$Spread3CrossConvexityCCC4C5[NumberOfAssets+i] * 
    (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[NumberOfAssets+i]/TL)
}
if(TA == -TL){
  dfSpread3CrossConvexityCCC4C5$Spread3CrossConvexityCCC4C5[MaxInstruments+1] <- NA
} else {
  dfSpread3CrossConvexityCCC4C5$Spread3CrossConvexityCCC4C5[MaxInstruments+1] <- (SRMA*TA + SRML*TL)/(TA + TL)
}
dfSpread3CrossConvexityCCC4C5$Spread3CrossConvexityCCC4C5[MaxInstruments+2] <- SRMA
dfSpread3CrossConvexityCCC4C5$Spread3CrossConvexityCCC4C5[MaxInstruments+3] <- SRML
# dfSpread3CrossConvexityCCC4C5


