# KM Spread4 Rate Static Risk Measures.R
# Spread4 rate static risk measures
L <- InitialCurves$Spread4[2]
k1 <- InitialCurves$Spread4[3]
S <- InitialCurves$Spread4[4]
C1 <- InitialCurves$Spread4[5]
k2 <- InitialCurves$Spread4[6]
C2 <- InitialCurves$Spread4[7]
k3 <- InitialCurves$Spread4[8]
C3 <- InitialCurves$Spread4[9]
k4 <- InitialCurves$Spread4[10]
C4 <- InitialCurves$Spread4[11]
k5 <- InitialCurves$Spread4[12]
C5 <- InitialCurves$Spread4[13]
# Spread4 rate maturity coefficients at Horizon
M <- dfStaticRiskMeasures$Maturity-Horizon
LengthM = length(M)
for(i in 1:LengthM){ # Cannot have zero in LSC model
  if(M[i] == 0)M[i] <- 0.000001
}
x1 <- (k1/M)*(1.0 - exp(-M/k1))
x2 <- x1 - exp(-M/k1)
x3 <- (k2/M) * (1.0 - exp(-M/k2)) - exp(-M/k2)
x4 <- (k3/M) * (1.0 - exp(-M/k3)) - exp(-M/k3)
x5 <- (k4/M) * (1.0 - exp(-M/k4)) - exp(-M/k4)
x6 <- (k5/M) * (1.0 - exp(-M/k5)) - exp(-M/k5)
W <- dfStaticRiskMeasures$Weight
CW <- dfStaticRiskMeasures$WSpread4 # Weight of particular curve
#
# Spread4 Duration
#
dfStaticRiskMeasures$Spread4DurationLevel <- M * 1.0 * W * CW
dfStaticRiskMeasures$Spread4DurationSlope <- M * x1 * W * CW
dfStaticRiskMeasures$Spread4DurationCurve1 <- M * x2 * W * CW
dfStaticRiskMeasures$Spread4DurationCurve2 <- M * x3 * W * CW
dfStaticRiskMeasures$Spread4DurationCurve3 <- M * x4 * W * CW
dfStaticRiskMeasures$Spread4DurationCurve4 <- M * x5 * W * CW
dfStaticRiskMeasures$Spread4DurationCurve5 <- M * x6 * W * CW
# Level
dfSpread4DurationLevel <- ddply(dfStaticRiskMeasures, .(Instrument), summarize, 
  dfStaticRiskMeasures=sum(Spread4DurationLevel))
dfSpread4DurationLevel$Spread4DurationLevel <- dfSpread4DurationLevel$dfStaticRiskMeasures
dfSpread4DurationLevel$dfStaticRiskMeasures <- NULL
# Compute Static Risk Measure for Net Worth
dfSpread4DurationLevel <- rbind(dfSpread4DurationLevel, y = c(MaxInstruments+1, NA))
dfSpread4DurationLevel <- rbind(dfSpread4DurationLevel, y = c(MaxInstruments+2, NA))
dfSpread4DurationLevel <- rbind(dfSpread4DurationLevel, y = c(MaxInstruments+3, NA))
TA <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+2]
TL <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+3]
SRMA <- 0.0
for(i in 1:NumberOfAssets){
  SRMA <- SRMA + dfSpread4DurationLevel$Spread4DurationLevel[i] * (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[i]/TA)
}
SRML <- 0.0
for(i in 1:NumberOfLiabilities){
  SRML <- SRML + dfSpread4DurationLevel$Spread4DurationLevel[NumberOfAssets+i] * 
    (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[NumberOfAssets+i]/TL)
}
if(TA == -TL){
  dfSpread4DurationLevel$Spread4DurationLevel[MaxInstruments+1] <- NA
} else {
  dfSpread4DurationLevel$Spread4DurationLevel[MaxInstruments+1] <- (SRMA*TA + SRML*TL)/(TA + TL)
}
dfSpread4DurationLevel$Spread4DurationLevel[MaxInstruments+2] <- SRMA
dfSpread4DurationLevel$Spread4DurationLevel[MaxInstruments+3] <- SRML
dfSpread4DurationLevel
# Slope
dfSpread4DurationSlope <- ddply(dfStaticRiskMeasures, .(Instrument), summarize, 
                             dfStaticRiskMeasures=sum(Spread4DurationSlope))
dfSpread4DurationSlope$Spread4DurationSlope <- dfSpread4DurationSlope$dfStaticRiskMeasures
dfSpread4DurationSlope$dfStaticRiskMeasures <- NULL
# Compute Static Risk Measure for Net Worth
dfSpread4DurationSlope <- rbind(dfSpread4DurationSlope, y = c(MaxInstruments+1, NA))
dfSpread4DurationSlope <- rbind(dfSpread4DurationSlope, y = c(MaxInstruments+2, NA))
dfSpread4DurationSlope <- rbind(dfSpread4DurationSlope, y = c(MaxInstruments+3, NA))
TA <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+2]
TL <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+3]
SRMA <- 0.0
for(i in 1:NumberOfAssets){
  SRMA <- SRMA + dfSpread4DurationSlope$Spread4DurationSlope[i] * (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[i]/TA)
}
SRML <- 0.0
for(i in 1:NumberOfLiabilities){
  SRML <- SRML + dfSpread4DurationSlope$Spread4DurationSlope[NumberOfAssets+i] * 
    (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[NumberOfAssets+i]/TL)
}
if(TA == -TL){
  dfSpread4DurationSlope$Spread4DurationSlope[MaxInstruments+1] <- NA
} else {
  dfSpread4DurationSlope$Spread4DurationSlope[MaxInstruments+1] <- (SRMA*TA + SRML*TL)/(TA + TL)
}
dfSpread4DurationSlope$Spread4DurationSlope[MaxInstruments+2] <- SRMA
dfSpread4DurationSlope$Spread4DurationSlope[MaxInstruments+3] <- SRML
dfSpread4DurationSlope
# Curvature 1
dfSpread4DurationCurve1 <- ddply(dfStaticRiskMeasures, .(Instrument), summarize, 
                              dfStaticRiskMeasures=sum(Spread4DurationCurve1))
dfSpread4DurationCurve1$Spread4DurationCurve1 <- dfSpread4DurationCurve1$dfStaticRiskMeasures
dfSpread4DurationCurve1$dfStaticRiskMeasures <- NULL
# Compute Static Risk Measure for Net Worth
dfSpread4DurationCurve1 <- rbind(dfSpread4DurationCurve1, y = c(MaxInstruments+1, NA))
dfSpread4DurationCurve1 <- rbind(dfSpread4DurationCurve1, y = c(MaxInstruments+2, NA))
dfSpread4DurationCurve1 <- rbind(dfSpread4DurationCurve1, y = c(MaxInstruments+3, NA))
TA <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+2]
TL <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+3]
SRMA <- 0.0
for(i in 1:NumberOfAssets){
  SRMA <- SRMA + dfSpread4DurationCurve1$Spread4DurationCurve1[i] * (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[i]/TA)
}
SRML <- 0.0
for(i in 1:NumberOfLiabilities){
  SRML <- SRML + dfSpread4DurationCurve1$Spread4DurationCurve1[NumberOfAssets+i] * 
    (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[NumberOfAssets+i]/TL)
}
if(TA == -TL){
  dfSpread4DurationCurve1$Spread4DurationCurve1[MaxInstruments+1] <- NA
} else {
  dfSpread4DurationCurve1$Spread4DurationCurve1[MaxInstruments+1] <- (SRMA*TA + SRML*TL)/(TA + TL)
}
dfSpread4DurationCurve1$Spread4DurationCurve1[MaxInstruments+2] <- SRMA
dfSpread4DurationCurve1$Spread4DurationCurve1[MaxInstruments+3] <- SRML
dfSpread4DurationCurve1
# Curvature 2
dfSpread4DurationCurve2 <- ddply(dfStaticRiskMeasures, .(Instrument), summarize, 
                              dfStaticRiskMeasures=sum(Spread4DurationCurve2))
dfSpread4DurationCurve2$Spread4DurationCurve2 <- dfSpread4DurationCurve2$dfStaticRiskMeasures
dfSpread4DurationCurve2$dfStaticRiskMeasures <- NULL
# Compute Static Risk Measure for Net Worth
dfSpread4DurationCurve2 <- rbind(dfSpread4DurationCurve2, y = c(MaxInstruments+1, NA))
dfSpread4DurationCurve2 <- rbind(dfSpread4DurationCurve2, y = c(MaxInstruments+2, NA))
dfSpread4DurationCurve2 <- rbind(dfSpread4DurationCurve2, y = c(MaxInstruments+3, NA))
TA <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+2]
TL <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+3]
SRMA <- 0.0
for(i in 1:NumberOfAssets){
  SRMA <- SRMA + dfSpread4DurationCurve2$Spread4DurationCurve2[i] * (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[i]/TA)
}
SRML <- 0.0
for(i in 1:NumberOfLiabilities){
  SRML <- SRML + dfSpread4DurationCurve2$Spread4DurationCurve2[NumberOfAssets+i] * 
    (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[NumberOfAssets+i]/TL)
}
if(TA == -TL){
  dfSpread4DurationCurve2$Spread4DurationCurve2[MaxInstruments+1] <- NA
} else {
  dfSpread4DurationCurve2$Spread4DurationCurve2[MaxInstruments+1] <- (SRMA*TA + SRML*TL)/(TA + TL)
}
dfSpread4DurationCurve2$Spread4DurationCurve2[MaxInstruments+2] <- SRMA
dfSpread4DurationCurve2$Spread4DurationCurve2[MaxInstruments+3] <- SRML
# Curvature 3
dfSpread4DurationCurve3 <- ddply(dfStaticRiskMeasures, .(Instrument), summarize, 
                              dfStaticRiskMeasures=sum(Spread4DurationCurve3))
dfSpread4DurationCurve3$Spread4DurationCurve3 <- dfSpread4DurationCurve3$dfStaticRiskMeasures
dfSpread4DurationCurve3$dfStaticRiskMeasures <- NULL
# Compute Static Risk Measure for Net Worth
dfSpread4DurationCurve3 <- rbind(dfSpread4DurationCurve3, y = c(MaxInstruments+1, NA))
dfSpread4DurationCurve3 <- rbind(dfSpread4DurationCurve3, y = c(MaxInstruments+2, NA))
dfSpread4DurationCurve3 <- rbind(dfSpread4DurationCurve3, y = c(MaxInstruments+3, NA))
TA <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+2]
TL <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+3]
SRMA <- 0.0
for(i in 1:NumberOfAssets){
  SRMA <- SRMA + dfSpread4DurationCurve3$Spread4DurationCurve3[i] * (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[i]/TA)
}
SRML <- 0.0
for(i in 1:NumberOfLiabilities){
  SRML <- SRML + dfSpread4DurationCurve3$Spread4DurationCurve3[NumberOfAssets+i] * 
    (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[NumberOfAssets+i]/TL)
}
if(TA == -TL){
  dfSpread4DurationCurve3$Spread4DurationCurve3[MaxInstruments+1] <- NA
} else {
  dfSpread4DurationCurve3$Spread4DurationCurve3[MaxInstruments+1] <- (SRMA*TA + SRML*TL)/(TA + TL)
}
dfSpread4DurationCurve3$Spread4DurationCurve3[MaxInstruments+2] <- SRMA
dfSpread4DurationCurve3$Spread4DurationCurve3[MaxInstruments+3] <- SRML
# Curvature 4
dfSpread4DurationCurve4 <- ddply(dfStaticRiskMeasures, .(Instrument), summarize, 
                              dfStaticRiskMeasures=sum(Spread4DurationCurve4))
dfSpread4DurationCurve4$Spread4DurationCurve4 <- dfSpread4DurationCurve4$dfStaticRiskMeasures
dfSpread4DurationCurve4$dfStaticRiskMeasures <- NULL
# Compute Static Risk Measure for Net Worth
dfSpread4DurationCurve4 <- rbind(dfSpread4DurationCurve4, y = c(MaxInstruments+1, NA))
dfSpread4DurationCurve4 <- rbind(dfSpread4DurationCurve4, y = c(MaxInstruments+2, NA))
dfSpread4DurationCurve4 <- rbind(dfSpread4DurationCurve4, y = c(MaxInstruments+3, NA))
TA <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+2]
TL <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+3]
SRMA <- 0.0
for(i in 1:NumberOfAssets){
  SRMA <- SRMA + dfSpread4DurationCurve4$Spread4DurationCurve4[i] * (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[i]/TA)
}
SRML <- 0.0
for(i in 1:NumberOfLiabilities){
  SRML <- SRML + dfSpread4DurationCurve4$Spread4DurationCurve4[NumberOfAssets+i] * 
    (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[NumberOfAssets+i]/TL)
}
if(TA == -TL){
  dfSpread4DurationCurve4$Spread4DurationCurve4[MaxInstruments+1] <- NA
} else {
  dfSpread4DurationCurve4$Spread4DurationCurve4[MaxInstruments+1] <- (SRMA*TA + SRML*TL)/(TA + TL)
}
dfSpread4DurationCurve4$Spread4DurationCurve4[MaxInstruments+2] <- SRMA
dfSpread4DurationCurve4$Spread4DurationCurve4[MaxInstruments+3] <- SRML
# Curvature 5
dfSpread4DurationCurve5 <- ddply(dfStaticRiskMeasures, .(Instrument), summarize, 
                              dfStaticRiskMeasures=sum(Spread4DurationCurve5))
dfSpread4DurationCurve5$Spread4DurationCurve5 <- dfSpread4DurationCurve5$dfStaticRiskMeasures
dfSpread4DurationCurve5$dfStaticRiskMeasures <- NULL
# Compute Static Risk Measure for Net Worth
dfSpread4DurationCurve5 <- rbind(dfSpread4DurationCurve5, y = c(MaxInstruments+1, NA))
dfSpread4DurationCurve5 <- rbind(dfSpread4DurationCurve5, y = c(MaxInstruments+2, NA))
dfSpread4DurationCurve5 <- rbind(dfSpread4DurationCurve5, y = c(MaxInstruments+3, NA))
TA <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+2]
TL <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+3]
SRMA <- 0.0
for(i in 1:NumberOfAssets){
  SRMA <- SRMA + dfSpread4DurationCurve5$Spread4DurationCurve5[i] * (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[i]/TA)
}
SRML <- 0.0
for(i in 1:NumberOfLiabilities){
  SRML <- SRML + dfSpread4DurationCurve5$Spread4DurationCurve5[NumberOfAssets+i] * 
    (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[NumberOfAssets+i]/TL)
}
if(TA == -TL){
  dfSpread4DurationCurve5$Spread4DurationCurve5[MaxInstruments+1] <- NA
} else {
  dfSpread4DurationCurve5$Spread4DurationCurve5[MaxInstruments+1] <- (SRMA*TA + SRML*TL)/(TA + TL)
}
dfSpread4DurationCurve5$Spread4DurationCurve5[MaxInstruments+2] <- SRMA
dfSpread4DurationCurve5$Spread4DurationCurve5[MaxInstruments+3] <- SRML
# dfPVBalanceSheet
# dfPVBalanceSheetAtHorizon
# dfSpread4DurationLevel
# dfSpread4DurationSlope
# dfSpread4DurationCurve1
# dfSpread4DurationCurve2
# dfSpread4DurationCurve3
# dfSpread4DurationCurve4
# dfSpread4DurationCurve5
#
# Spread4 Convexity
#
dfStaticRiskMeasures$Spread4ConvexityLevel <- (M^2) * 1.0 * W * CW
dfStaticRiskMeasures$Spread4ConvexitySlope <- (M^2) * (x1^2) * W * CW
dfStaticRiskMeasures$Spread4ConvexityCurve1 <- (M^2) * (x2^2) * W * CW
dfStaticRiskMeasures$Spread4ConvexityCurve2 <- (M^2) * (x3^2) * W * CW
dfStaticRiskMeasures$Spread4ConvexityCurve3 <- (M^2) * (x4^2) * W * CW
dfStaticRiskMeasures$Spread4ConvexityCurve4 <- (M^2) * (x5^2) * W * CW
dfStaticRiskMeasures$Spread4ConvexityCurve5 <- (M^2) * (x6^2) * W * CW
# Level
dfSpread4ConvexityLevel <- ddply(dfStaticRiskMeasures, .(Instrument), summarize, 
  dfStaticRiskMeasures=sum(Spread4ConvexityLevel))
dfSpread4ConvexityLevel$Spread4ConvexityLevel <- dfSpread4ConvexityLevel$dfStaticRiskMeasures
dfSpread4ConvexityLevel$dfStaticRiskMeasures <- NULL
# Compute Static Risk Measure for Net Worth
dfSpread4ConvexityLevel <- rbind(dfSpread4ConvexityLevel, y = c(MaxInstruments+1, NA))
dfSpread4ConvexityLevel <- rbind(dfSpread4ConvexityLevel, y = c(MaxInstruments+2, NA))
dfSpread4ConvexityLevel <- rbind(dfSpread4ConvexityLevel, y = c(MaxInstruments+3, NA))
TA <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+2]
TL <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+3]
SRMA <- 0.0
for(i in 1:NumberOfAssets){
  SRMA <- SRMA + dfSpread4ConvexityLevel$Spread4ConvexityLevel[i] * (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[i]/TA)
}
SRML <- 0.0
for(i in 1:NumberOfLiabilities){
  SRML <- SRML + dfSpread4ConvexityLevel$Spread4ConvexityLevel[NumberOfAssets+i] * 
    (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[NumberOfAssets+i]/TL)
}
if(TA == -TL){
  dfSpread4ConvexityLevel$Spread4ConvexityLevel[MaxInstruments+1] <- NA
} else {
  dfSpread4ConvexityLevel$Spread4ConvexityLevel[MaxInstruments+1] <- (SRMA*TA + SRML*TL)/(TA + TL)
}
dfSpread4ConvexityLevel$Spread4ConvexityLevel[MaxInstruments+2] <- SRMA
dfSpread4ConvexityLevel$Spread4ConvexityLevel[MaxInstruments+3] <- SRML
dfSpread4ConvexityLevel
# Slope
dfSpread4ConvexitySlope <- ddply(dfStaticRiskMeasures, .(Instrument), summarize, 
                             dfStaticRiskMeasures=sum(Spread4ConvexitySlope))
dfSpread4ConvexitySlope$Spread4ConvexitySlope <- dfSpread4ConvexitySlope$dfStaticRiskMeasures
dfSpread4ConvexitySlope$dfStaticRiskMeasures <- NULL
# Compute Static Risk Measure for Net Worth
dfSpread4ConvexitySlope <- rbind(dfSpread4ConvexitySlope, y = c(MaxInstruments+1, NA))
dfSpread4ConvexitySlope <- rbind(dfSpread4ConvexitySlope, y = c(MaxInstruments+2, NA))
dfSpread4ConvexitySlope <- rbind(dfSpread4ConvexitySlope, y = c(MaxInstruments+3, NA))
TA <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+2]
TL <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+3]
SRMA <- 0.0
for(i in 1:NumberOfAssets){
  SRMA <- SRMA + dfSpread4ConvexitySlope$Spread4ConvexitySlope[i] * (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[i]/TA)
}
SRML <- 0.0
for(i in 1:NumberOfLiabilities){
  SRML <- SRML + dfSpread4ConvexitySlope$Spread4ConvexitySlope[NumberOfAssets+i] * 
    (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[NumberOfAssets+i]/TL)
}
if(TA == -TL){
  dfSpread4ConvexitySlope$Spread4ConvexitySlope[MaxInstruments+1] <- NA
} else {
  dfSpread4ConvexitySlope$Spread4ConvexitySlope[MaxInstruments+1] <- (SRMA*TA + SRML*TL)/(TA + TL)
}
dfSpread4ConvexitySlope$Spread4ConvexitySlope[MaxInstruments+2] <- SRMA
dfSpread4ConvexitySlope$Spread4ConvexitySlope[MaxInstruments+3] <- SRML
dfSpread4ConvexitySlope
# Curvature 1
dfSpread4ConvexityCurve1 <- ddply(dfStaticRiskMeasures, .(Instrument), summarize, 
                              dfStaticRiskMeasures=sum(Spread4ConvexityCurve1))
dfSpread4ConvexityCurve1$Spread4ConvexityCurve1 <- dfSpread4ConvexityCurve1$dfStaticRiskMeasures
dfSpread4ConvexityCurve1$dfStaticRiskMeasures <- NULL
# Compute Static Risk Measure for Net Worth
dfSpread4ConvexityCurve1 <- rbind(dfSpread4ConvexityCurve1, y = c(MaxInstruments+1, NA))
dfSpread4ConvexityCurve1 <- rbind(dfSpread4ConvexityCurve1, y = c(MaxInstruments+2, NA))
dfSpread4ConvexityCurve1 <- rbind(dfSpread4ConvexityCurve1, y = c(MaxInstruments+3, NA))
TA <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+2]
TL <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+3]
SRMA <- 0.0
for(i in 1:NumberOfAssets){
  SRMA <- SRMA + dfSpread4ConvexityCurve1$Spread4ConvexityCurve1[i] * (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[i]/TA)
}
SRML <- 0.0
for(i in 1:NumberOfLiabilities){
  SRML <- SRML + dfSpread4ConvexityCurve1$Spread4ConvexityCurve1[NumberOfAssets+i] * 
    (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[NumberOfAssets+i]/TL)
}
if(TA == -TL){
  dfSpread4ConvexityCurve1$Spread4ConvexityCurve1[MaxInstruments+1] <- NA
} else {
  dfSpread4ConvexityCurve1$Spread4ConvexityCurve1[MaxInstruments+1] <- (SRMA*TA + SRML*TL)/(TA + TL)
}
dfSpread4ConvexityCurve1$Spread4ConvexityCurve1[MaxInstruments+2] <- SRMA
dfSpread4ConvexityCurve1$Spread4ConvexityCurve1[MaxInstruments+3] <- SRML
dfSpread4ConvexityCurve1
# Curvature 2
dfSpread4ConvexityCurve2 <- ddply(dfStaticRiskMeasures, .(Instrument), summarize, 
                              dfStaticRiskMeasures=sum(Spread4ConvexityCurve2))
dfSpread4ConvexityCurve2$Spread4ConvexityCurve2 <- dfSpread4ConvexityCurve2$dfStaticRiskMeasures
dfSpread4ConvexityCurve2$dfStaticRiskMeasures <- NULL
# Compute Static Risk Measure for Net Worth
dfSpread4ConvexityCurve2 <- rbind(dfSpread4ConvexityCurve2, y = c(MaxInstruments+1, NA))
dfSpread4ConvexityCurve2 <- rbind(dfSpread4ConvexityCurve2, y = c(MaxInstruments+2, NA))
dfSpread4ConvexityCurve2 <- rbind(dfSpread4ConvexityCurve2, y = c(MaxInstruments+3, NA))
TA <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+2]
TL <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+3]
SRMA <- 0.0
for(i in 1:NumberOfAssets){
  SRMA <- SRMA + dfSpread4ConvexityCurve2$Spread4ConvexityCurve2[i] * (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[i]/TA)
}
SRML <- 0.0
for(i in 1:NumberOfLiabilities){
  SRML <- SRML + dfSpread4ConvexityCurve2$Spread4ConvexityCurve2[NumberOfAssets+i] * 
    (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[NumberOfAssets+i]/TL)
}
if(TA == -TL){
  dfSpread4ConvexityCurve2$Spread4ConvexityCurve2[MaxInstruments+1] <- NA
} else {
  dfSpread4ConvexityCurve2$Spread4ConvexityCurve2[MaxInstruments+1] <- (SRMA*TA + SRML*TL)/(TA + TL)
}
dfSpread4ConvexityCurve2$Spread4ConvexityCurve2[MaxInstruments+2] <- SRMA
dfSpread4ConvexityCurve2$Spread4ConvexityCurve2[MaxInstruments+3] <- SRML
# Curvature 3
dfSpread4ConvexityCurve3 <- ddply(dfStaticRiskMeasures, .(Instrument), summarize, 
                              dfStaticRiskMeasures=sum(Spread4ConvexityCurve3))
dfSpread4ConvexityCurve3$Spread4ConvexityCurve3 <- dfSpread4ConvexityCurve3$dfStaticRiskMeasures
dfSpread4ConvexityCurve3$dfStaticRiskMeasures <- NULL
# Compute Static Risk Measure for Net Worth
dfSpread4ConvexityCurve3 <- rbind(dfSpread4ConvexityCurve3, y = c(MaxInstruments+1, NA))
dfSpread4ConvexityCurve3 <- rbind(dfSpread4ConvexityCurve3, y = c(MaxInstruments+2, NA))
dfSpread4ConvexityCurve3 <- rbind(dfSpread4ConvexityCurve3, y = c(MaxInstruments+3, NA))
TA <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+2]
TL <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+3]
SRMA <- 0.0
for(i in 1:NumberOfAssets){
  SRMA <- SRMA + dfSpread4ConvexityCurve3$Spread4ConvexityCurve3[i] * (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[i]/TA)
}
SRML <- 0.0
for(i in 1:NumberOfLiabilities){
  SRML <- SRML + dfSpread4ConvexityCurve3$Spread4ConvexityCurve3[NumberOfAssets+i] * 
    (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[NumberOfAssets+i]/TL)
}
if(TA == -TL){
  dfSpread4ConvexityCurve3$Spread4ConvexityCurve3[MaxInstruments+1] <- NA
} else {
  dfSpread4ConvexityCurve3$Spread4ConvexityCurve3[MaxInstruments+1] <- (SRMA*TA + SRML*TL)/(TA + TL)
}
dfSpread4ConvexityCurve3$Spread4ConvexityCurve3[MaxInstruments+2] <- SRMA
dfSpread4ConvexityCurve3$Spread4ConvexityCurve3[MaxInstruments+3] <- SRML
# Curvature 4
dfSpread4ConvexityCurve4 <- ddply(dfStaticRiskMeasures, .(Instrument), summarize, 
                              dfStaticRiskMeasures=sum(Spread4ConvexityCurve4))
dfSpread4ConvexityCurve4$Spread4ConvexityCurve4 <- dfSpread4ConvexityCurve4$dfStaticRiskMeasures
dfSpread4ConvexityCurve4$dfStaticRiskMeasures <- NULL
# Compute Static Risk Measure for Net Worth
dfSpread4ConvexityCurve4 <- rbind(dfSpread4ConvexityCurve4, y = c(MaxInstruments+1, NA))
dfSpread4ConvexityCurve4 <- rbind(dfSpread4ConvexityCurve4, y = c(MaxInstruments+2, NA))
dfSpread4ConvexityCurve4 <- rbind(dfSpread4ConvexityCurve4, y = c(MaxInstruments+3, NA))
TA <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+2]
TL <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+3]
SRMA <- 0.0
for(i in 1:NumberOfAssets){
  SRMA <- SRMA + dfSpread4ConvexityCurve4$Spread4ConvexityCurve4[i] * (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[i]/TA)
}
SRML <- 0.0
for(i in 1:NumberOfLiabilities){
  SRML <- SRML + dfSpread4ConvexityCurve4$Spread4ConvexityCurve4[NumberOfAssets+i] * 
    (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[NumberOfAssets+i]/TL)
}
if(TA == -TL){
  dfSpread4ConvexityCurve4$Spread4ConvexityCurve4[MaxInstruments+1] <- NA
} else {
  dfSpread4ConvexityCurve4$Spread4ConvexityCurve4[MaxInstruments+1] <- (SRMA*TA + SRML*TL)/(TA + TL)
}
dfSpread4ConvexityCurve4$Spread4ConvexityCurve4[MaxInstruments+2] <- SRMA
dfSpread4ConvexityCurve4$Spread4ConvexityCurve4[MaxInstruments+3] <- SRML
# Curvature 5
dfSpread4ConvexityCurve5 <- ddply(dfStaticRiskMeasures, .(Instrument), summarize, 
                              dfStaticRiskMeasures=sum(Spread4ConvexityCurve5))
dfSpread4ConvexityCurve5$Spread4ConvexityCurve5 <- dfSpread4ConvexityCurve5$dfStaticRiskMeasures
dfSpread4ConvexityCurve5$dfStaticRiskMeasures <- NULL
# Compute Static Risk Measure for Net Worth
dfSpread4ConvexityCurve5 <- rbind(dfSpread4ConvexityCurve5, y = c(MaxInstruments+1, NA))
dfSpread4ConvexityCurve5 <- rbind(dfSpread4ConvexityCurve5, y = c(MaxInstruments+2, NA))
dfSpread4ConvexityCurve5 <- rbind(dfSpread4ConvexityCurve5, y = c(MaxInstruments+3, NA))
TA <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+2]
TL <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+3]
SRMA <- 0.0
for(i in 1:NumberOfAssets){
  SRMA <- SRMA + dfSpread4ConvexityCurve5$Spread4ConvexityCurve5[i] * (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[i]/TA)
}
SRML <- 0.0
for(i in 1:NumberOfLiabilities){
  SRML <- SRML + dfSpread4ConvexityCurve5$Spread4ConvexityCurve5[NumberOfAssets+i] * 
    (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[NumberOfAssets+i]/TL)
}
if(TA == -TL){
  dfSpread4ConvexityCurve5$Spread4ConvexityCurve5[MaxInstruments+1] <- NA
} else {
  dfSpread4ConvexityCurve5$Spread4ConvexityCurve5[MaxInstruments+1] <- (SRMA*TA + SRML*TL)/(TA + TL)
}
dfSpread4ConvexityCurve5$Spread4ConvexityCurve5[MaxInstruments+2] <- SRMA
dfSpread4ConvexityCurve5$Spread4ConvexityCurve5[MaxInstruments+3] <- SRML
# dfPVBalanceSheet
# dfPVBalanceSheetAtHorizon
# dfSpread4ConvexityLevel
# dfSpread4ConvexitySlope
# dfSpread4ConvexityCurve1
# dfSpread4ConvexityCurve2
# dfSpread4ConvexityCurve3
# dfSpread4ConvexityCurve4
# dfSpread4ConvexityCurve5
#
# Spread4 Cross Convexiities (19!)
#
# Level x _____
dfStaticRiskMeasures$Spread4CrossConvexityCCLS <- (M^2) * 1.0 * x1 * W * CW
dfStaticRiskMeasures$Spread4CrossConvexityCCLC1 <- (M^2) * 1.0 * x2 * W * CW
dfStaticRiskMeasures$Spread4CrossConvexityCCLC2 <- (M^2) * 1.0 * x3 * W * CW
dfStaticRiskMeasures$Spread4CrossConvexityCCLC3 <- (M^2) * 1.0 * x4 * W * CW
dfStaticRiskMeasures$Spread4CrossConvexityCCLC4 <- (M^2) * 1.0 * x5 * W * CW
dfStaticRiskMeasures$Spread4CrossConvexityCCLC5 <- (M^2) * 1.0 * x6 * W * CW
# Slope x _____
dfStaticRiskMeasures$Spread4CrossConvexityCCSC1 <- (M^2) * x1 * x2 * W * CW
dfStaticRiskMeasures$Spread4CrossConvexityCCSC2 <- (M^2) * x1 * x3 * W * CW
dfStaticRiskMeasures$Spread4CrossConvexityCCSC3 <- (M^2) * x1 * x4 * W * CW
dfStaticRiskMeasures$Spread4CrossConvexityCCSC4 <- (M^2) * x1 * x5 * W * CW
dfStaticRiskMeasures$Spread4CrossConvexityCCSC5 <- (M^2) * x1 * x6 * W * CW
# Curve1 x _____
dfStaticRiskMeasures$Spread4CrossConvexityCCC1C2 <- (M^2) * x2 * x3 * W * CW
dfStaticRiskMeasures$Spread4CrossConvexityCCC1C3 <- (M^2) * x2 * x4 * W * CW
dfStaticRiskMeasures$Spread4CrossConvexityCCC1C4 <- (M^2) * x2 * x5 * W * CW
dfStaticRiskMeasures$Spread4CrossConvexityCCC1C5 <- (M^2) * x2 * x6 * W * CW
# Curve2 x _____
dfStaticRiskMeasures$Spread4CrossConvexityCCC2C3 <- (M^2) * x3 * x4 * W * CW
dfStaticRiskMeasures$Spread4CrossConvexityCCC2C4 <- (M^2) * x3 * x5 * W * CW
dfStaticRiskMeasures$Spread4CrossConvexityCCC2C5 <- (M^2) * x3 * x6 * W * CW
# Curve4 x _____
dfStaticRiskMeasures$Spread4CrossConvexityCCC3C4 <- (M^2) * x4 * x5 * W * CW
dfStaticRiskMeasures$Spread4CrossConvexityCCC3C5 <- (M^2) * x4 * x6 * W * CW
# Curve5 x _____
dfStaticRiskMeasures$Spread4CrossConvexityCCC4C5 <- (M^2) * x5 * x6 * W * CW
# Level x Slope (CCLS)
dfSpread4CrossConvexityCCLS <- ddply(dfStaticRiskMeasures, .(Instrument), summarize, 
                             dfStaticRiskMeasures=sum(Spread4CrossConvexityCCLS))
dfSpread4CrossConvexityCCLS$Spread4CrossConvexityCCLS <- dfSpread4CrossConvexityCCLS$dfStaticRiskMeasures
dfSpread4CrossConvexityCCLS$dfStaticRiskMeasures <- NULL
# Compute Static Risk Measure for Net Worth
dfSpread4CrossConvexityCCLS <- rbind(dfSpread4CrossConvexityCCLS, y = c(MaxInstruments+1, NA))
dfSpread4CrossConvexityCCLS <- rbind(dfSpread4CrossConvexityCCLS, y = c(MaxInstruments+2, NA))
dfSpread4CrossConvexityCCLS <- rbind(dfSpread4CrossConvexityCCLS, y = c(MaxInstruments+3, NA))
TA <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+2]
TL <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+3]
SRMA <- 0.0
for(i in 1:NumberOfAssets){
  SRMA <- SRMA + dfSpread4CrossConvexityCCLS$Spread4CrossConvexityCCLS[i] * (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[i]/TA)
}
SRML <- 0.0
for(i in 1:NumberOfLiabilities){
  SRML <- SRML + dfSpread4CrossConvexityCCLS$Spread4CrossConvexityCCLS[NumberOfAssets+i] * 
    (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[NumberOfAssets+i]/TL)
}
if(TA == -TL){
  dfSpread4CrossConvexityCCLS$Spread4CrossConvexityCCLS[MaxInstruments+1] <- NA
} else {
  dfSpread4CrossConvexityCCLS$Spread4CrossConvexityCCLS[MaxInstruments+1] <- (SRMA*TA + SRML*TL)/(TA + TL)
}
dfSpread4CrossConvexityCCLS$Spread4CrossConvexityCCLS[MaxInstruments+2] <- SRMA
dfSpread4CrossConvexityCCLS$Spread4CrossConvexityCCLS[MaxInstruments+3] <- SRML



# Level x Curve1 (CCLC1)
dfSpread4CrossConvexityCCLC1 <- ddply(dfStaticRiskMeasures, .(Instrument), summarize, 
                            dfStaticRiskMeasures=sum(Spread4CrossConvexityCCLC1))
dfSpread4CrossConvexityCCLC1$Spread4CrossConvexityCCLC1 <- dfSpread4CrossConvexityCCLC1$dfStaticRiskMeasures
dfSpread4CrossConvexityCCLC1$dfStaticRiskMeasures <- NULL
# Compute Static Risk Measure for Net Worth
dfSpread4CrossConvexityCCLC1 <- rbind(dfSpread4CrossConvexityCCLC1, y = c(MaxInstruments+1, NA))
dfSpread4CrossConvexityCCLC1 <- rbind(dfSpread4CrossConvexityCCLC1, y = c(MaxInstruments+2, NA))
dfSpread4CrossConvexityCCLC1 <- rbind(dfSpread4CrossConvexityCCLC1, y = c(MaxInstruments+3, NA))
TA <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+2]
TL <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+3]
SRMA <- 0.0
for(i in 1:NumberOfAssets){
  SRMA <- SRMA + dfSpread4CrossConvexityCCLC1$Spread4CrossConvexityCCLC1[i] * (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[i]/TA)
}
SRML <- 0.0
for(i in 1:NumberOfLiabilities){
  SRML <- SRML + dfSpread4CrossConvexityCCLC1$Spread4CrossConvexityCCLC1[NumberOfAssets+i] * 
    (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[NumberOfAssets+i]/TL)
}
if(TA == -TL){
  dfSpread4CrossConvexityCCLC1$Spread4CrossConvexityCCLC1[MaxInstruments+1] <- NA
} else {
  dfSpread4CrossConvexityCCLC1$Spread4CrossConvexityCCLC1[MaxInstruments+1] <- (SRMA*TA + SRML*TL)/(TA + TL)
}
dfSpread4CrossConvexityCCLC1$Spread4CrossConvexityCCLC1[MaxInstruments+2] <- SRMA
dfSpread4CrossConvexityCCLC1$Spread4CrossConvexityCCLC1[MaxInstruments+3] <- SRML
# Level x Curve2 (CCLC2)
dfSpread4CrossConvexityCCLC2 <- ddply(dfStaticRiskMeasures, .(Instrument), summarize, 
                             dfStaticRiskMeasures=sum(Spread4CrossConvexityCCLC2))
dfSpread4CrossConvexityCCLC2$Spread4CrossConvexityCCLC2 <- dfSpread4CrossConvexityCCLC2$dfStaticRiskMeasures
dfSpread4CrossConvexityCCLC2$dfStaticRiskMeasures <- NULL
# Compute Static Risk Measure for Net Worth
dfSpread4CrossConvexityCCLC2 <- rbind(dfSpread4CrossConvexityCCLC2, y = c(MaxInstruments+1, NA))
dfSpread4CrossConvexityCCLC2 <- rbind(dfSpread4CrossConvexityCCLC2, y = c(MaxInstruments+2, NA))
dfSpread4CrossConvexityCCLC2 <- rbind(dfSpread4CrossConvexityCCLC2, y = c(MaxInstruments+3, NA))
TA <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+2]
TL <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+3]
SRMA <- 0.0
for(i in 1:NumberOfAssets){
  SRMA <- SRMA + dfSpread4CrossConvexityCCLC2$Spread4CrossConvexityCCLC2[i] * (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[i]/TA)
}
SRML <- 0.0
for(i in 1:NumberOfLiabilities){
  SRML <- SRML + dfSpread4CrossConvexityCCLC2$Spread4CrossConvexityCCLC2[NumberOfAssets+i] * 
    (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[NumberOfAssets+i]/TL)
}
if(TA == -TL){
  dfSpread4CrossConvexityCCLC2$Spread4CrossConvexityCCLC2[MaxInstruments+1] <- NA
} else {
  dfSpread4CrossConvexityCCLC2$Spread4CrossConvexityCCLC2[MaxInstruments+1] <- (SRMA*TA + SRML*TL)/(TA + TL)
}
dfSpread4CrossConvexityCCLC2$Spread4CrossConvexityCCLC2[MaxInstruments+2] <- SRMA
dfSpread4CrossConvexityCCLC2$Spread4CrossConvexityCCLC2[MaxInstruments+3] <- SRML
# Level x Curve3 (CCLC3)
dfSpread4CrossConvexityCCLC3 <- ddply(dfStaticRiskMeasures, .(Instrument), summarize, 
                             dfStaticRiskMeasures=sum(Spread4CrossConvexityCCLC3))
dfSpread4CrossConvexityCCLC3$Spread4CrossConvexityCCLC3 <- dfSpread4CrossConvexityCCLC3$dfStaticRiskMeasures
dfSpread4CrossConvexityCCLC3$dfStaticRiskMeasures <- NULL
# Compute Static Risk Measure for Net Worth
dfSpread4CrossConvexityCCLC3 <- rbind(dfSpread4CrossConvexityCCLC3, y = c(MaxInstruments+1, NA))
dfSpread4CrossConvexityCCLC3 <- rbind(dfSpread4CrossConvexityCCLC3, y = c(MaxInstruments+2, NA))
dfSpread4CrossConvexityCCLC3 <- rbind(dfSpread4CrossConvexityCCLC3, y = c(MaxInstruments+3, NA))
TA <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+2]
TL <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+3]
SRMA <- 0.0
for(i in 1:NumberOfAssets){
  SRMA <- SRMA + dfSpread4CrossConvexityCCLC3$Spread4CrossConvexityCCLC3[i] * (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[i]/TA)
}
SRML <- 0.0
for(i in 1:NumberOfLiabilities){
  SRML <- SRML + dfSpread4CrossConvexityCCLC3$Spread4CrossConvexityCCLC3[NumberOfAssets+i] * 
    (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[NumberOfAssets+i]/TL)
}
if(TA == -TL){
  dfSpread4CrossConvexityCCLC3$Spread4CrossConvexityCCLC3[MaxInstruments+1] <- NA
} else {
  dfSpread4CrossConvexityCCLC3$Spread4CrossConvexityCCLC3[MaxInstruments+1] <- (SRMA*TA + SRML*TL)/(TA + TL)
}
dfSpread4CrossConvexityCCLC3$Spread4CrossConvexityCCLC3[MaxInstruments+2] <- SRMA
dfSpread4CrossConvexityCCLC3$Spread4CrossConvexityCCLC3[MaxInstruments+3] <- SRML
# Level x Curve4 (CCLC4)
dfSpread4CrossConvexityCCLC4 <- ddply(dfStaticRiskMeasures, .(Instrument), summarize, 
                             dfStaticRiskMeasures=sum(Spread4CrossConvexityCCLC4))
dfSpread4CrossConvexityCCLC4$Spread4CrossConvexityCCLC4 <- dfSpread4CrossConvexityCCLC4$dfStaticRiskMeasures
dfSpread4CrossConvexityCCLC4$dfStaticRiskMeasures <- NULL
# Compute Static Risk Measure for Net Worth
dfSpread4CrossConvexityCCLC4 <- rbind(dfSpread4CrossConvexityCCLC4, y = c(MaxInstruments+1, NA))
dfSpread4CrossConvexityCCLC4 <- rbind(dfSpread4CrossConvexityCCLC4, y = c(MaxInstruments+2, NA))
dfSpread4CrossConvexityCCLC4 <- rbind(dfSpread4CrossConvexityCCLC4, y = c(MaxInstruments+3, NA))
TA <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+2]
TL <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+3]
SRMA <- 0.0
for(i in 1:NumberOfAssets){
  SRMA <- SRMA + dfSpread4CrossConvexityCCLC4$Spread4CrossConvexityCCLC4[i] * (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[i]/TA)
}
SRML <- 0.0
for(i in 1:NumberOfLiabilities){
  SRML <- SRML + dfSpread4CrossConvexityCCLC4$Spread4CrossConvexityCCLC4[NumberOfAssets+i] * 
    (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[NumberOfAssets+i]/TL)
}
if(TA == -TL){
  dfSpread4CrossConvexityCCLC4$Spread4CrossConvexityCCLC4[MaxInstruments+1] <- NA
} else {
  dfSpread4CrossConvexityCCLC4$Spread4CrossConvexityCCLC4[MaxInstruments+1] <- (SRMA*TA + SRML*TL)/(TA + TL)
}
dfSpread4CrossConvexityCCLC4$Spread4CrossConvexityCCLC4[MaxInstruments+2] <- SRMA
dfSpread4CrossConvexityCCLC4$Spread4CrossConvexityCCLC4[MaxInstruments+3] <- SRML
# Level x Curve5 (CCLC5)
dfSpread4CrossConvexityCCLC5 <- ddply(dfStaticRiskMeasures, .(Instrument), summarize, 
                             dfStaticRiskMeasures=sum(Spread4CrossConvexityCCLC5))
dfSpread4CrossConvexityCCLC5$Spread4CrossConvexityCCLC5 <- dfSpread4CrossConvexityCCLC5$dfStaticRiskMeasures
dfSpread4CrossConvexityCCLC5$dfStaticRiskMeasures <- NULL
# Compute Static Risk Measure for Net Worth
dfSpread4CrossConvexityCCLC5 <- rbind(dfSpread4CrossConvexityCCLC5, y = c(MaxInstruments+1, NA))
dfSpread4CrossConvexityCCLC5 <- rbind(dfSpread4CrossConvexityCCLC5, y = c(MaxInstruments+2, NA))
dfSpread4CrossConvexityCCLC5 <- rbind(dfSpread4CrossConvexityCCLC5, y = c(MaxInstruments+3, NA))
TA <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+2]
TL <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+3]
SRMA <- 0.0
for(i in 1:NumberOfAssets){
  SRMA <- SRMA + dfSpread4CrossConvexityCCLC5$Spread4CrossConvexityCCLC5[i] * (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[i]/TA)
}
SRML <- 0.0
for(i in 1:NumberOfLiabilities){
  SRML <- SRML + dfSpread4CrossConvexityCCLC5$Spread4CrossConvexityCCLC5[NumberOfAssets+i] * 
    (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[NumberOfAssets+i]/TL)
}
if(TA == -TL){
  dfSpread4CrossConvexityCCLC5$Spread4CrossConvexityCCLC5[MaxInstruments+1] <- NA
} else {
  dfSpread4CrossConvexityCCLC5$Spread4CrossConvexityCCLC5[MaxInstruments+1] <- (SRMA*TA + SRML*TL)/(TA + TL)
}
dfSpread4CrossConvexityCCLC5$Spread4CrossConvexityCCLC5[MaxInstruments+2] <- SRMA
dfSpread4CrossConvexityCCLC5$Spread4CrossConvexityCCLC5[MaxInstruments+3] <- SRML
# dfSpread4CrossConvexityCCLS
# dfSpread4CrossConvexityCCLC1
# dfSpread4CrossConvexityCCLC2
# dfSpread4CrossConvexityCCLC3
# dfSpread4CrossConvexityCCLC4
# dfSpread4CrossConvexityCCLC5
# Slope x Curve1 (CCSC1)
dfSpread4CrossConvexityCCSC1 <- ddply(dfStaticRiskMeasures, .(Instrument), summarize, 
                             dfStaticRiskMeasures=sum(Spread4CrossConvexityCCSC1))
dfSpread4CrossConvexityCCSC1$Spread4CrossConvexityCCSC1 <- dfSpread4CrossConvexityCCSC1$dfStaticRiskMeasures
dfSpread4CrossConvexityCCSC1$dfStaticRiskMeasures <- NULL
# Compute Static Risk Measure for Net Worth
dfSpread4CrossConvexityCCSC1 <- rbind(dfSpread4CrossConvexityCCSC1, y = c(MaxInstruments+1, NA))
dfSpread4CrossConvexityCCSC1 <- rbind(dfSpread4CrossConvexityCCSC1, y = c(MaxInstruments+2, NA))
dfSpread4CrossConvexityCCSC1 <- rbind(dfSpread4CrossConvexityCCSC1, y = c(MaxInstruments+3, NA))
TA <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+2]
TL <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+3]
SRMA <- 0.0
for(i in 1:NumberOfAssets){
  SRMA <- SRMA + dfSpread4CrossConvexityCCSC1$Spread4CrossConvexityCCSC1[i] * (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[i]/TA)
}
SRML <- 0.0
for(i in 1:NumberOfLiabilities){
  SRML <- SRML + dfSpread4CrossConvexityCCSC1$Spread4CrossConvexityCCSC1[NumberOfAssets+i] * 
    (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[NumberOfAssets+i]/TL)
}
if(TA == -TL){
  dfSpread4CrossConvexityCCSC1$Spread4CrossConvexityCCSC1[MaxInstruments+1] <- NA
} else {
  dfSpread4CrossConvexityCCSC1$Spread4CrossConvexityCCSC1[MaxInstruments+1] <- (SRMA*TA + SRML*TL)/(TA + TL)
}
dfSpread4CrossConvexityCCSC1$Spread4CrossConvexityCCSC1[MaxInstruments+2] <- SRMA
dfSpread4CrossConvexityCCSC1$Spread4CrossConvexityCCSC1[MaxInstruments+3] <- SRML
# Level x Curve2 (CCSC2)
dfSpread4CrossConvexityCCSC2 <- ddply(dfStaticRiskMeasures, .(Instrument), summarize, 
                             dfStaticRiskMeasures=sum(Spread4CrossConvexityCCSC2))
dfSpread4CrossConvexityCCSC2$Spread4CrossConvexityCCSC2 <- dfSpread4CrossConvexityCCSC2$dfStaticRiskMeasures
dfSpread4CrossConvexityCCSC2$dfStaticRiskMeasures <- NULL
# Compute Static Risk Measure for Net Worth
dfSpread4CrossConvexityCCSC2 <- rbind(dfSpread4CrossConvexityCCSC2, y = c(MaxInstruments+1, NA))
dfSpread4CrossConvexityCCSC2 <- rbind(dfSpread4CrossConvexityCCSC2, y = c(MaxInstruments+2, NA))
dfSpread4CrossConvexityCCSC2 <- rbind(dfSpread4CrossConvexityCCSC2, y = c(MaxInstruments+3, NA))
TA <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+2]
TL <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+3]
SRMA <- 0.0
for(i in 1:NumberOfAssets){
  SRMA <- SRMA + dfSpread4CrossConvexityCCSC2$Spread4CrossConvexityCCSC2[i] * (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[i]/TA)
}
SRML <- 0.0
for(i in 1:NumberOfLiabilities){
  SRML <- SRML + dfSpread4CrossConvexityCCSC2$Spread4CrossConvexityCCSC2[NumberOfAssets+i] * 
    (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[NumberOfAssets+i]/TL)
}
if(TA == -TL){
  dfSpread4CrossConvexityCCSC2$Spread4CrossConvexityCCSC2[MaxInstruments+1] <- NA
} else {
  dfSpread4CrossConvexityCCSC2$Spread4CrossConvexityCCSC2[MaxInstruments+1] <- (SRMA*TA + SRML*TL)/(TA + TL)
}
dfSpread4CrossConvexityCCSC2$Spread4CrossConvexityCCSC2[MaxInstruments+2] <- SRMA
dfSpread4CrossConvexityCCSC2$Spread4CrossConvexityCCSC2[MaxInstruments+3] <- SRML
# Level x Curve3 (CCSC3)
dfSpread4CrossConvexityCCSC3 <- ddply(dfStaticRiskMeasures, .(Instrument), summarize, 
                             dfStaticRiskMeasures=sum(Spread4CrossConvexityCCSC3))
dfSpread4CrossConvexityCCSC3$Spread4CrossConvexityCCSC3 <- dfSpread4CrossConvexityCCSC3$dfStaticRiskMeasures
dfSpread4CrossConvexityCCSC3$dfStaticRiskMeasures <- NULL
# Compute Static Risk Measure for Net Worth
dfSpread4CrossConvexityCCSC3 <- rbind(dfSpread4CrossConvexityCCSC3, y = c(MaxInstruments+1, NA))
dfSpread4CrossConvexityCCSC3 <- rbind(dfSpread4CrossConvexityCCSC3, y = c(MaxInstruments+2, NA))
dfSpread4CrossConvexityCCSC3 <- rbind(dfSpread4CrossConvexityCCSC3, y = c(MaxInstruments+3, NA))
TA <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+2]
TL <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+3]
SRMA <- 0.0
for(i in 1:NumberOfAssets){
  SRMA <- SRMA + dfSpread4CrossConvexityCCSC3$Spread4CrossConvexityCCSC3[i] * (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[i]/TA)
}
SRML <- 0.0
for(i in 1:NumberOfLiabilities){
  SRML <- SRML + dfSpread4CrossConvexityCCSC3$Spread4CrossConvexityCCSC3[NumberOfAssets+i] * 
    (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[NumberOfAssets+i]/TL)
}
if(TA == -TL){
  dfSpread4CrossConvexityCCSC3$Spread4CrossConvexityCCSC3[MaxInstruments+1] <- NA
} else {
  dfSpread4CrossConvexityCCSC3$Spread4CrossConvexityCCSC3[MaxInstruments+1] <- (SRMA*TA + SRML*TL)/(TA + TL)
}
dfSpread4CrossConvexityCCSC3$Spread4CrossConvexityCCSC3[MaxInstruments+2] <- SRMA
dfSpread4CrossConvexityCCSC3$Spread4CrossConvexityCCSC3[MaxInstruments+3] <- SRML
# Level x Curve4 (CCSC4)
dfSpread4CrossConvexityCCSC4 <- ddply(dfStaticRiskMeasures, .(Instrument), summarize, 
                             dfStaticRiskMeasures=sum(Spread4CrossConvexityCCSC4))
dfSpread4CrossConvexityCCSC4$Spread4CrossConvexityCCSC4 <- dfSpread4CrossConvexityCCSC4$dfStaticRiskMeasures
dfSpread4CrossConvexityCCSC4$dfStaticRiskMeasures <- NULL
# Compute Static Risk Measure for Net Worth
dfSpread4CrossConvexityCCSC4 <- rbind(dfSpread4CrossConvexityCCSC4, y = c(MaxInstruments+1, NA))
dfSpread4CrossConvexityCCSC4 <- rbind(dfSpread4CrossConvexityCCSC4, y = c(MaxInstruments+2, NA))
dfSpread4CrossConvexityCCSC4 <- rbind(dfSpread4CrossConvexityCCSC4, y = c(MaxInstruments+3, NA))
TA <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+2]
TL <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+3]
SRMA <- 0.0
for(i in 1:NumberOfAssets){
  SRMA <- SRMA + dfSpread4CrossConvexityCCSC4$Spread4CrossConvexityCCSC4[i] * (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[i]/TA)
}
SRML <- 0.0
for(i in 1:NumberOfLiabilities){
  SRML <- SRML + dfSpread4CrossConvexityCCSC4$Spread4CrossConvexityCCSC4[NumberOfAssets+i] * 
    (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[NumberOfAssets+i]/TL)
}
if(TA == -TL){
  dfSpread4CrossConvexityCCSC4$Spread4CrossConvexityCCSC4[MaxInstruments+1] <- NA
} else {
  dfSpread4CrossConvexityCCSC4$Spread4CrossConvexityCCSC4[MaxInstruments+1] <- (SRMA*TA + SRML*TL)/(TA + TL)
}
dfSpread4CrossConvexityCCSC4$Spread4CrossConvexityCCSC4[MaxInstruments+2] <- SRMA
dfSpread4CrossConvexityCCSC4$Spread4CrossConvexityCCSC4[MaxInstruments+3] <- SRML
# Level x Curve5 (CCSC5)
dfSpread4CrossConvexityCCSC5 <- ddply(dfStaticRiskMeasures, .(Instrument), summarize, 
                             dfStaticRiskMeasures=sum(Spread4CrossConvexityCCSC5))
dfSpread4CrossConvexityCCSC5$Spread4CrossConvexityCCSC5 <- dfSpread4CrossConvexityCCSC5$dfStaticRiskMeasures
dfSpread4CrossConvexityCCSC5$dfStaticRiskMeasures <- NULL
# Compute Static Risk Measure for Net Worth
dfSpread4CrossConvexityCCSC5 <- rbind(dfSpread4CrossConvexityCCSC5, y = c(MaxInstruments+1, NA))
dfSpread4CrossConvexityCCSC5 <- rbind(dfSpread4CrossConvexityCCSC5, y = c(MaxInstruments+2, NA))
dfSpread4CrossConvexityCCSC5 <- rbind(dfSpread4CrossConvexityCCSC5, y = c(MaxInstruments+3, NA))
TA <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+2]
TL <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+3]
SRMA <- 0.0
for(i in 1:NumberOfAssets){
  SRMA <- SRMA + dfSpread4CrossConvexityCCSC5$Spread4CrossConvexityCCSC5[i] * (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[i]/TA)
}
SRML <- 0.0
for(i in 1:NumberOfLiabilities){
  SRML <- SRML + dfSpread4CrossConvexityCCSC5$Spread4CrossConvexityCCSC5[NumberOfAssets+i] * 
    (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[NumberOfAssets+i]/TL)
}
if(TA == -TL){
  dfSpread4CrossConvexityCCSC5$Spread4CrossConvexityCCSC5[MaxInstruments+1] <- NA
} else {
  dfSpread4CrossConvexityCCSC5$Spread4CrossConvexityCCSC5[MaxInstruments+1] <- (SRMA*TA + SRML*TL)/(TA + TL)
}
dfSpread4CrossConvexityCCSC5$Spread4CrossConvexityCCSC5[MaxInstruments+2] <- SRMA
dfSpread4CrossConvexityCCSC5$Spread4CrossConvexityCCSC5[MaxInstruments+3] <- SRML
# dfSpread4CrossConvexityCCSC1
# dfSpread4CrossConvexityCCSC2
# dfSpread4CrossConvexityCCSC3
# dfSpread4CrossConvexityCCSC4
# dfSpread4CrossConvexityCCSC5
# Curve1 x Curve2 (CCC1C2)
dfSpread4CrossConvexityCCC1C2 <- ddply(dfStaticRiskMeasures, .(Instrument), summarize, 
                             dfStaticRiskMeasures=sum(Spread4CrossConvexityCCC1C2))
dfSpread4CrossConvexityCCC1C2$Spread4CrossConvexityCCC1C2 <- dfSpread4CrossConvexityCCC1C2$dfStaticRiskMeasures
dfSpread4CrossConvexityCCC1C2$dfStaticRiskMeasures <- NULL
# Compute Static Risk Measure for Net Worth
dfSpread4CrossConvexityCCC1C2 <- rbind(dfSpread4CrossConvexityCCC1C2, y = c(MaxInstruments+1, NA))
dfSpread4CrossConvexityCCC1C2 <- rbind(dfSpread4CrossConvexityCCC1C2, y = c(MaxInstruments+2, NA))
dfSpread4CrossConvexityCCC1C2 <- rbind(dfSpread4CrossConvexityCCC1C2, y = c(MaxInstruments+3, NA))
TA <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+2]
TL <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+3]
SRMA <- 0.0
for(i in 1:NumberOfAssets){
  SRMA <- SRMA + dfSpread4CrossConvexityCCC1C2$Spread4CrossConvexityCCC1C2[i] * (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[i]/TA)
}
SRML <- 0.0
for(i in 1:NumberOfLiabilities){
  SRML <- SRML + dfSpread4CrossConvexityCCC1C2$Spread4CrossConvexityCCC1C2[NumberOfAssets+i] * 
    (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[NumberOfAssets+i]/TL)
}
if(TA == -TL){
  dfSpread4CrossConvexityCCC1C2$Spread4CrossConvexityCCC1C2[MaxInstruments+1] <- NA
} else {
  dfSpread4CrossConvexityCCC1C2$Spread4CrossConvexityCCC1C2[MaxInstruments+1] <- (SRMA*TA + SRML*TL)/(TA + TL)
}
dfSpread4CrossConvexityCCC1C2$Spread4CrossConvexityCCC1C2[MaxInstruments+2] <- SRMA
dfSpread4CrossConvexityCCC1C2$Spread4CrossConvexityCCC1C2[MaxInstruments+3] <- SRML
# Level x Curve3 (CCC1C3)
dfSpread4CrossConvexityCCC1C3 <- ddply(dfStaticRiskMeasures, .(Instrument), summarize, 
                             dfStaticRiskMeasures=sum(Spread4CrossConvexityCCC1C3))
dfSpread4CrossConvexityCCC1C3$Spread4CrossConvexityCCC1C3 <- dfSpread4CrossConvexityCCC1C3$dfStaticRiskMeasures
dfSpread4CrossConvexityCCC1C3$dfStaticRiskMeasures <- NULL
# Compute Static Risk Measure for Net Worth
dfSpread4CrossConvexityCCC1C3 <- rbind(dfSpread4CrossConvexityCCC1C3, y = c(MaxInstruments+1, NA))
dfSpread4CrossConvexityCCC1C3 <- rbind(dfSpread4CrossConvexityCCC1C3, y = c(MaxInstruments+2, NA))
dfSpread4CrossConvexityCCC1C3 <- rbind(dfSpread4CrossConvexityCCC1C3, y = c(MaxInstruments+3, NA))
TA <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+2]
TL <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+3]
SRMA <- 0.0
for(i in 1:NumberOfAssets){
  SRMA <- SRMA + dfSpread4CrossConvexityCCC1C3$Spread4CrossConvexityCCC1C3[i] * (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[i]/TA)
}
SRML <- 0.0
for(i in 1:NumberOfLiabilities){
  SRML <- SRML + dfSpread4CrossConvexityCCC1C3$Spread4CrossConvexityCCC1C3[NumberOfAssets+i] * 
    (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[NumberOfAssets+i]/TL)
}
if(TA == -TL){
  dfSpread4CrossConvexityCCC1C3$Spread4CrossConvexityCCC1C3[MaxInstruments+1] <- NA
} else {
  dfSpread4CrossConvexityCCC1C3$Spread4CrossConvexityCCC1C3[MaxInstruments+1] <- (SRMA*TA + SRML*TL)/(TA + TL)
}
dfSpread4CrossConvexityCCC1C3$Spread4CrossConvexityCCC1C3[MaxInstruments+2] <- SRMA
dfSpread4CrossConvexityCCC1C3$Spread4CrossConvexityCCC1C3[MaxInstruments+3] <- SRML
# Level x Curve4 (CCC1C4)
dfSpread4CrossConvexityCCC1C4 <- ddply(dfStaticRiskMeasures, .(Instrument), summarize, 
                             dfStaticRiskMeasures=sum(Spread4CrossConvexityCCC1C4))
dfSpread4CrossConvexityCCC1C4$Spread4CrossConvexityCCC1C4 <- dfSpread4CrossConvexityCCC1C4$dfStaticRiskMeasures
dfSpread4CrossConvexityCCC1C4$dfStaticRiskMeasures <- NULL
# Compute Static Risk Measure for Net Worth
dfSpread4CrossConvexityCCC1C4 <- rbind(dfSpread4CrossConvexityCCC1C4, y = c(MaxInstruments+1, NA))
dfSpread4CrossConvexityCCC1C4 <- rbind(dfSpread4CrossConvexityCCC1C4, y = c(MaxInstruments+2, NA))
dfSpread4CrossConvexityCCC1C4 <- rbind(dfSpread4CrossConvexityCCC1C4, y = c(MaxInstruments+3, NA))
TA <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+2]
TL <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+3]
SRMA <- 0.0
for(i in 1:NumberOfAssets){
  SRMA <- SRMA + dfSpread4CrossConvexityCCC1C4$Spread4CrossConvexityCCC1C4[i] * (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[i]/TA)
}
SRML <- 0.0
for(i in 1:NumberOfLiabilities){
  SRML <- SRML + dfSpread4CrossConvexityCCC1C4$Spread4CrossConvexityCCC1C4[NumberOfAssets+i] * 
    (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[NumberOfAssets+i]/TL)
}
if(TA == -TL){
  dfSpread4CrossConvexityCCC1C4$Spread4CrossConvexityCCC1C4[MaxInstruments+1] <- NA
} else {
  dfSpread4CrossConvexityCCC1C4$Spread4CrossConvexityCCC1C4[MaxInstruments+1] <- (SRMA*TA + SRML*TL)/(TA + TL)
}
dfSpread4CrossConvexityCCC1C4$Spread4CrossConvexityCCC1C4[MaxInstruments+2] <- SRMA
dfSpread4CrossConvexityCCC1C4$Spread4CrossConvexityCCC1C4[MaxInstruments+3] <- SRML
# Level x Curve5 (CCC1C5)
dfSpread4CrossConvexityCCC1C5 <- ddply(dfStaticRiskMeasures, .(Instrument), summarize, 
                             dfStaticRiskMeasures=sum(Spread4CrossConvexityCCC1C5))
dfSpread4CrossConvexityCCC1C5$Spread4CrossConvexityCCC1C5 <- dfSpread4CrossConvexityCCC1C5$dfStaticRiskMeasures
dfSpread4CrossConvexityCCC1C5$dfStaticRiskMeasures <- NULL
# Compute Static Risk Measure for Net Worth
dfSpread4CrossConvexityCCC1C5 <- rbind(dfSpread4CrossConvexityCCC1C5, y = c(MaxInstruments+1, NA))
dfSpread4CrossConvexityCCC1C5 <- rbind(dfSpread4CrossConvexityCCC1C5, y = c(MaxInstruments+2, NA))
dfSpread4CrossConvexityCCC1C5 <- rbind(dfSpread4CrossConvexityCCC1C5, y = c(MaxInstruments+3, NA))
TA <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+2]
TL <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+3]
SRMA <- 0.0
for(i in 1:NumberOfAssets){
  SRMA <- SRMA + dfSpread4CrossConvexityCCC1C5$Spread4CrossConvexityCCC1C5[i] * (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[i]/TA)
}
SRML <- 0.0
for(i in 1:NumberOfLiabilities){
  SRML <- SRML + dfSpread4CrossConvexityCCC1C5$Spread4CrossConvexityCCC1C5[NumberOfAssets+i] * 
    (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[NumberOfAssets+i]/TL)
}
if(TA == -TL){
  dfSpread4CrossConvexityCCC1C5$Spread4CrossConvexityCCC1C5[MaxInstruments+1] <- NA
} else {
  dfSpread4CrossConvexityCCC1C5$Spread4CrossConvexityCCC1C5[MaxInstruments+1] <- (SRMA*TA + SRML*TL)/(TA + TL)
}
dfSpread4CrossConvexityCCC1C5$Spread4CrossConvexityCCC1C5[MaxInstruments+2] <- SRMA
dfSpread4CrossConvexityCCC1C5$Spread4CrossConvexityCCC1C5[MaxInstruments+3] <- SRML
# dfSpread4CrossConvexityCCC1C2
# dfSpread4CrossConvexityCCC1C3
# dfSpread4CrossConvexityCCC1C4
# dfSpread4CrossConvexityCCC1C5
# Curve2 x Curve3 (CCC2C3)
dfSpread4CrossConvexityCCC2C3 <- ddply(dfStaticRiskMeasures, .(Instrument), summarize, 
                              dfStaticRiskMeasures=sum(Spread4CrossConvexityCCC2C3))
dfSpread4CrossConvexityCCC2C3$Spread4CrossConvexityCCC2C3 <- dfSpread4CrossConvexityCCC2C3$dfStaticRiskMeasures
dfSpread4CrossConvexityCCC2C3$dfStaticRiskMeasures <- NULL
# Compute Static Risk Measure for Net Worth
dfSpread4CrossConvexityCCC2C3 <- rbind(dfSpread4CrossConvexityCCC2C3, y = c(MaxInstruments+1, NA))
dfSpread4CrossConvexityCCC2C3 <- rbind(dfSpread4CrossConvexityCCC2C3, y = c(MaxInstruments+2, NA))
dfSpread4CrossConvexityCCC2C3 <- rbind(dfSpread4CrossConvexityCCC2C3, y = c(MaxInstruments+3, NA))
TA <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+2]
TL <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+3]
SRMA <- 0.0
for(i in 1:NumberOfAssets){
  SRMA <- SRMA + dfSpread4CrossConvexityCCC2C3$Spread4CrossConvexityCCC2C3[i] * (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[i]/TA)
}
SRML <- 0.0
for(i in 1:NumberOfLiabilities){
  SRML <- SRML + dfSpread4CrossConvexityCCC2C3$Spread4CrossConvexityCCC2C3[NumberOfAssets+i] * 
    (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[NumberOfAssets+i]/TL)
}
if(TA == -TL){
  dfSpread4CrossConvexityCCC2C3$Spread4CrossConvexityCCC2C3[MaxInstruments+1] <- NA
} else {
  dfSpread4CrossConvexityCCC2C3$Spread4CrossConvexityCCC2C3[MaxInstruments+1] <- (SRMA*TA + SRML*TL)/(TA + TL)
}
dfSpread4CrossConvexityCCC2C3$Spread4CrossConvexityCCC2C3[MaxInstruments+2] <- SRMA
dfSpread4CrossConvexityCCC2C3$Spread4CrossConvexityCCC2C3[MaxInstruments+3] <- SRML
# _____ x Curve4 (CCC2C4)
dfSpread4CrossConvexityCCC2C4 <- ddply(dfStaticRiskMeasures, .(Instrument), summarize, 
                              dfStaticRiskMeasures=sum(Spread4CrossConvexityCCC2C4))
dfSpread4CrossConvexityCCC2C4$Spread4CrossConvexityCCC2C4 <- dfSpread4CrossConvexityCCC2C4$dfStaticRiskMeasures
dfSpread4CrossConvexityCCC2C4$dfStaticRiskMeasures <- NULL
# Compute Static Risk Measure for Net Worth
dfSpread4CrossConvexityCCC2C4 <- rbind(dfSpread4CrossConvexityCCC2C4, y = c(MaxInstruments+1, NA))
dfSpread4CrossConvexityCCC2C4 <- rbind(dfSpread4CrossConvexityCCC2C4, y = c(MaxInstruments+2, NA))
dfSpread4CrossConvexityCCC2C4 <- rbind(dfSpread4CrossConvexityCCC2C4, y = c(MaxInstruments+3, NA))
TA <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+2]
TL <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+3]
SRMA <- 0.0
for(i in 1:NumberOfAssets){
  SRMA <- SRMA + dfSpread4CrossConvexityCCC2C4$Spread4CrossConvexityCCC2C4[i] * (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[i]/TA)
}
SRML <- 0.0
for(i in 1:NumberOfLiabilities){
  SRML <- SRML + dfSpread4CrossConvexityCCC2C4$Spread4CrossConvexityCCC2C4[NumberOfAssets+i] * 
    (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[NumberOfAssets+i]/TL)
}
if(TA == -TL){
  dfSpread4CrossConvexityCCC2C4$Spread4CrossConvexityCCC2C4[MaxInstruments+1] <- NA
} else {
  dfSpread4CrossConvexityCCC2C4$Spread4CrossConvexityCCC2C4[MaxInstruments+1] <- (SRMA*TA + SRML*TL)/(TA + TL)
}
dfSpread4CrossConvexityCCC2C4$Spread4CrossConvexityCCC2C4[MaxInstruments+2] <- SRMA
dfSpread4CrossConvexityCCC2C4$Spread4CrossConvexityCCC2C4[MaxInstruments+3] <- SRML
# _____ x Curve5 (CCC2C5)
dfSpread4CrossConvexityCCC2C5 <- ddply(dfStaticRiskMeasures, .(Instrument), summarize, 
                              dfStaticRiskMeasures=sum(Spread4CrossConvexityCCC2C5))
dfSpread4CrossConvexityCCC2C5$Spread4CrossConvexityCCC2C5 <- dfSpread4CrossConvexityCCC2C5$dfStaticRiskMeasures
dfSpread4CrossConvexityCCC2C5$dfStaticRiskMeasures <- NULL
# Compute Static Risk Measure for Net Worth
dfSpread4CrossConvexityCCC2C5 <- rbind(dfSpread4CrossConvexityCCC2C5, y = c(MaxInstruments+1, NA))
dfSpread4CrossConvexityCCC2C5 <- rbind(dfSpread4CrossConvexityCCC2C5, y = c(MaxInstruments+2, NA))
dfSpread4CrossConvexityCCC2C5 <- rbind(dfSpread4CrossConvexityCCC2C5, y = c(MaxInstruments+3, NA))
TA <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+2]
TL <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+3]
SRMA <- 0.0
for(i in 1:NumberOfAssets){
  SRMA <- SRMA + dfSpread4CrossConvexityCCC2C5$Spread4CrossConvexityCCC2C5[i] * (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[i]/TA)
}
SRML <- 0.0
for(i in 1:NumberOfLiabilities){
  SRML <- SRML + dfSpread4CrossConvexityCCC2C5$Spread4CrossConvexityCCC2C5[NumberOfAssets+i] * 
    (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[NumberOfAssets+i]/TL)
}
if(TA == -TL){
  dfSpread4CrossConvexityCCC2C5$Spread4CrossConvexityCCC2C5[MaxInstruments+1] <- NA
} else {
  dfSpread4CrossConvexityCCC2C5$Spread4CrossConvexityCCC2C5[MaxInstruments+1] <- (SRMA*TA + SRML*TL)/(TA + TL)
}
dfSpread4CrossConvexityCCC2C5$Spread4CrossConvexityCCC2C5[MaxInstruments+2] <- SRMA
dfSpread4CrossConvexityCCC2C5$Spread4CrossConvexityCCC2C5[MaxInstruments+3] <- SRML
# dfSpread4CrossConvexityCCC2C3
# dfSpread4CrossConvexityCCC2C4
# dfSpread4CrossConvexityCCC2C5
# Curve3 x Curve4 (CCC3C4)
dfSpread4CrossConvexityCCC3C4 <- ddply(dfStaticRiskMeasures, .(Instrument), summarize, 
                              dfStaticRiskMeasures=sum(Spread4CrossConvexityCCC3C4))
dfSpread4CrossConvexityCCC3C4$Spread4CrossConvexityCCC3C4 <- dfSpread4CrossConvexityCCC3C4$dfStaticRiskMeasures
dfSpread4CrossConvexityCCC3C4$dfStaticRiskMeasures <- NULL
# Compute Static Risk Measure for Net Worth
dfSpread4CrossConvexityCCC3C4 <- rbind(dfSpread4CrossConvexityCCC3C4, y = c(MaxInstruments+1, NA))
dfSpread4CrossConvexityCCC3C4 <- rbind(dfSpread4CrossConvexityCCC3C4, y = c(MaxInstruments+2, NA))
dfSpread4CrossConvexityCCC3C4 <- rbind(dfSpread4CrossConvexityCCC3C4, y = c(MaxInstruments+3, NA))
TA <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+2]
TL <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+3]
SRMA <- 0.0
for(i in 1:NumberOfAssets){
  SRMA <- SRMA + dfSpread4CrossConvexityCCC3C4$Spread4CrossConvexityCCC3C4[i] * (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[i]/TA)
}
SRML <- 0.0
for(i in 1:NumberOfLiabilities){
  SRML <- SRML + dfSpread4CrossConvexityCCC3C4$Spread4CrossConvexityCCC3C4[NumberOfAssets+i] * 
    (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[NumberOfAssets+i]/TL)
}
if(TA == -TL){
  dfSpread4CrossConvexityCCC3C4$Spread4CrossConvexityCCC3C4[MaxInstruments+1] <- NA
} else {
  dfSpread4CrossConvexityCCC3C4$Spread4CrossConvexityCCC3C4[MaxInstruments+1] <- (SRMA*TA + SRML*TL)/(TA + TL)
}
dfSpread4CrossConvexityCCC3C4$Spread4CrossConvexityCCC3C4[MaxInstruments+2] <- SRMA
dfSpread4CrossConvexityCCC3C4$Spread4CrossConvexityCCC3C4[MaxInstruments+3] <- SRML
# _____ x Curve5 (CCC3C5)
dfSpread4CrossConvexityCCC3C5 <- ddply(dfStaticRiskMeasures, .(Instrument), summarize, 
                              dfStaticRiskMeasures=sum(Spread4CrossConvexityCCC3C5))
dfSpread4CrossConvexityCCC3C5$Spread4CrossConvexityCCC3C5 <- dfSpread4CrossConvexityCCC3C5$dfStaticRiskMeasures
dfSpread4CrossConvexityCCC3C5$dfStaticRiskMeasures <- NULL
# Compute Static Risk Measure for Net Worth
dfSpread4CrossConvexityCCC3C5 <- rbind(dfSpread4CrossConvexityCCC3C5, y = c(MaxInstruments+1, NA))
dfSpread4CrossConvexityCCC3C5 <- rbind(dfSpread4CrossConvexityCCC3C5, y = c(MaxInstruments+2, NA))
dfSpread4CrossConvexityCCC3C5 <- rbind(dfSpread4CrossConvexityCCC3C5, y = c(MaxInstruments+3, NA))
TA <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+2]
TL <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+3]
SRMA <- 0.0
for(i in 1:NumberOfAssets){
  SRMA <- SRMA + dfSpread4CrossConvexityCCC3C5$Spread4CrossConvexityCCC3C5[i] * (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[i]/TA)
}
SRML <- 0.0
for(i in 1:NumberOfLiabilities){
  SRML <- SRML + dfSpread4CrossConvexityCCC3C5$Spread4CrossConvexityCCC3C5[NumberOfAssets+i] * 
    (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[NumberOfAssets+i]/TL)
}
if(TA == -TL){
  dfSpread4CrossConvexityCCC3C5$Spread4CrossConvexityCCC3C5[MaxInstruments+1] <- NA
} else {
  dfSpread4CrossConvexityCCC3C5$Spread4CrossConvexityCCC3C5[MaxInstruments+1] <- (SRMA*TA + SRML*TL)/(TA + TL)
}
dfSpread4CrossConvexityCCC3C5$Spread4CrossConvexityCCC3C5[MaxInstruments+2] <- SRMA
dfSpread4CrossConvexityCCC3C5$Spread4CrossConvexityCCC3C5[MaxInstruments+3] <- SRML
# dfSpread4CrossConvexityCCC3C4
# dfSpread4CrossConvexityCCC3C5
# Curve4 x Curve5 (CCC4C5)
dfSpread4CrossConvexityCCC4C5 <- ddply(dfStaticRiskMeasures, .(Instrument), summarize, 
                              dfStaticRiskMeasures=sum(Spread4CrossConvexityCCC4C5))
dfSpread4CrossConvexityCCC4C5$Spread4CrossConvexityCCC4C5 <- dfSpread4CrossConvexityCCC4C5$dfStaticRiskMeasures
dfSpread4CrossConvexityCCC4C5$dfStaticRiskMeasures <- NULL
# Compute Static Risk Measure for Net Worth
dfSpread4CrossConvexityCCC4C5 <- rbind(dfSpread4CrossConvexityCCC4C5, y = c(MaxInstruments+1, NA))
dfSpread4CrossConvexityCCC4C5 <- rbind(dfSpread4CrossConvexityCCC4C5, y = c(MaxInstruments+2, NA))
dfSpread4CrossConvexityCCC4C5 <- rbind(dfSpread4CrossConvexityCCC4C5, y = c(MaxInstruments+3, NA))
TA <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+2]
TL <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+3]
SRMA <- 0.0
for(i in 1:NumberOfAssets){
  SRMA <- SRMA + dfSpread4CrossConvexityCCC4C5$Spread4CrossConvexityCCC4C5[i] * (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[i]/TA)
}
SRML <- 0.0
for(i in 1:NumberOfLiabilities){
  SRML <- SRML + dfSpread4CrossConvexityCCC4C5$Spread4CrossConvexityCCC4C5[NumberOfAssets+i] * 
    (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[NumberOfAssets+i]/TL)
}
if(TA == -TL){
  dfSpread4CrossConvexityCCC4C5$Spread4CrossConvexityCCC4C5[MaxInstruments+1] <- NA
} else {
  dfSpread4CrossConvexityCCC4C5$Spread4CrossConvexityCCC4C5[MaxInstruments+1] <- (SRMA*TA + SRML*TL)/(TA + TL)
}
dfSpread4CrossConvexityCCC4C5$Spread4CrossConvexityCCC4C5[MaxInstruments+2] <- SRMA
dfSpread4CrossConvexityCCC4C5$Spread4CrossConvexityCCC4C5[MaxInstruments+3] <- SRML
# dfSpread4CrossConvexityCCC4C5


