# KM Spread5 Rate Static Risk Measures.R
# Spread5 rate static risk measures
L <- InitialCurves$Spread5[2]
k1 <- InitialCurves$Spread5[3]
S <- InitialCurves$Spread5[4]
C1 <- InitialCurves$Spread5[5]
k2 <- InitialCurves$Spread5[6]
C2 <- InitialCurves$Spread5[7]
k3 <- InitialCurves$Spread5[8]
C3 <- InitialCurves$Spread5[9]
k4 <- InitialCurves$Spread5[10]
C4 <- InitialCurves$Spread5[11]
k5 <- InitialCurves$Spread5[12]
C5 <- InitialCurves$Spread5[13]
# Spread5 rate maturity coefficients at Horizon
M <- dfStaticRiskMeasures$Maturity-Horizon
LengthM = length(M)
for(i in 1:LengthM){ # Cannot have zero in LSC model
  if(M[i] == 0)M[i] <- 0.000001
}
x1 <- (k1/M)*(1.0 - exp(-M/k1))
x2 <- x1 - exp(-M/k1)
x3 <- (k2/M) * (1.0 - exp(-M/k2)) - exp(-M/k2)
x4 <- (k3/M) * (1.0 - exp(-M/k3)) - exp(-M/k3)
x5 <- (k4/M) * (1.0 - exp(-M/k4)) - exp(-M/k4)
x6 <- (k5/M) * (1.0 - exp(-M/k5)) - exp(-M/k5)
W <- dfStaticRiskMeasures$Weight
CW <- dfStaticRiskMeasures$WSpread5 # Weight of particular curve
#
# Spread5 Duration
#
dfStaticRiskMeasures$Spread5DurationLevel <- M * 1.0 * W * CW
dfStaticRiskMeasures$Spread5DurationSlope <- M * x1 * W * CW
dfStaticRiskMeasures$Spread5DurationCurve1 <- M * x2 * W * CW
dfStaticRiskMeasures$Spread5DurationCurve2 <- M * x3 * W * CW
dfStaticRiskMeasures$Spread5DurationCurve3 <- M * x4 * W * CW
dfStaticRiskMeasures$Spread5DurationCurve4 <- M * x5 * W * CW
dfStaticRiskMeasures$Spread5DurationCurve5 <- M * x6 * W * CW
# Level
dfSpread5DurationLevel <- ddply(dfStaticRiskMeasures, .(Instrument), summarize, 
  dfStaticRiskMeasures=sum(Spread5DurationLevel))
dfSpread5DurationLevel$Spread5DurationLevel <- dfSpread5DurationLevel$dfStaticRiskMeasures
dfSpread5DurationLevel$dfStaticRiskMeasures <- NULL
# Compute Static Risk Measure for Net Worth
dfSpread5DurationLevel <- rbind(dfSpread5DurationLevel, y = c(MaxInstruments+1, NA))
dfSpread5DurationLevel <- rbind(dfSpread5DurationLevel, y = c(MaxInstruments+2, NA))
dfSpread5DurationLevel <- rbind(dfSpread5DurationLevel, y = c(MaxInstruments+3, NA))
TA <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+2]
TL <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+3]
SRMA <- 0.0
for(i in 1:NumberOfAssets){
  SRMA <- SRMA + dfSpread5DurationLevel$Spread5DurationLevel[i] * (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[i]/TA)
}
SRML <- 0.0
for(i in 1:NumberOfLiabilities){
  SRML <- SRML + dfSpread5DurationLevel$Spread5DurationLevel[NumberOfAssets+i] * 
    (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[NumberOfAssets+i]/TL)
}
if(TA == -TL){
  dfSpread5DurationLevel$Spread5DurationLevel[MaxInstruments+1] <- NA
} else {
  dfSpread5DurationLevel$Spread5DurationLevel[MaxInstruments+1] <- (SRMA*TA + SRML*TL)/(TA + TL)
}
dfSpread5DurationLevel$Spread5DurationLevel[MaxInstruments+2] <- SRMA
dfSpread5DurationLevel$Spread5DurationLevel[MaxInstruments+3] <- SRML
dfSpread5DurationLevel
# Slope
dfSpread5DurationSlope <- ddply(dfStaticRiskMeasures, .(Instrument), summarize, 
  dfStaticRiskMeasures=sum(Spread5DurationSlope))
dfSpread5DurationSlope$Spread5DurationSlope <- dfSpread5DurationSlope$dfStaticRiskMeasures
dfSpread5DurationSlope$dfStaticRiskMeasures <- NULL
# Compute Static Risk Measure for Net Worth


dfSpread5DurationSlope <- rbind(dfSpread5DurationSlope, y = c(MaxInstruments+1, NA))
dfSpread5DurationSlope <- rbind(dfSpread5DurationSlope, y = c(MaxInstruments+2, NA))
dfSpread5DurationSlope <- rbind(dfSpread5DurationSlope, y = c(MaxInstruments+3, NA))
TA <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+2]
TL <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+3]
SRMA <- 0.0
for(i in 1:NumberOfAssets){
  SRMA <- SRMA + dfSpread5DurationSlope$Spread5DurationSlope[i] * (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[i]/TA)
}
SRML <- 0.0
for(i in 1:NumberOfLiabilities){
  SRML <- SRML + dfSpread5DurationSlope$Spread5DurationSlope[NumberOfAssets+i] * 
    (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[NumberOfAssets+i]/TL)
}
if(TA == -TL){
  dfSpread5DurationSlope$Spread5DurationSlope[MaxInstruments+1] <- NA
} else {
  dfSpread5DurationSlope$Spread5DurationSlope[MaxInstruments+1] <- (SRMA*TA + SRML*TL)/(TA + TL)
}
dfSpread5DurationSlope$Spread5DurationSlope[MaxInstruments+2] <- SRMA
dfSpread5DurationSlope$Spread5DurationSlope[MaxInstruments+3] <- SRML
dfSpread5DurationSlope
# Curvature 1
dfSpread5DurationCurve1 <- ddply(dfStaticRiskMeasures, .(Instrument), summarize, 
                              dfStaticRiskMeasures=sum(Spread5DurationCurve1))
dfSpread5DurationCurve1$Spread5DurationCurve1 <- dfSpread5DurationCurve1$dfStaticRiskMeasures
dfSpread5DurationCurve1$dfStaticRiskMeasures <- NULL
# Compute Static Risk Measure for Net Worth
dfSpread5DurationCurve1 <- rbind(dfSpread5DurationCurve1, y = c(MaxInstruments+1, NA))
dfSpread5DurationCurve1 <- rbind(dfSpread5DurationCurve1, y = c(MaxInstruments+2, NA))
dfSpread5DurationCurve1 <- rbind(dfSpread5DurationCurve1, y = c(MaxInstruments+3, NA))
TA <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+2]
TL <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+3]
SRMA <- 0.0
for(i in 1:NumberOfAssets){
  SRMA <- SRMA + dfSpread5DurationCurve1$Spread5DurationCurve1[i] * (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[i]/TA)
}
SRML <- 0.0
for(i in 1:NumberOfLiabilities){
  SRML <- SRML + dfSpread5DurationCurve1$Spread5DurationCurve1[NumberOfAssets+i] * 
    (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[NumberOfAssets+i]/TL)
}
if(TA == -TL){
  dfSpread5DurationCurve1$Spread5DurationCurve1[MaxInstruments+1] <- NA
} else {
  dfSpread5DurationCurve1$Spread5DurationCurve1[MaxInstruments+1] <- (SRMA*TA + SRML*TL)/(TA + TL)
}
dfSpread5DurationCurve1$Spread5DurationCurve1[MaxInstruments+2] <- SRMA
dfSpread5DurationCurve1$Spread5DurationCurve1[MaxInstruments+3] <- SRML
dfSpread5DurationCurve1
# Curvature 2
dfSpread5DurationCurve2 <- ddply(dfStaticRiskMeasures, .(Instrument), summarize, 
                              dfStaticRiskMeasures=sum(Spread5DurationCurve2))
dfSpread5DurationCurve2$Spread5DurationCurve2 <- dfSpread5DurationCurve2$dfStaticRiskMeasures
dfSpread5DurationCurve2$dfStaticRiskMeasures <- NULL
# Compute Static Risk Measure for Net Worth
dfSpread5DurationCurve2 <- rbind(dfSpread5DurationCurve2, y = c(MaxInstruments+1, NA))
dfSpread5DurationCurve2 <- rbind(dfSpread5DurationCurve2, y = c(MaxInstruments+2, NA))
dfSpread5DurationCurve2 <- rbind(dfSpread5DurationCurve2, y = c(MaxInstruments+3, NA))
TA <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+2]
TL <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+3]
SRMA <- 0.0
for(i in 1:NumberOfAssets){
  SRMA <- SRMA + dfSpread5DurationCurve2$Spread5DurationCurve2[i] * (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[i]/TA)
}
SRML <- 0.0
for(i in 1:NumberOfLiabilities){
  SRML <- SRML + dfSpread5DurationCurve2$Spread5DurationCurve2[NumberOfAssets+i] * 
    (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[NumberOfAssets+i]/TL)
}
if(TA == -TL){
  dfSpread5DurationCurve2$Spread5DurationCurve2[MaxInstruments+1] <- NA
} else {
  dfSpread5DurationCurve2$Spread5DurationCurve2[MaxInstruments+1] <- (SRMA*TA + SRML*TL)/(TA + TL)
}
dfSpread5DurationCurve2$Spread5DurationCurve2[MaxInstruments+2] <- SRMA
dfSpread5DurationCurve2$Spread5DurationCurve2[MaxInstruments+3] <- SRML
# Curvature 3
dfSpread5DurationCurve3 <- ddply(dfStaticRiskMeasures, .(Instrument), summarize, 
  dfStaticRiskMeasures=sum(Spread5DurationCurve3))
dfSpread5DurationCurve3$Spread5DurationCurve3 <- dfSpread5DurationCurve3$dfStaticRiskMeasures
dfSpread5DurationCurve3$dfStaticRiskMeasures <- NULL
# Compute Static Risk Measure for Net Worth
dfSpread5DurationCurve3 <- rbind(dfSpread5DurationCurve3, y = c(MaxInstruments+1, NA))
dfSpread5DurationCurve3 <- rbind(dfSpread5DurationCurve3, y = c(MaxInstruments+2, NA))
dfSpread5DurationCurve3 <- rbind(dfSpread5DurationCurve3, y = c(MaxInstruments+3, NA))
TA <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+2]
TL <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+3]
SRMA <- 0.0
for(i in 1:NumberOfAssets){
  SRMA <- SRMA + dfSpread5DurationCurve3$Spread5DurationCurve3[i] * (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[i]/TA)
}
SRML <- 0.0
for(i in 1:NumberOfLiabilities){
  SRML <- SRML + dfSpread5DurationCurve3$Spread5DurationCurve3[NumberOfAssets+i] * 
    (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[NumberOfAssets+i]/TL)
}
if(TA == -TL){
  dfSpread5DurationCurve3$Spread5DurationCurve3[MaxInstruments+1] <- NA
} else {
  dfSpread5DurationCurve3$Spread5DurationCurve3[MaxInstruments+1] <- (SRMA*TA + SRML*TL)/(TA + TL)
}
dfSpread5DurationCurve3$Spread5DurationCurve3[MaxInstruments+2] <- SRMA
dfSpread5DurationCurve3$Spread5DurationCurve3[MaxInstruments+3] <- SRML
# Curvature 4
dfSpread5DurationCurve4 <- ddply(dfStaticRiskMeasures, .(Instrument), summarize, 
                              dfStaticRiskMeasures=sum(Spread5DurationCurve4))
dfSpread5DurationCurve4$Spread5DurationCurve4 <- dfSpread5DurationCurve4$dfStaticRiskMeasures
dfSpread5DurationCurve4$dfStaticRiskMeasures <- NULL
# Compute Static Risk Measure for Net Worth
dfSpread5DurationCurve4 <- rbind(dfSpread5DurationCurve4, y = c(MaxInstruments+1, NA))
dfSpread5DurationCurve4 <- rbind(dfSpread5DurationCurve4, y = c(MaxInstruments+2, NA))
dfSpread5DurationCurve4 <- rbind(dfSpread5DurationCurve4, y = c(MaxInstruments+3, NA))
TA <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+2]
TL <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+3]
SRMA <- 0.0
for(i in 1:NumberOfAssets){
  SRMA <- SRMA + dfSpread5DurationCurve4$Spread5DurationCurve4[i] * (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[i]/TA)
}
SRML <- 0.0
for(i in 1:NumberOfLiabilities){
  SRML <- SRML + dfSpread5DurationCurve4$Spread5DurationCurve4[NumberOfAssets+i] * 
    (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[NumberOfAssets+i]/TL)
}
if(TA == -TL){
  dfSpread5DurationCurve4$Spread5DurationCurve4[MaxInstruments+1] <- NA
} else {
  dfSpread5DurationCurve4$Spread5DurationCurve4[MaxInstruments+1] <- (SRMA*TA + SRML*TL)/(TA + TL)
}
dfSpread5DurationCurve4$Spread5DurationCurve4[MaxInstruments+2] <- SRMA
dfSpread5DurationCurve4$Spread5DurationCurve4[MaxInstruments+3] <- SRML
# Curvature 5
dfSpread5DurationCurve5 <- ddply(dfStaticRiskMeasures, .(Instrument), summarize, 
                              dfStaticRiskMeasures=sum(Spread5DurationCurve5))
dfSpread5DurationCurve5$Spread5DurationCurve5 <- dfSpread5DurationCurve5$dfStaticRiskMeasures
dfSpread5DurationCurve5$dfStaticRiskMeasures <- NULL
# Compute Static Risk Measure for Net Worth
dfSpread5DurationCurve5 <- rbind(dfSpread5DurationCurve5, y = c(MaxInstruments+1, NA))
dfSpread5DurationCurve5 <- rbind(dfSpread5DurationCurve5, y = c(MaxInstruments+2, NA))
dfSpread5DurationCurve5 <- rbind(dfSpread5DurationCurve5, y = c(MaxInstruments+3, NA))
TA <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+2]
TL <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+3]
SRMA <- 0.0
for(i in 1:NumberOfAssets){
  SRMA <- SRMA + dfSpread5DurationCurve5$Spread5DurationCurve5[i] * (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[i]/TA)
}
SRML <- 0.0
for(i in 1:NumberOfLiabilities){
  SRML <- SRML + dfSpread5DurationCurve5$Spread5DurationCurve5[NumberOfAssets+i] * 
    (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[NumberOfAssets+i]/TL)
}
if(TA == -TL){
  dfSpread5DurationCurve5$Spread5DurationCurve5[MaxInstruments+1] <- NA
} else {
  dfSpread5DurationCurve5$Spread5DurationCurve5[MaxInstruments+1] <- (SRMA*TA + SRML*TL)/(TA + TL)
}
dfSpread5DurationCurve5$Spread5DurationCurve5[MaxInstruments+2] <- SRMA
dfSpread5DurationCurve5$Spread5DurationCurve5[MaxInstruments+3] <- SRML
# dfPVBalanceSheet
# dfPVBalanceSheetAtHorizon
# dfSpread5DurationLevel
# dfSpread5DurationSlope
# dfSpread5DurationCurve1
# dfSpread5DurationCurve2
# dfSpread5DurationCurve3
# dfSpread5DurationCurve4
# dfSpread5DurationCurve5
#
# Spread5 Convexity
#
dfStaticRiskMeasures$Spread5ConvexityLevel <- (M^2) * 1.0 * W * CW
dfStaticRiskMeasures$Spread5ConvexitySlope <- (M^2) * (x1^2) * W * CW
dfStaticRiskMeasures$Spread5ConvexityCurve1 <- (M^2) * (x2^2) * W * CW
dfStaticRiskMeasures$Spread5ConvexityCurve2 <- (M^2) * (x3^2) * W * CW
dfStaticRiskMeasures$Spread5ConvexityCurve3 <- (M^2) * (x4^2) * W * CW
dfStaticRiskMeasures$Spread5ConvexityCurve4 <- (M^2) * (x5^2) * W * CW
dfStaticRiskMeasures$Spread5ConvexityCurve5 <- (M^2) * (x6^2) * W * CW
# Level
dfSpread5ConvexityLevel <- ddply(dfStaticRiskMeasures, .(Instrument), summarize, 
  dfStaticRiskMeasures=sum(Spread5ConvexityLevel))
dfSpread5ConvexityLevel$Spread5ConvexityLevel <- dfSpread5ConvexityLevel$dfStaticRiskMeasures
dfSpread5ConvexityLevel$dfStaticRiskMeasures <- NULL
# Compute Static Risk Measure for Net Worth
dfSpread5ConvexityLevel <- rbind(dfSpread5ConvexityLevel, y = c(MaxInstruments+1, NA))
dfSpread5ConvexityLevel <- rbind(dfSpread5ConvexityLevel, y = c(MaxInstruments+2, NA))
dfSpread5ConvexityLevel <- rbind(dfSpread5ConvexityLevel, y = c(MaxInstruments+3, NA))
TA <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+2]
TL <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+3]
SRMA <- 0.0
for(i in 1:NumberOfAssets){
  SRMA <- SRMA + dfSpread5ConvexityLevel$Spread5ConvexityLevel[i] * (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[i]/TA)
}
SRML <- 0.0
for(i in 1:NumberOfLiabilities){
  SRML <- SRML + dfSpread5ConvexityLevel$Spread5ConvexityLevel[NumberOfAssets+i] * 
    (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[NumberOfAssets+i]/TL)
}
if(TA == -TL){
  dfSpread5ConvexityLevel$Spread5ConvexityLevel[MaxInstruments+1] <- NA
} else {
  dfSpread5ConvexityLevel$Spread5ConvexityLevel[MaxInstruments+1] <- (SRMA*TA + SRML*TL)/(TA + TL)
}
dfSpread5ConvexityLevel$Spread5ConvexityLevel[MaxInstruments+2] <- SRMA
dfSpread5ConvexityLevel$Spread5ConvexityLevel[MaxInstruments+3] <- SRML
dfSpread5ConvexityLevel
# Slope
dfSpread5ConvexitySlope <- ddply(dfStaticRiskMeasures, .(Instrument), summarize, 
  dfStaticRiskMeasures=sum(Spread5ConvexitySlope))
dfSpread5ConvexitySlope$Spread5ConvexitySlope <- dfSpread5ConvexitySlope$dfStaticRiskMeasures
dfSpread5ConvexitySlope$dfStaticRiskMeasures <- NULL
# Compute Static Risk Measure for Net Worth
dfSpread5ConvexitySlope <- rbind(dfSpread5ConvexitySlope, y = c(MaxInstruments+1, NA))
dfSpread5ConvexitySlope <- rbind(dfSpread5ConvexitySlope, y = c(MaxInstruments+2, NA))
dfSpread5ConvexitySlope <- rbind(dfSpread5ConvexitySlope, y = c(MaxInstruments+3, NA))
TA <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+2]
TL <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+3]
SRMA <- 0.0
for(i in 1:NumberOfAssets){
  SRMA <- SRMA + dfSpread5ConvexitySlope$Spread5ConvexitySlope[i] * (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[i]/TA)
}
SRML <- 0.0
for(i in 1:NumberOfLiabilities){
  SRML <- SRML + dfSpread5ConvexitySlope$Spread5ConvexitySlope[NumberOfAssets+i] * 
    (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[NumberOfAssets+i]/TL)
}
if(TA == -TL){
  dfSpread5ConvexitySlope$Spread5ConvexitySlope[MaxInstruments+1] <- NA
} else {
  dfSpread5ConvexitySlope$Spread5ConvexitySlope[MaxInstruments+1] <- (SRMA*TA + SRML*TL)/(TA + TL)
}
dfSpread5ConvexitySlope$Spread5ConvexitySlope[MaxInstruments+2] <- SRMA
dfSpread5ConvexitySlope$Spread5ConvexitySlope[MaxInstruments+3] <- SRML
dfSpread5ConvexitySlope
# Curvature 1
dfSpread5ConvexityCurve1 <- ddply(dfStaticRiskMeasures, .(Instrument), summarize, 
                              dfStaticRiskMeasures=sum(Spread5ConvexityCurve1))
dfSpread5ConvexityCurve1$Spread5ConvexityCurve1 <- dfSpread5ConvexityCurve1$dfStaticRiskMeasures
dfSpread5ConvexityCurve1$dfStaticRiskMeasures <- NULL
# Compute Static Risk Measure for Net Worth
dfSpread5ConvexityCurve1 <- rbind(dfSpread5ConvexityCurve1, y = c(MaxInstruments+1, NA))
dfSpread5ConvexityCurve1 <- rbind(dfSpread5ConvexityCurve1, y = c(MaxInstruments+2, NA))
dfSpread5ConvexityCurve1 <- rbind(dfSpread5ConvexityCurve1, y = c(MaxInstruments+3, NA))
TA <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+2]
TL <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+3]
SRMA <- 0.0
for(i in 1:NumberOfAssets){
  SRMA <- SRMA + dfSpread5ConvexityCurve1$Spread5ConvexityCurve1[i] * (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[i]/TA)
}
SRML <- 0.0
for(i in 1:NumberOfLiabilities){
  SRML <- SRML + dfSpread5ConvexityCurve1$Spread5ConvexityCurve1[NumberOfAssets+i] * 
    (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[NumberOfAssets+i]/TL)
}
if(TA == -TL){
  dfSpread5ConvexityCurve1$Spread5ConvexityCurve1[MaxInstruments+1] <- NA
} else {
  dfSpread5ConvexityCurve1$Spread5ConvexityCurve1[MaxInstruments+1] <- (SRMA*TA + SRML*TL)/(TA + TL)
}
dfSpread5ConvexityCurve1$Spread5ConvexityCurve1[MaxInstruments+2] <- SRMA
dfSpread5ConvexityCurve1$Spread5ConvexityCurve1[MaxInstruments+3] <- SRML
dfSpread5ConvexityCurve1
# Curvature 2
dfSpread5ConvexityCurve2 <- ddply(dfStaticRiskMeasures, .(Instrument), summarize, 
                              dfStaticRiskMeasures=sum(Spread5ConvexityCurve2))
dfSpread5ConvexityCurve2$Spread5ConvexityCurve2 <- dfSpread5ConvexityCurve2$dfStaticRiskMeasures
dfSpread5ConvexityCurve2$dfStaticRiskMeasures <- NULL
# Compute Static Risk Measure for Net Worth
dfSpread5ConvexityCurve2 <- rbind(dfSpread5ConvexityCurve2, y = c(MaxInstruments+1, NA))
dfSpread5ConvexityCurve2 <- rbind(dfSpread5ConvexityCurve2, y = c(MaxInstruments+2, NA))
dfSpread5ConvexityCurve2 <- rbind(dfSpread5ConvexityCurve2, y = c(MaxInstruments+3, NA))
TA <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+2]
TL <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+3]
SRMA <- 0.0
for(i in 1:NumberOfAssets){
  SRMA <- SRMA + dfSpread5ConvexityCurve2$Spread5ConvexityCurve2[i] * (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[i]/TA)
}
SRML <- 0.0
for(i in 1:NumberOfLiabilities){
  SRML <- SRML + dfSpread5ConvexityCurve2$Spread5ConvexityCurve2[NumberOfAssets+i] * 
    (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[NumberOfAssets+i]/TL)
}
if(TA == -TL){
  dfSpread5ConvexityCurve2$Spread5ConvexityCurve2[MaxInstruments+1] <- NA
} else {
  dfSpread5ConvexityCurve2$Spread5ConvexityCurve2[MaxInstruments+1] <- (SRMA*TA + SRML*TL)/(TA + TL)
}
dfSpread5ConvexityCurve2$Spread5ConvexityCurve2[MaxInstruments+2] <- SRMA
dfSpread5ConvexityCurve2$Spread5ConvexityCurve2[MaxInstruments+3] <- SRML
# Curvature 3
dfSpread5ConvexityCurve3 <- ddply(dfStaticRiskMeasures, .(Instrument), summarize, 
                              dfStaticRiskMeasures=sum(Spread5ConvexityCurve3))
dfSpread5ConvexityCurve3$Spread5ConvexityCurve3 <- dfSpread5ConvexityCurve3$dfStaticRiskMeasures
dfSpread5ConvexityCurve3$dfStaticRiskMeasures <- NULL
# Compute Static Risk Measure for Net Worth
dfSpread5ConvexityCurve3 <- rbind(dfSpread5ConvexityCurve3, y = c(MaxInstruments+1, NA))
dfSpread5ConvexityCurve3 <- rbind(dfSpread5ConvexityCurve3, y = c(MaxInstruments+2, NA))
dfSpread5ConvexityCurve3 <- rbind(dfSpread5ConvexityCurve3, y = c(MaxInstruments+3, NA))
TA <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+2]
TL <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+3]
SRMA <- 0.0
for(i in 1:NumberOfAssets){
  SRMA <- SRMA + dfSpread5ConvexityCurve3$Spread5ConvexityCurve3[i] * (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[i]/TA)
}
SRML <- 0.0
for(i in 1:NumberOfLiabilities){
  SRML <- SRML + dfSpread5ConvexityCurve3$Spread5ConvexityCurve3[NumberOfAssets+i] * 
    (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[NumberOfAssets+i]/TL)
}
if(TA == -TL){
  dfSpread5ConvexityCurve3$Spread5ConvexityCurve3[MaxInstruments+1] <- NA
} else {
  dfSpread5ConvexityCurve3$Spread5ConvexityCurve3[MaxInstruments+1] <- (SRMA*TA + SRML*TL)/(TA + TL)
}
dfSpread5ConvexityCurve3$Spread5ConvexityCurve3[MaxInstruments+2] <- SRMA
dfSpread5ConvexityCurve3$Spread5ConvexityCurve3[MaxInstruments+3] <- SRML
# Curvature 4
dfSpread5ConvexityCurve4 <- ddply(dfStaticRiskMeasures, .(Instrument), summarize, 
                              dfStaticRiskMeasures=sum(Spread5ConvexityCurve4))
dfSpread5ConvexityCurve4$Spread5ConvexityCurve4 <- dfSpread5ConvexityCurve4$dfStaticRiskMeasures
dfSpread5ConvexityCurve4$dfStaticRiskMeasures <- NULL
# Compute Static Risk Measure for Net Worth
dfSpread5ConvexityCurve4 <- rbind(dfSpread5ConvexityCurve4, y = c(MaxInstruments+1, NA))
dfSpread5ConvexityCurve4 <- rbind(dfSpread5ConvexityCurve4, y = c(MaxInstruments+2, NA))
dfSpread5ConvexityCurve4 <- rbind(dfSpread5ConvexityCurve4, y = c(MaxInstruments+3, NA))
TA <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+2]
TL <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+3]
SRMA <- 0.0
for(i in 1:NumberOfAssets){
  SRMA <- SRMA + dfSpread5ConvexityCurve4$Spread5ConvexityCurve4[i] * (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[i]/TA)
}
SRML <- 0.0
for(i in 1:NumberOfLiabilities){
  SRML <- SRML + dfSpread5ConvexityCurve4$Spread5ConvexityCurve4[NumberOfAssets+i] * 
    (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[NumberOfAssets+i]/TL)
}
if(TA == -TL){
  dfSpread5ConvexityCurve4$Spread5ConvexityCurve4[MaxInstruments+1] <- NA
} else {
  dfSpread5ConvexityCurve4$Spread5ConvexityCurve4[MaxInstruments+1] <- (SRMA*TA + SRML*TL)/(TA + TL)
}
dfSpread5ConvexityCurve4$Spread5ConvexityCurve4[MaxInstruments+2] <- SRMA
dfSpread5ConvexityCurve4$Spread5ConvexityCurve4[MaxInstruments+3] <- SRML
# Curvature 5
dfSpread5ConvexityCurve5 <- ddply(dfStaticRiskMeasures, .(Instrument), summarize, 
                              dfStaticRiskMeasures=sum(Spread5ConvexityCurve5))
dfSpread5ConvexityCurve5$Spread5ConvexityCurve5 <- dfSpread5ConvexityCurve5$dfStaticRiskMeasures
dfSpread5ConvexityCurve5$dfStaticRiskMeasures <- NULL
# Compute Static Risk Measure for Net Worth
dfSpread5ConvexityCurve5 <- rbind(dfSpread5ConvexityCurve5, y = c(MaxInstruments+1, NA))
dfSpread5ConvexityCurve5 <- rbind(dfSpread5ConvexityCurve5, y = c(MaxInstruments+2, NA))
dfSpread5ConvexityCurve5 <- rbind(dfSpread5ConvexityCurve5, y = c(MaxInstruments+3, NA))
TA <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+2]
TL <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+3]
SRMA <- 0.0
for(i in 1:NumberOfAssets){
  SRMA <- SRMA + dfSpread5ConvexityCurve5$Spread5ConvexityCurve5[i] * (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[i]/TA)
}
SRML <- 0.0
for(i in 1:NumberOfLiabilities){
  SRML <- SRML + dfSpread5ConvexityCurve5$Spread5ConvexityCurve5[NumberOfAssets+i] * 
    (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[NumberOfAssets+i]/TL)
}
if(TA == -TL){
  dfSpread5ConvexityCurve5$Spread5ConvexityCurve5[MaxInstruments+1] <- NA
} else {
  dfSpread5ConvexityCurve5$Spread5ConvexityCurve5[MaxInstruments+1] <- (SRMA*TA + SRML*TL)/(TA + TL)
}
dfSpread5ConvexityCurve5$Spread5ConvexityCurve5[MaxInstruments+2] <- SRMA
dfSpread5ConvexityCurve5$Spread5ConvexityCurve5[MaxInstruments+3] <- SRML
# dfPVBalanceSheet
# dfPVBalanceSheetAtHorizon
# dfSpread5ConvexityLevel
# dfSpread5ConvexitySlope
# dfSpread5ConvexityCurve1
# dfSpread5ConvexityCurve2
# dfSpread5ConvexityCurve3
# dfSpread5ConvexityCurve4
# dfSpread5ConvexityCurve5
#
# Spread5 Cross Convexiities (19!)
#
# Level x _____
dfStaticRiskMeasures$Spread5CrossConvexityCCLS <- (M^2) * 1.0 * x1 * W * CW
dfStaticRiskMeasures$Spread5CrossConvexityCCLC1 <- (M^2) * 1.0 * x2 * W * CW
dfStaticRiskMeasures$Spread5CrossConvexityCCLC2 <- (M^2) * 1.0 * x3 * W * CW
dfStaticRiskMeasures$Spread5CrossConvexityCCLC3 <- (M^2) * 1.0 * x4 * W * CW
dfStaticRiskMeasures$Spread5CrossConvexityCCLC4 <- (M^2) * 1.0 * x5 * W * CW
dfStaticRiskMeasures$Spread5CrossConvexityCCLC5 <- (M^2) * 1.0 * x6 * W * CW
# Slope x _____
dfStaticRiskMeasures$Spread5CrossConvexityCCSC1 <- (M^2) * x1 * x2 * W * CW
dfStaticRiskMeasures$Spread5CrossConvexityCCSC2 <- (M^2) * x1 * x3 * W * CW
dfStaticRiskMeasures$Spread5CrossConvexityCCSC3 <- (M^2) * x1 * x4 * W * CW
dfStaticRiskMeasures$Spread5CrossConvexityCCSC4 <- (M^2) * x1 * x5 * W * CW
dfStaticRiskMeasures$Spread5CrossConvexityCCSC5 <- (M^2) * x1 * x6 * W * CW
# Curve1 x _____
dfStaticRiskMeasures$Spread5CrossConvexityCCC1C2 <- (M^2) * x2 * x3 * W * CW
dfStaticRiskMeasures$Spread5CrossConvexityCCC1C3 <- (M^2) * x2 * x4 * W * CW
dfStaticRiskMeasures$Spread5CrossConvexityCCC1C4 <- (M^2) * x2 * x5 * W * CW
dfStaticRiskMeasures$Spread5CrossConvexityCCC1C5 <- (M^2) * x2 * x6 * W * CW
# Curve2 x _____
dfStaticRiskMeasures$Spread5CrossConvexityCCC2C3 <- (M^2) * x3 * x4 * W * CW
dfStaticRiskMeasures$Spread5CrossConvexityCCC2C4 <- (M^2) * x3 * x5 * W * CW
dfStaticRiskMeasures$Spread5CrossConvexityCCC2C5 <- (M^2) * x3 * x6 * W * CW
# Curve4 x _____
dfStaticRiskMeasures$Spread5CrossConvexityCCC3C4 <- (M^2) * x4 * x5 * W * CW
dfStaticRiskMeasures$Spread5CrossConvexityCCC3C5 <- (M^2) * x4 * x6 * W * CW
# Curve5 x _____
dfStaticRiskMeasures$Spread5CrossConvexityCCC4C5 <- (M^2) * x5 * x6 * W * CW
# Level x Slope (CCLS)
dfSpread5CrossConvexityCCLS <- ddply(dfStaticRiskMeasures, .(Instrument), summarize, 
  dfStaticRiskMeasures=sum(Spread5CrossConvexityCCLS))
dfSpread5CrossConvexityCCLS$Spread5CrossConvexityCCLS <- dfSpread5CrossConvexityCCLS$dfStaticRiskMeasures
dfSpread5CrossConvexityCCLS$dfStaticRiskMeasures <- NULL
# Compute Static Risk Measure for Net Worth
dfSpread5CrossConvexityCCLS <- rbind(dfSpread5CrossConvexityCCLS, y = c(MaxInstruments+1, NA))
dfSpread5CrossConvexityCCLS <- rbind(dfSpread5CrossConvexityCCLS, y = c(MaxInstruments+2, NA))
dfSpread5CrossConvexityCCLS <- rbind(dfSpread5CrossConvexityCCLS, y = c(MaxInstruments+3, NA))
TA <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+2]
TL <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+3]
SRMA <- 0.0
for(i in 1:NumberOfAssets){
  SRMA <- SRMA + dfSpread5CrossConvexityCCLS$Spread5CrossConvexityCCLS[i] * (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[i]/TA)
}
SRML <- 0.0
for(i in 1:NumberOfLiabilities){
  SRML <- SRML + dfSpread5CrossConvexityCCLS$Spread5CrossConvexityCCLS[NumberOfAssets+i] * 
    (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[NumberOfAssets+i]/TL)
}
if(TA == -TL){
  dfSpread5CrossConvexityCCLS$Spread5CrossConvexityCCLS[MaxInstruments+1] <- NA
} else {
  dfSpread5CrossConvexityCCLS$Spread5CrossConvexityCCLS[MaxInstruments+1] <- (SRMA*TA + SRML*TL)/(TA + TL)
}
dfSpread5CrossConvexityCCLS$Spread5CrossConvexityCCLS[MaxInstruments+2] <- SRMA
dfSpread5CrossConvexityCCLS$Spread5CrossConvexityCCLS[MaxInstruments+3] <- SRML
# Level x Curve1 (CCLC1)
dfSpread5CrossConvexityCCLC1 <- ddply(dfStaticRiskMeasures, .(Instrument), summarize, 
  dfStaticRiskMeasures=sum(Spread5CrossConvexityCCLC1))
dfSpread5CrossConvexityCCLC1$Spread5CrossConvexityCCLC1 <- dfSpread5CrossConvexityCCLC1$dfStaticRiskMeasures
dfSpread5CrossConvexityCCLC1$dfStaticRiskMeasures <- NULL
# Compute Static Risk Measure for Net Worth
dfSpread5CrossConvexityCCLC1 <- rbind(dfSpread5CrossConvexityCCLC1, y = c(MaxInstruments+1, NA))
dfSpread5CrossConvexityCCLC1 <- rbind(dfSpread5CrossConvexityCCLC1, y = c(MaxInstruments+2, NA))
dfSpread5CrossConvexityCCLC1 <- rbind(dfSpread5CrossConvexityCCLC1, y = c(MaxInstruments+3, NA))
TA <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+2]
TL <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+3]
SRMA <- 0.0
for(i in 1:NumberOfAssets){
  SRMA <- SRMA + dfSpread5CrossConvexityCCLC1$Spread5CrossConvexityCCLC1[i] * (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[i]/TA)
}
SRML <- 0.0
for(i in 1:NumberOfLiabilities){
  SRML <- SRML + dfSpread5CrossConvexityCCLC1$Spread5CrossConvexityCCLC1[NumberOfAssets+i] * 
    (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[NumberOfAssets+i]/TL)
}
if(TA == -TL){
  dfSpread5CrossConvexityCCLC1$Spread5CrossConvexityCCLC1[MaxInstruments+1] <- NA
} else {
  dfSpread5CrossConvexityCCLC1$Spread5CrossConvexityCCLC1[MaxInstruments+1] <- (SRMA*TA + SRML*TL)/(TA + TL)
}
dfSpread5CrossConvexityCCLC1$Spread5CrossConvexityCCLC1[MaxInstruments+2] <- SRMA
dfSpread5CrossConvexityCCLC1$Spread5CrossConvexityCCLC1[MaxInstruments+3] <- SRML
# Level x Curve2 (CCLC2)
dfSpread5CrossConvexityCCLC2 <- ddply(dfStaticRiskMeasures, .(Instrument), summarize, 
                             dfStaticRiskMeasures=sum(Spread5CrossConvexityCCLC2))
dfSpread5CrossConvexityCCLC2$Spread5CrossConvexityCCLC2 <- dfSpread5CrossConvexityCCLC2$dfStaticRiskMeasures
dfSpread5CrossConvexityCCLC2$dfStaticRiskMeasures <- NULL
# Compute Static Risk Measure for Net Worth
dfSpread5CrossConvexityCCLC2 <- rbind(dfSpread5CrossConvexityCCLC2, y = c(MaxInstruments+1, NA))
dfSpread5CrossConvexityCCLC2 <- rbind(dfSpread5CrossConvexityCCLC2, y = c(MaxInstruments+2, NA))
dfSpread5CrossConvexityCCLC2 <- rbind(dfSpread5CrossConvexityCCLC2, y = c(MaxInstruments+3, NA))
TA <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+2]
TL <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+3]
SRMA <- 0.0
for(i in 1:NumberOfAssets){
  SRMA <- SRMA + dfSpread5CrossConvexityCCLC2$Spread5CrossConvexityCCLC2[i] * (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[i]/TA)
}
SRML <- 0.0
for(i in 1:NumberOfLiabilities){
  SRML <- SRML + dfSpread5CrossConvexityCCLC2$Spread5CrossConvexityCCLC2[NumberOfAssets+i] * 
    (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[NumberOfAssets+i]/TL)
}
if(TA == -TL){
  dfSpread5CrossConvexityCCLC2$Spread5CrossConvexityCCLC2[MaxInstruments+1] <- NA
} else {
  dfSpread5CrossConvexityCCLC2$Spread5CrossConvexityCCLC2[MaxInstruments+1] <- (SRMA*TA + SRML*TL)/(TA + TL)
}
dfSpread5CrossConvexityCCLC2$Spread5CrossConvexityCCLC2[MaxInstruments+2] <- SRMA
dfSpread5CrossConvexityCCLC2$Spread5CrossConvexityCCLC2[MaxInstruments+3] <- SRML
# Level x Curve3 (CCLC3)
dfSpread5CrossConvexityCCLC3 <- ddply(dfStaticRiskMeasures, .(Instrument), summarize, 
                             dfStaticRiskMeasures=sum(Spread5CrossConvexityCCLC3))
dfSpread5CrossConvexityCCLC3$Spread5CrossConvexityCCLC3 <- dfSpread5CrossConvexityCCLC3$dfStaticRiskMeasures
dfSpread5CrossConvexityCCLC3$dfStaticRiskMeasures <- NULL
# Compute Static Risk Measure for Net Worth
dfSpread5CrossConvexityCCLC3 <- rbind(dfSpread5CrossConvexityCCLC3, y = c(MaxInstruments+1, NA))
dfSpread5CrossConvexityCCLC3 <- rbind(dfSpread5CrossConvexityCCLC3, y = c(MaxInstruments+2, NA))
dfSpread5CrossConvexityCCLC3 <- rbind(dfSpread5CrossConvexityCCLC3, y = c(MaxInstruments+3, NA))
TA <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+2]
TL <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+3]
SRMA <- 0.0
for(i in 1:NumberOfAssets){
  SRMA <- SRMA + dfSpread5CrossConvexityCCLC3$Spread5CrossConvexityCCLC3[i] * (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[i]/TA)
}
SRML <- 0.0
for(i in 1:NumberOfLiabilities){
  SRML <- SRML + dfSpread5CrossConvexityCCLC3$Spread5CrossConvexityCCLC3[NumberOfAssets+i] * 
    (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[NumberOfAssets+i]/TL)
}
if(TA == -TL){
  dfSpread5CrossConvexityCCLC3$Spread5CrossConvexityCCLC3[MaxInstruments+1] <- NA
} else {
  dfSpread5CrossConvexityCCLC3$Spread5CrossConvexityCCLC3[MaxInstruments+1] <- (SRMA*TA + SRML*TL)/(TA + TL)
}
dfSpread5CrossConvexityCCLC3$Spread5CrossConvexityCCLC3[MaxInstruments+2] <- SRMA
dfSpread5CrossConvexityCCLC3$Spread5CrossConvexityCCLC3[MaxInstruments+3] <- SRML
# Level x Curve4 (CCLC4)
dfSpread5CrossConvexityCCLC4 <- ddply(dfStaticRiskMeasures, .(Instrument), summarize, 
                             dfStaticRiskMeasures=sum(Spread5CrossConvexityCCLC4))
dfSpread5CrossConvexityCCLC4$Spread5CrossConvexityCCLC4 <- dfSpread5CrossConvexityCCLC4$dfStaticRiskMeasures
dfSpread5CrossConvexityCCLC4$dfStaticRiskMeasures <- NULL
# Compute Static Risk Measure for Net Worth
dfSpread5CrossConvexityCCLC4 <- rbind(dfSpread5CrossConvexityCCLC4, y = c(MaxInstruments+1, NA))
dfSpread5CrossConvexityCCLC4 <- rbind(dfSpread5CrossConvexityCCLC4, y = c(MaxInstruments+2, NA))
dfSpread5CrossConvexityCCLC4 <- rbind(dfSpread5CrossConvexityCCLC4, y = c(MaxInstruments+3, NA))
TA <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+2]
TL <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+3]
SRMA <- 0.0
for(i in 1:NumberOfAssets){
  SRMA <- SRMA + dfSpread5CrossConvexityCCLC4$Spread5CrossConvexityCCLC4[i] * (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[i]/TA)
}
SRML <- 0.0
for(i in 1:NumberOfLiabilities){
  SRML <- SRML + dfSpread5CrossConvexityCCLC4$Spread5CrossConvexityCCLC4[NumberOfAssets+i] * 
    (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[NumberOfAssets+i]/TL)
}
if(TA == -TL){
  dfSpread5CrossConvexityCCLC4$Spread5CrossConvexityCCLC4[MaxInstruments+1] <- NA
} else {
  dfSpread5CrossConvexityCCLC4$Spread5CrossConvexityCCLC4[MaxInstruments+1] <- (SRMA*TA + SRML*TL)/(TA + TL)
}
dfSpread5CrossConvexityCCLC4$Spread5CrossConvexityCCLC4[MaxInstruments+2] <- SRMA
dfSpread5CrossConvexityCCLC4$Spread5CrossConvexityCCLC4[MaxInstruments+3] <- SRML
# Level x Curve5 (CCLC5)
dfSpread5CrossConvexityCCLC5 <- ddply(dfStaticRiskMeasures, .(Instrument), summarize, 
                             dfStaticRiskMeasures=sum(Spread5CrossConvexityCCLC5))
dfSpread5CrossConvexityCCLC5$Spread5CrossConvexityCCLC5 <- dfSpread5CrossConvexityCCLC5$dfStaticRiskMeasures
dfSpread5CrossConvexityCCLC5$dfStaticRiskMeasures <- NULL
# Compute Static Risk Measure for Net Worth
dfSpread5CrossConvexityCCLC5 <- rbind(dfSpread5CrossConvexityCCLC5, y = c(MaxInstruments+1, NA))
dfSpread5CrossConvexityCCLC5 <- rbind(dfSpread5CrossConvexityCCLC5, y = c(MaxInstruments+2, NA))
dfSpread5CrossConvexityCCLC5 <- rbind(dfSpread5CrossConvexityCCLC5, y = c(MaxInstruments+3, NA))
TA <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+2]
TL <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+3]
SRMA <- 0.0
for(i in 1:NumberOfAssets){
  SRMA <- SRMA + dfSpread5CrossConvexityCCLC5$Spread5CrossConvexityCCLC5[i] * (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[i]/TA)
}
SRML <- 0.0
for(i in 1:NumberOfLiabilities){
  SRML <- SRML + dfSpread5CrossConvexityCCLC5$Spread5CrossConvexityCCLC5[NumberOfAssets+i] * 
    (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[NumberOfAssets+i]/TL)
}
if(TA == -TL){
  dfSpread5CrossConvexityCCLC5$Spread5CrossConvexityCCLC5[MaxInstruments+1] <- NA
} else {
  dfSpread5CrossConvexityCCLC5$Spread5CrossConvexityCCLC5[MaxInstruments+1] <- (SRMA*TA + SRML*TL)/(TA + TL)
}
dfSpread5CrossConvexityCCLC5$Spread5CrossConvexityCCLC5[MaxInstruments+2] <- SRMA
dfSpread5CrossConvexityCCLC5$Spread5CrossConvexityCCLC5[MaxInstruments+3] <- SRML
# dfSpread5CrossConvexityCCLS
# dfSpread5CrossConvexityCCLC1
# dfSpread5CrossConvexityCCLC2
# dfSpread5CrossConvexityCCLC3
# dfSpread5CrossConvexityCCLC4
# dfSpread5CrossConvexityCCLC5
# Slope x Curve1 (CCSC1)
dfSpread5CrossConvexityCCSC1 <- ddply(dfStaticRiskMeasures, .(Instrument), summarize, 
                             dfStaticRiskMeasures=sum(Spread5CrossConvexityCCSC1))
dfSpread5CrossConvexityCCSC1$Spread5CrossConvexityCCSC1 <- dfSpread5CrossConvexityCCSC1$dfStaticRiskMeasures
dfSpread5CrossConvexityCCSC1$dfStaticRiskMeasures <- NULL
# Compute Static Risk Measure for Net Worth
dfSpread5CrossConvexityCCSC1 <- rbind(dfSpread5CrossConvexityCCSC1, y = c(MaxInstruments+1, NA))
dfSpread5CrossConvexityCCSC1 <- rbind(dfSpread5CrossConvexityCCSC1, y = c(MaxInstruments+2, NA))
dfSpread5CrossConvexityCCSC1 <- rbind(dfSpread5CrossConvexityCCSC1, y = c(MaxInstruments+3, NA))
TA <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+2]
TL <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+3]
SRMA <- 0.0
for(i in 1:NumberOfAssets){
  SRMA <- SRMA + dfSpread5CrossConvexityCCSC1$Spread5CrossConvexityCCSC1[i] * (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[i]/TA)
}
SRML <- 0.0
for(i in 1:NumberOfLiabilities){
  SRML <- SRML + dfSpread5CrossConvexityCCSC1$Spread5CrossConvexityCCSC1[NumberOfAssets+i] * 
    (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[NumberOfAssets+i]/TL)
}
if(TA == -TL){
  dfSpread5CrossConvexityCCSC1$Spread5CrossConvexityCCSC1[MaxInstruments+1] <- NA
} else {
  dfSpread5CrossConvexityCCSC1$Spread5CrossConvexityCCSC1[MaxInstruments+1] <- (SRMA*TA + SRML*TL)/(TA + TL)
}
dfSpread5CrossConvexityCCSC1$Spread5CrossConvexityCCSC1[MaxInstruments+2] <- SRMA
dfSpread5CrossConvexityCCSC1$Spread5CrossConvexityCCSC1[MaxInstruments+3] <- SRML
# Level x Curve2 (CCSC2)
dfSpread5CrossConvexityCCSC2 <- ddply(dfStaticRiskMeasures, .(Instrument), summarize, 
                             dfStaticRiskMeasures=sum(Spread5CrossConvexityCCSC2))
dfSpread5CrossConvexityCCSC2$Spread5CrossConvexityCCSC2 <- dfSpread5CrossConvexityCCSC2$dfStaticRiskMeasures
dfSpread5CrossConvexityCCSC2$dfStaticRiskMeasures <- NULL
# Compute Static Risk Measure for Net Worth
dfSpread5CrossConvexityCCSC2 <- rbind(dfSpread5CrossConvexityCCSC2, y = c(MaxInstruments+1, NA))
dfSpread5CrossConvexityCCSC2 <- rbind(dfSpread5CrossConvexityCCSC2, y = c(MaxInstruments+2, NA))
dfSpread5CrossConvexityCCSC2 <- rbind(dfSpread5CrossConvexityCCSC2, y = c(MaxInstruments+3, NA))
TA <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+2]
TL <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+3]
SRMA <- 0.0
for(i in 1:NumberOfAssets){
  SRMA <- SRMA + dfSpread5CrossConvexityCCSC2$Spread5CrossConvexityCCSC2[i] * (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[i]/TA)
}
SRML <- 0.0
for(i in 1:NumberOfLiabilities){
  SRML <- SRML + dfSpread5CrossConvexityCCSC2$Spread5CrossConvexityCCSC2[NumberOfAssets+i] * 
    (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[NumberOfAssets+i]/TL)
}
if(TA == -TL){
  dfSpread5CrossConvexityCCSC2$Spread5CrossConvexityCCSC2[MaxInstruments+1] <- NA
} else {
  dfSpread5CrossConvexityCCSC2$Spread5CrossConvexityCCSC2[MaxInstruments+1] <- (SRMA*TA + SRML*TL)/(TA + TL)
}
dfSpread5CrossConvexityCCSC2$Spread5CrossConvexityCCSC2[MaxInstruments+2] <- SRMA
dfSpread5CrossConvexityCCSC2$Spread5CrossConvexityCCSC2[MaxInstruments+3] <- SRML
# Level x Curve3 (CCSC3)
dfSpread5CrossConvexityCCSC3 <- ddply(dfStaticRiskMeasures, .(Instrument), summarize, 
                             dfStaticRiskMeasures=sum(Spread5CrossConvexityCCSC3))
dfSpread5CrossConvexityCCSC3$Spread5CrossConvexityCCSC3 <- dfSpread5CrossConvexityCCSC3$dfStaticRiskMeasures
dfSpread5CrossConvexityCCSC3$dfStaticRiskMeasures <- NULL
# Compute Static Risk Measure for Net Worth
dfSpread5CrossConvexityCCSC3 <- rbind(dfSpread5CrossConvexityCCSC3, y = c(MaxInstruments+1, NA))
dfSpread5CrossConvexityCCSC3 <- rbind(dfSpread5CrossConvexityCCSC3, y = c(MaxInstruments+2, NA))
dfSpread5CrossConvexityCCSC3 <- rbind(dfSpread5CrossConvexityCCSC3, y = c(MaxInstruments+3, NA))
TA <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+2]
TL <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+3]
SRMA <- 0.0
for(i in 1:NumberOfAssets){
  SRMA <- SRMA + dfSpread5CrossConvexityCCSC3$Spread5CrossConvexityCCSC3[i] * (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[i]/TA)
}
SRML <- 0.0
for(i in 1:NumberOfLiabilities){
  SRML <- SRML + dfSpread5CrossConvexityCCSC3$Spread5CrossConvexityCCSC3[NumberOfAssets+i] * 
    (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[NumberOfAssets+i]/TL)
}
if(TA == -TL){
  dfSpread5CrossConvexityCCSC3$Spread5CrossConvexityCCSC3[MaxInstruments+1] <- NA
} else {
  dfSpread5CrossConvexityCCSC3$Spread5CrossConvexityCCSC3[MaxInstruments+1] <- (SRMA*TA + SRML*TL)/(TA + TL)
}
dfSpread5CrossConvexityCCSC3$Spread5CrossConvexityCCSC3[MaxInstruments+2] <- SRMA
dfSpread5CrossConvexityCCSC3$Spread5CrossConvexityCCSC3[MaxInstruments+3] <- SRML
# Level x Curve4 (CCSC4)
dfSpread5CrossConvexityCCSC4 <- ddply(dfStaticRiskMeasures, .(Instrument), summarize, 
                             dfStaticRiskMeasures=sum(Spread5CrossConvexityCCSC4))
dfSpread5CrossConvexityCCSC4$Spread5CrossConvexityCCSC4 <- dfSpread5CrossConvexityCCSC4$dfStaticRiskMeasures
dfSpread5CrossConvexityCCSC4$dfStaticRiskMeasures <- NULL
# Compute Static Risk Measure for Net Worth
dfSpread5CrossConvexityCCSC4 <- rbind(dfSpread5CrossConvexityCCSC4, y = c(MaxInstruments+1, NA))
dfSpread5CrossConvexityCCSC4 <- rbind(dfSpread5CrossConvexityCCSC4, y = c(MaxInstruments+2, NA))
dfSpread5CrossConvexityCCSC4 <- rbind(dfSpread5CrossConvexityCCSC4, y = c(MaxInstruments+3, NA))
TA <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+2]
TL <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+3]
SRMA <- 0.0
for(i in 1:NumberOfAssets){
  SRMA <- SRMA + dfSpread5CrossConvexityCCSC4$Spread5CrossConvexityCCSC4[i] * (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[i]/TA)
}
SRML <- 0.0
for(i in 1:NumberOfLiabilities){
  SRML <- SRML + dfSpread5CrossConvexityCCSC4$Spread5CrossConvexityCCSC4[NumberOfAssets+i] * 
    (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[NumberOfAssets+i]/TL)
}
if(TA == -TL){
  dfSpread5CrossConvexityCCSC4$Spread5CrossConvexityCCSC4[MaxInstruments+1] <- NA
} else {
  dfSpread5CrossConvexityCCSC4$Spread5CrossConvexityCCSC4[MaxInstruments+1] <- (SRMA*TA + SRML*TL)/(TA + TL)
}
dfSpread5CrossConvexityCCSC4$Spread5CrossConvexityCCSC4[MaxInstruments+2] <- SRMA
dfSpread5CrossConvexityCCSC4$Spread5CrossConvexityCCSC4[MaxInstruments+3] <- SRML
# Level x Curve5 (CCSC5)
dfSpread5CrossConvexityCCSC5 <- ddply(dfStaticRiskMeasures, .(Instrument), summarize, 
                             dfStaticRiskMeasures=sum(Spread5CrossConvexityCCSC5))
dfSpread5CrossConvexityCCSC5$Spread5CrossConvexityCCSC5 <- dfSpread5CrossConvexityCCSC5$dfStaticRiskMeasures
dfSpread5CrossConvexityCCSC5$dfStaticRiskMeasures <- NULL
# Compute Static Risk Measure for Net Worth
dfSpread5CrossConvexityCCSC5 <- rbind(dfSpread5CrossConvexityCCSC5, y = c(MaxInstruments+1, NA))
dfSpread5CrossConvexityCCSC5 <- rbind(dfSpread5CrossConvexityCCSC5, y = c(MaxInstruments+2, NA))
dfSpread5CrossConvexityCCSC5 <- rbind(dfSpread5CrossConvexityCCSC5, y = c(MaxInstruments+3, NA))
TA <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+2]
TL <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+3]
SRMA <- 0.0
for(i in 1:NumberOfAssets){
  SRMA <- SRMA + dfSpread5CrossConvexityCCSC5$Spread5CrossConvexityCCSC5[i] * (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[i]/TA)
}
SRML <- 0.0
for(i in 1:NumberOfLiabilities){
  SRML <- SRML + dfSpread5CrossConvexityCCSC5$Spread5CrossConvexityCCSC5[NumberOfAssets+i] * 
    (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[NumberOfAssets+i]/TL)
}
if(TA == -TL){
  dfSpread5CrossConvexityCCSC5$Spread5CrossConvexityCCSC5[MaxInstruments+1] <- NA
} else {
  dfSpread5CrossConvexityCCSC5$Spread5CrossConvexityCCSC5[MaxInstruments+1] <- (SRMA*TA + SRML*TL)/(TA + TL)
}
dfSpread5CrossConvexityCCSC5$Spread5CrossConvexityCCSC5[MaxInstruments+2] <- SRMA
dfSpread5CrossConvexityCCSC5$Spread5CrossConvexityCCSC5[MaxInstruments+3] <- SRML
# dfSpread5CrossConvexityCCSC1
# dfSpread5CrossConvexityCCSC2
# dfSpread5CrossConvexityCCSC3
# dfSpread5CrossConvexityCCSC4
# dfSpread5CrossConvexityCCSC5
# Curve1 x Curve2 (CCC1C2)
dfSpread5CrossConvexityCCC1C2 <- ddply(dfStaticRiskMeasures, .(Instrument), summarize, 
                             dfStaticRiskMeasures=sum(Spread5CrossConvexityCCC1C2))
dfSpread5CrossConvexityCCC1C2$Spread5CrossConvexityCCC1C2 <- dfSpread5CrossConvexityCCC1C2$dfStaticRiskMeasures
dfSpread5CrossConvexityCCC1C2$dfStaticRiskMeasures <- NULL
# Compute Static Risk Measure for Net Worth
dfSpread5CrossConvexityCCC1C2 <- rbind(dfSpread5CrossConvexityCCC1C2, y = c(MaxInstruments+1, NA))
dfSpread5CrossConvexityCCC1C2 <- rbind(dfSpread5CrossConvexityCCC1C2, y = c(MaxInstruments+2, NA))
dfSpread5CrossConvexityCCC1C2 <- rbind(dfSpread5CrossConvexityCCC1C2, y = c(MaxInstruments+3, NA))
TA <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+2]
TL <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+3]
SRMA <- 0.0
for(i in 1:NumberOfAssets){
  SRMA <- SRMA + dfSpread5CrossConvexityCCC1C2$Spread5CrossConvexityCCC1C2[i] * (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[i]/TA)
}
SRML <- 0.0
for(i in 1:NumberOfLiabilities){
  SRML <- SRML + dfSpread5CrossConvexityCCC1C2$Spread5CrossConvexityCCC1C2[NumberOfAssets+i] * 
    (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[NumberOfAssets+i]/TL)
}
if(TA == -TL){
  dfSpread5CrossConvexityCCC1C2$Spread5CrossConvexityCCC1C2[MaxInstruments+1] <- NA
} else {
  dfSpread5CrossConvexityCCC1C2$Spread5CrossConvexityCCC1C2[MaxInstruments+1] <- (SRMA*TA + SRML*TL)/(TA + TL)
}
dfSpread5CrossConvexityCCC1C2$Spread5CrossConvexityCCC1C2[MaxInstruments+2] <- SRMA
dfSpread5CrossConvexityCCC1C2$Spread5CrossConvexityCCC1C2[MaxInstruments+3] <- SRML
# Level x Curve3 (CCC1C3)
dfSpread5CrossConvexityCCC1C3 <- ddply(dfStaticRiskMeasures, .(Instrument), summarize, 
                             dfStaticRiskMeasures=sum(Spread5CrossConvexityCCC1C3))
dfSpread5CrossConvexityCCC1C3$Spread5CrossConvexityCCC1C3 <- dfSpread5CrossConvexityCCC1C3$dfStaticRiskMeasures
dfSpread5CrossConvexityCCC1C3$dfStaticRiskMeasures <- NULL
# Compute Static Risk Measure for Net Worth
dfSpread5CrossConvexityCCC1C3 <- rbind(dfSpread5CrossConvexityCCC1C3, y = c(MaxInstruments+1, NA))
dfSpread5CrossConvexityCCC1C3 <- rbind(dfSpread5CrossConvexityCCC1C3, y = c(MaxInstruments+2, NA))
dfSpread5CrossConvexityCCC1C3 <- rbind(dfSpread5CrossConvexityCCC1C3, y = c(MaxInstruments+3, NA))
TA <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+2]
TL <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+3]
SRMA <- 0.0
for(i in 1:NumberOfAssets){
  SRMA <- SRMA + dfSpread5CrossConvexityCCC1C3$Spread5CrossConvexityCCC1C3[i] * (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[i]/TA)
}
SRML <- 0.0
for(i in 1:NumberOfLiabilities){
  SRML <- SRML + dfSpread5CrossConvexityCCC1C3$Spread5CrossConvexityCCC1C3[NumberOfAssets+i] * 
    (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[NumberOfAssets+i]/TL)
}
if(TA == -TL){
  dfSpread5CrossConvexityCCC1C3$Spread5CrossConvexityCCC1C3[MaxInstruments+1] <- NA
} else {
  dfSpread5CrossConvexityCCC1C3$Spread5CrossConvexityCCC1C3[MaxInstruments+1] <- (SRMA*TA + SRML*TL)/(TA + TL)
}
dfSpread5CrossConvexityCCC1C3$Spread5CrossConvexityCCC1C3[MaxInstruments+2] <- SRMA
dfSpread5CrossConvexityCCC1C3$Spread5CrossConvexityCCC1C3[MaxInstruments+3] <- SRML
# Level x Curve4 (CCC1C4)
dfSpread5CrossConvexityCCC1C4 <- ddply(dfStaticRiskMeasures, .(Instrument), summarize, 
                             dfStaticRiskMeasures=sum(Spread5CrossConvexityCCC1C4))
dfSpread5CrossConvexityCCC1C4$Spread5CrossConvexityCCC1C4 <- dfSpread5CrossConvexityCCC1C4$dfStaticRiskMeasures
dfSpread5CrossConvexityCCC1C4$dfStaticRiskMeasures <- NULL
# Compute Static Risk Measure for Net Worth
dfSpread5CrossConvexityCCC1C4 <- rbind(dfSpread5CrossConvexityCCC1C4, y = c(MaxInstruments+1, NA))
dfSpread5CrossConvexityCCC1C4 <- rbind(dfSpread5CrossConvexityCCC1C4, y = c(MaxInstruments+2, NA))
dfSpread5CrossConvexityCCC1C4 <- rbind(dfSpread5CrossConvexityCCC1C4, y = c(MaxInstruments+3, NA))
TA <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+2]
TL <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+3]
SRMA <- 0.0
for(i in 1:NumberOfAssets){
  SRMA <- SRMA + dfSpread5CrossConvexityCCC1C4$Spread5CrossConvexityCCC1C4[i] * (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[i]/TA)
}
SRML <- 0.0
for(i in 1:NumberOfLiabilities){
  SRML <- SRML + dfSpread5CrossConvexityCCC1C4$Spread5CrossConvexityCCC1C4[NumberOfAssets+i] * 
    (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[NumberOfAssets+i]/TL)
}
if(TA == -TL){
  dfSpread5CrossConvexityCCC1C4$Spread5CrossConvexityCCC1C4[MaxInstruments+1] <- NA
} else {
  dfSpread5CrossConvexityCCC1C4$Spread5CrossConvexityCCC1C4[MaxInstruments+1] <- (SRMA*TA + SRML*TL)/(TA + TL)
}
dfSpread5CrossConvexityCCC1C4$Spread5CrossConvexityCCC1C4[MaxInstruments+2] <- SRMA
dfSpread5CrossConvexityCCC1C4$Spread5CrossConvexityCCC1C4[MaxInstruments+3] <- SRML
# Level x Curve5 (CCC1C5)
dfSpread5CrossConvexityCCC1C5 <- ddply(dfStaticRiskMeasures, .(Instrument), summarize, 
                             dfStaticRiskMeasures=sum(Spread5CrossConvexityCCC1C5))
dfSpread5CrossConvexityCCC1C5$Spread5CrossConvexityCCC1C5 <- dfSpread5CrossConvexityCCC1C5$dfStaticRiskMeasures
dfSpread5CrossConvexityCCC1C5$dfStaticRiskMeasures <- NULL
# Compute Static Risk Measure for Net Worth
dfSpread5CrossConvexityCCC1C5 <- rbind(dfSpread5CrossConvexityCCC1C5, y = c(MaxInstruments+1, NA))
dfSpread5CrossConvexityCCC1C5 <- rbind(dfSpread5CrossConvexityCCC1C5, y = c(MaxInstruments+2, NA))
dfSpread5CrossConvexityCCC1C5 <- rbind(dfSpread5CrossConvexityCCC1C5, y = c(MaxInstruments+3, NA))
TA <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+2]
TL <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+3]
SRMA <- 0.0
for(i in 1:NumberOfAssets){
  SRMA <- SRMA + dfSpread5CrossConvexityCCC1C5$Spread5CrossConvexityCCC1C5[i] * (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[i]/TA)
}
SRML <- 0.0
for(i in 1:NumberOfLiabilities){
  SRML <- SRML + dfSpread5CrossConvexityCCC1C5$Spread5CrossConvexityCCC1C5[NumberOfAssets+i] * 
    (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[NumberOfAssets+i]/TL)
}
if(TA == -TL){
  dfSpread5CrossConvexityCCC1C5$Spread5CrossConvexityCCC1C5[MaxInstruments+1] <- NA
} else {
  dfSpread5CrossConvexityCCC1C5$Spread5CrossConvexityCCC1C5[MaxInstruments+1] <- (SRMA*TA + SRML*TL)/(TA + TL)
}
dfSpread5CrossConvexityCCC1C5$Spread5CrossConvexityCCC1C5[MaxInstruments+2] <- SRMA
dfSpread5CrossConvexityCCC1C5$Spread5CrossConvexityCCC1C5[MaxInstruments+3] <- SRML
# dfSpread5CrossConvexityCCC1C2
# dfSpread5CrossConvexityCCC1C3
# dfSpread5CrossConvexityCCC1C4
# dfSpread5CrossConvexityCCC1C5
# Curve2 x Curve3 (CCC2C3)
dfSpread5CrossConvexityCCC2C3 <- ddply(dfStaticRiskMeasures, .(Instrument), summarize, 
                              dfStaticRiskMeasures=sum(Spread5CrossConvexityCCC2C3))
dfSpread5CrossConvexityCCC2C3$Spread5CrossConvexityCCC2C3 <- dfSpread5CrossConvexityCCC2C3$dfStaticRiskMeasures
dfSpread5CrossConvexityCCC2C3$dfStaticRiskMeasures <- NULL
# Compute Static Risk Measure for Net Worth
dfSpread5CrossConvexityCCC2C3 <- rbind(dfSpread5CrossConvexityCCC2C3, y = c(MaxInstruments+1, NA))
dfSpread5CrossConvexityCCC2C3 <- rbind(dfSpread5CrossConvexityCCC2C3, y = c(MaxInstruments+2, NA))
dfSpread5CrossConvexityCCC2C3 <- rbind(dfSpread5CrossConvexityCCC2C3, y = c(MaxInstruments+3, NA))
TA <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+2]
TL <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+3]
SRMA <- 0.0
for(i in 1:NumberOfAssets){
  SRMA <- SRMA + dfSpread5CrossConvexityCCC2C3$Spread5CrossConvexityCCC2C3[i] * (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[i]/TA)
}
SRML <- 0.0
for(i in 1:NumberOfLiabilities){
  SRML <- SRML + dfSpread5CrossConvexityCCC2C3$Spread5CrossConvexityCCC2C3[NumberOfAssets+i] * 
    (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[NumberOfAssets+i]/TL)
}
if(TA == -TL){
  dfSpread5CrossConvexityCCC2C3$Spread5CrossConvexityCCC2C3[MaxInstruments+1] <- NA
} else {
  dfSpread5CrossConvexityCCC2C3$Spread5CrossConvexityCCC2C3[MaxInstruments+1] <- (SRMA*TA + SRML*TL)/(TA + TL)
}
dfSpread5CrossConvexityCCC2C3$Spread5CrossConvexityCCC2C3[MaxInstruments+2] <- SRMA
dfSpread5CrossConvexityCCC2C3$Spread5CrossConvexityCCC2C3[MaxInstruments+3] <- SRML
# _____ x Curve4 (CCC2C4)
dfSpread5CrossConvexityCCC2C4 <- ddply(dfStaticRiskMeasures, .(Instrument), summarize, 
                              dfStaticRiskMeasures=sum(Spread5CrossConvexityCCC2C4))
dfSpread5CrossConvexityCCC2C4$Spread5CrossConvexityCCC2C4 <- dfSpread5CrossConvexityCCC2C4$dfStaticRiskMeasures
dfSpread5CrossConvexityCCC2C4$dfStaticRiskMeasures <- NULL
# Compute Static Risk Measure for Net Worth
dfSpread5CrossConvexityCCC2C4 <- rbind(dfSpread5CrossConvexityCCC2C4, y = c(MaxInstruments+1, NA))
dfSpread5CrossConvexityCCC2C4 <- rbind(dfSpread5CrossConvexityCCC2C4, y = c(MaxInstruments+2, NA))
dfSpread5CrossConvexityCCC2C4 <- rbind(dfSpread5CrossConvexityCCC2C4, y = c(MaxInstruments+3, NA))
TA <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+2]
TL <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+3]
SRMA <- 0.0
for(i in 1:NumberOfAssets){
  SRMA <- SRMA + dfSpread5CrossConvexityCCC2C4$Spread5CrossConvexityCCC2C4[i] * (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[i]/TA)
}
SRML <- 0.0
for(i in 1:NumberOfLiabilities){
  SRML <- SRML + dfSpread5CrossConvexityCCC2C4$Spread5CrossConvexityCCC2C4[NumberOfAssets+i] * 
    (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[NumberOfAssets+i]/TL)
}
if(TA == -TL){
  dfSpread5CrossConvexityCCC2C4$Spread5CrossConvexityCCC2C4[MaxInstruments+1] <- NA
} else {
  dfSpread5CrossConvexityCCC2C4$Spread5CrossConvexityCCC2C4[MaxInstruments+1] <- (SRMA*TA + SRML*TL)/(TA + TL)
}
dfSpread5CrossConvexityCCC2C4$Spread5CrossConvexityCCC2C4[MaxInstruments+2] <- SRMA
dfSpread5CrossConvexityCCC2C4$Spread5CrossConvexityCCC2C4[MaxInstruments+3] <- SRML
# _____ x Curve5 (CCC2C5)
dfSpread5CrossConvexityCCC2C5 <- ddply(dfStaticRiskMeasures, .(Instrument), summarize, 
                              dfStaticRiskMeasures=sum(Spread5CrossConvexityCCC2C5))
dfSpread5CrossConvexityCCC2C5$Spread5CrossConvexityCCC2C5 <- dfSpread5CrossConvexityCCC2C5$dfStaticRiskMeasures
dfSpread5CrossConvexityCCC2C5$dfStaticRiskMeasures <- NULL
# Compute Static Risk Measure for Net Worth
dfSpread5CrossConvexityCCC2C5 <- rbind(dfSpread5CrossConvexityCCC2C5, y = c(MaxInstruments+1, NA))
dfSpread5CrossConvexityCCC2C5 <- rbind(dfSpread5CrossConvexityCCC2C5, y = c(MaxInstruments+2, NA))
dfSpread5CrossConvexityCCC2C5 <- rbind(dfSpread5CrossConvexityCCC2C5, y = c(MaxInstruments+3, NA))
TA <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+2]
TL <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+3]
SRMA <- 0.0
for(i in 1:NumberOfAssets){
  SRMA <- SRMA + dfSpread5CrossConvexityCCC2C5$Spread5CrossConvexityCCC2C5[i] * (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[i]/TA)
}
SRML <- 0.0
for(i in 1:NumberOfLiabilities){
  SRML <- SRML + dfSpread5CrossConvexityCCC2C5$Spread5CrossConvexityCCC2C5[NumberOfAssets+i] * 
    (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[NumberOfAssets+i]/TL)
}
if(TA == -TL){
  dfSpread5CrossConvexityCCC2C5$Spread5CrossConvexityCCC2C5[MaxInstruments+1] <- NA
} else {
  dfSpread5CrossConvexityCCC2C5$Spread5CrossConvexityCCC2C5[MaxInstruments+1] <- (SRMA*TA + SRML*TL)/(TA + TL)
}
dfSpread5CrossConvexityCCC2C5$Spread5CrossConvexityCCC2C5[MaxInstruments+2] <- SRMA
dfSpread5CrossConvexityCCC2C5$Spread5CrossConvexityCCC2C5[MaxInstruments+3] <- SRML
# dfSpread5CrossConvexityCCC2C3
# dfSpread5CrossConvexityCCC2C4
# dfSpread5CrossConvexityCCC2C5
# Curve3 x Curve4 (CCC3C4)
dfSpread5CrossConvexityCCC3C4 <- ddply(dfStaticRiskMeasures, .(Instrument), summarize, 
                              dfStaticRiskMeasures=sum(Spread5CrossConvexityCCC3C4))
dfSpread5CrossConvexityCCC3C4$Spread5CrossConvexityCCC3C4 <- dfSpread5CrossConvexityCCC3C4$dfStaticRiskMeasures
dfSpread5CrossConvexityCCC3C4$dfStaticRiskMeasures <- NULL
# Compute Static Risk Measure for Net Worth
dfSpread5CrossConvexityCCC3C4 <- rbind(dfSpread5CrossConvexityCCC3C4, y = c(MaxInstruments+1, NA))
dfSpread5CrossConvexityCCC3C4 <- rbind(dfSpread5CrossConvexityCCC3C4, y = c(MaxInstruments+2, NA))
dfSpread5CrossConvexityCCC3C4 <- rbind(dfSpread5CrossConvexityCCC3C4, y = c(MaxInstruments+3, NA))
TA <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+2]
TL <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+3]
SRMA <- 0.0
for(i in 1:NumberOfAssets){
  SRMA <- SRMA + dfSpread5CrossConvexityCCC3C4$Spread5CrossConvexityCCC3C4[i] * (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[i]/TA)
}
SRML <- 0.0
for(i in 1:NumberOfLiabilities){
  SRML <- SRML + dfSpread5CrossConvexityCCC3C4$Spread5CrossConvexityCCC3C4[NumberOfAssets+i] * 
    (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[NumberOfAssets+i]/TL)
}
if(TA == -TL){
  dfSpread5CrossConvexityCCC3C4$Spread5CrossConvexityCCC3C4[MaxInstruments+1] <- NA
} else {
  dfSpread5CrossConvexityCCC3C4$Spread5CrossConvexityCCC3C4[MaxInstruments+1] <- (SRMA*TA + SRML*TL)/(TA + TL)
}
dfSpread5CrossConvexityCCC3C4$Spread5CrossConvexityCCC3C4[MaxInstruments+2] <- SRMA
dfSpread5CrossConvexityCCC3C4$Spread5CrossConvexityCCC3C4[MaxInstruments+3] <- SRML
# _____ x Curve5 (CCC3C5)
dfSpread5CrossConvexityCCC3C5 <- ddply(dfStaticRiskMeasures, .(Instrument), summarize, 
                              dfStaticRiskMeasures=sum(Spread5CrossConvexityCCC3C5))
dfSpread5CrossConvexityCCC3C5$Spread5CrossConvexityCCC3C5 <- dfSpread5CrossConvexityCCC3C5$dfStaticRiskMeasures
dfSpread5CrossConvexityCCC3C5$dfStaticRiskMeasures <- NULL
# Compute Static Risk Measure for Net Worth
dfSpread5CrossConvexityCCC3C5 <- rbind(dfSpread5CrossConvexityCCC3C5, y = c(MaxInstruments+1, NA))
dfSpread5CrossConvexityCCC3C5 <- rbind(dfSpread5CrossConvexityCCC3C5, y = c(MaxInstruments+2, NA))
dfSpread5CrossConvexityCCC3C5 <- rbind(dfSpread5CrossConvexityCCC3C5, y = c(MaxInstruments+3, NA))
TA <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+2]
TL <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+3]
SRMA <- 0.0
for(i in 1:NumberOfAssets){
  SRMA <- SRMA + dfSpread5CrossConvexityCCC3C5$Spread5CrossConvexityCCC3C5[i] * (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[i]/TA)
}
SRML <- 0.0
for(i in 1:NumberOfLiabilities){
  SRML <- SRML + dfSpread5CrossConvexityCCC3C5$Spread5CrossConvexityCCC3C5[NumberOfAssets+i] * 
    (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[NumberOfAssets+i]/TL)
}
if(TA == -TL){
  dfSpread5CrossConvexityCCC3C5$Spread5CrossConvexityCCC3C5[MaxInstruments+1] <- NA
} else {
  dfSpread5CrossConvexityCCC3C5$Spread5CrossConvexityCCC3C5[MaxInstruments+1] <- (SRMA*TA + SRML*TL)/(TA + TL)
}
dfSpread5CrossConvexityCCC3C5$Spread5CrossConvexityCCC3C5[MaxInstruments+2] <- SRMA
dfSpread5CrossConvexityCCC3C5$Spread5CrossConvexityCCC3C5[MaxInstruments+3] <- SRML
# dfSpread5CrossConvexityCCC3C4
# dfSpread5CrossConvexityCCC3C5
# Curve4 x Curve5 (CCC4C5)
dfSpread5CrossConvexityCCC4C5 <- ddply(dfStaticRiskMeasures, .(Instrument), summarize, 
                              dfStaticRiskMeasures=sum(Spread5CrossConvexityCCC4C5))
dfSpread5CrossConvexityCCC4C5$Spread5CrossConvexityCCC4C5 <- dfSpread5CrossConvexityCCC4C5$dfStaticRiskMeasures
dfSpread5CrossConvexityCCC4C5$dfStaticRiskMeasures <- NULL
# Compute Static Risk Measure for Net Worth
dfSpread5CrossConvexityCCC4C5 <- rbind(dfSpread5CrossConvexityCCC4C5, y = c(MaxInstruments+1, NA))
dfSpread5CrossConvexityCCC4C5 <- rbind(dfSpread5CrossConvexityCCC4C5, y = c(MaxInstruments+2, NA))
dfSpread5CrossConvexityCCC4C5 <- rbind(dfSpread5CrossConvexityCCC4C5, y = c(MaxInstruments+3, NA))
TA <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+2]
TL <- dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[MaxInstruments+3]
SRMA <- 0.0
for(i in 1:NumberOfAssets){
  SRMA <- SRMA + dfSpread5CrossConvexityCCC4C5$Spread5CrossConvexityCCC4C5[i] * (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[i]/TA)
}
SRML <- 0.0
for(i in 1:NumberOfLiabilities){
  SRML <- SRML + dfSpread5CrossConvexityCCC4C5$Spread5CrossConvexityCCC4C5[NumberOfAssets+i] * 
    (dfPVBalanceSheetAtHorizon$EstimatedValueAtHorizon[NumberOfAssets+i]/TL)
}
if(TA == -TL){
  dfSpread5CrossConvexityCCC4C5$Spread5CrossConvexityCCC4C5[MaxInstruments+1] <- NA
} else {
  dfSpread5CrossConvexityCCC4C5$Spread5CrossConvexityCCC4C5[MaxInstruments+1] <- (SRMA*TA + SRML*TL)/(TA + TL)
}
dfSpread5CrossConvexityCCC4C5$Spread5CrossConvexityCCC4C5[MaxInstruments+2] <- SRMA
dfSpread5CrossConvexityCCC4C5$Spread5CrossConvexityCCC4C5[MaxInstruments+3] <- SRML
# dfSpread5CrossConvexityCCC4C5


