# 16.5 Keel Model Test.R
# rmarkdown::render("16.5 Keel Model Test.R", "word_document")
#  Master file
#
rm(list = ls())  # Take out the Environment "trash"
while (!is.null(dev.list()))  dev.off() # Clear old plots
cat("\014") # Clear Console, making error checking easier.
# Install requisite libraries: 
#   openxlsx - opening KM Inputs.R
#   plyr - sorting data frames in KM Static Calculations.R
PackagesToLibrary <- c("openxlsx", "plyr")
if (length(setdiff(PackagesToLibrary, rownames(installed.packages()))) > 0) {
  install.packages(setdiff(PackagesToLibrary, rownames(installed.packages())))  
} # Make sure libraries are installed on this computer
lapply(PackagesToLibrary, library, character.only = TRUE) # Load and attach libraries
rm(PackagesToLibrary)
#
# Key files:
#  dfInstruments - all instruments and related information
#  InitialCurves - initial information on base and spread curves
#  HorizonCurves - horizon information on base and spread curves
#
# Test Case: Two curves (C2), Three factors (F3)
# 
FileName <- "KeelModelInputsC2F3_Small_Bank.xlsx"
source("KM Inputs.R")
source("KM Rates.R")
source("KM Static Calculations.R")
NetWorthRowNumber <- NumberOfAssets + 1 + NumberOfLiabilities + 1 + 1
source("KM Reports C2F3.R")
# # Test Case: Three curves (C3), Three factors (F3)
# FileName <- "KeelModelInputsC3F3.xlsx"
# source("KM Inputs.R")
# source("KM Rates.R")
# source("KM Static Calculations.R")
# source("KM Reports C3F3.R")
# Test Case: Four curves (C4), Three factors (F3) -- Base, Credit Spread, Equity Spread, and Growth
# FileName <- "KeelModelInputsC4F3.xlsx"
# source("KM Inputs.R")
# source("KM Rates.R")
# source("KM Static Calculations.R")
# source("KM Reports C4F3.R")
#
# Begin work on risk management
#

